/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	JRV
 *
 *	$Log:	xy2color.c,v $
 * Revision 2.2  92/04/29  15:09:28  trillium
 * Ohio Release
 * 
 *      Function:	- Given a point on the complex plane x+iy, 
 *                        this returns color based on how close the
 *                        point is to the Mandelbrot set.
 *      Accepts:        - float x,y; The points.
 *      Returns:        - int4; The color.
 */

#include <stdio.h>
#include <math.h>
#include <portable.h>
#include "mandel.h"
 
char xy2color(x, y)
float			x,y;
{
	int4		i = 0;		/* iteration counter */
	complex		z, c;
	float		magnitude;
    
	z.real = 0;
	z.imaginary = 0;
	c.real = x;
	c.imaginary = y;

	while (i < MAX_ITERATIONS) {
		x = z.real*z.real - z.imaginary*z.imaginary + c.real;
		y = 2*z.real*z.imaginary + c.imaginary;

		z.real = x;
		z.imaginary = y;

		magnitude = (float)sqrt((double)
				    (z.real*z.real + z.imaginary*z.imaginary));

		if (magnitude >=  2) {
			return((char) (i*255/MAX_ITERATIONS));
		}
		else {
			i++;
		}
	}
	return((char) -1);
}
