/*
 *	Cornell Theory Center					Trillium
 *
 *	Copyright 1990 Cornell Research Foundation & The Ohio State University
 *
 *	MB
 *
 *	$Log:	fbrenda.c,v $
 * Revision 2.2  92/04/24  16:13:33  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/05/02  14:49:01  gdburns
 * Ohio release
 * 
 * Revision 2.0  90/09/26  12:37:08  gdburns
 * Homo sapien
 * 
 *
 *   FORTRAN wrappers for the basic Brenda functions.
 *
 *	To be called as FORTRAN SUBROUTINEs.  Parameter types:
 *	Tag, size, snode are INTEGER*4;  flags, ierr are INTEGER;
 *	buf is anything numeric, either scalar or array.
 *	Return value: "ierr" gets 0 (OK) or -1 (ERROR).
 *
 *	by Moshe Braner,  891026
 */

#include "brenda.h"

void
PUT (tag, buffer, size, flags, snode, ierr)
	long	*tag, *size, *snode;
	int	*flags, *ierr;
	char	*buffer;
{
	*ierr = put (*tag, buffer, *size, *flags, *snode);
}

void
GRAB (tag, buffer, size, flags, snode, ierr)
	long	*tag, *size, *snode;
	int	*flags, *ierr;
	char	*buffer;
{
	*ierr = grab (*tag, buffer, *size, *flags, *snode);
}

void
LOOK (tag, buffer, size, flags, snode, ierr)
	long	*tag, *size, *snode;
	int	*flags, *ierr;
	char	*buffer;
{
	*ierr = look (*tag, buffer, *size, *flags, *snode);
}

void
TRYGRAB (tag, buffer, size, flags, snode, ierr)
	long	*tag, *size, *snode;
	int	*flags, *ierr;
	char	*buffer;
{
	*ierr = trygrab (*tag, buffer, *size, *flags, *snode);
}

void
TRYLOOK (tag, buffer, size, flags, snode, ierr)
	long	*tag, *size, *snode;
	int	*flags, *ierr;
	char	*buffer;
{
	*ierr = trylook (*tag, buffer, *size, *flags, *snode);
}

void
BUMP (tag, buffer, size, flags, snode, ierr)
	long	*tag, *size, *snode;
	int	*flags, *ierr;
	char	*buffer;
{
	*ierr = bump (*tag, buffer, *size, *flags, *snode);
}

void
FREEZE()
{
	(void) freeze();
}

void
THAW()
{
	(void) thaw();
}
