.TH FILEDOCTOR l  "January 31, 1990" "Release 2.0" "TROLLIUS TOOLS"
.SH NAME
filedr \- File System diagnostic tool
.SH SYNTAX
.B filedr
[-chtvN] -ro/wo/rw/wr [-f filename] [-g flags] [-m modes] [-l numbytes]
.SH OPTIONS
.TP 15
.B \-c 
do not close 
.I filename.
.TP
.B \-h
print helpful information on this tool.
.TP 
.B \-t 
report timings for each file operation performed.
.TP
.B \-v
enable verbose mode.
.TP 
.B \-N 
work in pretend mode (bypass actual file operations).
.TP 
.B \-ro 
perform read only operation on 
.I filename.
.TP 
.B \-wo 
perform write only operation on 
.I filename. 
.TP 
.B \-rw 
perform read then write on 
.I filename. 
.TP 
.B \-wr 
perform write then read on 
.I filename.
.TP 
.B \-f filename 
work on 
.I filename.
.TP 
.B \-g flags
open 
.I filename 
with 
.I flags
enabled.
.TP
.B \-m modes
set read, write, execute permissions on 
.I filename 
as specified in 
.I modes 
(in octal only).
.TP
.B \-l numbytes
read/write 
.I numbytes 
amount of data from/to 
.I filename.

.SH DESCRIPTION
.I Filedr 
is a diagnostic tool for testing and timing the file system commands, viz.
topen(), tclose(), tread(), and twrite(). Supported operations are 
read-only(ro), write-only(wo), read followed by write(rw), and write 
followed by read(wr). The file open and close commands can be implicitly
tested. All work on the same file 
.I filename. 
If the 
.I '-f'
option is absent, the default file operated on is 'testfile'.
In case of the multiple operations 
.I rw
and
.I wr,
the file is closed before the second operation. However the 
.I '-c'
option results in disabling closure of files throughout the command
execution. 
.PP
The
.I '-g'
option is used to specify the flags with which the file must be
opened. 
.I flags 
is a string of characters from the set 
r,w,u,p,c,t,x,e,a,s,m corresponding to read, write, rdwr(update), 
append, create, trunc, excl, reuse, async, single, multiple modes. 
Filedr sets the default values (r,w,u,u) to 
.I flags 
according to the operation (ro,wo,rw,wr) specified. If 
.I filename 
does not exist, it is created even if the create flag is unspecified.
The
.I '-m'
option is used to specify the read, write, execute permissions to 
be set on the file while creating it. The default value of 
.I modes 
is octal 644. The 
.I '-l'
option is used to indicate the number of bytes to be read and/or written
from/into the file.
The 
.I '-t' 
option returns the execution times of each file operation involved.
Finally, with the 
.I '-N' 
option, the filedr bypasses (or pretends to do) the actual file 
operations of open, read, write, close. 
 
.SH EXAMPLES
.TP 4
.I "filedr -ct -rw -g ps -l 30"
Open (create if it does not exist) a default file 'testfile' in 'append'
and 'single' modes. Read 30 bytes of data from the file (this will
be meaningful only if the file is non-empty). Then without closing the file,
write 30 bytes of data into the same file. Report execution times of
each file operation involved.
.TP
.I "filedr -ro -f junk -m 664"
Read 0 bytes from file 'junk' with read, write, execute permissions
on the file as 664 (octal). This results in creation of the file if
it does not exist.
.TP
.I "filedr -vN -wr -f junk -l 1000"
Write and then read 1000 bytes of data from the file 'junk'. Pretending
to do the file operations, display the sequence of file operations that
filedr would otherwise perform.

.SH SEE ALSO
topen(l), tread(l), twrite(l), tclose(l)
