.TH IPCDR l  "August 14, 1990" "Release 2.1" "TROLLIUS TOOLS"
.SH NAME
ipcdr \- Inter-Process Communication diagnostic tool
.SH SYNTAX
.B ipcdr
[-bcdhotvCDFINRV] [-e event] [-l length] [-m messages] [-s <nodes>]
.SH OPTIONS
.TP 15
.B \-b
Disable message buffering.
.TP
.B \-c 
Check the contents of the received messages.
.TP
.B \-d
Turn on debugging mode.
.TP
.B \-h
Print helpful information on this tool.
.TP 
.B \-o
Check the ordering of the received messages.
.TP
.B \-t 
Report timings of the message exchanges.
.TP
.B \-v
Turn on verbose mode.
.TP 
.B \-C
The message body contains characters.
.TP
.B \-D
The message body contains double precision floating point numbers.
.TP
.B \-F
The message body contains floating point numbers.
.TP
.B \-I
The message body contains integers.
.TP
.B \-N 
Work in `pretend' mode by-passing actual message exchanges.
.TP
.B \-R
The message makes a round trip, returning to the sender.
.TP
.B \-V
Set up a virtual circuit for the message exchange.
.TP 
.B \-e event
Use 
.I event
for message synchronization.
.TP 
.B \-l length
Set the message length to
.I length
bytes.
.TP 
.B \-m messages
Set the number of message exchanges to
.I messages.
.TP
.B \-s <nodes>
Send messages to the specified nodes instead of receiving messages.

.SH DESCRIPTION
.I Ipcdr
is a diagnostic tool for testing and timing the network layer
inter-process communication commands, viz. nsend() and nrecv().
.I Ipcdr 
can be run either in the sender or the receiver modes. 
The 
.I `-s'
option is used to specify the sender mode, in which case the
destination node(s) must be supplied, otherwise
.I ipcdr
defaults to the receiver mode. 
The 
.I `-m' 
option is used to declare the number of messages to send to each
of the destination nodes (sender mode) or receive (receiver mode).
By default only one message is exchanged. 
In the case of multiple messages and multiple destination nodes, the
sender will cycle through the list of specified nodes, sending a message
to each before sending another message to the same node. 
Note that in such a case a seperate
.I ipcdr
must be run in each of the destination nodes, in receiver mode, 
expecting to receive the number of messages specified for the sender.
.PP
The length of the exchanged message(s) is set using the 
.I `-l'
option, the default value being a message of length zero.  
The length of the message refers to the number of data elements transmitted.
Data elements can be integers, floating point numbers (single or double
precision) or characters. 
Note that in 
the case of a zero-length message, only the message header is transmitted.
The
.I `-C', `-D', `-F'
and
.I `-I'
options specify the data elements to be characters, double precision
floating point numbers, single precision floating point numbers and 
integers respectively. 
These options are mutually exclusive. 
Characters are used by default. 
The 
.I `-e'
option allows 
.I event
to be used for message synchronization instead of the default 
event EVIPCDIAG. 
The 
.I `-b'
option disables the buffering of the messages and the 
.I `-V'
option sets up virtual circuits between the sender and each receiver node.
Proper operation of virtual circuits require that both sender
and receiver have the `-V' option enabled. 
The 
.I `-R'
option specifies that each message is to return to the sender, hence
making a round-trip. 
In order for the round-trip to be completed, both
sender and receiver have to have the `-R' option enabled. 
The 
.I `-c'
option requests that each incoming message have its contents checked
for transmission errors.  
Before transmission, the sender fills the
contents of the message with some specific numbers and 
the receiver checks for any mismatch in the message contents.
The
.I `-o'
option requests the receiver to check if the messages are arriving in
the order with which they were sent. 
The sender writes in the header of each message a sequence number
(0, 1, 2, ...) thus enabling the receiver to check if any messages arrive
out of order.
The 
.I `-t'
option reports the total time taken to complete all message transfers,
the average time per message and, for non zero-length messages, the average
time per byte transfer. 
This information is mostly useful when message
round-trips are specified, since it allows the extraction of the 
communication set up time and the transfer rates.
Note that in the case
of round-trips, the average message and byte times take into account the
doubling of the travelled distance, so there is no need to divide these
times in half. 
Finally, with the 
.I `-N'
option, 
.I ipcdr
bypasses (or pretends to do) the actual message transfers.

.SH EXAMPLES
.TP 4
.I "ipcdr  -C -m 4 -l 300 -s n0-3"
Send 4 messages of 300 characters to each of nodes n0 through n3. 
.TP
.I "ipcdr -c -l 5000 -F -e 33"
Receive one message of length not exceeding 5000 floating point numbers
on event 33. 
Check the message contents and report any transmission errors.
.TP
.I "ipcdr -s n7 -Rvt"
Send a zero-length message to node n7 and wait for it to return. 
Display timing information related to the message round-trip.
.SH BUGS
When using virtual circuits with options that require access to the
host screen (i.e. verbose and debug modes), care must be taken to
insure that such access is not blocked by the existence of the 
virtual circuits.
In general, the path from the node requiring host
access to the host must not interfere with the path of any virtual 
circuit set up. 
This restriction is due to the implementation of virtual circuits. 
.SH SEE ALSO
nrecv(l), nsend(l), ttime(l)
