.TH MTVD l  "March 31, 1992" "Release 2.2" "TROLLIUS DAEMONS"
.SH NAME
mtvd \- ITB Trollius graphics daemon (INMOS G300 version)
.SH SYNTAX
.B mtvd
[-h] [-b <bkp>] [-d <dsp>] [-k <vb>] [-l <lt>]
.if n .br
.if n	[-m <mi>] [-p <pll>] [-s <sdsp>] [-v <vs>] [-x <td>]
.if t [-m <mi>] [-p <pll>] [-s <sdsp>] [-v <vs>] [-x <td>]
.br
	[-B <bp>] [-H <hs>] [-V <vdsp>]
.SH OPTIONS
.TP 15
.B \-b <bkp>
Set the G300 BackPorch register to <bkp>.
.TP
.B \-B <bp>
Set the G300 BroadPulse register to <bp>.
.TP
.B \-d <dsp>
Set the G300 Display register to <dsp>.
.TP
.B \-h
Print useful information on this daemon.
.TP
.B \-H <hs>
Set the G300 HalfSync register to <hs>.
.TP
.B \-k <vb>
Set the G300 VBlank register to <vb>.
.TP
.B \-l <lt>
Set the G300 Linetime register to <lt>.
.TP
.B \-m <mi>
Set the G300 MemInit register to <mi>.
.TP
.B \-p <pll>
Set the G300 Boot Location register to the PLL clock multiplication
factor <pll>.
.TP
.B \-s <sdsp>
Set the G300 ShortDisplay register to <sdsp>.
.TP
.B \-v <vs>
Set the G300 VSync register to <vs>.
.TP
.B \-V <vdsp>
Set the G300 VDisplay register to <vdsp>.
.TP
.B \-x <td>
Set the G300 TransferDelay register to <td>.
.SH DESCRIPTION
.PP
.I Mtvd
is a graphics daemon for an ITB node that controls a frame buffer
using the INMOS G300 colour video controller chip.
This provides run-time visualization of results computed by a parallel
application running on the multicomputer.
Systems not having dedicated frame buffers may use the OTB X windows
graphics daemon xmtvd(l) to achieve the equivalent functionality at lower
performance and cost.
Visualization requests are initiated by applications using the remote
graphics functions described in rtv(l).
.I Mtvd
properly handles graphics requests extending beyond the limits of the frame
buffer by having their off-screen portions clipped.
.PP
The setup of the various registers of the G300 video controller depends
on the characteristics of the actual monitor used.
For this reason, the user is given full control over these registers
from the command line.
The
.I -h
option gives a menu of the various command line switches available.
In order to successfully control the registers of the G300 chip, a certain
level of knowledge about generating video timing signals is assumed.
For a full description of the registers and the operation of the G300 chip,
refer to "The Graphics Databook" from INMOS Ltd.
The default register values are set to match the requirements of the
Hitachi HM-4219/4119 monitors as given in the databook, using a screen
size of 1280 by 1024 pixels, 256 colours and characters occupying a grid
of 8 by 8 pixels.
The multicomputer node is assumed to have a system clock of 5 MHz. driving
the PllClkIn pin of the G300 chip.
.SH SEE ALSO
rtv(l), mtv(l), xmtvd(l),
.br
"The Graphics Databook", INMOS Ltd., Inmos Databook Series.
