.TH RLEDOP l "March 11, 1992" "Release 2.2" "TROLLIUS REMOTE LIBRARY"
.SH NAME
rledop, rledcc \- Control remote LEDs.
.SH SYNOPSIS
.nf
#include <ledreq.h>

int rledop (int node, int op, int bits);
int rledcc (int node, int cc);
.fi
.SH DESCRIPTION
.PP
Computers are often equipped with LEDs (Light Emitting Diodes) that
allow the status of a node or a process on a node to be monitored.
Some LEDs are user programmable, i.e. the user can turn them on and off to
indicate the beginning and end of some activity.
This is useful for writing demonstration or troubleshooting software.
.PP
These functions remotely operate the LEDs and special features of the
LED daemon.
.I Rledop()
sets, clears, or reverses LEDs on the given
.I node.
The 
.I op
argument specifies the operation.
The possible values, defined in <ledreq.h>, are:
.TP 10
LEDSET
Turn on LEDs.
.TP
LEDCLR
Turn off LEDs.
.TP
LEDNOT
Toggle LEDs.
.TP
LEDALL
Set all LEDs to specific values.
.PP
The argument
.I bits
is a bitmask specifying which LEDs on a node are to be affected.
Each bit in the mask corresponds to one LED.
If the corresponding bit is set to 1, the actions specified by
.I op
will be taken on that LED.
If the corresponding bit is set to 0, no action will be taken on that LED.
The exception is
.I LEDALL,
which sets every LED to the specific value of the corresponding bit in
the mask.
The number of LEDs on a node can be obtained with rlestate(l).
.PP
The LED daemon can reflect the current state of its LEDs as a
.I LEDALL
request to any other node.
The
.I rledcc()
function sets the reflected node identifier.
The special value NOTNODEID (defined in <net.h>) disables this
feature and is the default.
.SH "RETURN VALUE"
.PP
Upon successful completion, 0 is returned.
If an error occurs, \-1 is returned and the global error variable
.I errno
is set to the error code.
.SH ERRORS
.PP
These functions can experience any of the errors from nsend(l).
.SH "SEE ALSO"
rlestate(l)
