.TH RLESTATE l "March 11, 1992" "Release 2.2" "TROLLIUS REMOTE LIBRARY"
.SH NAME
rlestate
\- Report status of LEDs on a remote node.
.SH SYNOPSIS
.nf
#include <ledreq.h>
.PP
int rlestate (int node, struct lestate *table);
.fi
.SH DESCRIPTION
.PP
The function
.I rlestate()
fills a structure of LED status information from a remote node.
The structure is defined in <ledreq.h> and shown below:
.PP
.ta .5i 1.0i 2.0i 4.0i
.nf
	struct lestate {
		int4	les_nled;	/* # of LEDs */
		int4	les_shadow;	/* value of LEDs */
		int4	les_cc;		/* reflector node ID */
	};
.fi
.PP
The shadow register contains one bit for every LED.
Thus, an LED is either on (1) or off (0).
The
.I les_nled
field tells how many of the low order bits of the
.I les_shadow
field are defined.
.PP
The remote LED daemon has the capability to reflect the current
value of its shadow register to another node's LED daemon.
This reflector's node identifier is given in the
.I les_cc
field.
NOTNODEID indicates that the reflection feature is disabled.
.SH "RETURN VALUE"
.PP
Upon successful completion, 0 is returned.
If an error occurs, \-1 is returned and the global error variable
.I errno
is set to the error code.
.SH ERRORS
.PP
These functions can experience any of the errors from nsend(l) or nrecv(l).
.SH "SEE ALSO"
rledop(l)
