.TH RTRFGET l "August 19, 1991" "Release 2.1" "TROLLIUS REMOTE LIBRARY"
.SH NAME
rtrfget, rtrfforget, rtrsweep \- Unload and/or clean trace data from a
remote node.  (Trollius)
.SH SYNOPSIS
.nf
.ft B
int rtrfget (int nodeid, int fd);
int rtrfforget (int nodeid, int fd);
int rtrsweep (int nodeid);
.fi
.SH DESCRIPTION
The remote function,
.I rtrfget,
gets a copy of all the trace data held by a remote trace daemon and
stores it in a file.
It does not get trace data still stored with traced processes and
not found in the daemon.
See rtrsig(l) and rtrstore(l) for further information on how to
get runtime trace data.
The file is given as a descriptor, returned by open(2) and opened
for write.
.PP
The remote function,
.I rtrfforget,
is almost identical to
.I rtrfget,
except that the data is moved, not copied from the trace daemon.
This has the effect of sweeping the daemon clean of trace data.
The
.I rtrsweep
function is provided only to sweep clean the trace daemon but not
to transfer any data.
.SH "RETURN VALUE
Upon successful completion of all functions 0 is returned.
Otherwise, \-1 is returned and the global variable
.I errno
is set to one of the error codes returned by nsend(l) or nrecv(l).
.SH "SEE ALSO"
rtrsig(l), rtrsweep(l)
