.TH RTRSIG l "August 19, 1991" "Release 2.1" "TROLLIUS REMOTE LIBRARY"
.SH NAME
rtrsig \- Signal traced processes to unload trace data.  (Trollius)
.SH SYNOPSIS
.nf
.ft B
int rtrsig (int nodeid);
.fi
.SH DESCRIPTION
The remote function,
.I rtrsig,
instructs the trace daemon on a remote node to signal all of its
clients with SIGTRACE (see kdoom(l)).
A traced process is one that has registered with the trace daemon
using rtrattach(l) but has not de-registered with rtrdetach(l).
By default, a traced process catches SIGTRACE and responds by making
the rtrstore(l) request to the local trace daemon.
This unloads the process's runtime trace data buffer.
.PP
The traced process can ignore SIGTRACE and neither this function
nor the trace daemon reports any error.
This situation can be detected, however, with rtrstate(l) or trstate(l).
.SH "RETURN VALUE
Upon successful completion of
.I rtrsig 
0 is returned.
Otherwise, \-1 is returned and the global variable,
.I errno
is set to one of the error codes of nsend(l).
.SH "SEE ALSO"
kdoom(l), rtrattach(l), rtrstate(l), trstate(l)
