.TH RTRSTATE l "August 19, 1991" "Release 2.1" "TROLLIUS REMOTE LIBRARY"
.SH NAME
rtrstate
\- Get status of remote traced processes.  (Trollius)
.SH SYNOPSIS
.nf
.ft B
#include <trillium/trreq.h>
.sp
int rtrstate(int node, struct trstate *table, int maxsize, int *detlen);
.fi
.SH DESCRIPTION
The remote function
.I rtrstate
accesses a remote Trollius trace daemons and returns information
on each process that is currently supplying trace data to the daemon.
.PP
The arguments to 
.I rtrstate
are:
.I node,
the target node identifier;
.I table,
a pointer to an array of structures where state information will be stored;
.I maxsize,
the number of elements in that array; and
.I detlen,
the total length of trace data stored by process that have since
detached and are not seen in the state table.
.PP
Returned information about traced processes
are stored in an array of structures of the type
.I trstate,
defined in <trillium/trreq.h> as:
.PP
.nf
	struct trstate {
		int	trs_pid;
		int	trs_length;
		int	trs_sig;
	};
.fi
.PP
Upon returning from
.I rbfstate,
each
.I trstate
structure holds information about one traced process.
The fields in the structure hold:
the process identifer,
the total length of trace data for that process being held by the daemon,
and a flag indicating if the process has been prompted by signal to
store traced data (see rtrstore(l)) but has not yet done so.
The
.I detlen
parameter is filled in as described above.
.SH "RETURN VALUE"
Upon successful completion of
.I rtrstate,
the number of table entries received by the calling process from
the remote trace daemon is returned.
This may be more, less or equal to the maximum table size supplied
as the argument to
.I rtrstate.
Information in excess of the maximum table size was lost.
If an error occurred, \-1 is returned and the global variable
.I errno
is set to one of the error codes returned by nsend(l) or nrecv(l).
.SH "SEE ALSO"
rtrstore(l), trstate(l)
