.TH RTRSTORE l "August 19, 1991" "Release 2.1" "TROLLIUS REMOTE LIBRARY"
.SH NAME
rtrstore \- Store data with trace daemon.  (Trollius)
.SH SYNOPSIS
.nf
.ft B
int rtrstore (int nodeid, char *buffer, int length);
.fi
.SH DESCRIPTION
The remote function,
.I rtrstore,
delivers trace data from a local buffer to the trace daemon.
In theory, the trace transport system can be
used for any random data.
In practise, it is used to move trace data between the monitored
processes and a trace visualization system.
.PP
A process must first call rtrattach(l) to become a traced process
before calling
.I rtrstore.
Once attached, the traced process can transfer collected trace data
to the trace daemon at any time and any number of times.
In theory, the trace daemon on any node can be used and the target
nodeid must only match the nodeid supplied to rtrattach(l).
In practise, always use the local trace daemon, and set the nodeid
argument to LOCAL.
.PP
Any length of buffer is accepted and
.I rtrstore
will send messages to the trace daemon in MAXNMSGLEN byte packets.
(See dsend(l).)
.PP
The trace daemon will accept trace data and store it until it can
no longer get more memory from the system using malloc(3)(l).
It is not wise to push the daemon to this limit.
.SH "RETURN VALUE
Upon successful completion of
.I rtrstore 
0 is returned.
Otherwise, \-1 is returned and the global variable,
.I errno
is set to one of the error codes of nsend(l).
.SH "BUGS"
By packetizing a large buffer in smaller messages, the trace daemon
remains totally stateless but daemon requests from other sources
may be interspersed between the packets.
To be completely safe, a trace record should not span a MAXNMSGLEN
boundary in the trace buffer.
.SH "SEE ALSO"
rtrattach(l), rtrstate(l), ttrace(l)
