.TH TLED l  "March 11, 1992" "Release 2.2" "TROLLIUS COMMANDS"
.SH NAME
tled \- Control LEDs on remote Trollius nodes.
.SH SYNTAX
.B tled
[-h] [-c <mask>] [-n <mask>] [-s <mask>] [-S <leds>]
.br
[-f <node>] <node(s)>
.SH OPTIONS 
.TP 11
.B \-h
Print useful information on this command.
.TP
.B \-c <mask>
Clear (turn off) LEDs enabled in <mask>.
.TP
.B \-n <mask>
Reverse (logical NOT) the current status of LEDs enabled in <mask>.
.TP
.B \-s <mask>
Set (turn on) LEDs enabled in <mask>.
.TP
.B \-S <leds>
Set shadow register to value <leds>.
.TP
.B \-f <node>
Reflect updated LED values to a remote <node>.
.SH DESCRIPTION
.PP
Computers are often equipped with LEDs (Light Emitting Diodes) that
allow the status of a node or process on a node to be monitored.
Some LEDs may be user programmable, i.e. the user can turn them on and off
to indicate the beginning and end of some activity. 
This is useful for writing demonstration or troubleshooting software.
.PP
.I Tled
is a Trollius command that controls LEDs on remote nodes.
When used without options, 
.I tled
performs no action.
Most of the options change the value of one or more LEDs,
each of which is defined by one bit, either on (1) or off (0).
The set (\fI\-s\fR), clear (\fI\-c\fR) and negate (\fI\-n\fR) actions turn on,
turn off or toggle the LEDs corresponding to the 1 bits
in the associated
.I <mask>
argument.
LEDs corresponding to the 0 bits are not changed.
.PP
The \fI\-S\fR option affects all of the LEDs on a node.
Each LED is set or cleared according to the corresponding bit in the
.I <leds>
argument.
.PP
The remote LED daemon can reflect the current state of its LEDs to
request to any other node.
The \fI\-f\R option
sets the reflected node identifier to the
.I <node>
argument.
.PP
The nodes whose LEDs are to be controlled are specified on the command line.
Nodes are identified as 
.I n<list>,
where <list> can be a single node identifier or a list of node identifiers. 
Node identifiers are established in the boot schema (see nail(l))
and can be written in decimal and/or hexadecimal notation.
.SH EXAMPLES
.TP 4
.I "tled -s 0x5 n50-52"
Set (turn on) the LED 0 and LED 2 on nodes 50, 51, and 52.
.TP
.I "tled -S 0xF n5"
Set the LEDs on node 5 to value 0xF.
This sets LED 0 thru 3 and clears the rest.
.SH "SEE ALSO"
lestate(l)
