.TH TRSTATE l  "August 19, 1991" "Release 2.1" "TROLLIUS COMMANDS"
.SH NAME
trstate \- Report status of traced processes.  (Trollius)
.SH SYNTAX
.B trstate
[-h] [-B #] <node(s)>
.SH OPTIONS
.TP 12
.B \-h
Print useful information on this command.
.TP
.B \-B #
Limit the number of reported traced processes.
.SH DESCRIPTION
.I Trstate
displays information on Trollius processes which are supplying trace data
for performance and debug monitoring.
These processes have called rtrattach(l) but not rtrdetach(l).
The trace daemon, which supplies the status information to
.I trstate,
may contain trace data for processes that have already called rtrdetach(l).
Thus,
.I trstate
does not necessarily reveal the total state of trace data on a node;
it only shows the state of processes that continue to supply traced
to the daemon.
.PP
One line of information is printed for each traced process for each
node specified on the command line.
Information is displayed under the following headings:
.PP
.TP 12
NODE
The process is running on this nodeid.
.TP
PID
The process has this identifier.
.TP
LENGTH
The trace daemon is holding this quantity of trace data for the process.
.TP
SIGNAL?
If yes, the process has been signalled as a prompt to ship trace data
to the trace daemon, but it has not yet done so.
Otherwise, no outstanding signal exists.
.PP
.I Trstate
will print information on a limited number of processes.
If the number of traced processes exceeds this limit, a message is
printed.
The limit can be changed with the
.I -B
option.
.PP
.I Trstate
will also print one line at the end of the report showing the
cummulative size of trace data received from processes no longer
attaced to the daemon.
.PP
Nodes are identified as 
.I n<list>,
where <list> can be a single node identifier or a list of node
identifiers.
Node identifiers are established in the Boot Schema (see nail(l)).
The list can be written in decimal and/or hexadecimal notation, 
for example, 0-7,8,10,0xc,0x10-31.
.SH EXAMPLES
.TP 18
.I trstate n12-14
Display the status of all traced processes on nodes 12 through 14.
.SH SEE ALSO
rtrstate(l), ttrace(l)
