.TH TTRACE l  "August 19, 1991" "Release 2.1" "TROLLIUS COMMANDS"
.SH NAME
ttrace \- Control Trollius trace transportation.
.SH SYNTAX
.B ttrace
[-ghksv] <node(s)> [<filename>]
.SH OPTIONS
.TP 15
.B \-g
Signal all traced processes to unload their runtime trace buffer to the
trace daemon.
.TP
.B \-h
Print helpful information on this command.
.TP 
.B \-k
Unload a copy of the trace data stored with the daemon.
Do not remove the trace data in the daemon.
.TP 
.B \-s
Remove the trace data in the daemon.
.TP 
.B \-v
Operate verbosely.
.SH DESCRIPTION
.I Ttrace
provides command line control over certain trace daemon operations
on any Trollius node.
With no special options,
.I ttrace
unloads all trace data stored with the daemon on all
specified nodes into a specified \fIfilename\fR on the local (host) node.
It does not unload trace data still stored in the runtime buffers
of processes being traced.  See below.
The trace data is removed from the trace daemons.
Immediately after execution of this command, the daemons on the
specified nodes have no trace data.
.PP
With the \fI-k\fR option, a copy is made of the trace data and it is
not removed from the trace daemons.
.PP
With the \fI-s\fR option, the \fIfilename\fR argument is not given
and the only action is to remove/clean the trace data from
the daemons.
.PP
The traced processes (clients) of a remote trace daemon will
automatically move their trace data to the local daemon before exiting.
If desired, the clients can be prompted to move the current
contents of their runtime trace data buffers to the daemon
before/without terminating.
.I Ttrace
with the \fI-g\fR option tells the remote trace daemon(s) to prompt
the clients by means of the defined SIGTRACE signal and kdoom(l).
.PP
Nodes are identified as 
.I n<list>,
where <list> can be a single node identifier or a list of node
identifiers.
Node identifiers are established in the Boot Schema (see nail(l)).
The list can be written in decimal and/or hexadecimal notation, 
for example, 0-7,8,10,0xc,0x10-31.
.SH EXAMPLES
.TP 25
.I ttrace -v tdata n0-7
Unload and remove trace data from nodes 0 thru 7.
Report as each node is unloaded.
.TP
.I ttrace -s n0-7
Remove trace data from nodes 0 thru 7.
.SH SEE ALSO
trstate(l)
