.TH XLEDD l  "March 11, 1992" "Release 2.2" "TROLLIUS COMMANDS"
.SH NAME
xledd \- X Window Trollius LED daemon
.SH SYNTAX
.B xledd
[-ledfg <color>] [-ledsize <pixels>] <node(s)>
.SH OPTIONS
.TP 21
.B \-ledfg <color>
Set the color of the LEDs to <color>.
.TP
.B \-ledsize <pixels>
Set the edge length of the square LEDs to <pixels>.
.SH DESCRIPTION
.PP
Modern multicomputer nodes may not have physical LEDs.
.I Xledd
is a standard LED daemon for an OTB node that
simulates multiple node LED panels in an X Window.
This provides the visual benefits of LEDs if not
the low overhead control capability of a local hardware device.
The reflection capability of any LED daemon, especially
those running on ITB nodes without physical LEDs, can
be used to send LED values to \fIXledd\fR.
.PP
.I Xledd
creates two process on an OTB node.
The frontend is the portable LED daemon, a Trollius process.
The backend is an X Window application, not a Trollius process.
The daemon thinks that it controls one set (panel) of LEDs.
Each time the daemon receives a request to update its
LEDs, it sends the new value of the updated LEDs, along
with the client's node identifier, to the X application.
The X application actually maintains multiple LED sets,
one for each node on the
.I xledd
command line.
When the X application receives the LED values for one node,
it looks for the client node ID in its node list and changes
the corresponding LED panel to the LED values.
.SH "TYPICAL USAGE"
.PP
.I Xledd
is intended to simulate LEDs for multiple remote nodes.
An ITB LED daemon is also provided that has stub routines
for LED device drivers.
Select ITB nodes and load the ITB LED daemon on each one.
Then use the tled(l) command to reflect LED values on
these nodes to the OTB node running \fIxledd\fR.
Finally, start \fIxledd\fR with the selected node list
on the command line.
Do not use multicast identifiers.
Clients then send requests to the ITB LED daemons.
The results will appear in an X Window.
.PP
Nodes are identified as 
.I n<list>,
where <list> can be a single node identifier or a list of node
identifiers.
Node identifiers are established in the boot schema (see nail(l)).
The list can be written in decimal and/or hexadecimal notation, 
for example, 0-7,8,10,0xc,0x10-31.
.SH EXAMPLES
.TP 4
.I xledd -ledfg red n0-7
Display red LED panels for nodes 0 through 7.
.SH SEE ALSO
tled(l)
