.TH XMTVD l  "March 25, 1992" "Release 2.2" "TROLLIUS COMMANDS"
.SH NAME
xmtvd \- X Window Trollius graphics daemon
.SH SYNTAX
.B xmtvd
[-xsize <x_pixels>] [-ysize <y_pixels>]
.SH OPTIONS
.TP 21
.B \-xsize <x_pixels>
Set the horizontal size of the graphics screen to <x_pixels>.
.TP
.B \-ysize <y_pixels>
Set the vertical size of the graphics screen to <y_pixels>.
.SH DESCRIPTION
.PP
.I Xmtvd
is a graphics daemon for an OTB node that emulates a graphics frame buffer
in an X Window.
This provides a low cost and low performance alternative for run-time
visualization of results computed by a parallel application running on the
multicomputer.
Systems having dedicated graphics frame buffers may use the ITB graphics
daemon mtvd(l) to achieve a higher performance.
Visualization requests are initiated by applications using the remote
graphics functions described in rtv(l).
.PP
.I Xmtvd
creates two process on an OTB node.
The frontend is the portable graphics daemon, a Trollius process.
The backend is an X Window application, not a Trollius process.
Each time the daemon receives a graphics request, it sends the
relevant information to the X application.
The X application actually handles the tasks of plotting pixels,
mapping the character set to pixels and maintaining the status
information of the frame buffer and the colour lookup table.
.PP
The horizontal and vertical sizes of the frame buffer can be set using
the
.I -xsize
and the
.I -ysize
command line options.
The default screen is 512 pixels in width and 512 pixels in height.
The number of colours supported depends on the characteristics of the
workstation used but is limited to an upper bound of 256 colours.
In text mode, each character occupies a grid of 8 by 8 pixels.
Graphics requests extending beyond the limits of the frame buffer have their
off-screen portions properly clipped.
.PP
Currently, the character set and the colour table cannot be modified
though reasonable choices were made.
On screens supporting four colours, black, blue, green and red are chosen.
Screens allowing a larger number of colours are given a collection of
colours, ranging from the "typical" in the low numbered colours, to the
"fancy" shades in the higher numbered colours.
.SH EXAMPLES
.TP 4
.I xmtvd -xsize 640 -ysize 200
Display a graphics frame buffer of size 640 by 200 pixels.
.SH SEE ALSO
mtvd(l), rtv(l), mtv(l)
