/*
 *      OSU Research Computing                            	Trillium
 *      Copyright 1992 The Ohio State University
 *      GDB
 *
 *      $Log:	rledop.c,v $
 * Revision 2.2  92/04/24  16:32:50  trillium
 * Ohio Release
 * 
 *      Function:	- operate on remote LEDs
 *	Accepts:	- destination nodeid
 *			- LED operation
 *			- LED operation mask
 *	Returns:	- 0 or ERROR
 */

#include <net.h>
#include <events.h>
#include <ledreq.h>
#include <typical.h>

int4
rledop(nodeid, op, mask)

int4			nodeid;
int4			op;
int4			mask;

{
	struct nmsg	nhead;
	struct lereq	*req;

	req = (struct lereq *) nhead.nh_data;
	req->leq_src_node = (nodeid == LOCAL) ? LOCAL : getnodeid();
	req->leq_req = LEQOP;
	req->leq_op = op;
	req->leq_mask = mask;

	nhead.nh_node = nodeid;
	nhead.nh_event = EVLEDD;
	nhead.nh_type = 0;
	nhead.nh_flags = 0;
	nhead.nh_length = 0;
	nhead.nh_msg = (char *) 0;

	if (nsend(&nhead) < 0) {
		return(ERROR);
	}

	return(0);
}
