/*
 *      OSU Research Computing                            	Trillium
 *      Copyright 1992 The Ohio State University
 *      GDB
 *
 *      $Log:	rlestate.c,v $
 * Revision 2.2  92/04/24  16:32:50  trillium
 * Ohio Release
 * 
 *      Function:	- get status on remote LEDs
 *	Accepts:	- destination nodeid
 *			- pointer to LED status structure
 *	Returns:	- 0 or ERROR
 */

#include <net.h>
#include <events.h>
#include <ksignal.h>
#include <ledreq.h>
#include <typical.h>

int4
rlestate(nodeid, plestate)

int4			nodeid;
struct lestate		*plestate;

{
	struct nmsg	nhead;
	struct lereq	*req;
	int4		mask;

	req = (struct lereq *) nhead.nh_data;
	req->leq_src_node = (nodeid == LOCAL) ? nodeid : getnodeid();
	req->leq_src_event = -getpid();
	req->leq_req = LEQSTATE;

	nhead.nh_node = nodeid;
	nhead.nh_event = EVLEDD;
	nhead.nh_type = 0;
	nhead.nh_flags = 0;
	nhead.nh_length = 0;
	nhead.nh_msg = (char *) 0;

	if (nsend(&nhead) < 0) {
		return(ERROR);
	}

	mask = ksigblock(sigmask(SIGUDIE) | sigmask(SIGARREST));
	nhead.nh_event = -getpid();

	if (nrecv(&nhead) < 0) {
		return(ERROR);
	}

	(void) ksigsetmask(mask);

	bcopy((char *) nhead.nh_data, (char *) plestate,
		sizeof(struct lestate));

	return(0);
}
