/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	GDB
 *
 *	$Log:	rtrsig.c,v $
 * Revision 2.2  92/04/24  16:32:51  trillium
 * Ohio Release
 * 
 *	Function:	- asks traced to signal clients to store trace data
 *			  with traced
 *			- no reply from traced to us
 *	Accepts:	- target node ID
 *	Returns:	- return value of nsend()
 */

#include <events.h>
#include <net.h>
#include <trreq.h>

int4
rtrsig(nodeid)

int4			nodeid;		/* target node ID */

{
	struct nmsg	nhead;		/* network message desc. */
	struct trreq  	*request;	/* traced request */

	request = (struct trreq *) nhead.nh_data;
	request->trq_req = TRQSIG;
	request->trq_pid = getpid();

	nhead.nh_node = nodeid;
	nhead.nh_event = EVTRACED;
	nhead.nh_type = 0;
	nhead.nh_flags = 0;
	nhead.nh_length = 0;
	nhead.nh_msg = (char *) 0;

	return(nsend(&nhead));
}
