/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	RBD
 *
 *	$Log:	rtvsnake.c,v $
 * Revision 2.2  92/04/24  16:32:53  trillium
 * Ohio Release
 * 
 *	Function:	- plot a snake-like region of pixels
 *
 *	Accepts: 	- destination node
 *			- linear ordinate of first pixel
 *			- number of pixels in the snake
 *			- array of pixel colours
 *
 *	Returns:	- 0 or ERROR
 */

#include <portable.h>
#include <terror.h>
#include <typical.h>
#include <net.h>
#include <events.h>
#include <tvreq.h>

/*
 * external variables
 */
extern int		errno;		/* error code */


int
rtvsnake(node, x1, len, colours)

int4			node,
			x1,
			len;
char			*colours;

{
	struct nmsg	nhead;		/* message header */
	struct tvreq	*request;	/* ptr to mtvd request */
	int4		chunk;
/*
 * Check the trivial cases.
 */
	if (len == INT4_NIL) {
		return(0);
	}
	else if (len < INT4_NIL) {
		errno = EINVAL;
		return(ERROR);
	}
/*
 * Set up the request message.
 */
 	request = (struct tvreq *) nhead.nh_data;
	request->tvq_req	= TVQSNAKE;
	request->tvq_x1		= x1;

	nhead.nh_node	= node;
	nhead.nh_event	= EVMTVD;
	nhead.nh_type	= 0;
	nhead.nh_flags	= DINTDATA;
	nhead.nh_msg	= colours;
/*
 * Packetize the snake by chopping it into smaller snakes that
 * fit into one network message.
 */
	while (len > 0) {
		chunk = (len > (int4) MAXNMSGLEN) ? (int4) MAXNMSGLEN : len;
		request->tvq_len = chunk;
		nhead.nh_length	= chunk;
		
		if (nsend(&nhead)) {
			return(ERROR);
		}

		request->tvq_x1 += chunk;
		nhead.nh_msg += chunk;
		len -= chunk;
	}

	return(0);
}
