/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	RBD
 *
 *	$Log:	rtvstate.c,v $
 * Revision 2.2  92/04/24  16:32:53  trillium
 * Ohio Release
 * 
 *	Function:	- get status of graphic frame
 *
 *	Accepts: 	- destination node
 *			- ptr to state structure
 *
 *	Returns:	- 0 or ERROR
 */

#include <portable.h>
#include <typical.h>
#include <terror.h>
#include <net.h>
#include <events.h>
#include <tvreq.h>
#include <ksignal.h>

/*
 * external variables
 */
extern int		errno;		/* error code */

/*
 * external functions
 */
extern int		getpid();
extern int4		getnodeid();


int
rtvstate(node, ptvstate)

int4			node;
struct tvstate		*ptvstate;

{
	struct nmsg	nhead;		/* message header */
	struct tvreq	*request;	/* ptr to mtvd request */
	struct tvreply	*reply;		/* ptr to mtvd reply */
	int4		mask;

 	request = (struct tvreq *) nhead.nh_data;
	reply = (struct tvreply *) nhead.nh_data;
/*
 * Set up the request message.
 */
	request->tvq_req	= TVQSTATE;
	request->tvq_src_event	= -getpid();
	request->tvq_src_node	= (node == LOCAL) ? node : getnodeid();

	nhead.nh_node	= node;
	nhead.nh_event	= EVMTVD;
	nhead.nh_type	= 0;
	nhead.nh_flags	= DINTDATA;
	nhead.nh_length	= 0;
	nhead.nh_msg	= (char *) 0;

	if (nsend(&nhead)) {
		return(ERROR);
	}

	mask = ksigblock(sigmask(SIGUDIE) | sigmask(SIGARREST));
/*
 * Get the reply.
 */
	nhead.nh_event	= -getpid();
	nhead.nh_length	= 0;

	if (nrecv(&nhead)) {
		return(ERROR);
	}

	(void) ksigsetmask(mask);

	if (reply->tvr_ret) {
		errno = reply->tvr_errno;
		return(ERROR);
	}
	else {
		ptvstate->tvs_xlen	= reply->tvr_xlen;
		ptvstate->tvs_ylen	= reply->tvr_ylen;
		ptvstate->tvs_ncolour	= reply->tvr_ncolour;
		ptvstate->tvs_xtext	= reply->tvr_xtext;
		ptvstate->tvs_ytext	= reply->tvr_ytext;
		return(0);
	}
}
