/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	RBD
 *
 *	$Log:	rtvtext.c,v $
 * Revision 2.2  92/04/24  16:32:54  trillium
 * Ohio Release
 * 
 *	Function:	- plot a text string on the graphic screen
 *			- string length (excluding NULL) must be
 *			  strictly smaller than MAXNMSGLEN
 *
 *	Accepts: 	- destination node
 *			- horizontal ordinate of first character
 *			- vertical ordinate of first character
 *			- text colour
 *			- text string
 *
 *	Returns:	- 0 or ERROR
 */

#include <portable.h>
#include <net.h>
#include <events.h>
#include <tvreq.h>
#include <string.h>


int
rtvtext(node, x1, y1, colour, text)

int4			node,
			x1,
			y1,
			colour;
char			*text;

{
	struct nmsg	nhead;		/* message header */
	struct tvreq	*request;	/* ptr to mtvd request */
/*
 * Set up the request message.
 */
 	request = (struct tvreq *) nhead.nh_data;
	request->tvq_req	= TVQTEXT;
	request->tvq_x1		= x1;
	request->tvq_y1		= y1;
	request->tvq_colour	= colour;

	nhead.nh_node	= node;
	nhead.nh_event	= EVMTVD;
	nhead.nh_type	= 0;
	nhead.nh_flags	= DINTDATA;
	nhead.nh_length	= strlen(text) + 1;
	nhead.nh_msg	= text;

	return(nsend(&nhead));
}
