/*
 *	Cornell Theory Center					Trillium
 *
 *	Copyright 1990 Cornell Research Foundation & The Ohio State University
 *
 *	MB
 *
 *	$Log:	bcastcp.c,v $
 * Revision 2.2  92/04/24  16:38:15  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/05/02  14:17:52  gdburns
 * Ohio release
 * 
 * Revision 2.0  90/09/26  12:36:52  gdburns
 * Homo sapien
 * 
 *
 *	CrOS library implementation: bcastcp().
 *
 *	Note: this file to be compiled for OTB usage only.
 *
 *	Bcastcp() does not use a Trollius multicast, to allow
 *	usage while the grid is welded into virtual circuits.
 *	No check is made on the validity of the buffer parameter.
 *
 *	Differences between this implementation and the CrOS
 *	man pages in the book by Fox et al:
 *
 *	- bcastcp() returns once the data is sent out, although
 *		the receivers may not have received it yet.
 *	- no check is made here for data transmission errors.
 */


#include <net.h>
#include <cros.h>

PUBLIC int
/*
bcastcp (char *buffer, int nbytes)
*/
bcastcp (buffer, nbytes)
	char *buffer;
	int nbytes;
{
	struct nmsg nhead;

	nhead.nh_node   = 0;
	nhead.nh_event  = CFROMHOST;
	nhead.nh_type   = CBCASTCP;
	nhead.nh_flags  = 0;
	nhead.nh_msg    = buffer;
	nhead.nh_length = nbytes;
	if (nsend (&nhead) != OK)
		return (-1);

	return (nbytes);
}
