/*
 *	Cornell Theory Center					Trillium
 *
 *	Copyright 1990 Cornell Research Foundation & The Ohio State University
 *
 *	MB
 *
 *	$Log:	combcp.c,v $
 * Revision 2.2  92/04/24  16:38:17  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/05/02  14:17:56  gdburns
 * Ohio release
 * 
 * Revision 2.0  90/09/26  12:36:54  gdburns
 * Homo sapien
 * 
 *
 *	CrOS library implementation: combcp().
 *
 *	Note: this file to be compiled for OTB usage only.
 *
 *	Differences between this implementation and the CrOS
 *	man pages in the book by Fox et al:
 *
 *	- combcp() returns once the data is sent out, although
 *		the receivers may not have received it yet.
 *	- combcp() does not return an error if nitems is too small.
 *	- no check is made here for data transmission errors.
 */


#include <net.h>
#include <cros.h>

PUBLIC int
/*
combcp  (char *buffer, int size, int nitems)
*/
combcp  (buffer, size, nitems)
	char *buffer;
	int size, nitems;
{
	struct nmsg nhead;

	nhead.nh_node   = 0;
	nhead.nh_event  = CTOHOST;
	nhead.nh_type   = (CCOMBCP | CCOMBCPE);
	nhead.nh_flags  = 0;
	nhead.nh_msg    = buffer;
	nhead.nh_length = size * nitems;
	if (nrecv (&nhead) != OK)
		return (-1);

	if (nhead.nh_type == CCOMBCPE)			/* error */
		return (-1);

	if (size == 0)
		return (0);

	return (nhead.nh_length / size);
}
