/*
 *	Cornell Theory Center					Trillium
 *
 *	Copyright 1990 Cornell Research Foundation & The Ohio State University
 *
 *	MB
 *
 *	$Log:	fcwrite.c,v $
 * Revision 2.2  92/04/24  16:38:31  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/05/02  14:18:14  gdburns
 * Ohio release
 * 
 * Revision 2.0  90/09/26  12:37:01  gdburns
 * Homo sapien
 * 
 *
 *	CrOS library implementation: fcread() and fcwrite().
 *
 *	Note: this file to be compiled for OTB usage only.
 *
 *	Differences between this implementation and the CrOS
 *	man pages in the book by Fox et al:
 *
 *	- fcread() does not return an error if the incoming data
 *		is larger than the specified amount, although it
 *		does limit the file output and discards the rest.
 */


#include <net.h>
#include <cros.h>

extern char *malloc();
extern int read();
extern int write();


PUBLIC int
/*
fcread  (int fd, unsigned int inmask, int nbytes)
*/
fcread  (fd, inmask, nbytes)
	int fd;
	unsigned int inmask;
	int nbytes;
{
	char *buffer;

	buffer = malloc ((unsigned) nbytes);
	if (buffer == NULL)
		return (-1);

	nbytes = cread (buffer, inmask, 0, nbytes);
	if (nbytes < 0) {
		free (buffer);
		return (-1);
	}

	if (write (fd, buffer, nbytes) != nbytes)
		nbytes = -1;

	free (buffer);

	return (nbytes);
}


PUBLIC int
/*
fcwrite (int fd, unsigned int outmask, int nbytes)
*/
fcwrite (fd, outmask, nbytes)
	int fd;
	unsigned int outmask;
	int nbytes;
{
	char *buffer;

	buffer = malloc ((unsigned) nbytes);
	if (buffer == NULL)
		return (-1);

	if (read (fd, buffer, nbytes) != nbytes) {
		free (buffer);
		return (-1);
	}

	nbytes = cwrite (buffer, outmask, nbytes);

	free (buffer);

	return (nbytes);
}
