/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: argr864.c,v 2.2 92/04/21 10:54:54 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 *	File:	argr864.c
 *
 *	Implements T800 64 bit floating point argument range reduction
 *	function.
 *
 *	Based on INMOS supplied code.
 */

void
_argr(int *b,int *n,double *x,double y,double z,double z_err)
	{
	#pragma	asm
;
;	int	*b;	/* TRUE if more accurate remainder is done */
;	int	*n;	/* quotient */
;	double	*x;	/* y REM z */
;	double	y;
;	double	z;
;	double z_err;	/* assumed no larger than a last bit error in z */
;
	ajw	-3
	.ldc	0
	ldl	7
	ldnl	1
	.ldc	1
	shl
	.ldc	11
	lshl
	stl	0
	stl	2
	.ldc	0
	ldl	8
	ldnl	1
	.ldc	1
	shl
	.ldc	11
	lshl
	stl	0
	stl	1
	ldl	2
	ldl	1
	sub
	.ldc	20
	gt
	eqc	0
	cj	@L5
	ldl	7
	fpldnldb
	ldl	8
	fpldnldb
	fpremfirst
	eqc	0
	cj	@L2
L1:	fpremstep
	cj	@L1
L2:	fprev
	fpdup
	fprtoi32
	ldl	5
	fpstnli32
	ldl	9
	fpldnlmuldb
	fpadd
	ldl	8
	fpldnldb
	fpremfirst
	eqc	0
	cj	@L4
L3:	fpremstep
	cj	@L3
L4:	ldl	6
	fpstnldb
	j	@L8
L5:	.ldc	0
	ldl	4
	sb
	ldl	8
	ldl	7
	fpldnldb
	fpldnldb
	fpdiv
	fprtoi32
	ldl	5
	fpstnli32
	ldl	8
	ldl	7
	fpldnldb
	fpldnldb
	fpremfirst
	eqc	0
	cj	@L7
L6:	fpremstep
	cj	@L6
L7:	ldl	6
	fpstnldb
L8:	ajw	3
	#pragma	endasm
	}
