/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: floor32.c,v 2.2 92/04/21 10:54:57 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 *	File:	floor32.c
 *
 *	Implements T800/T414 32 bit floating point "floorf(x)/floor(x)".
 *
 *	Copyright 1987, 1988, 1989 by Logical Systems.
 */

#include	<inline.h>
#include	<math.h>
#include	<stddef.h>

#pragma	asm_expand			/* Recognize EDOM/ERANGE in "asm" */

float
floorf(float x)
	{
	#pragma	asm
#ifdef	DOUBLE32
	.pub	floor
floor:
#endif	DOUBLE32

#ifdef	T800
;
;	T800 32 bit version
;
	.ext	errno
	ldlp	[x]
	fpldnlsn
	fpnan				;Input NaN?
	cj	@L1			;Jump if not
	.ldc	EDOM			;Domain error
	_asm_eval1(&errno);
	stnl	0			;Signal "domain" error
	ret
L1	fpurm
	fpint
#else	/* T800 */
;
;	T414 32 bit version
;
#endif	/* T800 */
	#pragma	endasm
	}
