/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: frexp64.c,v 2.2 92/04/21 10:55:01 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 *	File:	frexp64.c
 *
 *	Implements T800/T414 64 bit floating point "frexp()".
 *
 *	Copyright 1988,1989 by Logical Systems.
 */

#include	<inline.h>
#include	<math.h>

double
frexp(double x,int *y)
	{
	#pragma	asm
#ifdef	T800
;
;	T800 64 bit version
;
	ldl	[x]+1			;Get high word of "value"
	mint
	not
	and				;Mask off sign bit
	ldl	[x]			;Get low word of "value"
	or
	eqc	0
	cj	@L1			;Jump if value isn't zero
	.ldc	0
	ldl	[y]			;Get address of "exp"
	stnl	0			;Exponent is zero
	fpldzerodb			;Return zero as result
	ret
L1	ldl	[x]+1			;Get high word of value
	.ldc	20
	shr				;Right justify exponent field
	.ldc	0x7FF
	and				;Mask off everything but exponent
	adc	-1022			;Remove exp bias (remember implied 1)
	ldl	[y]			;Get address of "exp"
	stnl	0			;Return exponent value
	ldl	[x]+1			;Get high word of value
	.ldc	0x800FFFFF
	and				;Remove exponent field
	.ldc	0x3FE00000
	or				;Put "-1" value exponent bias in
	stl	[x]+1
	ldlp	[x]
	fpldnldb			;Load as floating point #
#else	/* T800 */
;
;	T414 64 bit version
;
	.ext	_FPstate
	ldl	[x]+1			;Get high word of "value"
	mint
	not
	and				;Mask off sign bit
	ldl	[x]			;Get low word of "value"
	or
	eqc	0
	cj	@L1			;Jump if value isn't zero
	.ldc	0
	ldl	[y]			;Get address of "exp"
	stnl	0			;Exponent is zero
	.ldc	0
	stl	[x]+1			;Zero out high word in case -0
	j	@L2			;Return zero as result
L1	ldl	[x]+1			;Get high word of value
	.ldc	20
	shr				;Right justify exponent field
	.ldc	0x7FF
	and				;Mask off everything but exponent
	adc	-1022			;Remove exp bias (remember implied 1)
	ldl	[y]			;Get address of "exp"
	stnl	0			;Return exponent value
	ldl	[x]+1			;Get high word of value
	.ldc	0x800FFFFF
	and				;Remove exponent field
	.ldc	0x3FE00000
	or				;Put "-1" value exponent bias in
	stl	[x]+1
L2	ldlp	[x]
	.ldc	_FPstate		;Destination (FAreg)
	.ldc	8
	move
#endif	/* T800 */
	#pragma	endasm
	}
