/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: ldexp32.c,v 2.2 92/04/21 10:55:01 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 *	File:	ldexp32.c
 *
 *	Implements T800/T414 32 bit floating point "ldexpf(x,y)/ldexp(x,y)".
 *
 *	Copyright 1988,1989 by Logical Systems.
 */

#include	<inline.h>
#include	<math.h>
#include	<stddef.h>

#pragma	asm_expand			/* Recognize EDOM/ERANGE in "asm" */

float
ldexpf(float x,int y)
	{
	#pragma	asm
#ifdef	DOUBLE32
	.pub	ldexp
ldexp:
#endif	DOUBLE32

#ifdef	T800
;
;	T800 32 bit version
;
	.ext	errno
	ldl	[x]			;Get "x"
	mint
	not
	and				;Mask off sign bit
	eqc	0
	cj	@L1			;Jump if value isn't zero
	fpldzerosn			;Otherwise return zero as result
	ret
L1	ldl	[x]			;Get value
	.ldc	23
	shr				;Right justify exponent field
	.ldc	0xFF
	and				;Mask off everything but exponent
	ldl	[y]			;Get exponent modifier
	add
	dup				;Save a copy of prototype exponent
	.ldc	0
	gt
	cj	@L2			;Jump if exponent <= 0
	dup				;Save a copy of prototype exponent
	.ldc	254
	gt
	cj	@L3			;Jump if 0 < exponent < 255
L2	.ldc	undefined
	fpldnlsn			;Load "undefined" NaN
	.ldc	ERANGE
	_asm_eval1(&errno);
	stnl	0
	ret
	.align
undefined
	.dw	0x7F800010		;"undefined" NaN
L3	add				;Remove 0 from stack top
	.ldc	23
	shl				;Position future exponent field
	ldl	[x]			;Get original #
	.ldc	0x807FFFFF
	and				;Mask off original exponent
	or				;Mask in new exponent
	stl	[x]
	ldlp	[x]
	fpldnlsn			;Load resulting value
#else	/* T800 */
;
;	T414 32 bit version
;
	.ext	?SN32TOFAREG
	.ext	errno
	ldl	[x]			;Get "x"
	mint
	not
	and				;Mask off sign bit
	eqc	0
	cj	@L1			;Jump if value isn't zero
	.ldc	0
	.ldc	0
	cj	@L4			;Otherwise return zero as result
L1	ldl	[x]			;Get value
	.ldc	23
	shr				;Right justify exponent field
	.ldc	0xFF
	and				;Mask off everything but exponent
	ldl	[y]			;Get exponent modifier
	add
	stl	[y]
	ldl	[y]			;Save a copy of prototype exponent
	.ldc	0
	gt
	cj	@L2			;Jump if exponent <= 0
	ldl	[y]
	ldl	[y]			;Two copies of prototype exponent
	.ldc	254
	gt
	cj	@L3			;Jump if 0 < exponent < 255
L2	.ldc	ERANGE
	_asm_eval1(&errno);
	stnl	0
	.ldc	0x7F800010		;"undefined" NaN
	.ldc	0
	cj	@L4			;Return "undefined" NaN as result
L3	add				;Remove 0 from stack top
	.ldc	23
	shl				;Position future exponent field
	ldl	[x]			;Get original #
	.ldc	0x807FFFFF
	and				;Mask off original exponent
	or				;Mask in new exponent
	.ldc	0
L4	stl	[x]			;Toss A, put result in A
	call	@?SN32TOFAREG		;Store 32 bit fp in A into FAreg
#endif	/* T800 */
	#pragma	endasm
	}
