/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: modf32.c,v 2.2 92/04/21 10:55:02 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 *	File:	modf32.c
 *
 *	Implements T800/T414 32 bit floating point "modff(x,y)/modf(x,y)".
 *
 *	Copyright 1987, 1988, 1989 by Logical Systems.
 */

#include	<inline.h>
#include	<math.h>

float
modff(float x,float *y)
	{
	#pragma	asm
#ifdef	DOUBLE32
	.pub	modf
modf:
#endif	DOUBLE32

#ifdef	T800
;
;	T800 32 bit version
;
	ldlp	[x]			;Get address of "value"
	fpldnlsn			;Load value
	fpdup				;Save a copy
	fpurz				;Round towards zero
	fpint				;Compute integer part
	fpdup				;Save a copy
	ldl	[y]			;Get address of "iptr"
	fpstnlsn			;Store integral component
	fpsub				;Compute fractional component
#else	/* T800 */
;
;	T414 32 bit version
;
#endif	/* T800 */
	#pragma	endasm
	}
