/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: t800misc.c,v 2.2 92/04/21 10:55:06 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 *	t800misc.c
 *
 *	Miscellaneous primitives for the T800 Transputer.
 *
 *	Copyright 1988, 1989 by Logical Systems
 */

#include	<inline.h>
#include	<conc.h>

/*
 *	# of 1 bits in a word.
 */

#undef	BitCnt

int
BitCnt(int w)
	{
	#pragma	asm
	.ldc	0
	ldl	[w]
	bitcnt
	#pragma endasm
	}

/*
 *	Reverse the bit pattern in the low "n" bits in a word.
 */

#undef	BitRevNBits

int
BitRevNBits(int n,int w)
	{
	#pragma asm
	ldl	[w]
	ldl	[n]
	bitrevnbits
	#pragma endasm
	}

/*
 *	Reverse the bit pattern in a word.
 */

#undef	BitRevWord

int
BitRevWord(int w)
	{
	#pragma asm
	ldl	[w]
	bitrevword
	#pragma endasm
	}

/*
 *	Two dimensional block move using T800 "move2dall" instruction.
 */

#undef	Move2D

void
Move2D(void *sa,void *da,int w,int l,int ss,int ds)
	{
	#pragma	asm
	ldl	[ss]		;Source stride (width of big src array)
	ldl	[ds]		;Destination stride (width of big dst array)
	ldl	[l]		;Length of rectangle to be moved
	move2dinit
	ldl	[sa]		;Source address (addr of 1st byte moved)
	ldl	[da]		;Destination address (addr of 1st byte moved)
	ldl	[w]		;Width of rectangle to be moved
	move2dall
	#pragma	endasm
	}

/*
 *	Two dimensional block move (non-zero bytes only), using T800
 *	"move2nonzero" instruction.
 */

#undef	Move2DNonZero

void
Move2DNonZero(void *sa,void *da,int w,int l,int ss,int ds)
	{
	#pragma	asm
	ldl	[ss]		;Source stride (width of big src array)
	ldl	[ds]		;Destination stride (width of big dst array)
	ldl	[l]		;Length of rectangle to be moved
	move2dinit
	ldl	[sa]		;Source address (addr of 1st byte moved)
	ldl	[da]		;Destination address (addr of 1st byte moved)
	ldl	[w]		;Width of rectangle to be moved
	move2dnonzero
	#pragma	endasm
	}

/*
 *	Two dimensional block move (zero bytes only), using T800
 *	"move2zero" instruction.
 */

#undef	Move2DZero

void
Move2DZero(void *sa,void *da,int w,int l,int ss,int ds)
	{
	#pragma	asm
	ldl	[ss]		;Source stride (width of big src array)
	ldl	[ds]		;Destination stride (width of big dst array)
	ldl	[l]		;Length of rectangle to be moved
	move2dinit
	ldl	[sa]		;Source address (addr of 1st byte moved)
	ldl	[da]		;Destination address (addr of 1st byte moved)
	ldl	[w]		;Width of rectangle to be moved
	move2dzero
	#pragma	endasm
	}
