/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	K&R/GDB/MB
 *
 *	$Log:	itoa.c,v $
 * Revision 2.2  92/04/21  10:58:40  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.2  91/06/10  22:17:13  raja
 * Changed the function back to return nothing.
 * 
 * Revision 2.1.1.1  91/06/04  17:56:29  raja
 * Forced the precedence rules in the loop termination expression.
 * The function returns a pointer to the string formed.
 * 
 * Revision 2.1  91/03/20  13:28:04  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:38:02  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  12:00:50  trillium
 * Homo erectus
 *
 *	Function:	- homegrown itoa()
 *			- based on Trollius 2.0 Copyright 1990
 *			  The Ohio State University and Cornell
 *			  Research Foundation
 */

void
itoa(n, s)
	char	*s;
	int	n;
{
	char		sbuf[16];
	register char	*p;
	register unsigned int u;

	p = sbuf;
	if ( n < 0 ) {
		u = (unsigned)(-n);	/* make n positive */
		*s++ = '-';		/* record sign */
	} else {
		u = (unsigned) n;
	}
	do {				/* generate digits in reverse order */
		*p++ = (u % 10) + '0';
	} while (( u /= 10) > 0);
	while (p > sbuf)		/* copy digits in right order */
		*s++ = *--p;
	*s = '\0';
}
