/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: memccpy.c,v 2.2 92/04/21 10:58:40 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 *	memccpy - copy bytes up to a certain char
 *
 *	CHARBITS should be defined only if the compiler lacks "unsigned char".
 *	It should be a mask, e.g. 0377 for an 8-bit machine.
 */

#include	<string.h>

#ifndef CHARBITS
#	define	UNSCHAR(c)	((unsigned char)(c))
#else
#	define	UNSCHAR(c)	((c)&CHARBITS)
#endif

void	*
memccpy(dst, src, ucharstop, size)
	void	*dst;
	const	void	*src;
	int	ucharstop;
	size_t	size;
	{
	register char	*d;
	register const	char	*s;
	register size_t	n;
	register int	uc;

	s = src;
	d = dst;
	uc = UNSCHAR(ucharstop);
	for(n = size; n > 0; n--)
		if(UNSCHAR(*d++ = *s++) == uc)
			return(d);

	return(NULL);
	}
