/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: memchr.c,v 2.2 92/04/21 10:58:41 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 *	memchr - search for a byte
 *
 *	CHARBITS should be defined only if the compiler lacks "unsigned char".
 *	It should be a mask, e.g. 0377 for an 8-bit machine.
 */

#include	<string.h>

#ifndef CHARBITS
#	define	UNSCHAR(c)	((unsigned char)(c))
#else
#	define	UNSCHAR(c)	((c)&CHARBITS)
#endif

void	*
memchr(s, ucharwanted, size)
	const	void	*s;
	int	ucharwanted;
	size_t	size;
	{
	register const	char	*scan;
	register size_t	n;
	register int	uc;

	scan = s;
	uc = UNSCHAR(ucharwanted);
	for(n = size; n > 0; n--)
		if(UNSCHAR(*scan) == uc)
			return(scan);
		else
			scan++;

	return(NULL);
	}
