/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: memmove.c,v 2.2 92/04/21 10:58:42 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 *	memmove - equivalent to memcpy but works for overlapping memory
 *	regions.
 */

#include	<string.h>

void	*
memmove(dst, src, size)
	void	*dst;
	const	void	*src;
	size_t	size;
	{
	register char	*d;
	register const	char	*s;
	register size_t	n;

	if(size == 0)
		return(dst);

	s = src;
	d = dst;
	if(s <= d && s + (size-1) >= d)
		{
		/* Overlap, must copy right-to-left. */
		s += size-1;
		d += size-1;
		for(n = size; n > 0; n--)
			*d-- = *s--;
		}
	else	for(n = size; n > 0; n--)
			*d++ = *s++;

	return(dst);
	}
