/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: memset.c,v 2.2 92/04/21 10:58:43 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 *	memset - set bytes
 *
 *	CHARBITS should be defined only if the compiler lacks "unsigned char".
 *	It should be a mask, e.g. 0377 for an 8-bit machine.
 */

#include	<string.h>

#ifndef CHARBITS
#	define	UNSCHAR(c)	((unsigned char)(c))
#else
#	define	UNSCHAR(c)	((c)&CHARBITS)
#endif

void	*
memset(s, ucharfill, size)
	void	*s;
	register int	ucharfill;
	size_t	size;
	{
	register const	char	*scan;
	register size_t	n;
	register int	uc;

	scan = s;
	uc = UNSCHAR(ucharfill);
	for(n = size; n > 0; n--)
		*scan++ = uc;

	return(s);
	}
