/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: strcpy.c,v 2.2 92/04/21 10:58:46 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 *	strcpy - copy string src to dst
 *
 *	Assembly language version copyright 1988, 1989 by Logical Systems
 */

#include	<inline.h>
#include	<string.h>

char	*			/* dst */
strcpy(char *dst, const char *src)
	{
#ifndef	ISTC
	register char	*dscan;
	register const	char	*sscan;

	dscan = dst;
	sscan = src;
	while((*dscan++ = *sscan++) != '\0')
		continue;
	return(dst);
#else	/* ISTC */
#ifdef	STATIC_LINK
	#pragma	asm
	ldl	[src]
	stl	1			;Temp for holding roving source pointer
loop
	ldl	1			;Address of current probe
#ifdef	T800
	dup				;Dup stack top
#else
	ldl	1			;Get a copy
#endif	/* T800 */
	adc	1			;Advance src pointer
	stl	1			;Updated probe
	lb				;Get byte being probed
	cj	@found			;If done
	ldl	1			;Address of current probe
#ifdef	T800
	dup				;Dup stack top
#else
	ldl	1			;Get a copy
#endif	/* T800 */
	adc	1			;Advance src pointer
	stl	1			;Updated probe
	lb				;Get byte being probed
	cj	@found			;If done
	ldl	1			;Address of current probe
#ifdef	T800
	dup				;Dup stack top
#else
	ldl	1			;Get a copy
#endif	/* T800 */
	adc	1			;Advance src pointer
	stl	1			;Updated probe
	lb				;Get byte being probed
	cj	@found			;If done
	j	@loop			;Check next byte
found
	ldl	[src]			;Original source
	ldl	1			;Get src probe pointer
	ldl	[src]			;Original source
	diff				;Compute # of bytes to move
	ldl	[dst]
	rev				;Setup parameter order for move
	move
	ldl	[dst]			;Return destination pointer
	#pragma	endasm
#else	/* !STATIC_LINK */
	#pragma	asm
	ldl	[src]
	stl	3			;Temp for holding roving source pointer
loop
	ldl	3			;Address of current probe
#ifdef	T800
	dup				;Dup stack top
#else
	ldl	3			;Get a copy
#endif	/* T800 */
	adc	1			;Advance src pointer
	stl	3			;Updated probe
	lb				;Get byte being probed
	cj	@found			;If done
	ldl	3			;Address of current probe
#ifdef	T800
	dup				;Dup stack top
#else
	ldl	3			;Get a copy
#endif	/* T800 */
	adc	1			;Advance src pointer
	stl	3			;Updated probe
	lb				;Get byte being probed
	cj	@found			;If done
	ldl	3			;Address of current probe
#ifdef	T800
	dup				;Dup stack top
#else
	ldl	3			;Get a copy
#endif	/* T800 */
	adc	1			;Advance src pointer
	stl	3			;Updated probe
	lb				;Get byte being probed
	cj	@found			;If done
	j	@loop			;Check next byte
found
	ldl	[src]			;Original source
	ldl	3			;Get src probe pointer
	ldl	[src]			;Original source
	diff				;Compute # of bytes to move
	ldl	[dst]
	rev				;Setup parameter order for move
	move
	ldl	[dst]			;Return destination pointer
	#pragma	endasm
#endif	/* STATIC_LINK */
#endif	/* !ISTC */
	}
