/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: atan32.c,v 2.2 92/04/21 11:01:42 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 *	File:	atan32.c
 *
 *	Implements T800/T414 32 bit floating point "atanf(x)/atan(x)".
 *
 *	Based on INMOS supplied code.  Modified by Logical Systems for correct
 *	ANSI "C" setting of "errno" in ERANGE/EDOM situations.
 */

#include	<inline.h>
#include	<math.h>
#include	<stddef.h>

#pragma	asm_expand			/* Recognize EDOM/ERANGE in "asm" */

float
atanf(float x)
	{
	#pragma	asm
#ifdef	DOUBLE32
	.pub	atan
atan:
#endif	DOUBLE32

#ifdef	T800
;
;	T800 32 bit version
;
	.ext	errno
	_asm_ajw(-7);
	.ldc	data1
	stl	6
	.ldc	0
	stl	5
	.ldc	0
	stl	4
	fpldzerosn
	ldlp	[x]
	fpldnlsn
	fpgt
	stl	4
	ldlp	[x]
	fpldnlsn
	fpnan
	stl	5
	ldlp	[x]
	fpldnlsn
	fpuabs
	ldlp	2
	fpstnlsn
	ldl	5
	cj	@L7
	ldl	[x]
	stl	3
	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L16
	.align
data1:	.dw	0x4b800000
	.dw	0xbfc90fdb
	.dw	0x3fc90fdb
	.dw	0x3f800000
	.dw	0x39800000
L7:	ldlp	2
	fpldnlsn
	ldl	6
	fpldnlsn
	fpgt
	cj	@L10
	ldl	4
	cj	@L8
	ldl	6
	ldnl	1
	stl	3
	j	@L9
L8:	ldl	6
	ldnl	2
	stl	3
L9:	j	@L16
L10:	ldlp	2
	fpldnlsn
	ldl	6
	ldnlp	3
	fpldnlsn
	fpgt
	cj	@L13
	ldlp	2
	ldl	6
	ldnlp	3
	fpldnlsn
	fpldnlsn
	fpdiv
	ldlp	0
	fpstnlsn
	ldl	0
	ldlp	1
	call	@rtan
	ldl	4
	cj	@L11
	ldl	6
	ldnlp	2
	ldlp	1
	fpldnlsn
	fpldnlsn
	fpsub
	ldlp	3
	fpstnlsn
	j	@L12
L11:	ldlp	1
	ldl	6
	ldnlp	2
	fpldnlsn
	fpldnlsn
	fpsub
	ldlp	3
	fpstnlsn
L12:	j	@L16
L13:	ldl	6
	ldnlp	4
	fpldnlsn
	ldlp	2
	fpldnlsn
	fpgt
	cj	@L14
	ldl	[x]
	stl	3
	j	@L16
L14:	ldl	2
	ldlp	1
	call	@rtan
	ldl	4
	cj	@L15
	fpldzerosn
	ldlp	1
	fpldnlsn
	fpsub
	ldlp	3
	fpstnlsn
	j	@L16
L15:	ldl	1
	stl	3
L16:	ldlp	3
	fpldnlsn
	_asm_ajw(7);
	ret

; void rtan(r, x)
; float *r;
; float x;
	.align
	.dw	0x3e8930a3
	.dw	0x3f3b67af
	.dw	0x3f000000
	.dw	0x3fddb3d8
	.dw	0x39800000
	.dw	0xbd508691
	.dw	0xbef110f6
	.dw	0x3fb4ccd4
	.dw	0x3f060a92
rtan:	ajw	-4
	.ldc	-42
	ldpi
	stl	7
	.ldc	0
	stl	3
	ldlp	6
	fpldnlsn
	ldl	7
	fpldnlsn
	fpgt
	cj	@L1
	.ldc	1
	stl	3
	ldl	7
	ldnlp	1
	ldlp	6
	fpldnlsn
	fpldnlmulsn
	ldl	7
	ldnlp	2
	fpldnlsn
	fpsub
	ldl	7
	ldnlp	2
	fpldnlsn
	fpsub
	ldlp	6
	fpldnladdsn
	ldl	7
	ldnlp	3
	ldlp	6
	fpldnlsn
	fpldnladdsn
	fpdiv
	ldlp	2
	fpstnlsn
	j	@L2
L1:	.ldc	0
	stl	3
	ldl	6
	stl	2
L2:	ldlp	2
	fpldnlsn
	fpuabs
	ldlp	1
	fpstnlsn
	ldl	7
	ldnlp	4
	fpldnlsn
	ldlp	1
	fpldnlsn
	fpgt
	cj	@L3
	ldl	2
	stl	1
	j	@L4
L3:	ldlp	2
	ldlp	2
	fpldnlsn
	fpldnlmulsn
	ldlp	0
	fpstnlsn
	ldl	7
	ldnlp	5
	ldlp	0
	fpldnlsn
	fpldnlmulsn
	ldl	7
	ldnlp	6
	fpldnladdsn
	ldlp	0
	fpldnlmulsn
	ldlp	0
	ldl	7
	ldnlp	7
	fpldnlsn
	fpldnladdsn
	fpdiv
	ldlp	2
	fpldnlmulsn
	ldlp	2
	fpldnladdsn
	ldlp	1
	fpstnlsn
L4:	ldl	3
	cj	@L5
	ldlp	1
	ldl	7
	ldnlp	8
	fpldnlsn
	fpldnladdsn
	ldl	5
	fpstnlsn
	j	@L6
L5:	ldl	1
	ldl	5
	stnl	0
L6:	ajw	4
#else	/* T800 */
;
;	T414 32 bit version
;
#endif	/* T800 */
	#pragma	endasm
	}
