/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: atan64.c,v 2.2 92/04/21 11:01:43 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 *	File:	atan64.c
 *
 *	Implements T800/T414 64 bit floating point "atan(x)".
 *
 *	Based on INMOS supplied code.  Modified by Logical Systems for correct
 *	ANSI "C" setting of "errno" in ERANGE/EDOM situations.
 */

#include	<inline.h>
#include	<math.h>
#include	<stddef.h>

#pragma	asm_expand			/* Recognize EDOM/ERANGE in "asm" */

double
atan(double x)
	{
	#pragma	asm
#ifdef	T800
;
;	T800 64 bit version
;
	.ext	errno
	_asm_ajw(-11)
	.ldc	data
	stl	10
	.ldc	0
	stl	5
	fpldzerodb
	ldlp	[x]
	fpldnldb
	fpgt
	stl	5
	.ldc	0
	stl	4
	ldlp	[x]
	fpldnldb
	fpnan
	stl	4
	ldlp	[x]
	fpldnldb
	fpuabs
	ldlp	8
	fpstnldb
	ldl	4
	cj	@L7
	ldlp	[x]
	ldlp	6
	.ldc	8
	move
	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L16
	.align
data:	.dw	0x00000000
	.dw	0x43400000
	.dw	0x54442d18
	.dw	0xbff921fb
	.dw	0x54442d18
	.dw	0x3ff921fb
	.dw	0x00000000
	.dw	0x3ff00000
	.dw	0x00000000
	.dw	0x3e500000
L7:	ldlp	8
	fpldnldb
	ldl	10
	fpldnldb
	fpgt
	cj	@L10
	ldl	5
	cj	@L8
	ldl	10
	ldnlp	2
	ldlp	6
	.ldc	8
	move
	j	@L9
L8:	ldl	10
	ldnlp	4
	ldlp	6
	.ldc	8
	move
L9:	j	@L16
L10:	ldlp	8
	fpldnldb
	ldl	10
	ldnlp	6
	fpldnldb
	fpgt
	cj	@L13
	ldlp	8
	ldl	10
	ldnlp	6
	fpldnldb
	fpldnldb
	fpdiv
	ldlp	0
	fpstnldb
	ldlp	0
	ldlp	2
	call	@rtan
	ldl	5
	cj	@L11
	ldl	10
	ldnlp	4
	ldlp	2
	fpldnldb
	fpldnldb
	fpsub
	ldlp	6
	fpstnldb
	j	@L12
L11:	ldlp	2
	ldl	10
	ldnlp	4
	fpldnldb
	fpldnldb
	fpsub
	ldlp	6
	fpstnldb
L12:	j	@L16
L13:	ldl	10
	ldnlp	8
	fpldnldb
	ldlp	8
	fpldnldb
	fpgt
	cj	@L14
	ldlp	[x]
	ldlp	6
	.ldc	8
	move
	j	@L16
L14:	ldlp	8
	ldlp	2
	call	@rtan
	ldl	5
	cj	@L15
	fpldzerodb
	ldlp	2
	fpldnldb
	fpsub
	ldlp	6
	fpstnldb
	j	@L16
L15:	ldl	2
	stl	6
	ldl	3
	stl	7
L16:	ldlp	6
	fpldnldb
	_asm_ajw(11)
	ret
;
;	void rtan(r, x)
;	double *r;
;	double *x;
;
	.align
	.dw	0x5e9ecd56
	.dw	0x3fd12614
	.dw	0xd0b09955
	.dw	0x3fe76cf5
	.dw	0x00000000
	.dw	0x3fe00000
	.dw	0xe8584cab
	.dw	0x3ffbb67a
	.dw	0x00000000
	.dw	0x3e500000
	.dw	0xd9b187be
	.dw	0xbfeacd7a
	.dw	0x5c8d6a64
	.dw	0xc020fd3f
	.dw	0xb9e2bccb
	.dw	0xc034817f
	.dw	0x51061ce2
	.dw	0xc02b60a6
	.dw	0xe14ac711
	.dw	0x402e0c49
	.dw	0x320da3d7
	.dw	0x404dca0a
	.dw	0x040b6da5
	.dw	0x40558a12
	.dw	0xbcc495aa
	.dw	0x4044887c
	.dw	0x382d7366
	.dw	0x3fe0c152
rtan:	ajw	-7
	.ldc	-118
	ldpi
	stl	10
	.ldc	0
	stl	4
	ldl	9
	fpldnldb
	ldl	10
	fpldnldb
	fpgt
	cj	@L1
	.ldc	1
	stl	4
	ldl	10
	ldnlp	2
	ldl	9
	fpldnldb
	fpldnlmuldb
	ldl	10
	ldnlp	4
	fpldnldb
	fpsub
	ldl	10
	ldnlp	4
	fpldnldb
	fpsub
	ldl	9
	fpldnladddb
	ldl	10
	ldnlp	6
	ldl	9
	fpldnldb
	fpldnladddb
	fpdiv
	ldlp	5
	fpstnldb
	j	@L2
L1:	.ldc	0
	stl	4
	ldl	9
	ldlp	5
	.ldc	8
	move
L2:	ldlp	5
	fpldnldb
	fpuabs
	ldlp	2
	fpstnldb
	ldl	10
	ldnlp	8
	fpldnldb
	ldlp	2
	fpldnldb
	fpgt
	cj	@L3
	ldl	5
	stl	2
	ldl	6
	stl	3
	j	@L4
L3:	ldlp	5
	ldlp	5
	fpldnldb
	fpldnlmuldb
	ldlp	0
	fpstnldb
	ldl	10
	ldnlp	10
	ldlp	0
	fpldnldb
	fpldnlmuldb
	ldl	10
	ldnlp	12
	fpldnladddb
	ldlp	0
	fpldnlmuldb
	ldl	10
	ldnlp	14
	fpldnladddb
	ldlp	0
	fpldnlmuldb
	ldl	10
	ldnlp	16
	fpldnladddb
	ldlp	0
	fpldnlmuldb
	ldlp	0
	ldl	10
	ldnlp	18
	fpldnldb
	fpldnladddb
	ldlp	0
	fpldnlmuldb
	ldl	10
	ldnlp	20
	fpldnladddb
	ldlp	0
	fpldnlmuldb
	ldl	10
	ldnlp	22
	fpldnladddb
	ldlp	0
	fpldnlmuldb
	ldl	10
	ldnlp	24
	fpldnladddb
	fpdiv
	ldlp	5
	fpldnlmuldb
	ldlp	5
	fpldnladddb
	ldlp	2
	fpstnldb
L4:	ldl	4
	cj	@L5
	ldlp	2
	ldl	10
	ldnlp	26
	fpldnldb
	fpldnladddb
	ldl	8
	fpstnldb
	j	@L6
L5:	ldlp	2
	ldl	8
	.ldc	8
	move
L6:	ajw	7
	ret
#else	/* T800 */
;
;	T414 64 bit version (from D700D).  NO attempt is made here to optimize
;	the OCCAM generated code (for example see lines after label "L11", hope
;	to get to this someday...)
;
	.ext	errno
	.ext	_fdiv64
	.ext	_FPstate
	.ext	_iexp64
	.ext	_fix64
	.ext	_fmul64
	.ext	_refl64
	.ext	_r64op
	_asm_ajw(-15)
	.ldc	data1
	stl	14
	ldlp	[x]
	ldlp	10
	.ldc	8
	move
	.ldc	0
	stl	9
	.ldc	0
	ldl	11
	gt
	stl	9
	ldl	10
	stl	7
	ldl	11
	.ldc	2147483647
	and
	stl	8
	ldl	8
	.ldc	2146435072
	gt
	eqc	0
	cj	@L11
	ldl	8
	.ldc	2146435072
	diff
	eqc	0
	cj	@L10
	ldl	7
	mint
	xor
	mint
	gt
L10:	eqc	0
L11:	eqc	0
	cj	@L12
	ldl	10
	stl	5
	ldl	11
	stl	6
	ldl	5
	stl	12
	ldl	6
	stl	13
	.ldc	EDOM			;Domain error (input is Inf/NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L27
	.align
data1:	.dw	0x54442d18
	.dw	0xbff921fb
	.dw	0x54442d18
	.dw	0x3ff921fb
	.dw	0x00000000
	.dw	0x3ff00000
	.dw	0x33145c07
	.dw	0x3c91a626
	.dw	0x00000000
	.dw	0x00000000
L12:	ldl	8
	.ldc	1128267776
	gt
	eqc	0
	cj	@L14
	ldl	8
	.ldc	1128267776
	diff
	eqc	0
	cj	@L13
	ldl	7
	mint
	xor
	mint
	gt
L13:	eqc	0
L14:	eqc	0
	cj	@L17
	ldl	9
	cj	@L15
	ldl	14
	ldlp	12
	.ldc	8
	move
	j	@L16
L15:	ldl	14
	ldnlp	2
	ldlp	12
	.ldc	8
	move
L16:	j	@L27
L17:	ldl	8
	.ldc	1072693248
	gt
	eqc	0
	cj	@L19
	ldl	8
	.ldc	1072693248
	diff
	eqc	0
	cj	@L18
	ldl	7
	mint
	xor
	mint
	gt
L18:	eqc	0
L19:	eqc	0
	cj	@L22
	ldl	7
	stl	5
	ldl	8
	stl	6
	ldl	9
	cj	@L20
	ldlp	5
	stl	0
	.ldc	3
	ldl	14
	ldnlp	4
	ldlp	3
	call	@_r64op
	ldlp	3
	ldlp	1
	call	@P1
	ldl	14
	ldnlp	6
	stl	0
	.ldc	1
	ldlp	1
	ldlp	3
	call	@_r64op
	ldl	14
	ldnlp	2
	stl	0
	.ldc	1
	ldlp	3
	ldlp	12
	call	@_r64op
	j	@L21
L20:	ldlp	5
	stl	0
	.ldc	3
	ldl	14
	ldnlp	4
	ldlp	3
	call	@_r64op
	ldlp	3
	ldlp	1
	call	@P1
	ldlp	1
	stl	0
	.ldc	1
	ldl	14
	ldnlp	6
	ldlp	3
	call	@_r64op
	ldlp	3
	stl	0
	.ldc	0
	ldl	14
	ldnlp	2
	ldlp	12
	call	@_r64op
L21:	j	@L27
L22:	.ldc	1045430272
	ldl	8
	gt
	eqc	0
	cj	@L24
	.ldc	1045430272
	ldl	8
	diff
	eqc	0
	cj	@L23
	mint
	ldl	7
	mint
	xor
	gt
L23:	eqc	0
L24:	eqc	0
	cj	@L25
	ldl	10
	stl	5
	ldl	11
	stl	6
	ldl	5
	stl	12
	ldl	6
	stl	13
	j	@L27
L25:	ldl	9
	cj	@L26
	ldl	7
	stl	5
	ldl	8
	stl	6
	ldlp	5
	ldlp	3
	call	@P1
	ldlp	3
	stl	0
	.ldc	1
	ldl	14
	ldnlp	8
	ldlp	12
	call	@_r64op
	j	@L27
L26:	ldl	7
	stl	5
	ldl	8
	stl	6
	ldlp	5
	ldlp	12
	call	@P1
L27:	ldlp	12
	.ldc	_FPstate		;Addr of "soft" FAreg
	.ldc	8
	move
	_asm_ajw(15)
	ret

	.align
data2:	.dw	0x6132a9cf
	.dw	0x6ed9eba1
	.dw	0x2ff3f578
	.dw	0xf9a5162d
	.dw	0x00000000
	.dw	0x04000000
	.dw	0x382d7366
	.dw	0x3fe0c152
P1:	ajw	-22
	.ldc	data2
	stl	25
	ldl	24
	ldlp	18
	.ldc	8
	move
	.ldc	0
	stl	13
	ldl	19
	.ldc	1070671380
	gt
	eqc	0
	cj	@L2
	ldl	19
	.ldc	1070671380
	diff
	eqc	0
	cj	@L1
	ldl	18
	mint
	xor
	.ldc	-560018090
	gt
L1:	eqc	0
L2:	eqc	0
	cj	@L3
	.ldc	-1
	ldl	24
	ldlp	11
	call	@_iexp64
	ldlp	11
	ldlp	16
	call	@_fix64
	ldlp	16
	ldl	25
	ldlp	9
	call	@_fmul64
	ldl	9
	stl	7
	.ldc	0
	ldl	10
	.ldc	536870912
	lsub
	stl	8
	ldlp	7
	stl	6
	ldl	17
	ldl	16
	.ldc	1
	lshr
	stl	9
	stl	10
	.ldc	0
	ldl	9
	.ldc	-1332128537
	lsum
	stl	4
	ldl	10
	.ldc	929887696
	ladd
	stl	5
	ldlp	4
	ldl	6
	ldlp	11
	call	@_fdiv64
	ldl	11
	stl	16
	ldl	12
	stl	17
	ldlp	16
	ldlp	14
	call	@_refl64
	.ldc	1
	stl	13
	j	@L4
L3:	ldl	18
	stl	11
	ldl	19
	stl	12
	ldlp	11
	ldlp	16
	call	@_fix64
	ldl	11
	stl	14
	ldl	12
	stl	15
	.ldc	0
	stl	13
L4:	ldlp	14
	stl	12
	ldl	12
	ldnl	0
	stl	10
	ldl	12
	ldnl	1
	.ldc	2147483647
	and
	stl	11
	.ldc	1045430272
	ldl	11
	gt
	eqc	0
	cj	@L6
	.ldc	1045430272
	ldl	11
	diff
	eqc	0
	cj	@L5
	mint
	ldl	10
	mint
	xor
	gt
L5:	eqc	0
L6:	eqc	0
	cj	@L7
	ldl	12
	stl	11
	ldl	11
	ldlp	20
	.ldc	8
	move
	j	@L8
L7:	ldlp	16
	ldlp	16
	ldlp	11
	call	@_fmul64
	ldl	25
	ldnlp	2
	ldlp	11
	ldlp	7
	call	@_fmul64
	.ldc	0
	ldl	7
	.ldc	812742942
	lsum
	stl	3
	ldl	8
	.ldc	-573706948
	ladd
	stl	4
	ldlp	3
	ldlp	11
	ldlp	5
	call	@_fmul64
	.ldc	0
	ldl	5
	.ldc	-529622612
	lsum
	stl	3
	ldl	6
	.ldc	-573690422
	ladd
	stl	4
	ldlp	3
	ldlp	11
	ldlp	7
	call	@_fmul64
	ldl	25
	ldnlp	4
	ldlp	11
	ldlp	5
	call	@_fmul64
	.ldc	0
	ldl	5
	.ldc	-285139919
	lsum
	stl	1
	ldl	6
	.ldc	617260193
	ladd
	stl	2
	ldlp	1
	ldlp	11
	ldlp	3
	call	@_fmul64
	.ldc	0
	ldl	3
	.ldc	-1485662034
	lsum
	stl	1
	ldl	4
	.ldc	1376881800
	ladd
	stl	2
	ldlp	1
	ldlp	11
	ldlp	5
	call	@_fmul64
	.ldc	0
	ldl	5
	.ldc	-1351680382
	lsum
	stl	3
	ldl	6
	.ldc	860535631
	ladd
	stl	4
	ldlp	3
	ldlp	7
	ldlp	9
	call	@_fdiv64
	ldl	10
	ldl	9
	.ldc	1
	lshr
	stl	5
	stl	6
	.ldc	0
	stl	3
	ldl	10
	mint
	and
	stl	4
	ldl	5
	ldl	3
	or
	stl	1
	ldl	6
	ldl	4
	or
	stl	2
	ldlp	1
	ldlp	7
	call	@_refl64
	ldlp	14
	stl	0
	.ldc	2
	ldlp	7
	ldlp	5
	call	@_r64op
	ldlp	14
	stl	0
	.ldc	0
	ldlp	5
	ldlp	20
	call	@_r64op
L8:	ldl	13
	cj	@L9
	ldl	25
	ldnlp	6
	stl	0
	.ldc	0
	ldlp	20
	ldlp	11
	call	@_r64op
	ldl	11
	stl	20
	ldl	12
	stl	21
L9:	ldlp	20
	ldl	23
	.ldc	8
	move
	ajw	22
	ret
#endif	/* T800 */
	#pragma	endasm
	}
