/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: cosh32.c,v 2.2 92/04/21 11:01:46 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 *	File:	cosh32.c
 *
 *	Implements T800/T414 32 bit floating point "coshf(x)/cosh(x)".
 *
 *	Based on INMOS supplied code.  Modified by Logical Systems for correct
 *	ANSI "C" setting of "errno" in ERANGE/EDOM situations.
 */

#include	<inline.h>
#include	<math.h>
#include	<stddef.h>

#pragma	asm_expand			/* Recognize EDOM/ERANGE in "asm" */

float
coshf(float x)
	{
	#pragma	asm
#ifdef	DOUBLE32
	.pub	cosh
cosh:
#endif	DOUBLE32

#ifdef	T800
;
;	T800 32 bit version
;
	.ext	errno
	.ext	expf
	_asm_ajw(-5);
	.ldc	data
	stl	8
	.ldc	0
	stl	2
	ldlp	[x]
	fpldnlsn
	fpnan
	stl	2
	ldlp	[x]
	fpldnlsn
	fpuabs
	ldlp	3
	fpstnlsn
	ldl	2
	cj	@L1
	ldl	[x]
	stl	4
	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L4
	.align
data:	.dw	0x42b1721a
	.dw	0x7f800000
	.dw	0x41051eb8
	.dw	0x3f317300
	.dw	0x37680897
	.dw	0x3f800000
L1:	ldlp	3
	fpldnlsn
	ldl	8
	fpldnlsn
	fpgt
	cj	@L2
	ldl	8
	ldnl	1
	stl	4
	j	@L4
L2:	ldlp	3
	fpldnlsn
	ldl	8
	ldnlp	2
	fpldnlsn
	fpgt
	cj	@L3
	ldl	8
	ldnlp	3
	ldlp	3
	fpldnlsn
	fpldnlsn
	fpsub
	ldlp	0
	fpstnlsn
	ldl	0
#ifdef	STATIC_LINK
	ldl	[?slb]
#endif	/* STATIC_LINK */
	call	@expf
	ldlp	1
	fpstnlsn
	ldlp	1
	ldl	8
	ldnlp	4
	fpldnlsn
	fpldnlmulsn
	ldlp	1
	fpldnladdsn
	ldlp	4
	fpstnlsn
	j	@L4
L3:	ldl	3
#ifdef	STATIC_LINK
	ldl	[?slb]
#endif	/* STATIC_LINK */
	call	@expf
	ldlp	1
	fpstnlsn
	ldlp	1
	ldl	8
	ldnlp	5
	fpldnlsn
	fpldnlsn
	fpdiv
	ldlp	1
	fpldnladdsn
	fpudivby2
	ldlp	4
	fpstnlsn
L4:	ldlp	4
	fpldnlsn
	_asm_ajw(5);
#else	/* T800 */
;
;	T414 32 bit version
;
#endif	/* T800 */
	#pragma	endasm
	}
