/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: hypot64.c,v 2.2 92/04/21 11:01:50 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 *	File:	hypot64.c
 *
 *	Implements T800/T414 64 bit floating point "hypot(x,y)".
 *
 *	Based on INMOS supplied code.  Modified by Logical Systems for correct
 *	ANSI "C" setting of "errno" in ERANGE/EDOM situations.
 *
 *	Uses the simpleminded implementation, a more accurate version should
 *	eventually be used to replace this.
 */

#include	<inline.h>
#include	<math.h>
#include	<stddef.h>

#pragma	asm_expand			/* Recognize EDOM/ERANGE in "asm" */

double
hypot(double x,double y)
	{
#ifdef	T800
	#pragma	asm
;
;	T800 64 bit version
;
	.ext	errno
	ldlp	[x]
	fpldnldb
	fpnan
	cj	@L1			;Jump if not NaN
	ldlp	[y]
	fpldnladddb			;Promote NaN priority
L0:	.ldc	EDOM			;Domain error
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	ret
L1:	fpdup
	fpmul
	ldlp	[y]
	fpldnldb
	fpnan
	cj	@L2			;Jump if not NaN
	.ldc	0
	cj	@L0			;Jump if "y" was NaN
L2:	fpdup
	fpmul
	fpadd
	fpusqrtfirst
	fpusqrtstep
	fpusqrtstep
	fpusqrtstep
	fpusqrtstep
	fpusqrtstep
	fpusqrtlast
	ret
	#pragma	endasm
#else	/* T800 */
	return (sqrt((x * x) + (y * y)));
#endif	/* T800 */
	}
