/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: log1064.c,v 2.2 92/04/21 11:01:53 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 *	File:	log1064.c
 *
 *	Implements T800/T414 64 bit floating point "log10(x)".
 *
 *	Based on INMOS supplied code.
 *
 */

#include	<inline.h>
#include	<math.h>

double
log10(double x)
	{
	#pragma	asm
#ifdef	T800
;
;	T800 64 bit version
;
	.ext	log
	_asm_ajw(-2)
	ldl	[x]+1			;Load operand to "log()"
	ldl	[x]
#ifdef	STATIC_LINK
	ldl	[?slb]
#endif	/* STATIC_LINK */
	call	@log
	fpdup
	ldlp	0
	fpstnldb
	fpnan
	eqc	0
	cj	@L2
	ldlp	0
	.ldc	data
	fpldnldb
	fpldnlmuldb
	ldlp	0
	fpstnldb
L2:	ldlp	0
	fpldnldb
	_asm_ajw(2)
	ret
	.align
data:	.dw	0x1526e50e
	.dw	0x3fdbcb7b
#else	/* T800 */
;
;	T414 64 bit version (from D700D).  A modest attempt has been made to
;	hand optimize the OCCAM generated code here...
;
	.ext	_FPstate
	.ext	log
	.ext	_r64op
	_asm_ajw(-5)
	ldl	[x]+1			;Load operand to "log()"
	ldl	[x]
#ifdef	STATIC_LINK
	ldl	[?slb]
#endif	/* STATIC_LINK */
	call	@log
	.ldc	_FPstate		;Store FAreg result in 3,4
	stl	3
	ldl	3
	ldnl	1
	stl	4
	ldl	3
	ldnl	0
	stl	3
	ldl	4
	.ldc	0x7ff00000		;See if result was Inf/NaN
	and
	eqc	2146435072
	eqc	0
	cj	@L2			;Jump if so
	.ldc	data
	stl	0
	.ldc	2
	ldlp	3
	ldlp	1
	call	@_r64op
	ldl	1
	stl	3
	ldl	2
	stl	4
L2:	ldlp	3
	.ldc	_FPstate		;Addr of "soft" FAreg
	.ldc	8
	move
	_asm_ajw(5)
	ret
	.align
data:	.dw	0x1526e50e
	.dw	0x3fdbcb7b
#endif	/* T800 */
	#pragma	endasm
	}
