/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: log32.c,v 2.2 92/04/21 11:01:53 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 *	File:	log32.c
 *
 *	Implements T800/T414 32 bit floating point "logf(x)/log(x)".
 *
 *	Based on INMOS supplied code.  Modified by Logical Systems for correct
 *	ANSI "C" setting of "errno" in ERANGE/EDOM situations.
 */

#include	<inline.h>
#include	<math.h>
#include	<stddef.h>

#pragma	asm_expand			/* Recognize EDOM/ERANGE in "asm" */

float
logf(float x)
	{
	#pragma	asm
#ifdef	DOUBLE32
	.pub	log
log:
#endif	DOUBLE32

#ifdef	T800
;
;	T800 32 bit version
;
	.ext	errno
	.ext	_unpkf
	_asm_ajw(-8);
	.ldc	data
	stl	11
	.ldc	0
	stl	6
	.ldc	0
	stl	5
	ldlp	[x]
	fpldnlsn
	fpnan
	stl	6
	ldlp	[x]
	fpldnlsn
	fpnotfinite
	stl	5
	ldl	6
	cj	@L1
	ldl	[x]
	stl	7
L0:	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L7
	.align
data:	.dw	0x7f800010
	.dw	0x3f3504f3
	.dw	0x3f000000
	.dw	0xbf0d7e3d
	.dw	0xc0d43f3b
	.dw	0xfefa39ef
	.dw	0x3fe62e42
L1:	ldl	5
	eqc	0
	cj	@L2
	ldlp	[x]
	fpldnlsn
	fpldzerosn
	fpgt
	eqc	0
	cj	@L3
L2:	ldl	11
	ldnl	0
	stl	7
	ldlp	[x]
	fpldnlsn
	fpldzerosn
	fpeq
	cj	@L0			;Input zero?
	.ldc	ERANGE			;Yes, signal range error
	_asm_eval1(&errno);
	stnl	0			;Set errno to ERANGE
	j	@L7
L3:	ldl	[x]
	ldlp	4
	ldlp	2
	call	@_unpkf
	ldlp	4
	fpldnlsn
	fpudivby2
	ldlp	4
	fpstnlsn
	ldl	2
	adc	1
	stl	2
	ldlp	4
	fpldnlsn
	ldl	11
	ldnlp	1
	fpldnlsn
	fpgt
	cj	@L4
	ldl	11
	ldnlp	2
	ldlp	4
	fpldnlsn
	fpldnlsn
	fpsub
	ldl	11
	ldnlp	2
	fpldnlsn
	fpsub
	ldlp	4
	ldl	11
	ldnlp	2
	fpldnlsn
	fpldnlmulsn
	ldl	11
	ldnlp	2
	fpldnladdsn
	fpdiv
	ldlp	1
	fpstnlsn
	j	@L5
L4:	ldl	11
	ldnlp	2
	ldlp	4
	fpldnlsn
	fpldnlsn
	fpsub
	ldlp	0
	fpstnlsn
	ldl	2
	adc	-1
	stl	2
	ldlp	0
	fpldnlsn
	ldlp	0
	ldl	11
	ldnlp	2
	fpldnlsn
	fpldnlmulsn
	ldl	11
	ldnlp	2
	fpldnladdsn
	fpdiv
	ldlp	1
	fpstnlsn
L5:	ldlp	1
	ldlp	1
	fpldnlsn
	fpldnlmulsn
	ldlp	0
	fpstnlsn
	ldlp	0
	ldl	11
	ldnlp	3
	fpldnlsn
	fpldnlmulsn
	ldlp	0
	ldl	11
	ldnlp	4
	fpldnlsn
	fpldnladdsn
	fpdiv
	ldlp	1
	fpldnlmulsn
	ldlp	1
	fpldnladdsn
	ldlp	3
	fpstnlsn
	ldl	2
	eqc	0
	cj	@L6
	ldl	3
	stl	7
	j	@L7
L6:	ldlp	2
	fpi32tor64
	ldl	11
	ldnlp	5
	fpldnlmuldb
	fpur64tor32
	ldlp	3
	fpldnladdsn
	ldlp	7
	fpstnlsn
L7:	ldlp	7
	fpldnlsn
	_asm_ajw(8);
#else	/* T800 */
;
;	T414 32 bit version
;
#endif	/* T800 */
	#pragma	endasm
	}
