/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: log64.c,v 2.2 92/04/21 11:01:54 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 *	File:	log64.c
 *
 *	Implements T800/T414 64 bit floating point "log(x)".
 *
 *	Based on INMOS supplied code.  Modified by Logical Systems for correct
 *	ANSI "C" setting of "errno" in ERANGE/EDOM situations.
 */

#include	<inline.h>
#include	<math.h>
#include	<stddef.h>

#pragma	asm_expand			/* Recognize EDOM/ERANGE in "asm" */

double
log(double x)
	{
	#pragma	asm
#ifdef	T800
;
;	T800 64 bit version
;
	.ext	errno
	.ext	_unpk
	_asm_ajw(-14)
	.ldc	data
	stl	13
	.ldc	0
	stl	12
	.ldc	0
	stl	11
	ldlp	[x]
	fpldnldb
	fpnan
	stl	12
	ldlp	[x]
	fpldnldb
	fpnotfinite
	stl	11
	ldl	12
	cj	@L1
	ldlp	[x]
	ldlp	9
	.ldc	8
	move
L0:	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L7
	.align
;
;	The first floating point constant in the following array is the
;	"undefined" NaN constant value.  The original INMOS code used values
;	for this which are inconsistent with the latest INMOS Compiler Writers'
;	Guide.  The value has been changed to reflect the one used in the
;	"Guide".
;
data:	.dw	0x00000000		;Was 0x00000010
	.dw	0x7ff00002		;Was 0x7FF00000
	.dw	0x667f3bcd
	.dw	0x3fe6a09e
	.dw	0x00000000
	.dw	0x3fe00000
	.dw	0xb356bd29
	.dw	0xbfe94415
	.dw	0x2016afed
	.dw	0x4030624a
	.dw	0x12b3b59b
	.dw	0xc05007ff
	.dw	0x4b67ce0f
	.dw	0xc041d580
	.dw	0xfa15267e
	.dw	0x40738083
	.dw	0x9c0d9078
	.dw	0xc0880bfe
	.dw	0x5c610ca8
	.dw	0xbf2bd010
	.dw	0x00000000
	.dw	0x3fe63000
L1:	ldl	11
	eqc	0
	cj	@L2
	ldlp	[x]
	fpldnldb
	fpldzerodb
	fpgt
	eqc	0
	cj	@L3
L2:	ldl	13
	ldlp	9
	.ldc	8
	move
	ldlp	[x]
	fpldnldb
	fpldzerodb
	fpeq
	cj	@L0			;Input zero?
	.ldc	ERANGE			;Yes signal range error
	_asm_eval1(&errno);
	stnl	0			;Set errno to ERANGE
	j	@L7
L3:	ldlp	[x]
	ldlp	7
	ldlp	4
	call	@_unpk
	ldlp	7
	fpldnldb
	fpudivby2
	ldlp	7
	fpstnldb
	ldl	4
	adc	1
	stl	4
	ldlp	7
	fpldnldb
	ldl	13
	ldnlp	2
	fpldnldb
	fpgt
	cj	@L4
	ldl	13
	ldnlp	4
	ldlp	7
	fpldnldb
	fpldnldb
	fpsub
	ldl	13
	ldnlp	4
	fpldnldb
	fpsub
	ldlp	7
	ldl	13
	ldnlp	4
	fpldnldb
	fpldnlmuldb
	ldl	13
	ldnlp	4
	fpldnladddb
	fpdiv
	ldlp	2
	fpstnldb
	j	@L5
L4:	ldl	4
	adc	-1
	stl	4
	ldl	13
	ldnlp	4
	ldlp	7
	fpldnldb
	fpldnldb
	fpsub
	ldlp	0
	fpstnldb
	ldlp	0
	fpldnldb
	ldlp	0
	ldl	13
	ldnlp	4
	fpldnldb
	fpldnlmuldb
	ldl	13
	ldnlp	4
	fpldnladddb
	fpdiv
	ldlp	2
	fpstnldb
L5:	ldlp	2
	ldlp	2
	fpldnldb
	fpldnlmuldb
	ldlp	0
	fpstnldb
	ldl	13
	ldnlp	6
	ldlp	0
	fpldnldb
	fpldnlmuldb
	ldl	13
	ldnlp	8
	fpldnladddb
	ldlp	0
	fpldnlmuldb
	ldl	13
	ldnlp	10
	fpldnladddb
	ldlp	0
	fpldnlmuldb
	ldlp	0
	ldl	13
	ldnlp	12
	fpldnldb
	fpldnladddb
	ldlp	0
	fpldnlmuldb
	ldl	13
	ldnlp	14
	fpldnladddb
	ldlp	0
	fpldnlmuldb
	ldl	13
	ldnlp	16
	fpldnladddb
	fpdiv
	ldlp	2
	fpldnlmuldb
	ldlp	2
	fpldnladddb
	ldlp	5
	fpstnldb
	ldl	4
	eqc	0
	cj	@L6
	ldl	5
	stl	9
	ldl	6
	stl	10
	j	@L7
L6:	ldlp	4
	fpi32tor64
	ldlp	2
	fpstnldb
	ldlp	2
	ldl	13
	ldnlp	18
	fpldnldb
	fpldnlmuldb
	ldlp	5
	fpldnladddb
	ldlp	2
	ldl	13
	ldnlp	20
	fpldnldb
	fpldnlmuldb
	fpadd
	ldlp	9
	fpstnldb
L7:	ldlp	9
	fpldnldb
	_asm_ajw(14)
	ret
#else	/* T800 */
;
;	T414 64 bit version (from D700D).  NO attempt is made here to optimize
;	the OCCAM generated code (hope to get to this someday...)  Modified to
;	conform to ANSI "C" requirements (EDOM on NaN & Inf & x < 0,
;	ERANGE on x == 0).
;
	.ext	errno
	.ext	_fdiv64
	.ext	_fmul64
	.ext	_FPstate
	.ext	_iexp64
	.ext	_refl64
	.ext	_norm64
	.ext	_r64fmi
	.ext	_r64op
	_asm_ajw(-25)
	.ldc	data
	stl	24
	ldlp	[x]
	ldlp	20
	.ldc	8
	move
	ldl	20
	stl	18
	ldl	21
	.ldc	2147483647
	and
	stl	19
	ldl	19
	.ldc	2146435072
	gt
	eqc	0
	cj	@L2
	ldl	19
	.ldc	2146435072
	diff
	eqc	0
	cj	@L1
	ldl	18
	mint
	xor
	mint
	gt
L1:	eqc	0
L2:	eqc	0
	cj	@L3
	ldlp	[x]
	ldlp	22
	.ldc	8
	move
	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L19
	.align
data:	.dw	0x00000000		;"undefined" NaN
	.dw	0x7ff00002
	.dw	0x00000000
	.dw	0x00000000
	.dw	0x00000000
	.dw	0x20000000
	.dw	0x0e9d9c67
	.dw	0xfedcac78
	.dw	0x00000000
	.dw	0x02000000
	.dw	0x5c610ca8
	.dw	0xbf2bd010
	.dw	0x00000000
	.dw	0x3fe63000
L3:	ldl	21			;"x" <= 0?
	.ldc	0
	gt
	eqc	0
	cj	@L5
	ldl	21
	eqc	0
	cj	@L4
	ldl	20
	mint
	xor
	mint
	gt
L4:	eqc	0
L5:	eqc	0
	cj	@L6A			;Jump if "x" <= 0
	ldl	20			;"x" == Inf?
	ldl	21
	.ldc	2146435072		;DRealInf
	diff
	or
	eqc	0
	cj	@L7
L6:	ldl	24
	ldlp	22
	.ldc	8
	move
	.ldc	ERANGE			;"x" == Inf, signal range error
	_asm_eval1(&errno);
	stnl	0			;Set errno to ERANGE
	j	@L19
L6A:	.ldc	0
	ldl	21			;"x" < 0?
	gt
	cj	@L6			;Jump if "x" == 0
	ldl	24
	ldlp	22
	.ldc	8
	move
	.ldc	EDOM			;"x" < 0, signal domain error
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L19
L7:	ldlp	20
	stl	16
	.ldc	0
	ldl	16
	ldnl	1
	.ldc	12
	lshl
	stl	15
	stl	17
	ldl	20
	stl	18
	ldl	21
	.ldc	1048575
	and
	stl	19
	ldl	17
	eqc	0
	cj	@L8
	ldlp	18
	stl	0
	ldl	24
	ldnlp	2
	stl	1
	ldlp	13
	ldlp	11
	ldlp	15
	call	@_norm64
	ldl	11
	stl	18
	ldl	12
	stl	19
	.ldc	-1010
	ldl	15
	diff
	stl	17
	ldl	18
	stl	11
	ldl	19
	.ldc	2147483647
	and
	stl	12
	ldl	12
	ldl	11
	.ldc	1
	lshr
	stl	13
	stl	14
	ldl	13
	stl	18
	ldl	14
	stl	19
	j	@L9
L8:	ldl	17
	adc	-1022
	stl	17
	ldl	19
	ldl	18
	.ldc	10
	lshl
	stl	15
	stl	16
	ldl	15
	stl	18
	ldl	16
	stl	19
L9:	ldl	19
	.ldc	444758425
	gt
	eqc	0
	cj	@L11
	ldl	19
	.ldc	444758425
	diff
	eqc	0
	cj	@L10
	ldl	18
	mint
	xor
	.ldc	2096050754
	gt
L10:	eqc	0
L11:	eqc	0
	cj	@L12
	ldl	19
	ldl	18
	.ldc	1
	lshr
	stl	13
	stl	14
	ldl	13
	stl	15
	.ldc	0
	ldl	14
	.ldc	1610612736
	ladd
	stl	16
	ldl	18
	stl	13
	.ldc	0
	ldl	19
	.ldc	1073741824
	lsub
	stl	14
	ldl	13
	stl	18
	ldl	14
	stl	19
	j	@L13
L12:	ldl	17
	adc	-1
	stl	17
	ldl	19
	ldl	18
	.ldc	1
	lshr
	stl	13
	stl	14
	ldl	13
	stl	15
	.ldc	0
	ldl	14
	.ldc	1073741824
	ladd
	stl	16
L13:	ldl	18
	ldl	19
	or
	eqc	0
	cj	@L14
	.ldc	0
	stl	22
	.ldc	0
	stl	23
	j	@L16
L14:	ldlp	15
	ldlp	18
	ldlp	13
	call	@_fdiv64
	ldlp	13
	ldlp	13
	ldlp	7
	call	@_fmul64
	ldl	7
	stl	13
	ldl	8
	stl	14
	ldlp	15
	ldl	24
	ldnlp	4
	ldlp	11
	call	@_fdiv64
	ldl	24
	ldnlp	6
	ldlp	13
	ldlp	7
	call	@_fmul64
	ldl	24
	ldnlp	8
	ldlp	13
	ldlp	5
	call	@_fmul64
	.ldc	0
	ldl	5
	.ldc	23803190
	lsum
	stl	1
	ldl	6
	.ldc	-480242921
	ladd
	stl	2
	ldlp	1
	ldlp	13
	ldlp	3
	call	@_fmul64
	.ldc	0
	ldl	7
	.ldc	234235417
	lsum
	stl	1
	ldl	8
	.ldc	118607195
	ladd
	stl	2
	ldlp	1
	stl	0
	.ldc	0
	ldl	3
	.ldc	391575896
	lsum
	stl	7
	ldl	4
	.ldc	1503473527
	ladd
	stl	8
	ldlp	7
	ldl	0
	ldlp	5
	call	@_fdiv64
	.ldc	0
	ldl	5
	.ldc	-1320599574
	lsum
	stl	3
	ldl	6
	.ldc	9544601
	ladd
	stl	4
	ldlp	3
	ldlp	13
	ldlp	7
	call	@_fmul64
	ldlp	7
	ldlp	11
	ldlp	5
	call	@_fmul64
	.ldc	0
	ldl	11
	ldl	5
	lsum
	stl	9
	ldl	12
	ldl	6
	ladd
	stl	10
	ldl	9
	ldl	10
	or
	eqc	0
	cj	@L15
	.ldc	0
	stl	22
	.ldc	0
	stl	23
	j	@L16
L15:	ldlp	9
	ldlp	7
	call	@_refl64
	ldlp	18
	ldlp	5
	call	@_refl64
	ldlp	5
	stl	0
	.ldc	2
	ldlp	7
	ldlp	3
	call	@_r64op
	.ldc	2
	ldlp	3
	ldlp	22
	call	@_iexp64
L16:	ldl	17
	eqc	0
	cj	@L18
	j	@L19
L18:	ldl	17
	ldlp	15
	call	@_r64fmi
	ldl	24
	ldnlp	10
	stl	0
	.ldc	2
	ldlp	15
	ldlp	11
	call	@_r64op
	ldlp	11
	stl	0
	.ldc	0
	ldlp	22
	ldlp	9
	call	@_r64op
	ldl	24
	ldnlp	12
	stl	0
	.ldc	2
	ldlp	15
	ldlp	11
	call	@_r64op
	ldlp	11
	stl	0
	.ldc	0
	ldlp	9
	ldlp	13
	call	@_r64op
	ldl	13
	stl	22
	ldl	14
	stl	23
L19:	ldlp	22
	.ldc	_FPstate		;Addr of "soft" FAreg
	.ldc	8
	move
	_asm_ajw(25)
	ret
#endif	/* T800 */
	#pragma	endasm
	}
