/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: sinh32.c,v 2.2 92/04/21 11:01:57 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 *	File:	sinh32.c
 *
 *	Implements T800/T414 32 bit floating point "sinhf(x)/sinh(x)".
 *
 *	Based on INMOS supplied code.  Modified by Logical Systems for correct
 *	ANSI "C" setting of "errno" in ERANGE/EDOM situations.
 */

#include	<inline.h>
#include	<math.h>
#include	<stddef.h>

#pragma	asm_expand			/* Recognize EDOM/ERANGE in "asm" */

float
sinhf(float x)
	{
	#pragma	asm
#ifdef	DOUBLE32
	.pub	sinh
sinh:
#endif	DOUBLE32

#ifdef	T800
;
;	T800 32 bit version
;
	.ext	errno
	.ext	expf
	_asm_ajw(-6);
	.ldc	data
	stl	9
	.ldc	0
	stl	3
	.ldc	0
	stl	2
	fpldzerosn
	ldlp	[x]
	fpldnlsn
	fpgt
	stl	2
	ldlp	[x]
	fpldnlsn
	fpnan
	stl	3
	ldlp	[x]
	fpldnlsn
	fpuabs
	ldlp	4
	fpstnlsn
	ldl	3
	cj	@L1
	ldl	[x]
	stl	5
	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L13
	.align
data:	.dw	0x42b1721a
	.dw	0xff800000
	.dw	0x7f800000
	.dw	0x41051eb8
	.dw	0x3f317300
	.dw	0x37680897
	.dw	0x3f800000
	.dw	0x39800000
	.dw	0xbe42e6c3
	.dw	0xc0e469f0
	.dw	0xc22b4f94
L1:	ldlp	4
	fpldnlsn
	ldl	9
	fpldnlsn
	fpgt
	cj	@L4
	ldl	2
	cj	@L2
	ldl	9
	ldnl	1
	stl	5
	j	@L3
L2:	ldl	9
	ldnl	2
	stl	5
L3:	j	@L13
L4:	ldlp	4
	fpldnlsn
	ldl	9
	ldnlp	3
	fpldnlsn
	fpgt
	cj	@L7
	ldl	9
	ldnlp	4
	ldlp	4
	fpldnlsn
	fpldnlsn
	fpsub
	ldlp	0
	fpstnlsn
	ldl	0
#ifdef	STATIC_LINK
	ldl	[?slb]
#endif	/* STATIC_LINK */
	call	@expf
	ldlp	1
	fpstnlsn
	ldl	2
	cj	@L5
	fpldzerosn
	ldlp	1
	ldl	9
	ldnlp	5
	fpldnlsn
	fpldnlmulsn
	ldlp	1
	fpldnladdsn
	fpsub
	ldlp	5
	fpstnlsn
	j	@L6
L5:	ldlp	1
	ldl	9
	ldnlp	5
	fpldnlsn
	fpldnlmulsn
	ldlp	1
	fpldnladdsn
	ldlp	5
	fpstnlsn
L6:	j	@L13
L7:	ldl	9
	ldnlp	6
	fpldnlsn
	ldlp	4
	fpldnlsn
	fpgt
	eqc	0
	cj	@L10
	ldl	4
	call	@expf
	ldlp	1
	fpstnlsn
	ldlp	1
	fpldnlsn
	ldlp	1
	ldl	9
	ldnlp	6
	fpldnlsn
	fpldnlsn
	fpdiv
	fpsub
	fpudivby2
	ldlp	0
	fpstnlsn
	ldl	2
	cj	@L8
	fpldzerosn
	ldlp	0
	fpldnlsn
	fpsub
	ldlp	5
	fpstnlsn
	j	@L9
L8:	ldl	0
	stl	5
L9:	j	@L13
L10:	ldl	9
	ldnlp	7
	fpldnlsn
	ldlp	4
	fpldnlsn
	fpgt
	cj	@L11
	ldl	[x]
	stl	5
	j	@L13
L11:	ldlp	4
	ldlp	4
	fpldnlsn
	fpldnlmulsn
	ldlp	1
	fpstnlsn
	ldl	9
	ldnlp	8
	ldlp	1
	fpldnlsn
	fpldnlmulsn
	ldl	9
	ldnlp	9
	fpldnladdsn
	ldlp	1
	ldl	9
	ldnlp	10
	fpldnlsn
	fpldnladdsn
	fpdiv
	ldlp	1
	fpldnlmulsn
	ldlp	4
	fpldnlmulsn
	ldlp	4
	fpldnladdsn
	ldlp	0
	fpstnlsn
	ldl	2
	cj	@L12
	fpldzerosn
	ldlp	0
	fpldnlsn
	fpsub
	ldlp	5
	fpstnlsn
	j	@L13
L12:	ldl	0
	stl	5
L13:	ldlp	5
	fpldnlsn
	_asm_ajw(6);
#else	/* T800 */
;
;	T414 32 bit version
;
#endif	/* T800 */
	#pragma	endasm
	}
