/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: sinh64.c,v 2.2 92/04/21 11:01:58 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 *	File:	sinh64.c
 *
 *	Implements T800/T414 64 bit floating point "sinh(x)".
 *
 *	Based on INMOS supplied code.  Modified by Logical Systems for correct
 *	ANSI "C" setting of "errno" in ERANGE/EDOM situations.
 */

#include	<inline.h>
#include	<math.h>
#include	<stddef.h>

#pragma	asm_expand			/* Recognize EDOM/ERANGE in "asm" */

double
sinh(double x)
	{
	#pragma	asm
#ifdef	T800
;
;	T800 64 bit version
;
	.ext	errno
	.ext	exp
	_asm_ajw(-13)
	.ldc	data
	stl	12
	fpldzerodb
	ldlp	[x]
	fpldnldb
	fpgt
	stl	11
	.ldc	0
	stl	6
	ldlp	[x]
	fpldnldb
	fpnan
	stl	6
	ldlp	[x]
	fpldnldb
	fpuabs
	ldlp	9
	fpstnldb
	ldl	6
	cj	@L1
	ldlp	[x]
	ldlp	7
	.ldc	8
	move
	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L13
	.align
data:	.dw	0x9708893b
	.dw	0x408633ce
	.dw	0x00000000
	.dw	0xfff00000
	.dw	0x00000000
	.dw	0x7ff00000
	.dw	0x00000000
	.dw	0x3e500000
	.dw	0x7b2737fa
	.dw	0x40325e4f
	.dw	0x00000000
	.dw	0x3fe62e60
	.dw	0xeb0202d5
	.dw	0x3eed0112
	.dw	0x00000000
	.dw	0x3ff00000
	.dw	0xb86fc81b
	.dw	0xbfe944e7
	.dw	0x6385be4b
	.dw	0xc0647841
	.dw	0xb6941490
	.dw	0xc0c695c2
	.dw	0x56533419
	.dw	0xc1157913
	.dw	0x81c97ff3
	.dw	0xc0715bc3
	.dw	0x23b65ec7
	.dw	0x40e1a857
	.dw	0x80be6713
	.dw	0xc1401ace
L1:	ldlp	9
	fpldnldb
	ldl	12
	fpldnldb
	fpgt
	cj	@L4
	ldl	11
	cj	@L2
	ldl	12
	ldnlp	2
	ldlp	7
	.ldc	8
	move
	j	@L3
L2:	ldl	12
	ldnlp	4
	ldlp	7
	.ldc	8
	move
L3:	j	@L13
L4:	ldl	12
	ldnlp	6
	fpldnldb
	ldlp	9
	fpldnldb
	fpgt
	cj	@L5
	ldlp	[x]
	ldlp	7
	.ldc	8
	move
	j	@L13
L5:	ldlp	9
	fpldnldb
	ldl	12
	ldnlp	8
	fpldnldb
	fpgt
	cj	@L8
	ldl	12
	ldnlp	10
	ldlp	9
	fpldnldb
	fpldnldb
	fpsub
	ldlp	2
	fpstnldb
	ldl	3
	ldl	2
#ifdef	STATIC_LINK
	ldl	[?slb]
#endif	/* STATIC_LINK */
	call	@exp
	ldlp	4
	fpstnldb
	ldl	11
	cj	@L6
	fpldzerodb
	ldlp	4
	ldl	12
	ldnlp	12
	fpldnldb
	fpldnlmuldb
	ldlp	4
	fpldnladddb
	fpsub
	ldlp	7
	fpstnldb
	j	@L7
L6:	ldlp	4
	ldl	12
	ldnlp	12
	fpldnldb
	fpldnlmuldb
	ldlp	4
	fpldnladddb
	ldlp	7
	fpstnldb
L7:	j	@L13
L8:	ldl	12
	ldnlp	14
	fpldnldb
	ldlp	9
	fpldnldb
	fpgt
	eqc	0
	cj	@L11
	ldl	10
	ldl	9
#ifdef	STATIC_LINK
	ldl	[?slb]
#endif	/* STATIC_LINK */
	call	@exp
	ldlp	4
	fpstnldb
	ldlp	4
	fpldnldb
	ldlp	4
	ldl	12
	ldnlp	14
	fpldnldb
	fpldnldb
	fpdiv
	fpsub
	ldlp	0
	fpstnldb
	ldlp	0
	fpldnldb
	fpudivby2
	ldlp	2
	fpstnldb
	ldl	11
	cj	@L9
	fpldzerodb
	ldlp	2
	fpldnldb
	fpsub
	ldlp	7
	fpstnldb
	j	@L10
L9:	ldl	2
	stl	7
	ldl	3
	stl	8
L10:	j	@L13
L11:	ldlp	9
	ldlp	9
	fpldnldb
	fpldnlmuldb
	ldlp	4
	fpstnldb
	ldl	12
	ldnlp	16
	ldlp	4
	fpldnldb
	fpldnlmuldb
	ldl	12
	ldnlp	18
	fpldnladddb
	ldlp	4
	fpldnlmuldb
	ldl	12
	ldnlp	20
	fpldnladddb
	ldlp	4
	fpldnlmuldb
	ldl	12
	ldnlp	22
	fpldnladddb
	ldlp	4
	ldl	12
	ldnlp	24
	fpldnldb
	fpldnladddb
	ldlp	4
	fpldnlmuldb
	ldl	12
	ldnlp	26
	fpldnladddb
	ldlp	4
	fpldnlmuldb
	ldl	12
	ldnlp	28
	fpldnladddb
	fpdiv
	ldlp	4
	fpldnlmuldb
	ldlp	9
	fpldnlmuldb
	ldlp	9
	fpldnladddb
	ldlp	2
	fpstnldb
	ldl	11
	cj	@L12
	fpldzerodb
	ldlp	2
	fpldnldb
	fpsub
	ldlp	7
	fpstnldb
	j	@L13
L12:	ldl	2
	stl	7
	ldl	3
	stl	8
L13:	ldlp	7
	fpldnldb
	_asm_ajw(13)
	ret
#else	/* T800 */
;
;	T414 64 bit version (from D700D).  NO attempt is made here to optimize
;	the OCCAM generated code (hope to get to this someday...)
;
	.ext	errno
	.ext	_fix64
	.ext	_fmul64
	.ext	_FPstate
	.ext	_iexp64
	.ext	_refl64
	.ext	_rex64
	.ext	_r64op
	_asm_ajw(-20)
	.ldc	data
	stl	19
	ldlp	[x]
	ldlp	15
	.ldc	8
	move
	.ldc	0
	ldl	16
	gt
	stl	14
	ldl	15
	stl	12
	ldl	16
	.ldc	2147483647
	and
	stl	13
	ldl	13
	.ldc	2146435072
	gt
	eqc	0
	cj	@L2
	ldl	13
	.ldc	2146435072
	diff
	eqc	0
	cj	@L1
	ldl	12
	mint
	xor
	mint
	gt
L1:	eqc	0
L2:	eqc	0
	cj	@L3
	ldl	15
	stl	10
	ldl	16
	stl	11
	ldl	10
	stl	17
	ldl	11
	stl	18
	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L23
	.align
data:	.dw	0x00000000
	.dw	0x7ff00000
	.dw	0x00000000
	.dw	0x3fe62e60
	.dw	0xeb0202d5
	.dw	0x3eed0112
	.dw	0x00000000
	.dw	0x00000000
	.dw	0x00000000
	.dw	0x3ff00000
	.dw	0x59c2956a
	.dw	0x00000000
L3:	ldl	13
	.ldc	1082536910
	gt
	eqc	0
	cj	@L5
	ldl	13
	.ldc	1082536910
	diff
	eqc	0
	cj	@L4
	ldl	12
	mint
	xor
	.ldc	386435387
	gt
L4:	eqc	0
L5:	eqc	0
	cj	@L8
	.ldc	ERANGE			;Range error (input too large)
	_asm_eval1(&errno);
	stnl	0			;Set errno to ERANGE
	ldl	14
	cj	@L6
	ldl	19
	ldlp	17
	call	@P1
	j	@L7
L6:	ldl	19
	ldlp	17
	.ldc	8
	move
L7:	j	@L23
L8:	ldl	13
	.ldc	1077042767
	gt
	eqc	0
	cj	@L10
	ldl	13
	.ldc	1077042767
	diff
	eqc	0
	cj	@L9
	ldl	12
	mint
	xor
	.ldc	-81315846
	gt
L9:	eqc	0
L10:	eqc	0
	cj	@L13
	ldl	12
	stl	10
	ldl	13
	stl	11
	ldl	19
	ldnlp	2
	stl	0
	.ldc	1
	ldlp	10
	ldlp	6
	call	@_r64op
	ldlp	6
	ldlp	8
	call	@_rex64
	ldl	14
	cj	@L11
	ldl	19
	ldnlp	4
	stl	0
	.ldc	2
	ldlp	8
	ldlp	6
	call	@_r64op
	ldlp	6
	stl	0
	.ldc	0
	ldlp	8
	ldlp	4
	call	@_r64op
	ldlp	4
	stl	0
	.ldc	1
	ldl	19
	ldnlp	6
	ldlp	17
	call	@_r64op
	j	@L12
L11:	ldl	19
	ldnlp	4
	stl	0
	.ldc	2
	ldlp	8
	ldlp	6
	call	@_r64op
	ldlp	6
	stl	0
	.ldc	0
	ldlp	8
	ldlp	17
	call	@_r64op
L12:	j	@L23
L13:	.ldc	1072693248
	ldl	13
	gt
	eqc	0
	cj	@L15
	.ldc	1072693248
	ldl	13
	diff
	eqc	0
	cj	@L14
	mint
	ldl	12
	mint
	xor
	gt
L14:	eqc	0
L15:	cj	@L18
	ldl	12
	stl	10
	ldl	13
	stl	11
	ldlp	10
	ldlp	8
	call	@_rex64
	ldl	14
	cj	@L16
	ldlp	8
	stl	0
	.ldc	3
	ldl	19
	ldnlp	8
	ldlp	6
	call	@_r64op
	ldlp	6
	stl	0
	.ldc	1
	ldlp	8
	ldlp	4
	call	@_r64op
	.ldc	-1
	ldlp	4
	ldlp	6
	call	@_iexp64
	ldlp	6
	stl	0
	.ldc	1
	ldl	19
	ldnlp	6
	ldlp	17
	call	@_r64op
	j	@L17
L16:	ldlp	8
	stl	0
	.ldc	3
	ldl	19
	ldnlp	8
	ldlp	6
	call	@_r64op
	ldlp	6
	stl	0
	.ldc	1
	ldlp	8
	ldlp	4
	call	@_r64op
	.ldc	-1
	ldlp	4
	ldlp	17
	call	@_iexp64
L17:	j	@L23
L18:	.ldc	1045430272
	ldl	13
	gt
	eqc	0
	cj	@L20
	.ldc	1045430272
	ldl	13
	diff
	eqc	0
	cj	@L19
	mint
	ldl	12
	mint
	xor
	gt
L19:	eqc	0
L20:	eqc	0
	cj	@L21
	ldlp	[x]
	ldlp	17
	.ldc	8
	move
	j	@L23
L21:	ldl	12
	stl	8
	ldl	13
	stl	9
	ldlp	8
	ldlp	10
	call	@_fix64
	ldlp	10
	ldlp	10
	ldlp	4
	call	@_fmul64
	ldl	4
	stl	10
	ldl	5
	stl	11
	ldl	19
	ldnlp	10
	ldlp	10
	ldlp	4
	call	@_fmul64
	.ldc	0
	ldl	4
	.ldc	-897193232
	lsum
	stl	0
	ldl	5
	.ldc	53
	ladd
	stl	1
	ldlp	0
	ldlp	10
	ldlp	2
	call	@_fmul64
	.ldc	0
	ldl	2
	.ldc	-452763984
	lsum
	stl	0
	ldl	3
	.ldc	5917
	ladd
	stl	1
	ldlp	0
	ldlp	10
	ldlp	4
	call	@_fmul64
	.ldc	0
	ldl	4
	.ldc	101122936
	lsum
	stl	0
	ldl	5
	.ldc	426088
	ladd
	stl	1
	ldlp	0
	ldlp	10
	ldlp	2
	call	@_fmul64
	.ldc	0
	ldl	2
	.ldc	287641356
	lsum
	stl	0
	ldl	3
	.ldc	17895697
	ladd
	stl	1
	ldlp	0
	ldlp	10
	ldlp	4
	call	@_fmul64
	.ldc	0
	ldl	4
	.ldc	1431575184
	lsum
	stl	0
	ldl	5
	.ldc	357913941
	ladd
	stl	1
	ldlp	0
	ldlp	10
	ldlp	2
	call	@_fmul64
	ldlp	2
	ldlp	6
	call	@_refl64
	ldl	14
	cj	@L22
	ldlp	8
	stl	0
	.ldc	2
	ldlp	6
	ldlp	4
	call	@_r64op
	ldlp	4
	stl	0
	.ldc	0
	ldlp	8
	ldlp	2
	call	@_r64op
	ldlp	2
	stl	0
	.ldc	1
	ldl	19
	ldnlp	6
	ldlp	17
	call	@_r64op
	j	@L23
L22:	ldlp	8
	stl	0
	.ldc	2
	ldlp	6
	ldlp	4
	call	@_r64op
	ldlp	4
	stl	0
	.ldc	0
	ldlp	8
	ldlp	17
	call	@_r64op
L23:	ldlp	17
	.ldc	_FPstate		;Addr of "soft" FAreg
	.ldc	8
	move
	_asm_ajw(20)
	ret

P1:	ajw	-5
	ldl	7
	stl	1
	ldlp	2
	stl	0
	ldl	1
	ldnl	0
	ldl	0
	stnl	0
	ldl	1
	ldnl	1
	mint
	xor
	ldl	0
	stnl	1
	ldlp	2
	ldl	6
	.ldc	8
	move
	ajw	5
	ret
#endif	/* T800 */
	#pragma	endasm
	}
