/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: tan32.c,v 2.2 92/04/21 11:01:59 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 *	File:	tan32.c
 *
 *	Implements T800/T414 32 bit floating point "tanf(x)/tan(x)".
 *
 *	Based on INMOS supplied code.  Modified by Logical Systems for correct
 *	ANSI "C" setting of "errno" in ERANGE/EDOM situations.
 */

#include	<inline.h>
#include	<math.h>
#include	<stddef.h>

#pragma	asm_expand			/* Recognize EDOM/ERANGE in "asm" */

float
tanf(float x)
	{
	#pragma	asm
#ifdef	DOUBLE32
	.pub	tan
tan:
#endif	DOUBLE32

#ifdef	T800
;
;	T800 32 bit version
;
	.ext	_argrf
	.ext	errno
	_asm_ajw(-11);
	.ldc	data
	stl	14
	.ldc	0
	stl	8
	.ldc	0
	stl	7
	ldlp	[x]
	fpldnlsn
	fpnan
	stl	7
	ldlp	[x]
	fpldnlsn
	fpuabs
	ldlp	9
	fpstnlsn
	fpldzerosn
	ldlp	[x]
	fpldnlsn
	fpgt
	stl	8
	ldl	7
	cj	@L1
	ldl	[x]
	stl	10
	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L13
	.align
data:	.dw	0x45c90fdb
	.dw	0x7f800004
	.dw	0x3f490fdb
	.dw	0xb33bbd2e
	.dw	0x3fc90fdb
	.dw	0x39800000
	.dw	0xbdc433b9
	.dw	0x3c1f3376
	.dw	0xbedbb7b0
	.dw	0x3f800000
	.dw	0x7f800008
L1:	ldlp	9
	fpldnlsn
	ldl	14
	fpldnlsn
	fpgt
	cj	@L2
	ldl	14
	ldnl	1
	stl	10
	j	@L13
L2:	.ldc	0
	stl	6
	ldlp	9
	fpldnlsn
	ldl	14
	ldnlp	2
	fpldnlsn
	fpgt
	cj	@L5
	.ldc	0
	stl	3
	ldl	14
	ldnl	3
	stl	2
	ldl	14
	ldnl	4
	stl	1
	ldl	9
	stl	0
	ldlp	9
	ldlp	4
	ldlp	3
	call	@_argrf
	ldl	4
	.ldc	1
	and
	eqc	1
	stl	6
	fpldzerosn
	ldlp	9
	fpldnlsn
	fpgt
	cj	@L3
	ldl	6
	ldl	8
	diff
	eqc	0
	stl	8
	fpldzerosn
	ldlp	9
	fpldnlsn
	fpsub
	ldlp	9
	fpstnlsn
	j	@L4
L3:	ldl	6
	ldl	8
	diff
	eqc	0
	eqc	0
	stl	8
L4:	j	@L6
L5:	.ldc	0
	stl	6
L6:	ldl	14
	ldnlp	5
	fpldnlsn
	ldlp	9
	fpldnlsn
	fpgt
	cj	@L7
	ldl	9
	stl	5
	j	@L8
L7:	ldlp	9
	ldlp	9
	fpldnlsn
	fpldnlmulsn
	ldlp	4
	fpstnlsn
	ldl	14
	ldnlp	6
	ldlp	4
	fpldnlsn
	fpldnlmulsn
	ldlp	9
	fpldnlmulsn
	ldlp	9
	fpldnladdsn
	ldl	14
	ldnlp	7
	ldlp	4
	fpldnlsn
	fpldnlmulsn
	ldl	14
	ldnlp	8
	fpldnladdsn
	ldlp	4
	fpldnlmulsn
	ldl	14
	ldnlp	9
	fpldnladdsn
	fpdiv
	ldlp	5
	fpstnlsn
L8:	ldl	6
	cj	@L10
	ldlp	5
	fpldnlsn
	fpldzerosn
	fpeq
	cj	@L9
	ldl	14
	ldnl	10
	stl	5
	j	@L10
L9:	ldlp	5
	ldl	14
	ldnlp	9
	fpldnlsn
	fpldnlsn
	fpdiv
	ldlp	5
	fpstnlsn
L10:	ldl	8
	cj	@L12
	fpldzerosn
	ldlp	5
	fpldnlsn
	fpsub
	ldlp	10
	fpstnlsn
	j	@L13
L12:	ldl	5
	stl	10
L13:	ldlp	10
	fpldnlsn
	_asm_ajw(11);
#else	/* T800 */
;
;	T414 32 bit version
;
#endif	/* T800 */
	#pragma	endasm
	}
