/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: tanh32.c,v 2.2 92/04/21 11:02:02 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 *	File:	tanh32.c
 *
 *	Implements T800/T414 32 bit floating point "tanhf(x)/tanh(x)".
 *
 *	Based on INMOS supplied code.  Modified by Logical Systems for correct
 *	ANSI "C" setting of "errno" in ERANGE/EDOM situations.
 */

#include	<inline.h>
#include	<math.h>
#include	<stddef.h>

#pragma	asm_expand			/* Recognize EDOM/ERANGE in "asm" */

float
tanhf(float x)
	{
	#pragma	asm
#ifdef	DOUBLE32
	.pub	tanh
tanh:
#endif	DOUBLE32

#ifdef	T800
;
;	T800 32 bit version
;
	.ext	errno
	.ext	expf
	_asm_ajw(-6);
	.ldc	data
	stl	9
	.ldc	0
	stl	3
	.ldc	0
	stl	2
	fpldzerosn
	ldlp	[x]
	fpldnlsn
	fpgt
	stl	2
	ldlp	[x]
	fpldnlsn
	fpnan
	stl	3
	ldlp	[x]
	fpldnlsn
	fpuabs
	ldlp	4
	fpstnlsn
	ldl	3
	cj	@L1
	ldl	[x]
	stl	5
	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L9
	.align
data:	.dw	0x41051592
	.dw	0x3f800000
	.dw	0x3f0c9f54
	.dw	0x40000000
	.dw	0x39800000
	.dw	0xbb7b11b2
	.dw	0xbf52e2c7
	.dw	0x401e2a1a
L1:	ldlp	4
	fpldnlsn
	ldl	9
	fpldnlsn
	fpgt
	cj	@L2
	ldl	9
	ldnl	1
	stl	1
	j	@L5
L2:	ldlp	4
	fpldnlsn
	ldl	9
	ldnlp	2
	fpldnlsn
	fpgt
	cj	@L3
	ldlp	4
	fpldnlsn
	fpumulby2
	ldlp	1
	fpstnlsn
	ldl	1
#ifdef	STATIC_LINK
	ldl	[?slb]
#endif	/* STATIC_LINK */
	call	@expf
	ldlp	1
	fpstnlsn
	ldl	9
	ldnlp	3
	fpldnlsn
	ldl	9
	ldnlp	1
	ldlp	1
	fpldnlsn
	fpldnladdsn
	fpdiv
	ldl	9
	ldnlp	1
	fpldnlsn
	fprev
	fpsub
	ldlp	1
	fpstnlsn
	j	@L5
L3:	ldl	9
	ldnlp	4
	fpldnlsn
	ldlp	4
	fpldnlsn
	fpgt
	cj	@L4
	ldl	4
	stl	1
	j	@L5
L4:	ldlp	4
	ldlp	4
	fpldnlsn
	fpldnlmulsn
	ldlp	0
	fpstnlsn
	ldl	9
	ldnlp	5
	ldlp	0
	fpldnlsn
	fpldnlmulsn
	ldl	9
	ldnlp	6
	fpldnladdsn
	ldlp	0
	fpldnlmulsn
	ldlp	0
	ldl	9
	ldnlp	7
	fpldnlsn
	fpldnladdsn
	fpdiv
	ldlp	4
	fpldnlmulsn
	ldlp	4
	fpldnladdsn
	ldlp	1
	fpstnlsn
L5:	ldl	2
	cj	@L8
	fpldzerosn
	ldlp	1
	fpldnlsn
	fpsub
	ldlp	5
	fpstnlsn
	j	@L9
L8:	ldl	1
	stl	5
L9:	ldlp	5
	fpldnlsn
	_asm_ajw(6);
#else	/* T800 */
;
;	T414 32 bit version
;
#endif	/* T800 */
	#pragma	endasm
	}
