/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: tanh64.c,v 2.2 92/04/21 11:02:03 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 *	File:	tanh64.c
 *
 *	Implements T800/T414 64 bit floating point "tanh(x)".
 *
 *	Based on INMOS supplied code.  Modified by Logical Systems for correct
 *	ANSI "C" setting of "errno" in ERANGE/EDOM situations.
 */

#include	<inline.h>
#include	<math.h>
#include	<stddef.h>

#pragma	asm_expand			/* Recognize EDOM/ERANGE in "asm" */

double
tanh(double x)
	{
	#pragma	asm
#ifdef	T800
;
;	T800 64 bit version
;
	.ext	errno
	.ext	exp
	_asm_ajw(-10);
	fpldzerodb
	ldlp	[x]
	fpldnldb
	fpgt
	stl	9
	.ldc	0
	stl	8
	ldlp	[x]
	fpldnldb
	fpnan
	stl	8
	ldl	8
	cj	@L1
	ldlp	[x]
	ldlp	6
	.ldc	8
	move
	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L9
	.align
data:	.dw	0x93b3a68b
	.dw	0x40330fc1
	.dw	0x00000000
	.dw	0x3ff00000
	.dw	0x7aad030b
	.dw	0x3fe193ea
	.dw	0x00000000
	.dw	0x40000000
	.dw	0x00000000
	.dw	0x3e500000
	.dw	0xcefba77f
	.dw	0xbfeedc28
	.dw	0xa1ba5ccd
	.dw	0xc058ce75
	.dw	0xc9be1e19
	.dw	0xc09935a5
	.dw	0xe1ebf7fb
	.dw	0x405c2fa9
	.dw	0x4d01f0f3
	.dw	0x40a1738b
	.dw	0x574e9693
	.dw	0x40b2e83c
L1:	ldlp	[x]
	fpldnldb
	.ldc	data
	stl	[x]			;Re-use
	fpuabs
	ldlp	4
	fpstnldb
	ldlp	4
	fpldnldb
	ldl	[x]
	fpldnldb
	fpgt
	cj	@L2
	ldl	[x]
	ldnlp	2
	ldlp	2
	.ldc	8
	move
	j	@L5
L2:	ldlp	4
	fpldnldb
	ldl	[x]
	ldnlp	4
	fpldnldb
	fpgt
	cj	@L3
	ldlp	4
	fpldnldb
	fpumulby2
	ldlp	2
	fpstnldb
	ldl	3
	ldl	2
#ifdef	STATIC_LINK
	ldl	[?slb]
#endif	/* STATIC_LINK */
	call	@exp
	ldlp	2
	fpstnldb
	ldl	[x]
	ldnlp	6
	fpldnldb
	ldl	[x]
	ldnlp	2
	ldlp	2
	fpldnldb
	fpldnladddb
	fpdiv
	ldl	[x]
	ldnlp	2
	fpldnldb
	fprev
	fpsub
	ldlp	2
	fpstnldb
	j	@L5
L3:	ldl	[x]
	ldnlp	8
	fpldnldb
	ldlp	4
	fpldnldb
	fpgt
	cj	@L4
	ldl	4
	stl	2
	ldl	5
	stl	3
	j	@L5
L4:	ldlp	4
	ldlp	4
	fpldnldb
	fpldnlmuldb
	ldlp	0
	fpstnldb
	ldl	[x]
	ldnlp	10
	ldlp	0
	fpldnldb
	fpldnlmuldb
	ldl	[x]
	ldnlp	12
	fpldnladddb
	ldlp	0
	fpldnlmuldb
	ldl	[x]
	ldnlp	14
	fpldnladddb
	ldlp	0
	fpldnlmuldb
	ldlp	0
	ldl	[x]
	ldnlp	16
	fpldnldb
	fpldnladddb
	ldlp	0
	fpldnlmuldb
	ldl	[x]
	ldnlp	18
	fpldnladddb
	ldlp	0
	fpldnlmuldb
	ldl	[x]
	ldnlp	20
	fpldnladddb
	fpdiv
	ldlp	4
	fpldnlmuldb
	ldlp	4
	fpldnladddb
	ldlp	2
	fpstnldb
L5:	ldl	9
	cj	@L8
	fpldzerodb
	ldlp	2
	fpldnldb
	fpsub
	ldlp	6
	fpstnldb
	j	@L9
L8:	ldl	2
	stl	6
	ldl	3
	stl	7
L9:	ldlp	6
	fpldnldb
	_asm_ajw(10);
	ret
#else	/* T800 */
;
;	T414 64 bit version
;
	.ext	errno
	.ext	_fdiv64
	.ext	_fix64
	.ext	_fmul64
	.ext	_FPstate
	.ext	_iexp64
	.ext	_refl64
	.ext	_rex64
	.ext	_r64op
	_asm_ajw(-22);
	.ldc	data
	stl	21
	ldlp	[x]
	ldlp	17
	.ldc	8
	move
	ldl	17
	stl	15
	ldl	18
	.ldc	2147483647
	and
	stl	16
	.ldc	0
	stl	14
	.ldc	0
	ldl	18
	gt
	stl	14
	ldl	16
	.ldc	2146435072
	gt
	eqc	0
	cj	@L2
	ldl	16
	.ldc	2146435072
	diff
	eqc	0
	cj	@L1
	ldl	15
	mint
	xor
	mint
	gt
L1:	eqc	0
L2:	eqc	0
	cj	@L3
	ldl	17
	stl	12
	ldl	18
	stl	13
	ldl	12
	stl	19
	ldl	13
	stl	20
	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L16
	.align
data:	.dw	0x00000000
	.dw	0x3ff00000
	.dw	0x00000000
	.dw	0x40000000
	.dw	0x87d4a416
	.dw	0xffffe83f
	.dw	0x00000000
	.dw	0x01000000
	.dw	0x00000000
	.dw	0x00000000
L3:	ldl	16
	.ldc	1077088193
	gt
	eqc	0
	cj	@L5
	ldl	16
	.ldc	1077088193
	diff
	eqc	0
	cj	@L4
	ldl	15
	mint
	xor
	.ldc	330540683
	gt
L4:	eqc	0
L5:	eqc	0
	cj	@L6
	ldl	21
	ldlp	19
	.ldc	8
	move
	j	@L13
L6:	ldl	16
	.ldc	1071748074
	gt
	eqc	0
	cj	@L8
	ldl	16
	.ldc	1071748074
	diff
	eqc	0
	cj	@L7
	ldl	15
	mint
	xor
	.ldc	-89324789
	gt
L7:	eqc	0
L8:	eqc	0
	cj	@L9
	ldl	15
	stl	12
	ldl	16
	stl	13
	.ldc	1
	ldlp	12
	ldlp	10
	call	@_iexp64
	ldlp	10
	ldlp	8
	call	@_rex64
	ldlp	8
	stl	0
	.ldc	0
	ldl	21
	ldlp	10
	call	@_r64op
	ldlp	10
	stl	0
	.ldc	3
	ldl	21
	ldnlp	2
	ldlp	8
	call	@_r64op
	ldlp	8
	stl	0
	.ldc	1
	ldl	21
	ldlp	19
	call	@_r64op
	j	@L13
L9:	.ldc	1045430272
	ldl	16
	gt
	eqc	0
	cj	@L11
	.ldc	1045430272
	ldl	16
	diff
	eqc	0
	cj	@L10
	mint
	ldl	15
	mint
	xor
	gt
L10:	eqc	0
L11:	eqc	0
	cj	@L12
	ldl	15
	stl	12
	ldl	16
	stl	13
	ldl	12
	stl	19
	ldl	13
	stl	20
	j	@L13
L12:	ldl	15
	stl	12
	ldl	16
	stl	13
	ldlp	12
	ldlp	10
	call	@_fix64
	ldlp	10
	ldlp	10
	ldlp	8
	call	@_fmul64
	ldl	8
	stl	10
	ldl	9
	stl	11
	ldl	21
	ldnlp	4
	ldlp	10
	ldlp	8
	call	@_fmul64
	.ldc	0
	ldl	8
	.ldc	267855701
	lsum
	stl	4
	ldl	9
	.ldc	-15488506
	ladd
	stl	5
	ldlp	4
	ldlp	10
	ldlp	6
	call	@_fmul64
	ldl	21
	ldnlp	6
	ldlp	10
	ldlp	8
	call	@_fmul64
	.ldc	0
	ldl	8
	.ldc	1450145111
	lsum
	stl	2
	ldl	9
	.ldc	430184387
	ladd
	stl	3
	ldlp	2
	ldlp	10
	ldlp	4
	call	@_fmul64
	.ldc	0
	ldl	6
	.ldc	1656456595
	lsum
	stl	2
	ldl	7
	.ldc	-319765725
	ladd
	stl	3
	ldlp	2
	stl	1
	.ldc	0
	ldl	4
	.ldc	-673037725
	lsum
	stl	6
	ldl	5
	.ldc	959297173
	ladd
	stl	7
	ldlp	6
	ldl	1
	ldlp	8
	call	@_fdiv64
	ldlp	8
	ldlp	10
	ldlp	6
	call	@_fmul64
	ldlp	6
	ldlp	8
	call	@_refl64
	ldlp	8
	stl	0
	.ldc	2
	ldlp	12
	ldlp	6
	call	@_r64op
	ldlp	6
	stl	0
	.ldc	0
	ldlp	12
	ldlp	19
	call	@_r64op
L13:	ldl	14
	cj	@L16
	ldlp	19
	stl	0
	.ldc	1
	ldl	21
	ldnlp	8
	ldlp	12
	call	@_r64op
	ldl	12
	stl	19
	ldl	13
	stl	20
L16:	ldlp	19
	.ldc	_FPstate		;Addr of "soft" FAreg
	.ldc	8
	move
	_asm_ajw(22);
	ret
#endif	/* T800 */
	#pragma	endasm
	}
