/*
 *	OSU Research Computing					Trillium
 *	(public domain software)
 *
 *	$Log:	fclose.c,v $
 * Revision 2.2  92/04/21  11:02:58  trillium
 * Ohio Release
 * 
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 * This file is originally from dLibs 1.2 by Dale Schumacher et al.
 * It was modified for Trollius by MB, 88/12.
 * It was modified again for portability by GDB, 91/08.
 */

#include <stdio.h>

int
fclose(fp)
	FILE *fp;
{
	int f;

	if(fp == NULL)
		return(EOF);		/* NULL file pointer file */
	f = fp->_flag;
	if((f & (_IOREAD | _IOWRT)) == 0)
		return(EOF);		/* file not open! */
	fflush(fp);
	if(fp->_flag & _IOMYBUF)	/* throw away non-standard buffer */
	{
		free(fp->_base);
	}
	fp->_base = NULL;
	fp->_ptr = NULL;
	fp->_bsiz = 0;
	fp->_flag = 0;			/* clear status */
	if(f & _IODEV)			/* leave tty's alone */
		return(0);
	f = close(fp->_file);
	return(f ? EOF : 0);
}

/*
 *	fcloseall
 *
 *	Function:	- Close all streams.
 */

void
fcloseall()

{
	int i, f;

	for(i=0; i<_NFILE; ++i) {
		f = _iob[i]._flag;
		if(f & (_IOREAD | _IOWRT))
			fclose(&_iob[i]);
	}
}
