/*
 *	OSU Research Computing					Trillium
 *	(public domain software)
 *
 *	$Log:	fgetc.c,v $
 * Revision 2.2  92/04/21  11:02:59  trillium
 * Ohio Release
 * 
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 * This file is originally from dLibs 1.2 by Dale Schumacher et al.
 * It was modified for Trollius by MB, 88/12.
 * It was modified again for portability by GDB, 91/08.
 */

/*
 * The CRLF --> \n translation left in in case we ever go back to MS-DOS.
 */

#include <stdio.h>

/*
 * external variables
 */
extern int _ioexit;

/*
 * external functions
 */
extern void fcloseall();
extern void _getbuf();
extern long read();

int
fgetc(fp)
	FILE *fp;
{
	int c, f, m, look = 0;

	if (! _ioexit) {
		if (atkexit (fcloseall, (char *) 0) != 0)
			return (EOF);
		_ioexit = 1;
	}

	f = (fp->_flag &= ~_IORW);
	if(!(f & _IOREAD) || (f & (_IOERR | _IOEOF)))
		return(EOF);
	if(fp->_base == NULL)	/* allocate a buffer if there wasn't one */
		_getbuf(fp);
_fgetc1:
	if(--(fp->_cnt) < 0) {
		m = (int) read(fp->_file, (char *) fp->_base, (long) fp->_bsiz);
		if(m <= 0) {
			fp->_flag |= ((m == 0) ? _IOEOF : _IOERR);
			c = EOF;
			goto _fgetc2;
		}
		fp->_cnt = (m - 1);
		fp->_ptr = fp->_base;
	}
	c = *(fp->_ptr)++;
_fgetc2:
	if (!(f & _IOBIN)) {		/* TRANSLATED STREAM PROCESSING */
		if (look) {			/* process lookahead */
			if(c != '\n') {		/* if not CR+LF.. */
				if(c == EOF) {	/* ..undo EOF.. */
					fp->_flag &= ~(_IOERR | _IOEOF);
				} else {	/* ..or unget character */
					*--(fp->_ptr) = c;
					++(fp->_cnt);
				}
				c = '\r';	/* return CR */
			}
		} else if(c == '\r') {		/* found CR */
			if(f & _IODEV)		/* return it for tty */
				c = '\n';
			else {			/* else lookahead for LF */
				look = 1;
				goto _fgetc1;
			}
		} else if(c == 0x00) {		/* Ignore NUL's */
			goto _fgetc1;
		} else if(c == 0x1A) {		/* ^Z becomes EOF */
			fp->_flag |= _IOEOF;
			c = EOF;
		}
	}
	return(c);
}

int
fungetc(c, fp)
	int c;
	FILE *fp;
{
	if((fp->_flag & (_IOERR | _IOEOF))	/* error or eof */
	|| (fp->_ptr <= fp->_base))		/* or too many ungets */
		return(EOF);
	++(fp->_cnt);
	return(*--(fp->_ptr) = c);
}
