/*
 *	OSU Research Computing					Trillium
 *	(public domain software)
 *
 *	$Log:	fputc.c,v $
 * Revision 2.2  92/04/21  11:03:03  trillium
 * Ohio Release
 * 
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 * This file is originally from dLibs 1.2 by Dale Schumacher et al.
 * It was modified for Trollius by MB, 88/12.
 * MB: added call to atkexit() 891012
 * It was modified again for portability by GDB, 91/08.
 */

/*
 * the CRLF --> \n translation left in case we ever go back to MS-DOS
 */

#include <stdio.h>

/*
 * external variables
 */
extern int _ioexit;

/*
 * external functions
 */
extern void fcloseall();
extern void _getbuf();
extern long write();

int
fputc(c, fp)
	int c;
	FILE *fp;
{
	int f, m, nl = 0;

	if (! _ioexit) {
		if (atkexit (fcloseall, (char *) 0) != 0)
			return (EOF);
		_ioexit = 1;
	}

	f = (fp->_flag |= _IORW);
	if(!(f & _IOWRT)			/* not opened for write? */
	|| (f & (_IOERR | _IOEOF)))		/* error/eof conditions? */
		return(EOF);
	if(fp->_base == NULL)	/* allocate a buffer if there wasn't one */
		_getbuf(fp);
	if(!(f & _IOBIN) && (c == '\n'))	/* NL -> CR+LF ? */
	{
#ifdef	DOS
		c = '\r';
		nl = 1;
#endif
	}
_fputc:
	*(fp->_ptr)++ = c;
	if (((++(fp->_cnt)) >= fp->_bsiz)
	||  (c == '\n' && (f & _IOLBF)))	/* - MB: added */
	{
		m = fp->_cnt;			/* MB: may be < _bsiz */
		fp->_cnt = 0;
		fp->_ptr = fp->_base;
		if(((int) write(fp->_file, (char *) fp->_base, (long) m)) != m)
		{
			fp->_flag |= _IOERR;
			return(EOF);
		}
	}
	if(nl && (c == '\r'))			/* NL -> CR+LF ? */
	{
		c = '\n';
		goto _fputc;
	}
	return(c);
}
