/*
 *	OSU Research Computing					Trillium
 *	(public domain software)
 *
 *	$Log:	fread.c,v $
 * Revision 2.2  92/04/21  11:03:04  trillium
 * Ohio Release
 * 
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 * This file is originally from dLibs 1.2 by Dale Schumacher et al.
 * It was modified for Trollius by MB, 88/12.
 * It was modified again for portability by GDB, 91/08.
 */

#include <stdio.h>

/*
 * external functions
 */
extern void fcloseall();
extern long read();

/*
 * external variables
 */
extern int _ioexit;
extern int errno;

long
fread(data, size, count, fp)
	char *data;
	long size;
	long count;
	FILE *fp;
{
	long n, m;
	int f, c;

	if (! _ioexit) {
		if (atkexit (fcloseall, (char *) 0) != 0)
			return (-1);
		_ioexit = 1;
	}

	f = (fp->_flag &= ~_IORW);
	n = count * size;
	if(f & _IODEV)			/* device i/o */
	{
		for(m = 0; (m < n); ++m)
		{
			if((c = fgetc(fp)) == EOF)
				break;
			*data++ = (char) c;
		} 
	}
	else				/* file i/o */
	{
		fflush(fp);			/* re-sync file pointers */
		m = read(fp->_file, data, n);
	}
	return((m > 0) ? (m / size) : (long) (errno = ((int) m)));
}
