/*
 *	OSU Research Computing					Trillium
 *	(public domain software)
 *
 *	$Log:	fwrite.c,v $
 * Revision 2.2  92/04/21  11:03:06  trillium
 * Ohio Release
 * 
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 * This file is originally from dLibs 1.2 by Dale Schumacher et al.
 * It was modified for Trollius by MB, 88/12.
 * MB: added call to atkexit() 891012
 * It was modified again for portability by GDB, 91/08.
 */

#include <stdio.h>

/*
 * external variables
 */
extern int _ioexit;
extern int errno;

/*
 * external functions
 */
extern void fcloseall();
extern long write();

long
fwrite(data, size, count, fp)
	char *data;
	long size;
	long count;
	FILE *fp;
{
	long n, m;
	int f;

	if (! _ioexit) {
		if (atkexit (fcloseall, (char *) 0) != 0)
			return (-1);
		_ioexit = 1;
	}

	f = (fp->_flag |= _IORW);
	n = count * size;
	if(f & _IODEV)				/* device i/o */
	{
		for(m=0; m<n; ++m)
			if(fputc(*data++, fp) == EOF)
				break;
	}
	else					/* file i/o */
	{
		fflush(fp);			/* re-sync file pointers */
		m = write(fp->_file, data, n);
	}
	return((m > 0) ? (m / size) : (long) (errno = ((int) m)));
}
