/*
 *	OSU Research Computing					Trillium
 *	(public domain software)
 *
 *	$Log:	setbuf.c,v $
 * Revision 2.2  92/04/21  11:03:08  trillium
 * Ohio Release
 * 
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 * This file is originally from dLibs 1.2 by Dale Schumacher et al.
 * It was modified for Trollius by MB, 88/12.
 * It was modified again for portability by GDB, 91/08.
 */

#include <stdio.h>

void
setbuffer(fp, buf, size)
	FILE *fp;
	unsigned char *buf;
	int size;
{
	if (! (fp->_flag & (_IOREAD | _IOWRT))) return;
	fp->_cnt = 0;
	fp->_ptr = buf;
	if(fp->_base = buf)		/* assignment intentional */
	{
		fp->_bsiz = size;
	}
	else
	{
		fp->_flag &= ~(_IOFBF | _IOLBF | _IONBF | _IOMYBUF);
		fp->_flag |= _IONBF;
		fp->_bsiz = 0;
	}
}

void
setbuf(fp, buf)

FILE		*fp;
unsigned char	*buf;

{
	setbuffer(fp, buf, BUFSIZ);
}

int
setvbuf(fp, buf, type, size)

FILE		*fp;
unsigned char	*buf;
int		type;
int		size;

{
	if (! (fp->_flag & (_IOREAD | _IOWRT))) {
		return(EOF);
	}

	if ((type != _IOFBF) || (type != _IOLBF) || (type != _IONBF)) {
		return(EOF);
	}

	fp->_flag &= ~(_IOFBF | _IOLBF | _IONBF);
	fp->_flag |= type;

	if (buf) {

		if (size <= 0) {
			return(EOF);
		}

		fp->_base = buf;
		fp->_ptr = buf;
		fp->_bsiz = size;
		fp->_cnt = 0;
	}

	return(0);
}

int
setlinebuf(fp)

FILE		*fp;

{
	if (! (fp->_flag & (_IOREAD | _IOWRT))) {
		return(EOF);
	}

	fp->_flag &= ~(_IOFBF | _IOLBF | _IONBF);
	fp->_flag |= _IOLBF;
	return(0);
}
