.TH LSTCC l "April 29, 1992" "Release 2.2" "TROLLIUS COMMANDS"
.SH NAME
tcc
\- Trollius ITB C compiler (LSTT version)
.SH SYNOPSIS
.nf
.ft B
tcc [options] filename(s)
.fi
.SH DESCRIPTION
This command provides a UNIX-
.I cc
-like user interface to the Logical Systems Transputer Toolkit (LSTT).
Tools accessible via
.I tcc
include the preprocessor (PP), compiler (TCX), assembler (TASM),
linker (TLNK), and an executable-file format conversion program (TCVT).
The LSTT librarian (TLIB) has its own
.I ar
-like wrapper:
.I trar.
.PP
.I Tcc
knows about standard suffixes, for example, it will assemble without
compiling an assembly language source file.
Options allow termination at any intermediate point of the process.
.PP
Note that the default suffixes of assembly language and linkable object
files are the standard UNIX
.I .s
and
.I .o
and not the default
.I .tal
and
.I .trl
suffixes used in the LSTT documentation.
One must not mix these files with assembler language and object files
generated by the host's native development tools, such as cc(1),
or with files generated by other transputer specific compilers.
.PP
The options understood by
.I tcc
include many of the options standard to cc(1)
and also additional options specific to the LSTT.
Unless overridden by command line options,
.I tcc
uses default options and tool pathnames that were hardwired into it at the
time it was compiled.
.I Tcc
uses also the two environment variables TROLLIUSHOME and LSTTHOME if they
are defined.
.PP
Here is a list of cc(1)
standard options supported by
.I tcc.
For more details about these options consult the manual entry for cc(1).
.TP 16
.B \-c
Compile but do not link.
.TP
.B \-D<symbol>
.TP
.B \-D<symbol=value>
Predefine a preprocessor symbol.
.TP
.B \-E
Run only the preprocessor.
.TP
.B \-I<dir>
Specify directory holding user versions of include files.
.TP
.B \-L<path>
Specify directory holding libraries.
.TP
.B \-l<name>
Link to the library lib\fIname\fR.
.TP
.B \-O
Invoke the code optimization option of the compiler.
.TP
.B \-o <outfile>
Name the output (executable) file
.I outfile.
.TP
.B \-S
Compile but do not assemble.
.TP
.B \-U<symbol>
Undefine a predefined preprocessor symbol.
.PP
Additional, non-standard, options to the preprocessing phase supported are:
.TP 16
.B \-d
Turn on debug mode: print detailed information about the linking step.
.TP
.B \-N
Turn on pretend mode: generate the command lines but do not execute them.
.TP
.B \-v
Be verbose about the details of the compilation steps:
displays the command lines generated.
.TP
.B \-0
Do not link to the standard C startup module
.I crt0.
.TP
.B +a <option>
Pass an arbitrary option to TASM, verbatim.
.TP
.B +c <option>
Pass an arbitrary option to TCX, verbatim.
.TP
.B +l <option>
Pass an arbitrary option to TLNK, verbatim.
.TP
.B +p <option>
Pass an arbitrary option to PP, verbatim.
.PP
Options specific to the TCX, TASM, and TLNK tools are explained in the
LSTT documentation.
.SH FILES
.TP 30
file.c
C source file
.TP
file.s
assembler source file
.TP
file.o
object file
.TP
file.a
library of object files
.TP
a.out
default executable output file
.TP
$TROLLIUSHOME/itb/lib/lstt/crt0.o
.TP
/usr/local/trillium/itb/lib/lstt/crt0.o
C startup module
.TP
$TROLLIUSHOME/itb/lib/lstt
.TP
$LSTTHOME/itb/lib/lstt
.TP
/usr/local/trillium/itb/lib/lstt
directory for libraries
.TP
$LSTTHOME/h/lstt
.TP
/usr/local/trillium/h/lstt
directory for tool specific `#include' files
.TP
$TROLLIUSHOME/h
.TP
/usr/local/trillium/h
directory for Trollius `#include' files
.PP
.I Tcc
creates various temporary files, by default in
.I /tmp,
unless overriden by the TMP environment variable.
Their names are of the form:
.I Tx#####.TCC
where the
.I x
is a letter of the alphabet \[A\-Z\] and the
.I #####
part holds a number (the process ID of the invocation of
.I tcc).
These files are automatically removed.
.SH TRADEMARKS
UNIX is a trademark of AT&T.  Transputer is a trademark of Inmos.
.SH SEE ALSO
cc(1), ld(1), trar(l)
