/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: stdlib.h,v 2.2 92/04/21 11:07:09 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 *	stdlib.h
 *
 *	Copyright 1987-1988 by Logical Systems.
 */

#ifndef	_STDLIB				/* Avoid duplication */
#define	_STDLIB		1

#ifndef	_MEM_ROUTINE_			/* If not included in mem. routines */
extern	void	*_freelist;		/* Root of free list */
extern	void	*_heapstart;		/* Points to start of heap */
extern	void	*_heapend;		/* Points to the end of the heap */
#endif	/* _MEM_ROUTINE_ */

#ifndef	volatile
#define	volatile			/* Not implemented yet */
#define	const				/* Not implemented yet */
#endif	/* volatile */

#ifndef ERANGE				/* OSU */
#define	ERANGE		2		/* Range error */
#endif

#ifndef	T212
#ifdef	DOUBLE32			/* If double is 32 bits long */
#define	HUGE_VAL	3.40282347E+38	/* "max" double value */
#else	/* DOUBLE32 */
/*
 *	Value for LSD of HUGE_VAL should be "6" instead of "5" but some
 *	host system "C" compilers treat this incorrectly as a NaN.
 */
#define	HUGE_VAL	1.797693134862315E+308	/* "max" double value */
#endif	/* DOUBLE32 */
#endif	/* !T212 */

#define	EXIT_FAILURE	1
#define	EXIT_SUCCESS	0
#ifndef NULL
#define	NULL		0
#endif

#ifdef	T212
#define	RAND_MAX	32767
#else	/* !T212 */
#define	RAND_MAX	2147483647
#endif	/* T212 */

typedef	struct	{ int quot;	int rem; } div_t;
typedef	struct	{ long int quot;	long int rem; }	ldiv_t;
typedef	unsigned int	size_t;

/*void	abort(void);	*/
int	abs(int j);
void	addfree(void *ptr,size_t size);
/*int	atexit(void (*func)(void));	*/
#ifndef	T212
double	atof(const char *nptr);
#endif	/* !T212 */
int	atoi(const char *nptr);
long int atol(const char *nptr);
void	*bsearch(const void *key, const void *base, size_t nmemb,
		size_t size, int (*compar)(const void *, const void *));
void	*calloc(size_t nmemb, size_t size);
void	cfree(void *ptr);
div_t	div(int numer, int denom);
void	exit(int status);
#ifndef	T212
double	frand(void);
float	frandf(void);
#endif	/* !T212 */
void	free(void *ptr);
char	*getenv(const char *name);
void	isort(void *base, size_t nmemb, size_t size,
		int (*compar)(const void *, const void *));
long int labs(long int j);
ldiv_t	ldiv(long int numer, long int denom);
void	*malloc(size_t size);
void	_ns_exit(void);
void	qsort(void *base, size_t nmemb, size_t size,
		int (*compar)(const void *, const void *));
int	rand(void);
void	*realloc(void *ptr, size_t size);
void	srand(unsigned int seed);
void	ssort(void *base, size_t nmemb, size_t size,
		int (*compar)(const void *, const void *));
#ifndef	T212
double	strtod(const char *nptr, char **endptr);
#endif	/* !T212 */
long int strtol(const char *nptr, char **endptr, int base);
unsigned long int strtoul(const char *nptr, char **endptr, int base);
int	system(const char *string);

#endif	/* _STDLIB */
