/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: tcx6e.c,v 2.2 92/04/21 11:11:18 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 *	TCX Compiler (6e of 11)	Intrinsic Functions
 *
 *	Copyright 1988-1991 by Logical Systems.  All rights reserved.
 *
 *	Published by:	Logical Systems
 *			P.O. Box 1702
 *			Corvallis, OR 97339 (USA)
 *
 *	06/01/88
 */

#include	<stdio.h>
#include	<string.h>
#include	"tcx.h"
#include	"tcxdecl.h"
#include	"tcxext.h"

/*
 *	Local function declarations.
 */
PRIVATE	unsigned	int	iperr();
PRIVATE	unsigned	int	order312();
PRIVATE	unsigned	int	iajw();
PRIVATE	unsigned	int	ieval();
PRIVATE	unsigned	int	ifabs();
PRIVATE	unsigned	int	isqrt();
PRIVATE	unsigned	int	imemcpy();
PRIVATE	unsigned	int	icin();
PRIVATE	unsigned	int	icinc();
PRIVATE	unsigned	int	icini();
PRIVATE	unsigned	int	icout();
PRIVATE	unsigned	int	icoutc();
PRIVATE	unsigned	int	icouti();
PRIVATE	unsigned	int	icreset();
PRIVATE	unsigned	int	ipafter();
PRIVATE	unsigned	int	ipgetpri();
PRIVATE	unsigned	int	ipresch();
PRIVATE	unsigned	int	ipstop();
PRIVATE	unsigned	int	ipwait();
PRIVATE	unsigned	int	istime();
PRIVATE	unsigned	int	itime();
PRIVATE	unsigned	int	islopri();
PRIVATE	unsigned	int	ishipri();
PRIVATE	unsigned	int	iglopri();
PRIVATE	unsigned	int	ighipri();
PRIVATE	unsigned	int	ibcnt();
PRIVATE	unsigned	int	ibrevnb();
PRIVATE	unsigned	int	ibrevw();
PRIVATE	unsigned	int	move_help();
PRIVATE	unsigned	int	imv2d();
PRIVATE	unsigned	int	imv2dnz();
PRIVATE	unsigned	int	imv2dz();
PRIVATE	unsigned	int	iphalt();
PRIVATE	unsigned	int	iprun();

/*
 *	Intrinsic function parameter size/type error helper routine.
 */
PRIVATE	unsigned int
iperr(str,args)
	char			*str;
	struct	arg_info	args[];
	{
	char			buf[NAMEMAX + 1];

strcpy(buf,"Bad parameter number/type/size for internal function: _BUILTIN_");
	strcat(buf,str);
	error(buf);
	if(args[0].code != NULL)
		dvrt_free(args[0].code);
	if(args[1].code != NULL)
		dvrt_free(args[1].code);
	if(args[2].code != NULL)
		dvrt_free(args[2].code);
	return (0);
	}

/*
 *	Takes a normal 1,2,3 parameter ordering and converts it into a 3,1,2
 *	ordering so that the "do_call3" routine may be used to produce the
 *	commonly desired parameter order (assumes only 3 parameters all of
 *	which are integral).
 */
PRIVATE	unsigned int
order312(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	struct	dvrt		*tcode;
	unsigned int		tdepth;
	struct	op_node		*texpr;

	tcode = args[0].code;
	tdepth = args[0].depth;
	texpr = args[0].expr;
	args[0].code = args[2].code;
	args[0].depth = args[2].depth;
	args[0].expr = args[2].expr;
	args[2].code = args[1].code;
	args[2].depth = args[1].depth;
	args[2].expr = args[1].expr;
	args[1].code = tcode;
	args[1].depth = tdepth;
	args[1].expr = texpr;
	return (do_call3(numargs,args,FALSE));
	}

/*
 *	Intrinsic "ajw"
 */
PRIVATE	unsigned int
iajw(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	INT32			adjust_size;

	if((numargs != 1) || (! (EXPRTYPE(args[0].expr) & INTEGRAL_NODE)) ||
		(! ISCONSTANT(args[0].expr)))
		{
		return (iperr("ajw",args));
		}
	dvrt_free(args[0].code);	/* Throw away parameter code */
	adjust_size = args[0].expr->right.ptr.terminal->val.integral;
/*
 *	Output stuff to cause desired workspace	adjustment.
 */
	assign(WORKSPACE,WORKSPACE,TRUE,(INT32) -adjust_size);
	assign(TEMPBASE,TEMPBASE,TRUE,(INT32) -adjust_size);
	assign(STRUCTBASE,STRUCTBASE,TRUE,(INT32) -adjust_size);
	abs_oper(TOP_AJW,(INT32) adjust_size);

	return (INT_DEEP(1));		/* "fake" depth so no confusion */
	}

/*
 *	Intrinsic "eval"
 */
PRIVATE	unsigned int
ieval(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	struct	op_node		*current;
	int			p_count;
/*
 *	Time for some parameter error checking.
 */
	if(numargs < 2)
		return (iperr("eval",args));

	if((! (EXPRTYPE(args[0].expr) & INTEGRAL_NODE)) ||
		(! ISCONSTANT(args[0].expr)))
		{
		return (iperr("eval",args));
		}
	p_count = (int) args[0].expr->right.ptr.terminal->val.integral;
	if((p_count < 1) || (p_count > 3) ||
		((p_count < 3) && (p_count >= numargs)) ||
			((p_count == 3) && (numargs != 3)))
		{
		return (iperr("eval",args));
		}
	dvrt_free(args[0].code);	/* Throw away param count code */
/*
 *	Move the parameters up to replace the first parameter count cell which
 *	was discarded.
 */
	args[0].code = args[1].code;
	args[0].depth = args[1].depth;
	args[0].expr = args[1].expr;
	args[0].node = args[1].node;
	args[0].size = args[1].size;
	args[1].code = args[2].code;
	args[1].depth = args[2].depth;
	args[1].expr = args[2].expr;
	args[1].node = args[2].node;
	args[1].size = args[2].size;
	args[2].code = NULL;
	args[2].depth = 0;
	args[2].expr = NULL;
	args[2].node = NULL;
	args[2].size = 0;
/*
 *	See if we have to evaluate the last argument (only the first three have
 *	been done automatically).
 */
	if((numargs = p_count) == 3)
		{
		current = LEFT(args[1].node);
		args[2].node = current;		/* Node handle */
		args[2].expr = RIGHT(current);	/* Expression handle */
/*
 *	Set size of operand (wrong if float or struct/union but ignored).
 */
		args[2].size = 1;
/*
 *	If the operand isn't a float or struct/union (error checking for which
 *	will be provided later), evaluate the code to load it.
 */
		if(! (RIGHTTYPE(current) & (FP_NODE | SU_NODE)))
			{
			dvrt_stack();
			args[2].depth = expr_code(NULL,
					RIGHT(current),NEED_VALUE);
			args[2].code = dvrt_unstack();
			}
		}
/*
 *	Make sure user isn't slipping a float or struct/union in on us.
 */
	for(p_count = 0; p_count < numargs; p_count++)
		{
		if(RIGHTTYPE(args[p_count].node) & (FP_NODE | SU_NODE))
			{
			return (iperr("eval",args));
			}
		}
/*
 *	Set up the stack as requested and return the depth used.
 */
	return (do_call3(numargs,args,FALSE));
	}

/*
 *	Intrinsic "fabs/fabsf"
 */
PRIVATE	unsigned int
ifabs(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	if((numargs != 1) || (args[0].size > 2))
		return (iperr("fabs/fabsf",args));
	dvrt_append(args[0].code);
	no_oper(TOP_FPUABS);
	return (depth_max(args[0].depth,INT_DEEP(1)));
	}

/*
 *	Intrinsic "sqrt/sqrtf"
 */
PRIVATE	unsigned int
isqrt(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	if((numargs != 1) || (args[0].size > 2))
		return (iperr("sqrt/sqrtf",args));
	dvrt_append(args[0].code);
	no_oper(TOP_FPUSQRTFIRST);
	no_oper(TOP_FPUSQRTSTEP);
	no_oper(TOP_FPUSQRTSTEP);
	if(args[0].size == 2)
		{
		no_oper(TOP_FPUSQRTSTEP);
		no_oper(TOP_FPUSQRTSTEP);
		no_oper(TOP_FPUSQRTSTEP);
		}
	no_oper(TOP_FPUSQRTLAST);
	return (depth_max(args[0].depth,(INT_DEEP(1) | FLT_DEEP(3))));
	}

/*
 *	Intrinsic "memcpy"
 */
PRIVATE	unsigned int
imemcpy(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	unsigned int		tdepth;
	TEMP			temp;
	TEMP			temp1;

	if((numargs != 3) || (args[0].size != 1) || (args[1].size != 1) ||
		(args[2].size != 1))
		{
		return (iperr("memcpy/bcopy",args));
		}
/*
 *	Before we figure out the optimum load order for the "move" instruction
 *	we need to see if the destination address (which will be returned as
 *	the result), is "simple" or not.  If it is simple we just load the
 *	three operands in an optimum fashion, do a "move" and reload the
 *	destination address.  If it isn't simple we evaluate the destination
 *	address first into a temp and then load the three operands as
 *	appropriate and get the return value from the temp.
 */
	if(is_simple(args[0].expr))
		{
		tdepth = order312(numargs,args);
		no_oper(TOP_MOVE);
		(VOID) expr_code(NULL,args[1].expr,NEED_VALUE);
		}
	else
		{
		dvrt_append(args[0].code);	/* Destination address code */
		temp = get_temp();
		store_temp(Inttype,temp);	/* Save dest. address */
		dvrt_free(args[1].code);	/* In case temp # changes */
		dvrt_free(args[2].code);
/*
 *	Perform a bit of case analysis to determine the optimum load order
 *	when we know the destination address is stored in a temp already.
 */
		if((args[2].depth & INT_STACK) <= INT_DEEP(1))
			{
			(VOID) expr_code(NULL,args[1].expr,NEED_VALUE);
			tdepth = depth_max(args[0].depth,args[1].depth);
			load_temp(Inttype,temp);
			(VOID) expr_code(NULL,args[2].expr,NEED_VALUE);
			tdepth = depth_max(tdepth,args[2].depth);
			}
		else
		if((args[2].depth & INT_STACK) <= INT_DEEP(2))
			{
			(VOID) expr_code(NULL,args[1].expr,NEED_VALUE);
			tdepth = depth_max(args[0].depth,args[1].depth);
			(VOID) expr_code(NULL,args[2].expr,NEED_VALUE);
			tdepth = depth_max(tdepth,args[2].depth);
			load_temp(Inttype,temp);
			rev(Inttype);
			}
		else
		if((args[1].depth & INT_STACK) <= INT_DEEP(2))
			{
			(VOID) expr_code(NULL,args[2].expr,NEED_VALUE);
			tdepth = depth_max(args[0].depth,args[2].depth);
			(VOID) expr_code(NULL,args[1].expr,NEED_VALUE);
			tdepth = depth_max(tdepth,args[1].depth);
			rev(Inttype);
			load_temp(Inttype,temp);
			rev(Inttype);
			}
		else
			{
			(VOID) expr_code(NULL,args[2].expr,NEED_VALUE);
			tdepth = depth_max(args[0].depth,args[2].depth);
			temp1 = get_temp();
			store_temp(Inttype,temp1);	/* Save # bytes */
			(VOID) expr_code(NULL,args[1].expr,NEED_VALUE);
			tdepth = depth_max(tdepth,args[1].depth);
			load_temp(Inttype,temp);
			load_temp(Inttype,temp1);
			free_temp(temp1);
			}
		no_oper(TOP_MOVE);
		load_temp(Inttype,temp);	/* Returned dest. address */
		free_temp(temp);
		tdepth = depth_max(tdepth,INT_DEEP(3));
		}
	return (tdepth);
	}

/*
 *	Intrinsic "ChanIn"
 */
PRIVATE	unsigned int
icin(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	if((numargs != 3) || (args[0].size != 1) || (args[1].size != 1) ||
		(args[2].size != 1))
		{
		return (iperr("ChanIn",args));
		}
	(VOID) order312(numargs,args);
	no_oper(TOP_IN);
	return (INT_DEEP(3) | FLT_DEEP(3));
	}

/*
 *	Intrinsic "ChanInChar"
 */
PRIVATE	unsigned int
icinc(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	TEMP			temp;

	if((numargs != 1) || (args[0].size != 1))
		{
		return (iperr("ChanInChar",args));
		}
	temp = get_temp();
	dvrt_free(args[0].code);	/* To account for temp */
	if((args[0].depth & INT_STACK) <= INT_DEEP(2))
		{
		addr_temp(temp);	/* Address of temp */
		(VOID) expr_code(NULL,args[0].expr,NEED_VALUE);
		}
	else
		{
		(VOID) expr_code(NULL,args[0].expr,NEED_VALUE);
		addr_temp(temp);	/* Address of temp */
		rev(Inttype);
		}
	loadconstant((INT32) 1);
	no_oper(TOP_IN);
	addr_temp(temp);		/* Address of temp */
	no_oper(TOP_LB);		/* Load character that was read */
	if(Cpu_schar)			/* Should it be sign extended? */
		{
		/* Need to sign extend */
		loadconstant((INT32) 0x80);	/* Sign bit for chars */
		no_oper(TOP_XWORD);
		}
	free_temp(temp);
	return (INT_DEEP(3) | FLT_DEEP(3));
	}

/*
 *	Intrinsic "ChanInInt"
 */
PRIVATE	unsigned int
icini(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	TEMP			temp;

	if((numargs != 1) || (args[0].size != 1))
		{
		return (iperr("ChanInInt",args));
		}
	temp = get_temp();
	dvrt_free(args[0].code);	/* To account for temp */
	if((args[0].depth & INT_STACK) <= INT_DEEP(2))
		{
		addr_temp(temp);	/* Address of temp */
		(VOID) expr_code(NULL,args[0].expr,NEED_VALUE);
		}
	else
		{
		(VOID) expr_code(NULL,args[0].expr,NEED_VALUE);
		addr_temp(temp);	/* Address of temp */
		rev(Inttype);
		}
	loadconstant((INT32) Sizeof_int);
	no_oper(TOP_IN);
	load_temp(Inttype,temp);
	free_temp(temp);
	return (INT_DEEP(3) | FLT_DEEP(3));
	}

/*
 *	Intrinsic "ChanOut"
 */
PRIVATE	unsigned int
icout(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	if((numargs != 3) || (args[0].size != 1) || (args[1].size != 1) ||
		(args[2].size != 1))
		{
		return (iperr("ChanOut",args));
		}
	(VOID) order312(numargs,args);
	no_oper(TOP_OUT);
	return (INT_DEEP(3) | FLT_DEEP(3));
	}

/*
 *	Intrinsic "ChanOutChar"
 */
PRIVATE	unsigned int
icoutc(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	TEMP			temp;

	if((numargs != 2) || (args[0].size != 1) || (args[1].size != 1))
		{
		return (iperr("ChanOutChar",args));
		}
	dvrt_append(args[1].code);
	temp = get_temp();
	store_temp(Inttype,temp);
	dvrt_free(args[0].code);	/* To account for temp */
	if((args[0].depth & INT_STACK) <= INT_DEEP(2))
		{
		addr_temp(temp);	/* Address of temp */
		(VOID) expr_code(NULL,args[0].expr,NEED_VALUE);
		}
	else
		{
		(VOID) expr_code(NULL,args[0].expr,NEED_VALUE);
		addr_temp(temp);	/* Address of temp */
		rev(Inttype);
		}
	loadconstant((INT32) 1);
	no_oper(TOP_OUT);
	free_temp(temp);
	return (INT_DEEP(3) | FLT_DEEP(3));
	}

/*
 *	Intrinsic "ChanOutInt"
 */
PRIVATE	unsigned int
icouti(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	TEMP			temp;

	if((numargs != 2) || (args[0].size != 1) || (args[1].size != 1))
		{
		return (iperr("ChanOutInt",args));
		}
	dvrt_append(args[1].code);
	temp = get_temp();
	store_temp(Inttype,temp);
	dvrt_free(args[0].code);	/* To account for temp */
	if((args[0].depth & INT_STACK) <= INT_DEEP(2))
		{
		addr_temp(temp);	/* Address of temp */
		(VOID) expr_code(NULL,args[0].expr,NEED_VALUE);
		}
	else
		{
		(VOID) expr_code(NULL,args[0].expr,NEED_VALUE);
		addr_temp(temp);	/* Address of temp */
		rev(Inttype);
		}
	loadconstant((INT32) Sizeof_int);
	no_oper(TOP_OUT);
	free_temp(temp);
	return (INT_DEEP(3) | FLT_DEEP(3));
	}

/*
 *	Intrinsic "ChanReset"
 */
PRIVATE	unsigned int
icreset(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	if((numargs != 1) || (args[0].size != 1))
		return (iperr("ChanReset",args));
	dvrt_append(args[0].code);
	no_oper(TOP_RESETCH);
	return (args[0].depth);
	}

/*
 *	Intrinsic "ProcAfter"
 */
PRIVATE	unsigned int
ipafter(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	if((numargs != 1) || (args[0].size != 1))
		return (iperr("ProcAfter",args));
	dvrt_append(args[0].code);
	no_oper(TOP_TIN);
	return (INT_DEEP(3) | FLT_DEEP(3));
	}

/*
 *	Intrinsic "ProcGetPriority"
 */
PRIVATE	unsigned int
ipgetpri(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	if(numargs != 0)
		return (iperr("ProcGetPriority",args));
	no_oper(TOP_LDPRI);
	return (INT_DEEP(1));
	}

/*
 *	Intrinsic "ProcReschedule"
 */
PRIVATE	unsigned int
ipresch(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	if(numargs != 0)
		return (iperr("ProcReschedule",args));
	abs_oper(TOP_LDLP,(INT32) 0);
	no_oper(TOP_LDPRI);
	no_oper(TOP_OR);
	no_oper(TOP_RUNP);
	no_oper(TOP_STOPP);
	return (INT_DEEP(3) | FLT_DEEP(3));
	}

/*
 *	Intrinsic "PStop/ProcStop"
 */
PRIVATE	unsigned int
ipstop(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	if(numargs != 0)
		return (iperr("PStop/ProcStop",args));
	no_oper(TOP_STOPP);
	return (INT_DEEP(3) | FLT_DEEP(3));	/* Doesn't matter for STOPP */
	}

/*
 *	Intrinsic "ProcWait"
 */
PRIVATE	unsigned int
ipwait(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	if((numargs != 1) || (args[0].size != 1))
		return (iperr("ProcWait",args));
	dvrt_append(args[0].code);
	no_oper(TOP_LDTIMER);
	no_oper(TOP_SUM);
	no_oper(TOP_TIN);
	return (INT_DEEP(3) | FLT_DEEP(3));
	}

/*
 *	Intrinsic "SetTime"
 */
PRIVATE	unsigned int
istime(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	if((numargs != 1) || (args[0].size != 1))
		return (iperr("SetTime",args));
	dvrt_append(args[0].code);
	no_oper(TOP_STTIMER);
	return (args[0].depth);
	}

/*
 *	Intrinsic "Time"
 */
PRIVATE	unsigned int
itime(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	if(numargs != 0)
		return (iperr("Time",args));
	no_oper(TOP_LDTIMER);
	return (INT_DEEP(1));
	}

/*
 *	Intrinsic "SetLoPriQ"
 */
PRIVATE	unsigned int
islopri(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	if((numargs != 2) || (args[0].size != 1) || (args[1].size != 1))
		return (iperr("SetLoPriQ",args));
	dvrt_append(args[0].code);
	no_oper(TOP_STLF);
	dvrt_append(args[1].code);
	no_oper(TOP_STLB);
	return (depth_max(args[0].depth,args[1].depth));
	}

/*
 *	Intrinsic "SetHiPriQ"
 */
PRIVATE	unsigned int
ishipri(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	if((numargs != 2) || (args[0].size != 1) || (args[1].size != 1))
		return (iperr("SetHiPriQ",args));
	dvrt_append(args[0].code);
	no_oper(TOP_STHF);
	dvrt_append(args[1].code);
	no_oper(TOP_STHB);
	return (depth_max(args[0].depth,args[1].depth));
	}

/*
 *	Intrinsic "GetLoPriQ"
 */
PRIVATE	unsigned int
iglopri(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	if((numargs != 1) || (args[0].size != 1))
		return (iperr("GetLoPriQ",args));
	dvrt_append(args[0].code);
	no_oper(TOP_SAVEL);
	return (args[0].depth);
	}

/*
 *	Intrinsic "GetHiPriQ"
 */
PRIVATE	unsigned int
ighipri(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	if((numargs != 1) || (args[0].size != 1))
		return (iperr("GetHiPriQ",args));
	dvrt_append(args[0].code);
	no_oper(TOP_SAVEH);
	return (args[0].depth);
	}

/*
 *	Intrinsic "BitCnt"
 */
PRIVATE	unsigned int
ibcnt(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	unsigned int		depth;

	if((numargs != 1) || (args[0].size != 1))
		return (iperr("BitCnt",args));

	if((args[0].depth & INT_STACK) < INT_DEEP(3))
		{
		loadconstant((INT32) 0);
		dvrt_append(args[0].code);
		depth = depth_max(args[0].depth,args[0].depth + INT_DEEP(1));
		}
	else
		{
		dvrt_append(args[0].code);
		loadconstant((INT32) 0);
		rev(Inttype);
		depth = depth_max(args[0].depth,INT_DEEP(2));
		}
	no_oper(TOP_BITCNT);
	return (depth);
	}

/*
 *	Intrinsic "BitRevNBits"
 */
PRIVATE	unsigned int
ibrevnb(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	unsigned int		depth;

	if((numargs != 2) || (args[0].size != 1) || (args[1].size != 1))
		return (iperr("BitRevNBits",args));

	depth = do_call3(numargs,args,FALSE);
	no_oper(TOP_BITREVNBITS);
	return (depth);
	}

/*
 *	Intrinsic "BitRevWord"
 */
PRIVATE	unsigned int
ibrevw(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	if((numargs != 1) || (args[0].size != 1))
		return (iperr("BitRevWord",args));
	dvrt_append(args[0].code);
	no_oper(TOP_BITREVWORD);
	return (args[0].depth);
	}

/*
 *	Helping function for 2 dimensional block move/clip instructions.
 */
PRIVATE	unsigned int
move_help(numargs,args,name,ins_type)
	int			numargs;
	struct	arg_info	args[];
	char			*name;
	int			ins_type;
	{
	struct	arg_info	args2[3];
	struct	op_node		*current2;
	register int		numargs2;
	struct	dvrt		*tcode;
	struct	op_node		*texpr;
	unsigned int		tdepth;

	if((numargs != 3) || (args[0].size != 1) || (args[1].size != 1) ||
		(args[2].size != 1))
		{
		return (iperr(name,args));
		}
/*
 *	Initialize info table for second three parameters.
 */
	for(numargs2 = 0; numargs2 < 3; numargs2++)
		{
		args2[numargs2].code = NULL;
		args2[numargs2].depth = 0;
		args2[numargs2].expr = NULL;
		args2[numargs2].node = NULL;
		args2[numargs2].size = 0;
		}
/*
 *	Divert code for the second three parameters.  Keep track of the
 *	three expressions, the code each generates, the depth of the
 *	various stacks which evaluating the parameter trashes and the size
 *	of each parameter.
 */
	for(current2 = LEFT(args[2].node), numargs2 = 0;
		((current2 != NULL) && (numargs2 < 3));
			current2 = LEFT(current2),numargs2++)
		{
		/* Save node handle */
		args2[numargs2].node = current2;

		/* Save expression handle */
		args2[numargs2].expr = RIGHT(current2);
/*
 *	Compute & save parameter size depth and code.  Since the only legal
 *	operands are integral, arbitrarily set the size of other parameter
 *	types to 2 (illegal), so later error check will catch.
 */
		if(RIGHTTYPE(current2) & (FP_NODE | SU_NODE))
			args2[numargs2].size = 2;
		else
			{
			args2[numargs2].size = 1;
			dvrt_stack();
			args2[numargs2].depth = expr_code(NULL,
					RIGHT(current2),NEED_VALUE);
			args2[numargs2].code = dvrt_unstack();
			}
		}
/*
 *	Do error checking on second three sets of parameters.
 */
	if((numargs2 != 3) || (args2[0].size != 1) || (args2[1].size != 1) ||
		(args2[2].size != 1))
		{
/*
 *	Manually return diversions used by second set of parameters, first
 *	set diversions will be returned by "iperr".
 */
		if(args2[0].code != NULL)
			dvrt_free(args2[0].code);
		if(args2[1].code != NULL)
			dvrt_free(args2[1].code);
		if(args2[2].code != NULL)
			dvrt_free(args2[2].code);
		return (iperr(name,args));
		}
/*
 *	Now we twist the parameter order around in the "args" and "args2"
 *	structures to match what will be required by the move instructions.
 */
	tcode = args[0].code;
	tdepth = args[0].depth;
	texpr = args[0].expr;
	args[0].code = args[2].code;
	args[0].depth = args[2].depth;
	args[0].expr = args[2].expr;
	args[2].code = tcode;
	args[2].depth = tdepth;
	args[2].expr = texpr;

	tcode = args2[1].code;
	tdepth = args2[1].depth;
	texpr = args2[1].expr;
	args2[1].code = args2[2].code;
	args2[1].depth = args2[2].depth;
	args2[1].expr = args2[2].expr;
	args2[2].code = tcode;
	args2[2].depth = tdepth;
	args2[2].expr = texpr;
/*
 *	Evaluate the two sets of three expressions and insert the required
 *	instructions.
 */
	tdepth = do_call3(3,args2,FALSE);
	no_oper(TOP_MOVE2DINIT);
	tdepth = depth_max(tdepth,do_call3(3,args,FALSE));
	no_oper(ins_type);
	return (depth_max(tdepth,INT_DEEP(3)));
	}

/*
 *	Intrinsic "Move2D"
 */
PRIVATE	unsigned int
imv2d(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	return (move_help(numargs,args,"Move2D",TOP_MOVE2DALL));
	}

/*
 *	Intrinsic "Move2DNonZero"
 */
PRIVATE	unsigned int
imv2dnz(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	return (move_help(numargs,args,"Move2DNonZero",TOP_MOVE2DNONZERO));
	}

/*
 *	Intrinsic "Move2DZero"
 */
PRIVATE	unsigned int
imv2dz(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	return (move_help(numargs,args,"Move2DZero",TOP_MOVE2DZERO));
	}

/*
 *	Intrinsic "PHalt"
 */
PRIVATE	unsigned int
iphalt(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	if((numargs != 1) || (args[0].size != 1))
		return (iperr("PHalt",args));

	if((args[0].depth & INT_STACK) < INT_DEEP(3))
		{
		abs_oper(TOP_LDLP,(INT32) 0);
		no_oper(TOP_LDPRI);
		no_oper(TOP_OR);
		dvrt_append(args[0].code);
		}
	else
		{
		dvrt_append(args[0].code);
		abs_oper(TOP_LDLP,(INT32) 0);
		no_oper(TOP_LDPRI);
		no_oper(TOP_OR);
		rev(Inttype);
		}
	abs_oper(TOP_STNL,(INT32) 0);
	no_oper(TOP_STOPP);
	return (INT_DEEP(3) | FLT_DEEP(3));	/* Doesn't matter for STOPP */
	}

/*
 *	Intrinsic "PRun"
 */
PRIVATE	unsigned int
iprun(numargs,args)
	int			numargs;
	struct	arg_info	args[];
	{
	if((numargs != 1) || (args[0].size != 1))
		return (iperr("PRun",args));
	dvrt_append(args[0].code);
	no_oper(TOP_RUNP);
	return (args[0].depth);
	}

PUBLIC	unsigned int
do_icall(expr,numargs,args)
	struct	op_node		*expr;
	int			numargs;
	struct	arg_info	args[];
	{
	switch((unsigned int) (RIGHT(expr)->right.ptr.terminal->val.funcnum))
		{
		case	BI_ajw:
				return (iajw(numargs,args));
		case	BI_eval:
				return (ieval(numargs,args));
		case	BI_fabs:
		case	BI_fabsf:
				return (ifabs(numargs,args));
		case	BI_sqrt:
		case	BI_sqrtf:
				return (isqrt(numargs,args));
		case	BI_memcpy:
				return (imemcpy(numargs,args));
		case	BI_ChanIn:
				return (icin(numargs,args));
		case	BI_ChanInChar:
				return (icinc(numargs,args));
		case	BI_ChanInInt:
				return (icini(numargs,args));
		case	BI_ChanOut:
				return (icout(numargs,args));
		case	BI_ChanOutChar:
				return (icoutc(numargs,args));
		case	BI_ChanOutInt:
				return (icouti(numargs,args));
		case	BI_ChanReset:
				return (icreset(numargs,args));
		case	BI_ProcAfter:
				return (ipafter(numargs,args));
		case	BI_ProcGetPriority:
				return (ipgetpri(numargs,args));
		case	BI_ProcReschedule:
				return (ipresch(numargs,args));
		case	BI_ProcStop:
				return (ipstop(numargs,args));
		case	BI_ProcWait:
				return (ipwait(numargs,args));
		case	BI_SetTime:
				return (istime(numargs,args));
		case	BI_Time:
				return (itime(numargs,args));
		case	BI_SetLoPriQ:
				return (islopri(numargs,args));
		case	BI_SetHiPriQ:
				return (ishipri(numargs,args));
		case	BI_GetLoPriQ:
				return (iglopri(numargs,args));
		case	BI_GetHiPriQ:
				return (ighipri(numargs,args));
		case	BI_BitCnt:
				return (ibcnt(numargs,args));
		case	BI_BitRevNBits:
				return (ibrevnb(numargs,args));
		case	BI_BitRevWord:
				return (ibrevw(numargs,args));
		case	BI_Move2D:
				return (imv2d(numargs,args));
		case	BI_Move2DNonZero:
				return (imv2dnz(numargs,args));
		case	BI_Move2DZero:
				return (imv2dz(numargs,args));
		case	BI_PHalt:
				return (iphalt(numargs,args));
		case	BI_PRun:
				return (iprun(numargs,args));
		}
	return (INT_DEEP(3) | FLT_DEEP(3));	/* Only needed by lint... */
	}

/* End of tcx6e.c */
