/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: tcxdecl.h,v 2.2 92/04/21 11:11:23 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 *	TCX Compiler Global Declarations
 *
 *	Copyright (c) 1987 by Quality Computer Systems and Logical Systems.
 *	All rights reserved.
 *
 *	Published by:	Logical Systems
 *			P.O. Box 1702
 *			Corvallis, OR 97339 (USA)
 *
 *	03/17/87
 *
 *	This file is set up to actually allocate storage when the symbol
 *	MAIN is defined before including this file.  Otherwise, it just
 *	generates external references to the various variables.  It is
 *	easier to keep this file correct as compared to two different
 *	files which must be kept mostly the same.
 */

#ifdef	MAIN

#define	EXTERN	PUBLIC		/* Actually allocate storage		*/
/*lint -e723		These definitions are really what I want	*/
#define	EQ_BRZERO		= {0}
#define	EQ_TRUE			= TRUE
#define	EQ_FALSE		= FALSE
#define	EQ_ZERO			= 0
#define	EQ_ONE			= 1
#define	EQ_TWO			= 2
#define	EQ_THREE		= 3
#define	EQ_INT_SIZE		= WORD_SIZE_32B
#define	EQ_NULL			= NULL
#define	COPYRIGHT = "Copyright (c) 1987-1991 Quality Computer Systems and Logical Systems"
#define	SIGNON			= "TCX Compiler "
#if H_OPSYS == MS_DOS
#define	VERSION			= "V91.1 (PC->Transputer)"
#endif
#if H_OPSYS == VMS
#define	VERSION			= "V91.1 (VMS->Transputer)"
#endif
#if ((H_OPSYS == UNIX) || (H_OPSYS == BSD))
#define	VERSION			= "V91.1 (Unix->Transputer)"
#endif
#if H_OPSYS == MPW
#define	VERSION			= "V91.1 (Mac->Transputer)"
#endif
#if H_OPSYS == XENIX
#define VERSION			= "V91.1 (XENIX->Transputer)"
#endif
/*lint +e723 */

#else

#define	EXTERN	extern		/* Just give a reference to the variables */
#define	EQ_BRZERO
#define	EQ_TRUE
#define	EQ_FALSE
#define	EQ_ZERO
#define	EQ_ONE
#define	EQ_TWO
#define	EQ_THREE
#define	EQ_INT_SIZE
#define	EQ_NULL
#define	COPYRIGHT
#define	SIGNON
#define	VERSION

#endif

/*
 *	Set up the banner strings.
 */
EXTERN	char	Copyright[]	COPYRIGHT;
EXTERN	char	Signon[]	SIGNON;
EXTERN	char	Version[]	VERSION;

/*
 *	Operator switch settings.
 */
EXTERN	int	Cpu_schar	EQ_FALSE;	/* TRUE if signed chars	*/
EXTERN	int	Cpu_srshift	EQ_FALSE;	/* TRUE if signed >>	*/
EXTERN	int	Cpu_type			/* CPU type		*/
#ifdef MAIN
#if	KIT_VERSION
				= T4EX
#else	/* !KIT_VERSION */
				= T414
#endif	/* KIT_VERSION */
#endif		/* MAIN */
	;
EXTERN	BOOL	Debug		EQ_FALSE;	/* TRUE/write debug info*/
EXTERN	BOOL	Errdel		EQ_TRUE;	/* TRUE/kill out if err	*/
EXTERN	int	Float_mode	EQ_ONE;		/* Floating point mode	*/
EXTERN	BOOL	FP_reorder	EQ_TRUE;	/* TRUE/reorder FP opt. */
EXTERN	BOOL	Builtin		EQ_TRUE;	/* TRUE/use intrinsics	*/
EXTERN	BOOL	Inter_file	EQ_FALSE;	/* TRUE/inter-pass buff.*/
EXTERN	BOOL	Peepopt		EQ_TRUE;	/* TRUE/use peephole opt*/
EXTERN	BOOL	Rel_only	EQ_FALSE;	/* TRUE/gen. rel. code	*/
EXTERN	BOOL	Round_mode	EQ_FALSE;	/* TRUE/round to nearest*/
EXTERN	int	SegMap[3]	EQ_BRZERO;	/* Mapping for segments	*/
EXTERN	BOOL	Source_info	EQ_TRUE;	/* TRUE/print #line info*/
EXTERN	BOOL	Static_link	EQ_FALSE;	/* TRUE/static link mdl	*/
EXTERN	BOOL	Tracein		EQ_FALSE;	/* TRUE/use in trace fn	*/
EXTERN	BOOL	Traceout	EQ_FALSE;	/* TRUE/use out trace fn*/
EXTERN	char	Triname[MAXLABEL+1] EQ_BRZERO;	/* Trace in fn name buf	*/
EXTERN	char	Troname[MAXLABEL+1] EQ_BRZERO;	/* Trace out fn name buf*/

#if	H_OPSYS != MPW
EXTERN	BOOL	Verbose		EQ_FALSE;	/* TRUE to be chatty	*/
#else
EXTERN	BOOL	Verbose		EQ_FALSE;	/* TRUE to be chatty	*/
#endif	/* !MPW */

EXTERN	int	Warn_level	EQ_TWO;		/* Wrng lvl dflts to "2"*/

/*
 *	Size of basic target machine data types in bytes.
 */
EXTERN	int	Sizeof_int	EQ_INT_SIZE;	/* Size of a normal int	*/
EXTERN	int	Sizeof_long	EQ_INT_SIZE;	/* Size of a long int	*/
EXTERN	int	Sizeof_ptr	EQ_INT_SIZE;	/* Size of a pointer	*/
EXTERN	int	Sizeof_short	EQ_INT_SIZE;	/* Size of a short int	*/

/*
 *	Compiler "base" type pointers.
 */
EXTERN	struct	id_node	*Typelist	EQ_NULL;/* The type table	*/
EXTERN	struct	id_node	*Ifunctype	EQ_NULL;/* 'func returing int'	*/
EXTERN	struct	id_node	*Voidtype	EQ_NULL;/* 'void'		*/
EXTERN	struct	id_node	*Chartype	EQ_NULL;/* 'char'		*/
EXTERN	struct	id_node	*Uchartype	EQ_NULL;/* 'unsigned char'	*/
EXTERN	struct	id_node	*Shorttype	EQ_NULL;/* 'short'		*/
EXTERN	struct	id_node	*Ushorttype	EQ_NULL;/* 'unsigned short'	*/
EXTERN	struct	id_node	*Inttype	EQ_NULL;/* 'int'		*/
EXTERN	struct	id_node	*Uinttype	EQ_NULL;/* 'unsigned int'	*/
EXTERN	struct	id_node	*Longtype	EQ_NULL;/* 'long'		*/
EXTERN	struct	id_node	*Ulongtype	EQ_NULL;/* 'unsigned long'	*/
EXTERN	struct	id_node	*Floattype	EQ_NULL;/* 'float'		*/
EXTERN	struct	id_node	*Doubletype	EQ_NULL;/* 'double'		*/
EXTERN	struct	id_node	*Ldoubletype	EQ_NULL;/* 'long double'	*/
EXTERN	struct	id_node	*True		EQ_NULL;/* TRUE constant	*/
EXTERN	struct	id_node	*False		EQ_NULL;/* FALSE constant	*/

/*
 *	Misc variables.
 */
EXTERN	INT32	Autospace 	EQ_ZERO;	/* Max sze of loc vars	*/
EXTERN struct swheader *Casestack EQ_NULL;	/* Switch stmt stack	*/
EXTERN	char	Coutext[FILNAMSIZE + 1] 	/* Code output exten.	*/
#ifdef MAIN
				= ASM_FEXT
#endif		/* MAIN */
	;
EXTERN	char	Coutfil[FILNAMSIZE+1] EQ_BRZERO;/* Code output fname	*/
EXTERN	FILE	*Coutput	EQ_NULL;	/* IOB for output file	*/
EXTERN	BOOL	Eof		EQ_FALSE;	/* TRUE/reached EOF	*/
EXTERN	int	Errcnt		EQ_ZERO;	/* # compile errors	*/
EXTERN struct id_node *Func_type EQ_NULL;	/* Cur. function type	*/
EXTERN char Infil[FILNAMSIZE+1] EQ_BRZERO;	/* Current in file name */
EXTERN struct op_node *Initlist EQ_NULL;	/* List of auto inits	*/
EXTERN	FILE	*Input		EQ_NULL;	/* IOB for input file	*/
EXTERN	FILE	*Interfp	EQ_NULL;	/* IOB for inter-pass	*/
EXTERN char Ipfil[FILNAMSIZE+1] EQ_BRZERO;	/* Inter-pass filename	*/
EXTERN	char	*Line		EQ_NULL;	/* Parsing buffer	*/
EXTERN	int	Lineno		EQ_ZERO;	/* Ln # in cur in file	*/
EXTERN	char	*Lptr		EQ_NULL;	/* Parsing line buffer	*/
EXTERN	int	Mem_id_space			/* ID # of cur memb NS	*/
#ifdef	MAIN
				= NS_MEMBER
#endif		/* MAIN */
	;
EXTERN	int	Ncmp		EQ_ZERO;	/* # open blocks ("{}")	*/
EXTERN	BOOL	Newfile		EQ_TRUE;	/* TRUE/new fname is fnd*/
EXTERN	char	**Nextfil	EQ_NULL;	/* Ptr/name next inp fil*/
EXTERN	int	Ninfils		EQ_ZERO;	/* # of input files	*/
EXTERN	INT32	Slboff		EQ_ZERO;	/* Static link loc addr */
EXTERN struct dvrt *Static_dvrt EQ_NULL;	/* Static div. within fn*/
EXTERN	BOOL	Stopeol		EQ_FALSE;	/* TRUE/stop EOL if WS	*/
EXTERN	INT32	Structspace	EQ_ZERO;	/* Max SU fn ret tmp siz*/
EXTERN	struct	swq *Swqueue	EQ_NULL;	/* Strt of switch/loop Q*/
EXTERN	INT32	Tempspace	EQ_ZERO;	/* Max size tmps for fn	*/

/*
 *	Opcode strings and equivalent values (only those used by TCX).
 */
#define	TOP_BETWEEN		0
#define	TOP_COMMENT		1
#define	TOP_LABEL		2

#define	TOP_SPECIAL_MAX		2	/* Largest # for special output */

#define	TOP_ALIGN		3
#define	TOP_ALL			4
#define	TOP_BAD			5
#define	TOP_DB			6
#define	TOP_DS			7
#define	TOP_DW			8
#define	TOP_EMULATE		9
#define	TOP_END			10
#define	TOP_EXT			11
#define	TOP_MOD			12
#define	TOP_PUB			13
#define	TOP_REAL32		14
#define	TOP_REAL64		15
#define	TOP_REL			16
#define	TOP_RETF		17
#define	TOP_SYM			18
#define	TOP_T212		19
#define	TOP_T414		20
#define	TOP_T800		21
#define	TOP_VAL			22
#define	TOP_ADC			23
#define	TOP_ADD			24
#define	TOP_AJW			25
#define	TOP_AND			26
#define	TOP_BCNT		27
#define	TOP_BITCNT		28
#define	TOP_BITREVNBITS		29
#define	TOP_BITREVWORD		30
#define	TOP_CALL		31
#define	TOP_CJ			32
#define	TOP_DIFF		33
#define	TOP_DIV			34
#define	TOP_DUP			35
#define	TOP_EQC			36
#define	TOP_FPADD		37
#define	TOP_FPB32TOR64		38
#define	TOP_FPDIV		39
#define	TOP_FPDUP		40
#define	TOP_FPEQ		41
#define	TOP_FPGT		42
#define	TOP_FPI32TOR32		43
#define	TOP_FPI32TOR64		44
#define	TOP_FPINT		45
#define	TOP_FPLDNLADDDB		46
#define	TOP_FPLDNLADDSN		47
#define	TOP_FPLDNLDB		48
#define	TOP_FPLDNLMULDB		49
#define	TOP_FPLDNLMULSN		50
#define	TOP_FPLDNLSN		51
#define	TOP_FPLDZERODB		52
#define	TOP_FPLDZEROSN		53
#define	TOP_FPMUL		54
#define	TOP_FPREV		55
#define	TOP_FPSTNLDB		56
#define	TOP_FPSTNLI32		57
#define	TOP_FPSTNLSN		58
#define	TOP_FPSUB		59
#define	TOP_FPUABS		60
#define	TOP_FPUDIVBY2		61
#define	TOP_FPUMULBY2		62
#define	TOP_FPUR32TOR64		63
#define	TOP_FPUR64TOR32		64
#define	TOP_FPURZ		65
#define	TOP_FPUSQRTFIRST	66
#define	TOP_FPUSQRTLAST		67
#define	TOP_FPUSQRTSTEP		68
#define	TOP_GAJW		69
#define	TOP_GCALL		70
#define	TOP_GT			71
#define	TOP_IN			72
#define	TOP_J			73
#define	TOP_LB			74
#define	TOP_LDC			75
#define	TOP_LDIV		76
#define	TOP_LDL			77
#define	TOP_LDLP		78
#define	TOP_LDNL		79
#define	TOP_LDPI		80
#define	TOP_LDPRI		81
#define	TOP_LDTIMER		82
#define	TOP_LSHR		83
#define	TOP_MINT		84
#define	TOP_MOVE		85
#define	TOP_MOVE2DALL		86
#define	TOP_MOVE2DINIT		87
#define	TOP_MOVE2DNONZERO	88
#define	TOP_MOVE2DZERO		89
#define	TOP_NOT			90
#define	TOP_OR			91
#define	TOP_OUT			92
#define	TOP_PROD		93
#define	TOP_REM			94
#define	TOP_RESETCH		95
#define	TOP_RET			96
#define	TOP_REV			97
#define	TOP_RUNP		98
#define	TOP_SAVEH		99
#define	TOP_SAVEL		100
#define	TOP_SB			101
#define	TOP_SHL			102
#define	TOP_SHR			103
#define	TOP_STHB		104
#define	TOP_STHF		105
#define	TOP_STL			106
#define	TOP_STLB		107
#define	TOP_STLF		108
#define	TOP_STNL		109
#define	TOP_STOPP		110
#define	TOP_STTIMER		111
#define	TOP_SUB			112
#define	TOP_SUM			113
#define	TOP_TIN			114
#define	TOP_U32TOR32		115
#define	TOP_XDBLE		116
#define	TOP_XOR			117
#define	TOP_XWORD		118

/*
 *	The timings in the following list are only approximate since no
 *	determination of required prefix length can generally be done at
 *	compile time.  The timings are also more accurate for the 32 bit word
 *	size CPU's, but a rough correction for those instructions whose length
 *	is heavily word length dependent is accomplished using the I_WORDTIMING
 *	flag which indicates that the listed time should be divided by two for
 *	the 16 bit parts.
 */
EXTERN	struct	ins_info	Opcodes[]
#ifdef	MAIN
	=
	{
		{"<BETWEEN>",	0},	/* Between stack reservations */
		{"<COMMENT>",	0},	/* Full line comment */
		{"<LABEL>",	0},	/* Label line */

		{".ALIGN",	0},
		{".ALL",	0},
		{".BAD",	0},	/* Internal compiler error */
		{".DB",		0},
		{".DS",		0},
		{".DW",		0},
		{".EMULATE",	0},
		{".END",	0},
		{".EXT",	0},
		{".MOD",	0},
		{".PUB",	0},
		{".REAL32",	0},
		{".REAL64",	0},
		{".REL",	0},
		{".RETF",	0},
		{".SYM",	0},
		{".T212",	0},
		{".T414",	0},
		{".T800",	0},
		{".VAL",	0},
		{"ADC",		(1 |I_OP3ROLE)},		/* Average */
		{"ADD",		(1 |I_OP3ROLE)},
		{"AJW",		(1 |I_OP3ROLE)},		/* Average */
		{"AND",		(2 |I_OP3ROLE)},
		{"BCNT",	(3 |I_OP3ROLE)},
		{"BITCNT",	(19|I_OP3ROLE|I_WORDTIMING)},	/* Average */
		{"BITREVNBITS",	(21|I_OP3ROLE|I_WORDTIMING)},	/* Average */
		{"BITREVWORD",	(37|I_OP3ROLE|I_WORDTIMING)},
		{"CALL",	(7 )},				/* Average */
		{"CJ",		(3 )},				/* Average */
		{"DIFF",	(1 |I_OP3ROLE)},
		{"DIV",		(43|I_OP3ROLE|I_WORDTIMING)},	/* Average */
		{"DUP",		(2 |I_OP3ROLE)},
		{"EQC",		(2 |I_OP3ROLE)},		/* Average */
		{"FPADD",	(8 |I_FPOP1ROLE|I_FPOP2ROLE)},
		{"FPB32TOR64",	(11|I_FPOP1ROLE)},
		{"FPDIV",	(25|I_FPOP1ROLE|I_FPOP2ROLE)},	/* Average */
		{"FPDUP",	(2 |I_FPOP2ROLE)},
		{"FPEQ",	(5 )},
		{"FPGT",	(6 )},
		{"FPI32TOR32",	(12|I_FPOP1ROLE)},
		{"FPI32TOR64",	(12|I_FPOP1ROLE)},
		{"FPINT",	(6 |I_FPOP1ROLE|I_FPOP2ROLE)},
		{"FPLDNLADDDB",	(13|I_FPOP1ROLE)},
		{"FPLDNLADDSN",	(11|I_FPOP1ROLE)},
		{"FPLDNLDB",	(6 )},
		{"FPLDNLMULDB",	(26|I_FPOP1ROLE)},
		{"FPLDNLMULSN",	(15|I_FPOP1ROLE)},
		{"FPLDNLSN",	(4 )},
		{"FPLDZERODB",	(2 |I_FPOP2ROLE)},
		{"FPLDZEROSN",	(2 |I_FPOP2ROLE)},
		{"FPMUL",	(16|I_FPOP1ROLE|I_FPOP2ROLE)},	/* Average */
		{"FPREV",	(2 |I_FPOP2ROLE)},
		{"FPSTNLDB",	(6 )},
		{"FPSTNLI32",	(5 )},
		{"FPSTNLSN",	(4 )},
		{"FPSUB",	(8 |I_FPOP1ROLE|I_FPOP2ROLE)},
		{"FPUABS",	(3 )},
		{"FPUDIVBY2",	(9 |I_FPOP1ROLE)},
		{"FPUMULBY2",	(9 |I_FPOP1ROLE)},
		{"FPUR32TOR64",	(4 |I_FPOP1ROLE)},
		{"FPUR64TOR32",	(6 |I_FPOP1ROLE)},
		{"FPURZ",	(1 )},
		{"FPUSQRTFIRST",(26|I_FPOP1ROLE)},
		{"FPUSQRTLAST",	(11|I_FPOP1ROLE)},
		{"FPUSQRTSTEP",	(43|I_FPOP1ROLE)},
		{"GAJW",	(3 |I_OP3ROLE)},
		{"GCALL",	(4 )},
		{"GT",		(2 |I_OP3ROLE)},
		{"IN",		(20)},				/* Length? */
		{"J",		(3 )},				/* Average */
		{"LB",		(5 |I_OP3ROLE)},
		{".LDC",	(1 |I_OP3ROLE)},		/* Average */
		{"LDIV",	(36|I_OP3ROLE|I_WORDTIMING)},
		{"LDL",		(2 |I_OP3ROLE)},		/* Average */
		{"LDLP",	(1 |I_OP3ROLE)},		/* Average */
		{"LDNL",	(2 |I_OP3ROLE)},		/* Average */
		{"LDPI",	(3 |I_OP3ROLE)},
		{"LDPRI",	(2 |I_OP3ROLE)},
		{"LDTIMER",	(3 |I_OP3ROLE)},
		{"LSHR",	(20|I_OP3ROLE|I_WORDTIMING)},
		{"MINT",	(2 |I_OP3ROLE)},
		{"MOVE",	(11|I_OP3ROLE|I_WORDTIMING)},
		{"MOVE2DALL",	(99|I_OP3ROLE)},		/* Unknown */
		{"MOVE2DINIT",	(99|I_OP3ROLE)},		/* Unknown */
		{"MOVE2DNONZERO",(99|I_OP3ROLE)},		/* Unknown */
		{"MOVE2DZERO",	(99|I_OP3ROLE)},		/* Unknown */
		{"NOT",		(2 |I_OP3ROLE)},
		{"OR",		(2 |I_OP3ROLE)},
		{"OUT",		(21)},				/* Length? */
		{"PROD",	(20|I_OP3ROLE|I_WORDTIMING)},	/* Average */
		{"REM",		(37|I_OP3ROLE|I_WORDTIMING)},	/* Average */
		{"RESETCH",	(4 |I_OP3ROLE)},
		{"RET",		(6 )},
		{"REV",		(1 |I_OP3ROLE)},
		{"RUNP",	(11)},
		{"SAVEH",	(5 |I_OP3ROLE)},
		{"SAVEL",	(5 |I_OP3ROLE)},
		{"SB",		(5 |I_OP3ROLE)},
		{"SHL",		(19|I_OP3ROLE|I_WORDTIMING)},	/* Average */
		{"SHR",		(19|I_OP3ROLE|I_WORDTIMING)},	/* Average */
		{"STHB",	(2 |I_OP3ROLE)},
		{"STHF",	(2 |I_OP3ROLE)},
		{"STL",		(1 |I_OP3ROLE)},		/* Average */
		{"STLB",	(2 |I_OP3ROLE)},
		{"STLF",	(2 |I_OP3ROLE)},
		{"STNL",	(2 |I_OP3ROLE)},		/* Average */
		{"STOPP",	(12)},
		{"STTIMER",	(2 |I_OP3ROLE)},
		{"SUB",		(1 |I_OP3ROLE)},
		{"SUM",		(2 |I_OP3ROLE)},
		{"TIN",		(99)},				/* Unknown */
		{"?U32TOR32",	(99)},				/* Unknown */
		{"XDBLE",	(3 |I_OP3ROLE)},
		{"XOR",		(2 |I_OP3ROLE)},
		{"XWORD",	(5 |I_OP3ROLE)},
		{NULL,		0}
	}
#endif	/* MAIN */
	;

/* End of TCXDECL.H */
