/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: tlnkdef.h,v 2.2 92/04/21 11:13:03 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/************************************************************************/
/*									*/
/*	File:	tlnkdef.h						*/
/*									*/
/*	Definitions for the Transputer Linker (TLNK).			*/
/*									*/
/*		Written by Kirk Bailey of Logical Systems.		*/
/*									*/
/*		Copyright (c) 1986-1987 by Logical Systems.		*/
/*									*/
/*				09/01/86				*/
/*									*/
/************************************************************************/

#define	EXTRA_TEMP	"tlnktemp"	/* Filename for "extra" temp file */
#define	TEMP_NAME	"tlnktemp."	/* Name prefix for "module" temps */

#define	T212_LOAD	0xFFFF8800L	/* T212 default program base addr */
#define	T212_STACK	0xFFFF8800L	/* T212 default workspace/stack */
#define	T414_LOAD	0x80000800L	/* T414 default program base addr */
#define	T414_STACK	0x80000800L	/* T414 default workspace/stack */
#define	T800_LOAD	0x80001000L	/* T800 default program base addr */
#define	T800_STACK	0x80001000L	/* T800 default workspace/stack */

#define	MAX_SYMBOLS	5450		/* Max. # of local + global symbols */

#if	(H_OPSYS == MS_DOS) && (MAX_SYMBOLS > 5450)
#define	HUGE_LOCALST	1		/* Local symbol table > 64K */
#else
#define	HUGE_LOCALST	0		/* Not MS-DOS or locals <= 64K */
#endif

#define	MAX_GLOBALS	2048		/* Max. # global symbols (see next) */
#define	GLOBALS_MASK	0x07FF		/* Log base 2 of "MAX_GLOBALS" */
#define	ACCDATASIZE	1024		/* Data accumulation buffer size */

#define	ST_LIST_COLS	3		/* # of columns in symbol table list */
#define	SYM_LIST_COLS	6		/* # of columns in file symbol list */

#define	ENTRYPOINT	"_start"	/* Default entry point symbol */
#define	SLBNAME		"?slb"		/* Global "static link" base name */

/*
 *	Possible values for "entry_type".
 */

#define	NO_ENTRY	0		/* No entrypoint selected */
#define	NUM_ENTRY	1		/* Numeric entrypoint ("entry_n") */
#define	SYM_ENTRY	2		/* Symbolic entrypoint ("entry_s") */

/*
 *	Virtual memory/local buffering stuff.
 */

#ifdef	VMFILE
#define	VBSIZE		500		/* # chars/virtual memory buffer */
typedef	struct	vstream	*	VSTREAM;	/* VM stream "pointer" */
#define	PUT_1B(c)	{ if(put_buf.count >= VBSIZE) alloc_vbuf();\
				*put_buf.ptr++ = (c); put_buf.count++; }
#else	/* !VMFILE */
typedef	STREAM		VSTREAM;
#define	PUT_1B(c)	{ *put_buf.ptr++ = (c);\
				if(++put_buf.count >= LOCAL_BUF_SIZE)\
					put_flush(); }
#endif	/* VMFILE */

#define	GET_1B()	((get_buf.count-- >0)?((int)*get_buf.ptr++):get_next())
#define	IN_1B()		(is_lib ? in_1b() :\
				((get_buf.count-- > 0) ?\
					((int) *get_buf.ptr++) : in_next()))
