/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: tlnktyp.h,v 2.2 92/04/21 11:13:04 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/************************************************************************/
/*									*/
/*	File:	tlnktyp.h						*/
/*									*/
/*	Data type declarations for the Transputer Linker (TLNK).	*/
/*									*/
/*		Written by Kirk Bailey of Logical Systems.		*/
/*									*/
/*		Copyright (c) 1986-1987 by Logical Systems.		*/
/*									*/
/*				09/01/86				*/
/*									*/
/************************************************************************/

#ifdef	VMFILE
struct	vbuf				/* Virtual memory buffer unit */
	{
	struct	vbuf	*next;		/* Point to next "vbuf" in file */
	UINT	vcount;			/* Bytes in this buffer */
	UCHAR	vbuffer[VBSIZE];	/* Actual characters in buffer */
	};

struct	vstream				/* Virtual memory "stream" ptr info */
	{
	struct	vbuf	*first;		/* First "vbuf" of file */
	struct	vbuf	*current;	/* Current "vbuf" of file */
	};
#endif	/* VMFILE */

struct	gst				/* Global symbol table element */
	{
	UINT	lst_num;		/* Definition local symbol # */
	STRING	name;			/* Point to ASCII symbol name */
	};

struct	lbuf				/* Local buffer control structure */
	{
	unsigned char	*start;		/* Pointer to start of buffer */
	UINT	count;			/* # of chars in buffer */
	VSTREAM	fp;			/* File pointer for buffer */
	unsigned char	*ptr;		/* Current buffer pointer */
	};

struct	lst				/* Local symbol table element */
	{
	UINT	gst_num;		/* Global symbol table # (if needed) */
	SLONG	max_addr;		/* Maximum definition address */
	SLONG	min_addr;		/* Minimum definition address */
	UINT	region;			/* Code/data region tag */
/*
 *	If the local symbol table will be >128K in length under MS-DOS, we
 *	need to round the array element size up to a power of 2 (16 bytes),
 *	in order to make MSC's "halloc" function happy (not to mention
 *	keeping the "huge" segment math from breaking).  Note that HUGE_LOCALST
 *	is TRUE for symbol tables >64K so this is a bit wasteful for tables
 *	which are between 64K and 128K...
 */
#if	HUGE_LOCALST
	char	padding[4];
#endif	/* HUGE_LOCALST */
	};
