/*
 *	OSU Research Computing					Trillium
 *
 *	Function:	- bnail.1x8.ring
 *			- eight ITB nodes connected in a loop with the
 *			  host node via /dev/bxiv0
 */

/*
 * general NaIL syntax
 *
 * TWEIGHT = <[link_wt], [host_wt], [order_wt], [mcast_wt], [hop_wt]>
 * TNODE = <nodeid, node_type>
 * TLINK = <from_node, outlink, [oname], to_node, inlink, [iname], [weight]>
 * TROUTE = <any_node, dest_node, outlink, [outlink2]>
 * TORDER = <src_node, dest_node, [weight]>
 * TSOLDER = <node, [hostname], [sysnode]>
 */

TWEIGHT = <1, 1, 1, 1, 0>;

/*
 * host node
 */
TNODE = <100, 0>;

/*
 * ITB nodes
 */
TNODE = <0, 1> <1, 1> <2, 1> <3, 1>;
TNODE = <4, 1> <5, 1> <6, 1> <7, 1>;

/*
 * host connections
 */
TLINK = <100, 0, "/dev/bxiv0", 0, 0,,> <0, 0,, 100, 0, "/dev/bxiv0",>;

/*
 * ITB grid links
 */
TLINK = <0, 2,, 1, 1,,> <1, 1,, 0, 2,,>;
TLINK = <1, 2,, 2, 1,,> <2, 1,, 1, 2,,>;
TLINK = <2, 2,, 3, 1,,> <3, 1,, 2, 2,,>;
TLINK = <3, 2,, 4, 1,,> <4, 1,, 3, 2,,>;
TLINK = <4, 2,, 5, 1,,> <5, 1,, 4, 2,,>;
TLINK = <5, 2,, 6, 1,,> <6, 1,, 5, 2,,>;
TLINK = <6, 2,, 7, 1,,> <7, 1,, 6, 2,,>;
TLINK = <7, 0,, 0, 3,,> <0, 3,, 7, 0,,>;

/*
 * vendor specific node assignment
 */
TSOLDER = <100,,>;
TSOLDER = <0,, "0.0"> <1,, "0.1"> <2,, "0.2"> <3,, "0.3">;
TSOLDER = <4,, "0.4"> <5,, "0.5"> <6,, "0.6"> <7,, "0.7">;
