/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	GDB
 *
 *	$Log:	T_TYPES.h,v $
 * Revision 2.2  92/04/30  14:44:46  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.1  92/01/19  20:24:28  gdburns
 * facelift and sync with new features
 * 
 * Revision 2.1  91/03/20  11:34:36  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.2  90/11/15  16:13:42  raghu
 * Changed RW and RS to reflect the types of arguments.
 * 
 * Revision 2.0.1.1  90/07/13  19:28:02  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:54:51  trillium
 * Homo erectus
 * 
 *	Function:	- defines type conversions for F77
 */

#ifndef _T_TYPESF
#define _T_TYPESF

#ifdef gould

#define ILTOT(x)	(IRW(x))
#define ITTOL(x)	(IRW(x))
#define ILTOTS(x)	(IRS(x))
#define ITTOLS(x)	(IRS(x))

#elif vax

#define ILTOT(x)	(x)
#define ITTOL(x)	(x)
#define ILTOTS(x)	(x)
#define ITTOLS(x)	(x)

#elif sparc || mc68020

#define ILTOT(x)	(IRW(x))
#define ITTOL(x)	(IRW(x))
#define ILTOTS(x)	(IRS(x))
#define ITTOLS(x)	(IRS(x))
#define FTTOLF(x)	(FRF(x))
#define FLTOTF(x)	(FRF(x))
#define FTTOLD(x)	(FRD(x))
#define FLTOTD(x)	(FRD(x))

#elif ibm032

#define ILTOT(x)	(IRW(x))
#define ITTOL(x)	(IRW(x))
#define ILTOTS(x)	(IRS(x))
#define ITTOLS(x)	(IRS(x))
#define FTTOLF(x)	(FRF(x))
#define FLTOTF(x)	(FRF(x))
#define FTTOLD(x)	(FRD(x))
#define FLTOTD(x)	(FRD(x))

#elif tputer

#define ILTOT(x)	(x)
#define ITTOL(x)	(x)
#define ILTOTS(x)	(x)
#define ITTOLS(x)	(x)
#define FTTOLF(x)	(x)
#define FLTOTF(x)	(x)
#define FTTOLD(x)	(x)
#define FLTOTD(x)	(x)

#elif i386 || i860

#define ILTOT(x)	(x)
#define ITTOL(x)	(x)
#define ILTOTS(x)	(x)
#define ITTOLS(x)	(x)
#define FTTOLF(x)	(x)
#define FLTOTF(x)	(x)
#define FTTOLD(x)	(x)
#define FLTOTD(x)	(x)

#elif CRAY

#define ILTOT(x)	(x)
#define ITTOL(x)	(x)
#define ILTOTS(x)	(x)
#define ITTOLS(x)	(x)
#define FTTOLF(x)	(x)
#define FLTOTF(x)	(x)
#define FTTOLD(x)	(x)
#define FLTOTD(x)	(x)

#endif

#endif _T_TYPESF
