/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	GDB
 *
 *	$Log:	events.h,v $
 * Revision 2.2  92/04/30  14:45:15  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.3  92/02/23  22:34:44  gdburns
 * Shuffle EVTRACED and add EVMTVD.
 * 
 * Revision 2.1.1.2  92/01/19  20:36:00  gdburns
 * Move dlevent() macro elsewhere.
 * 
 * Revision 2.1.1.1  91/10/03  14:51:03  gdburns
 * Add i860d and traced events.
 * 
 * Revision 2.1  91/03/20  11:34:47  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.2  90/11/27  17:58:05  gdburns
 * Changed from old filesys to new filed.
 * 
 * Revision 2.0.1.1  90/07/13  19:28:01  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:54:50  trillium
 * Homo erectus
 * 
 *	Function:	- Trillium server events
 *			- Events should not be multiples of 4
 *			  to avoid collision with virtual circuits.
 *
 *			- based on Trollius 2.0 Copyright 1990
 *			  The Ohio State University and Cornell
 *			  Research Foundation
 */

#ifndef _EVENTS
#define _EVENTS

#ifndef	NOTEVENT
#define	NOTEVENT	0x80000001
#endif

/*
 * core Trillium server events
 */
#define EVROUTER	-1
#define EVBOOTD		-2
#define EVMALLOCD	-3
#define EVDLMOM		-5
#define EVCASTD		-6
#define EVFILED		-7
#define EVLOADD		-9
#define EVBUFFER	-10
#define EVKENYAD	-11
#define EVECHOD		-13
#define EVBUFFERD	-14
#define EVFLATD		-15

/*
 * special local layer events
 */
#define EVPAUSE		-17
#define EVSTOP		-18

/*
 * optional Trillium server events
 */
#define EVLEDD		-33
#define EVSPEAKD	-34
#define EVI860D		-35
#define EVTRACED	-37
#define EVMTVD		-38
#define EVMEMD		-39

/*
 * optional Trollius tools.
 */
#define EVIPCDIAG	-0x31

/*
 * datalink events
 */
#define EVDL0		0x80000000
#define EVDL1		0x80000004
#define EVDL2		0x80000008
#define EVDL3		0x8000000c

#endif
