/*
 *	Cornell Theory Center					Trillium
 *
 *	Copyright 1987 Cornell University
 *
 *	GDB
 *
 *	$Log:	flatreq.h,v $
 * Revision 2.2  92/04/30  14:45:19  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  11:34:48  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:28:23  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:55:09  trillium
 * Homo erectus
 * 
 * Revision 1.1  88/06/05  01:09:41  trillium
 * long overdue after 127 fixes and upgrades
 * 
 * Revision 1.0.1.1  88/06/01  16:53:25  gdburns
 * Added FL_DONE.
 * 
 * Revision 1.0  87/12/19  15:46:05  trillium
 * Initial revision
 * 
 *
 *	Function:	- defined constants and structures associated
 *			  with the flatd server
 */


#ifndef _FLATREQ

#define _FLATREQ

#include "net.h"

#define FLSTACK		(MAXNMSGLEN + 0x800)	/* flatd worker's stack size */

/*
 * flatd requests
 */
#define FL_LOAD		1
#define FL_GET		2
#define FL_FORGET	3
#define FL_DONE		4

struct flat_request {
	int		fl_src_node;
	int		fl_src_event;
	int		fl_req;
	int		fl_parm1;
#define fl_tag		fl_parm1
#define fl_pid		fl_parm1
	int		fl_parm2;
#define fl_ma_length	fl_parm2
#define fl_dseg		fl_parm2
	int		fl_parm3;
#define fl_ld_length	fl_parm3
};

struct flat_reply {
	int		fl_reply;
	char		*fl_address;
};

struct flat_region {
	int		fl_tag;			/* identifying tag */
	char		*fl_addr;		/* physical address */
};

#define FLMAX		16
#define	EMPTY		((char *) 0x80000000)

#endif
