/*
 *      OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *      VSD/GDB
 *
 *      $Log:	ledreq.h,v $
 * Revision 2.2  92/04/24  16:44:14  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.1  92/04/24  14:57:39  gdburns
 * major rewrite of all things LED
 * 
 * Revision 2.1  91/03/20  11:34:55  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:27:47  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:54:43  trillium
 * Homo erectus
 * 
 *	Function:	- constants and templates associated with ledd
 */

#ifndef _LEDREQ
#define _LEDREQ

#include <portable.h>

/*
 * ledd requests
 */
#define LEQOP		0		/* LED manipulation */
#define LEQSTATE	1		/* LED status */
#define LEQCC		2		/* echo to remote node */

/*
 * ledd LEQOP manipulation codes
 */
#define LEDCLR		0		/* clear specified bits */
#define LEDSET		1		/* set specified bits */
#define LEDNOT		2		/* toggle specified bits */
#define LEDALL		3		/* assign all bits */

/*
 * ledd request
 */
struct lereq {
	int4		leq_src_node;	/* client's nodeid */
	int4		leq_src_event;	/* client's reply event	*/
	int4		leq_req;	/* ledd request	code */
	int4		leq_op;		/* LED manipulation code */
#define leq_cc		leq_op		/* echo nodeid */
	int4		leq_mask;	/* LED application mask */
};

/*
 * ledd state
 */
struct lestate {
	int4		les_nled;	/* # LEDs */
	int4		les_shadow;	/* LED shadow register */
	int4		les_cc;		/* carbon copy nodeid */
};

#endif
