/*
 *	Cornell Theory Center					Trillium
 *	Copyright 1989 Cornell University
 *	MB
 *
 *	$Log:	c.h,v $
 * Revision 2.2  92/04/21  11:07:03  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  11:33:43  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:28:38  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:55:18  trillium
 * Homo erectus
 * 
 *	C access macros for access to nifty transputer functions.
 *	Assumes the existence of some support in the C compiler.
 */

/*
 *  Synonyms for some conc.h functions to fit c.h
 */

#ifndef _C_T4
#define _C_T4

#ifdef tputer

/* first include conc.h to get the prototypes: */
#ifndef	_CONC
#include "conc.h"
#endif

#ifndef	volatile
#define	volatile			/* Not implemented yet */
#endif	/* volatile */
#ifndef	const
#define	const				/* Not implemented yet */
#endif  /* const */

#define in(c,b,n)	_BUILTIN_ChanIn((Channel *)c,b,n)
#define out(c,b,n)	_BUILTIN_ChanOut((Channel *)c,b,n)
#define resetch(c)	_BUILTIN_ChanReset((Channel *)c)

#define runp(w)		_BUILTIN_PRun((PDes)w)
#define stopp()		_BUILTIN_ProcStop()

#define ldtimer()	_BUILTIN_Time()
#define sttimer(x)	_BUILTIN_SetTime(x)

#define ldpri()		_BUILTIN_ProcGetPriority()
#define setpri(p)	((p)? ProcToLow() : ProcToHigh())
#define flick()		_BUILTIN_ProcReschedule()
#define tin(x)		_BUILTIN_ProcAfter(x)

void	*_BUILTIN_memcpy(void *d, const void *s, unsigned int n);
#ifndef bcopy
#define	bcopy(s,d,n)	_BUILTIN_memcpy(d,s,n)
#endif
#define move(s,d,n)	_BUILTIN_memcpy(d,s,n)

#define mint()		(0x80000000)

/* #define gajw(w)	*/
/* #define sthf(w)	*/
/* #define sthb(w)	*/
/* #define stlf(w)	*/
/* #define stlb(w)	*/

#else

#define move(s,d,n) (bcopy(s,d,n))

#endif tputer
#endif  _C_T4
