/*
 *	OSU Research Computing					Trillium
 *	(third party software provided under license)
 *
 *	$Header: ctype.h,v 2.2 92/04/21 11:07:04 trillium Rel $
 *	We are just putting our stamp on this for housekeeping reasons.
 */

/*
 *	ctype.h
 */

#ifndef	_CTYPE				/* Avoid duplication */
#define	_CTYPE	1

#ifndef	volatile
#define	volatile
#define	const
#endif	/* volatile */

/*
 *	Character type
 */
#define _P	0x01			/* Punctuation	*/
#define _C	0x02			/* Control char	*/
#define	_N	0x04			/* Number	*/
#define	_S	0x08			/* Space	*/
#define	_U	0x10	/* Upper case (changes will affect _tolower_()	*/
#define	_L	0x20	/* Lower case (changes will affect _toupper_()	*/
#define _X	0x40			/* Hex digit	*/
#define	_W	0x80			/* Non-space whitespace	*/

extern	char	_ctype_[];

#define isalnum(c)	((_ctype_+1)[c]&(_U|_L|_N))
#define	isalpha(c)	((_ctype_+1)[c]&(_U|_L))
#define isascii(c)	((unsigned)(c)<=0x7f)
#define iscntrl(c)	((_ctype_+1)[c]&_C)
#define	isdigit(c)	((_ctype_+1)[c]&_N)
#define	isgraph(c)	((_ctype_+1)[c]&(_P|_U|_L|_N))
#define	islower(c)	((_ctype_+1)[c]&_L)
#define isprint(c)	((_ctype_+1)[c]&(_S|_P|_U|_L|_N))
#define ispunct(c)	((_ctype_+1)[c]&(_P))
#define	isspace(c)	((_ctype_+1)[c]&(_S|_W))
#define	isupper(c)	((_ctype_+1)[c]&_U)
#define	isxdigit(c)	((_ctype_+1)[c]&(_N|_X))
#define toascii(c)	((c)&0x7f)

/*
 *	ANSI requires arguments be evaluated only once, thus the following are
 *	not implemented in the traditional macro form.
 */

int	tolower(int c);
int	toupper(int c);

#endif	/* _CTYPE */
