/*
 *	Cornell Theory Center					Trillium
 *
 *	Copyright 1989 Cornell University
 *
 *	MB, 890628
 *
 *	$Log:	malloc.h,v $
 * Revision 2.2  92/04/30  14:45:53  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  11:34:57  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:28:17  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:55:05  trillium
 * Homo erectus
 * 
 * 
 *	Header file for malloc.c.
 */


#ifndef _MALLOC

#define _MALLOC

/***
	PORTABILITY WARNING:
	====================

	This program assumes 32-bit ints.
***/


/**** >>>> Edit these for your system: <<<< ****/


/*
 *  Sizeof(ALIGNER) must be >= than any pointer,
 *  and ALIGNER's alignment must be good enough for anything.
 *  (The type 'long' is good enough for any system I know of,
 *   but you may need more in some wierd cases.)
 */
typedef long ALIGNER;


/*
 *  Malloc keeps track of memory block sizes in units
 *  of sizeof(struct mheader), typically 8 bytes.
 *  These constants determine how many such units are
 *  procured from the system at once, to be cut up
 *  into smaller pieces locally.
 */
#define ALLOCMIN	512	/* min. no. of units to allocate at once */
#define ALLOCBLK	4	/* else round up to a multiple of this */
				/* GDB */


/****  Function Prototypes  ****/

#ifdef __STDC__
void	_reset_malloc (void);
int	free (char *cp);
char	*malloc (unsigned int amount);
char	*calloc (unsigned int nelem, unsigned int elsize);
char	*realloc (char *cp, unsigned int amount);
#else
extern void	_reset_malloc();
extern int	free();
extern char	*malloc();
extern char	*calloc();
extern char	*realloc();
#endif

#endif
