/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	RBD
 *
 *	$Log:	tvreq.h,v $
 * Revision 2.2  92/04/24  16:44:15  trillium
 * Ohio Release
 * 
 *	Function:	- constants and templates associated with mtvd
 */

#ifndef _TVREQ
#define _TVREQ

#include <portable.h>

/*
 * constants
 */
#define MAXTVREQ	5			/* number of mtvd requests */

#define TVQCLR		((int4) 0)		/* clear screen */
#define TVQRECT		((int4) 1)		/* plot rectangular region */
#define TVQSNAKE	((int4) 2)		/* plot snake region */
#define TVQTEXT		((int4) 3)		/* write text string */
#define TVQSTATE	((int4) 4)		/* return state information */

/*
 * structures
 */
struct tvreq {					/* mtvd request */
	int4		tvq_req;		/* request code */
	int4		tvq_src_node;		/* client nodeid */
	int4		tvq_src_event;		/* client event */
	int4		tvq_param3;
#define tvq_x1		tvq_param3		/* point x ordinate */
	int4		tvq_param4;
#define tvq_y1		tvq_param4		/* point y ordinate */
	int4		tvq_param5;
#define tvq_xlen	tvq_param5		/* rectangle width */
#define tvq_len		tvq_param5		/* snake length */
#define tvq_colour	tvq_param5		/* text colour */
	int4		tvq_param6;
#define tvq_ylen	tvq_param6		/* rectangle height */
};

struct tvreply {				/* mtvd reply */
	int4		tvr_errno;		/* error code */
	int4		tvr_ret;		/* return value */
	int4		tvr_param2;
#define	tvr_xlen	tvr_param2		/* screen pixel width */
	int4		tvr_param3;
#define tvr_ylen	tvr_param3		/* screen pixel height */
	int4		tvr_param4;
#define tvr_ncolour	tvr_param4		/* number of colours */
	int4		tvr_param5;
#define tvr_xtext	tvr_param5		/* screen character width */
	int4		tvr_param6;
#define tvr_ytext	tvr_param6		/* screen character height */
};

struct tvstate {				/* mtvd state information */
	int4		tvs_xlen;		/* screen pixel width */
	int4		tvs_ylen;		/* screen pixel height */
	int4		tvs_ncolour;		/* number of colours */
	int4		tvs_xtext;		/* screen character width */
	int4		tvs_ytext;		/* screen character height */
};

#endif /* _TVREQ */
