/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	GDB
 *
 *	$Log:	bootd.h,v $
 * Revision 2.2  92/04/30  10:19:43  trillium
 * Ohio Release
 * 
 *	Function:	- define constants and templates used by bootd
 */

#ifndef _BOOTD
#define _BOOTD

#include <portable.h>

#define NLINKS		4		/* max links per node */

/*
 * boot process descriptor
 */
struct btprog {
	void		*btp_load;	/* load module addr, includes text */
	void		*btp_data;	/* data segment address */
	void		*btp_stack;	/* stack segment address */
	char		**btp_argv;	/* argument structure address */
	int4		btp_stksize;	/* stack size */
	int4		btp_argc;	/* # arguments */
	int4		btp_avsize;	/* argument structure size */
	int4		btp_flags;	/* miscellaneous flags */
	int4		btp_priority;	/* process priority */
	int4		btp_tag;	/* load module tag (for text sharing) */
};

#define BTPNULL	(struct btproc *) 0	/* null pointer */

/*
 * max btproc table size 
 * This number, multiplied by sizeof(struct btproc), must reconcile
 * with the space allocated for the boot spawn table in the memory map.
 * See maconfig.h.
 */
#define BTPMAX		20

#endif
