/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	GDB
 *
 *	$Log:	bfcreate.c,v $
 * Revision 2.2  92/04/30  10:21:29  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.1  92/02/23  19:08:38  gdburns
 * Remove assembly language macros file, c.h.
 * 
 * Revision 2.1  91/03/20  03:01:20  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:27:19  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:54:28  trillium
 * Homo erectus
 *
 *	Function:	- Create a buffer worker process.
 *			- ITB module
 *			- based on Trollius 2.0 Copyright 1990
 *			  The Ohio State University and Cornell
 *			  Research Foundation
 *
 *	Returns:	- pid of child or ERROR
 */

#include <bufreq.h>
#include <kreq.h>
#include <shared.h>
#include <typical.h>

/*
 * external functions
 */
extern void		bfworker();

/*
 * local variables
 */
static KS_STATE		birth;


int
create()

{
	int		pid;		/* child process ID */
	char		*memblock;	/* stack and data/bss for child */

	memblock = (char *) kpar_Fe(bfworker, BFSTACK, &pid, 0);

	if (memblock) {
/*
 * To ensure proper process structuring, we must poll until the new born
 * process attaches to the kernel.
 */
		while (kstate(pid, &birth)) {
			tin(ldtimer() + 1);
		}

		return(pid);
	} else {
		return(ERROR);
	}
}
