/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	GDB
 *
 *	$Log:	dli_ortho.c,v $
 * Revision 2.2  92/04/30  10:23:04  trillium
 * Ohio Release
 * 
 *	Function:	- datalink input program for transputer link
 *			- orthodox version
 */

#include <net.h>
#include <typical.h>
#include <pcb.h>
#include <shared.h>
#ifdef itb
#include <c.h>
#endif

/*
 * external variables
 */
extern int		errno;		/* global error code */
extern struct pcb_t	*_pcb;		/* Process Control Block */

/*
 * local variables
 */
static char		*myname = "dli_ortho";


void
dli_ortho(inlink)

int			inlink;		/* input channel address */

{
	int		mynodeid;	/* cache getnodeid() */
	struct nmsg	nhead;		/* network msg descriptor */
	char		nmsg[MAXNMSGLEN];

/*
 * Connect to the kernel.
 */
	if (kinit(0) < 0) {
		panic(errno);
	}
/*
 * Become a high priority process.
 */
	setpri(0);
/*
 * Fuss with our arguments.
 */
	_pcb->pc_argv = &myname;
	_pcb->pc_argc = 1;
/*
 * Connect to kenyad.
 */
	if (rpattach(LOCAL) < 0) {
		panic(errno);
	}
/*
 * Input frame header.
 */
	in(inlink, (char *) &nhead, sizeof(struct nmsg));
/*
 * Inform the router of activity on the link.
 * NOTNODEID will cause no damage if route table is already in place.
 * Otherwise it will set the dumb route and all outbound messages will be
 * sent to my dlo partner.
 */
	(void) rsetroute(LOCAL, NOTNODEID, inlink - 0x10, inlink - 0x10);

	for (;;) {
/*
 * Store and forward.
 */
		if (nhead.nh_length) {
			in(inlink, nmsg, nhead.nh_length);
		}

		nhead.nh_flags &= ~BYBUF;
		nhead.nh_flags |= DDLI;
		nhead.nh_msg = nmsg;
		mynodeid = getnodeid();

		if ((mynodeid == NOTNODEID) ||
	    		(mynodeid == nhead.nh_node)) {

			nhead.nh_node = LOCAL;
		}

		(void) nsend(&nhead);
/*
 * Input frame header.
 */
		in(inlink, (char *) &nhead, sizeof(struct nmsg));
	}
}
