/*
 *	Cornell Theory Center					Trillium
 *
 *	Copyright 1987 Cornell University
 *
 *	GDB
 *
 *	$Log:	patch.c,v $
 * Revision 2.2  92/04/30  10:31:25  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  03:02:20  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:26:59  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:54:11  trillium
 * Homo erectus
 * 
 * Revision 1.1  88/06/05  01:02:10  trillium
 * long overdue after 127 fixes and upgrades
 * 
 * Revision 1.0  87/12/19  15:43:23  trillium
 * Initial revision
 * 
 *
 *	Function:	- patch argv string ptrs for a specific address
 *			- assumes nothing about current ptr values
 *			- assumes all strings are properly null terminated
 *			- assumes argv structure to reside contiguous in memory
 *
 *			  |----------------------|
 *			  |     argv pointers    |
 *			  |----------------------|
 *			  |     argv strings     |
 *			  |----------------------|
 *
 *	Accepts:	- argc
 *			- argv
 */

void
patch_argv(argc, argv)

int			argc;
char			**argv;

{
	int		i;			/* favourite index variable */
	char		*curr_argv;		/* current string pointer */


	if (argc) {
		curr_argv = (char *) (argv + (argc + 1));

		for (i = 0; i < argc; ++i) {
			while (! *curr_argv) ++curr_argv;
			*argv++ = curr_argv;
			curr_argv += strlen(curr_argv) + 1;
		}

		*argv = (char *) 0;
	}
}
