/*
 *	Cornell Theory Center					Trillium
 *
 *	Copyright 1987 Cornell University
 *
 *	GDB
 *
 *	$Log:	memd.c,v $
 * Revision 2.2  92/04/30  10:40:15  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  03:03:29  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:26:35  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:53:59  trillium
 * Homo erectus
 * 
 * Revision 1.1  88/06/05  01:03:21  trillium
 * long overdue after 127 fixes and upgrades
 * 
 * Revision 1.0  87/12/19  15:44:04  trillium
 * Initial revision
 * 
 *
 *	Function:	- server to read/write memory on an itb node
 */


#include <net.h>
#include <typical.h>
#include <events.h>
#include <memreq.h>
#include <shared.h>


static char *_copyright = "Copyright 1987 Cornell University $Revision: 2.2 $";

/*
 * external variables
 */
extern int			errno;		/* error number */


main()

{
	struct nmsg		nhead;		/* message descriptor */
	struct memreq		*request;	/* memory write request */


	if (kinit(0)) {
		panic(errno);
	}

	if (rpattach(LOCAL)) {
		panic(errno);
	}

	request = (struct memreq *) nhead.nh_data;
	
	for (;;) {

		nhead.nh_event = EVMEMD;
		nhead.nh_type = 0;
		nhead.nh_flags = NOBUF;
		nhead.nh_length = 0;
		nhead.nh_msg = (char *) 0;

		if (nrecv(&nhead)) {
			panic(errno);
		}
/*
 * Data is received on a private event
 * supplied by the client, usually its process ID.
 * This is not a fool proof method, but it would
 * be really bad luck if it broke.  A worker process
 * should be used to handle the data transfer and a synchronizing
 * reply should be sent.
 */
		nhead.nh_node  = request->mem_node;
		nhead.nh_event = request->mem_event;
		nhead.nh_msg = request->mem_address;

		while (request->mem_length) {

			nhead.nh_length = (request->mem_length > MAXNMSGLEN) ?
					MAXNMSGLEN : request->mem_length;

			if (nhead.nh_type == MWRITE) {

				if (nrecv(&nhead)) {
					panic(errno);
				}
			}

			else {
				if (nsend(&nhead)) {
					panic(errno);
				}
			}

			request->mem_length -= nhead.nh_length;
			nhead.nh_msg += nhead.nh_length;
		}
	}   /* for */
}
