/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	GDB
 *
 *	$Log:	shared.c,v $
 * Revision 2.2  92/04/30  10:40:38  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.2  92/01/19  20:51:17  gdburns
 * Remove a few undeserving functions and add a few useful ones.
 * 
 * Revision 2.1.1.1  91/12/16  21:40:24  gdburns
 * Remove bootd runtime functions.
 * 
 * Revision 2.1  91/03/20  03:03:50  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.4  90/11/29  19:54:23  gdburns
 * Converted to new filed.
 * 
 * Revision 2.0.1.3  90/11/16  15:03:10  raja
 * Change in the configuration of on-chip RAM.
 * 
 * Revision 2.0.1.2  90/09/07  13:10:50  gdburns
 * added _kexit
 * 
 * Revision 2.0.1.1  90/07/13  19:27:20  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:54:29  trillium
 * Homo erectus
 * 
 *	Function:	- shared library module
 *
 *			- based on Trollius 2.0 Copyright 1990
 *			  The Ohio State University and Cornell
 *			  Research Foundation
 */

#include <freq.h>
#include <kio.h>
#include <pcb.h>
#include <machine/maconfig.h>

#define SH_MAX		26

/*
 * globals for compatibility with crt0
 */
int			errno = 0;
struct pcb_t		*_pcb = 0;
struct kio_t		_kio = {0};
struct fclient		_ufd[FUMAX] = {0};

/*
 * external functions
 */
extern int		do_drecv();
extern int		do_dsend();
extern int		do_nrecv();
extern int		do_nsend();
extern int		getnet();
extern int		getnodeid();
extern int		getnodes();
extern int		getorigin();
extern int		getroute();
extern int		getsmart();
extern int		kcreate();
extern int		kdoom();
extern void		kexit();
extern int		kinit();
extern char		*kpar_Fe();
extern int		kstate();
extern int		rcreate();
extern int		rflat();
extern char		*rforget();
extern int		rfree();
extern char		*rmalloc();
extern int		rpattach();
extern int		ksigblock();
extern int		ksigsetmask();
extern void		_kexit();
extern int		getntype();

/*
 * table of shared library pointers
 */
int			(*(shared[SH_MAX]))() = {
				do_drecv,
				do_dsend,
				do_nrecv,
				do_nsend,
				getnet,
				getnodeid,
				getnodes,
				getorigin,
				getroute,
				getsmart,
				kcreate,
				kdoom,
				(int (*)()) kexit,
				kinit,
				(int (*)()) kpar_Fe,
				kstate,
				rcreate,
				rflat,
				(int (*)()) rforget,
				rfree,
				(int (*)()) rmalloc,
				rpattach,
				ksigblock,
				ksigsetmask,
				(int (*)()) _kexit,
				getntype
			};

_start()

{
	bcopy((char *) shared, (char *) SH_BASE, SH_MAX * sizeof(int (*)()));
	_exit(0);
}
