/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *      GDB
 *
 *	$Log:	RUCHCX.c,v $
 * Revision 2.2  92/04/30  11:38:45  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.1  92/02/23  20:00:00  gdburns
 * Change O_ASYNC to O_NOCBX.
 * 
 * Revision 2.1  91/03/19  23:34:06  gdburns
 * Ohio Release
 * 
 *	Function:	- tf77 file unit change CUBIX mode
 */

#include <freq.h>

/* 
 * external functions
 */
extern int		rfchcx();
extern void		IUTOD();

void
RUCHCX(unit, mode, ierror)

int			*unit;		/* tf77 unit # */
int			*mode;		/* new CUBIX mode */
int			*ierror;	/* error code, value returned */

{
	int		ufd;		/* Trollius user descriptor */

	IUTOD(&ufd, unit);
	*ierror = rfchcx(ufd, *mode); 
}

void
UASYNC(unit, ierror)

int			*unit;		/* tf77 unit # */
int			*ierror;	/* error code, value returned */

{
	int		ufd;		/* Trollius user descriptor */

	IUTOD(&ufd, unit);
	*ierror = rfchcx(ufd, O_NOCBX); 
}

void
USINGL(unit, ierror)

int			*unit;		/* tf77 unit # */
int			*ierror;	/* error code, value returned */

{
	int		ufd;		/* Trollius user descriptor */

	IUTOD(&ufd, unit);
	*ierror = rfchcx(ufd, FSINGL); 
}

void
UMULTI(unit, ierror)

int			*unit;		/* tf77 unit # */
int			*ierror;	/* error code, value returned */

{
	int		ufd;		/* Trollius user descriptor */

	IUTOD(&ufd, unit);
	*ierror = rfchcx(ufd, FMULTI); 
}
