/*
 *	OSU Research Computing, architects and contractors	Trillium
 *
 *	Copyright 1990 The Ohio State University & Cornell University
 *
 *      VSD
 *
 *	$Log:	TOPEN.c,v $
 * Revision 2.2  92/04/30  11:38:50  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  13:12:41  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.3  91/03/19  23:31:09  gdburns
 * File name parameter uses double indirection
 * and does not implicitly pass string length.
 * 
 * Revision 2.0.1.2  90/07/13  19:33:17  gdburns
 * Homo sapien
 * 
 * Revision 2.0.1.1  90/06/15  20:11:56  dixit-v
 * Changed from function to subroutine.
 * 
 * Revision 2.0  90/02/20  11:58:10  trillium
 * Homo erectus
 * 
 *
 *	Function:	- tf77 interface to topen
 *
 */

#include <errno.h>
#include <typical.h>

#define MAXLEN 176			/* maximum file name length */

/*
 * external functions
 */
extern int		rfopen();
extern char		*strchr();
extern char		*strncpy();

/*
 * external variables
 */
extern int      	errno;		/* global error variable */

/*
 * local variables
 */
char			buf[MAXLEN];

void
TOPEN(ufd, name, flags, modes, ierror)

int			*ufd;		/* user file descriptor, value ret */
char			**name;		/* complete node:file specification */
int			*flags; 	/* open flags */
int			*modes;		/* modes */
int			*ierror;	/* returns error code */

{
	int		lname;		/* file name length */
	char		*pblank;	/* ptr to first blank in name */

	lname = *(((int *) name) + 1);
/*
 * Check for a character array as opposed to a string.
 */
	if (lname == 1) {
		pblank = strchr(*name, ' ');

		if (pblank == (char *) 0) {
			*ierror = errno = ENAMETOOLONG;
			*ufd = ERROR;
			return;
		}

		lname = pblank - *name;
	}

	if (lname > (MAXLEN - 1)) {
		*ierror = errno = ENAMETOOLONG;
		*ufd = ERROR;
		return;
	}

	(void) strncpy(buf, *name, lname);
	buf[lname] = '\0';

	if ((*ufd = rfopen(buf, *flags, *modes)) == ERROR) {
		*ierror = errno;
	} else {
		*ierror = 0;
	}
}
