/*
 *	OSU Research Computing, architects and contractors	Trillium
 *
 *	Copyright 1990 The Ohio State University & Cornell University
 *
 *      VSD
 *
 *	$Log:	KSENDRECV.c,v $
 * Revision 2.2  92/04/30  11:39:23  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  13:13:03  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.2  90/07/13  19:33:22  gdburns
 * Homo sapien
 * 
 * Revision 2.0.1.1  90/06/15  20:02:22  dixit-v
 * Changed function names.
 * 
 * Revision 2.0  90/02/20  11:58:14  trillium
 * Homo erectus
 * 
 *
 *	Function:	- f77 interface to ksend, ktry_send, krecv, ktry_recv
 *
 */
			  

#include <typical.h>
#include <kreq.h>
#include <kmsg.h>

extern int	do_ksend();
extern int	do_krecv();
extern int	errno;

#define MYSEND KSEND
#define MYRECV KRECV

#undef KSEND
#undef KRECV

void
KSEND(kevent, ktype, klength, kflags, kmsg, ierror)

int				*kevent,
				*ktype,
				*klength,
				*kflags,
				*ierror;
char				*kmsg;

{
	struct kmsg		khead;

	khead.k_event	= *kevent;
	khead.k_type	= *ktype;
	khead.k_length	= *klength;
	khead.k_flags	= *kflags;
	khead.k_msg	= kmsg;

	if (do_ksend(&khead, MYSEND) != SUCCESS) {
		*ierror = errno;
	}
	else {
		*ierror = 0;
	}
}
			  

void
KTSEND(kevent, ktype, klength, kflags, kmsg, ierror)

int				*kevent,
				*ktype,
				*klength,
				*kflags,
				*ierror;
char				*kmsg;

{
	struct kmsg		khead;

	khead.k_event	= *kevent;
	khead.k_type	= *ktype;
	khead.k_length	= *klength;
	khead.k_flags	= *kflags;
	khead.k_msg	= kmsg;

	if (do_ksend(&khead, KTRY_SEND) != SUCCESS) {
		*ierror = errno;
	}
	else {
		*ierror = 0;
	}
}
			  

void
KRECV(kevent, ktype, klength, kflags, kmsg, ierror)

int				*kevent,
				*ktype,
				*klength,
				*kflags,
				*ierror;

char				*kmsg;

{
	struct kmsg		khead;

	khead.k_event	= *kevent;
	khead.k_type	= *ktype;
	khead.k_length	= *klength;
	khead.k_flags	= *kflags;
	khead.k_msg	= kmsg;

	if (do_krecv(&khead, MYRECV) != SUCCESS) {
		*ierror = errno;
	}
	else {
		*ierror = 0;
		*ktype = khead.k_type;
		*klength = khead.k_length;
	}
}


void
KTRECV(kevent, ktype, klength, kflags, kmsg, ierror)

int				*kevent,
				*ktype,
				*klength,
				*kflags,
				*ierror;

char				*kmsg;

{
	struct kmsg		khead;

	khead.k_event	= *kevent;
	khead.k_type	= *ktype;
	khead.k_length	= *klength;
	khead.k_flags	= *kflags;
	khead.k_msg	= kmsg;

	if (do_krecv(&khead, KTRY_RECV) != SUCCESS) {
		*ierror = errno;
	}
	else {
		*ierror = 0;
		*ktype = khead.k_type;
		*klength = khead.k_length;
	}
}


