/*
 *	OSU Research Computing, architects and contractors	Trillium
 *
 *	Copyright 1990 The Ohio State University & Cornell University
 *
 *      VSD
 *
 *	$Log:	KSTATE.c,v $
 * Revision 2.2  92/04/30  11:39:25  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  13:13:04  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:33:28  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:58:19  trillium
 * Homo erectus
 * 
 *
 *	Function:	- f77 interface to kstate
 *
 *	Accepts:	- ptr to Trillium process identifier (0 means yourself)
 *			- a pointer to a state structure where information
 *			  from the kernel will be stored
 *
 */
			  

#include <typical.h>
#include <kreq.h>
#undef KSTATE

extern int	kstate();
extern int	errno;

void
KSTATE(pid, state, kpriority, kevent, ktype, ksignal, ierror)

int	*pid,		/* Trillium process ID */
	*state,
	*kpriority,
	*kevent,
	*ktype,
	*ksignal,
	*ierror;

{

	struct kstate		khead;

	khead.ks_state = *state;
	khead.ks_priority = *kpriority;
	khead.ks_event = *kevent;
	khead.ks_type = *ktype;
	khead.ks_signal = *ksignal;

	if (kstate(*pid, &khead) != SUCCESS) {
		*ierror = errno;
	}
	else {
		*ierror = 0;
	}
}
