/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	RBD
 *
 *	$Log:	BSENDRECV.c,v $
 * Revision 2.2  92/04/30  11:40:00  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.1  92/02/23  20:07:58  gdburns
 * Upgrade to suit LSTT 91.1.
 * 
 * Revision 2.1  91/10/24  23:18:32  raja
 * initial revision
 * 
 *	Function:	- F77 interface to bsend (sendb), brecv (recvb)
 *			- ITB version
 */

#include <portable.h>
#include <net.h>

/*
 * external functions
 */
extern int4		sendb();
extern int4		recvb();

/*
 * external variables
 */
extern int		errno;


void
BSEND(bdestnode, bmsg, blength, bdatatype, ierror)

int4			*bdestnode;
int4			*blength;
int4			*bdatatype;
int4			*ierror;
char			*bmsg;

{
	int4		new_length;

	new_length = sendb(*bdestnode, (void *) bmsg, *blength, *bdatatype);

	if (new_length < 0) {
		*ierror = errno;
	} else {
		*ierror = 0;
	}
}

void
BRECV(bsrcnode, bmsg, blength, bdatatype, ierror)

int4			*bsrcnode;
int4			*blength;
int4			*bdatatype;
int4			*ierror;
char			*bmsg;

{
	int4		new_length;

	new_length = recvb(*bsrcnode, (void *) bmsg, *blength, *bdatatype);

	if (new_length < 0) {
		*ierror = errno;
	} else {
		*ierror = 0;
		*blength = new_length;
	}
}
