/*
 *	OSU Research Computing, architects and contractors	Trillium
 *
 *	Copyright 1990 The Ohio State University & Cornell University
 *
 *	RBD
 *
 *	$Log:	GETNET.c,v $
 * Revision 2.2  92/04/30  11:40:08  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  13:13:25  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.2  90/07/13  19:33:35  gdburns
 * Homo sapien
 * 
 * Revision 2.0.1.1  90/06/15  19:33:49  dixit-v
 * Changed function names.
 * 
 * Revision 2.0  90/02/20  11:58:25  trillium
 * Homo erectus
 * 
 *
 *	Function:	- f77 interface to getnet, getnodeid, getnodetype,
 *			  getorigin
 *
 */

#include <net.h>
#include <typical.h>

extern int		getnet();
extern int 		getnodeid();
extern int		getnodetype();
extern int		getorigin();
extern int		errno;		/* global error variable */

void
GNET(nodeid, nodetype, origin, ierror)

int	*nodeid, *nodetype, *origin;
int	*ierror;

{
	struct net_info nodes;

	if (getnet(&nodes) != SUCCESS) {
		*ierror = errno;
	}
	else {
		*nodeid = nodes.ni_nodeid;
		*nodetype = nodes.ni_nodetype;
		*origin = nodes.ni_origin;
		*ierror = SUCCESS;
	}
}



void
IGNDID(ret)

int	*ret;

{
	*ret = getnodeid();

}


void
IGNDTP(ret)

int	*ret;

{
	*ret = getnodetype();
}


void
IGORGN(ret)

int	*ret;

{
	*ret = getorigin();

}


