/*
 *	OSU Research Computing, architects and contractors	Trillium
 *
 *	Copyright 1990 The Ohio State University & Cornell University
 *
 *	RBD
 *
 *	$Log:	GETRENT.c,v $
 * Revision 2.2  92/04/30  11:40:12  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  13:13:28  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.2  91/03/19  23:26:26  raja
 * Added GRENT GRENTC calls.
 * 
 * Revision 2.0.1.1  90/07/13  19:33:36  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/06/15  19:36:04  dixit-v
 * Homo erectus
 * 
 * 
 *
 *	Function:	- itb f77 interface to getrent, getrentc, getroute,
 *			  getrtype
 *
 */

#include <net.h>
#include <events.h>
#include <rreq.h>
#include <typical.h>

extern int		getrent();
extern int		getrentc();
extern int		getroute();
extern int		getrtype();

extern int		errno;		/* global error variable */


void
GROUTE(nodeid, event, ierror)

int		*nodeid, *event; 
int		*ierror;

{
	if ((*event = getroute(*nodeid, *event)) == NOTEVENT) {
		*ierror = errno;
	}
	else {
		*ierror = 0;
	}
}


void
IGRTP(ret, nodeid)

int		*ret;
int		*nodeid;

{
	*ret = getrtype(*nodeid);
}


void
GRENT(nodeid, event, nodetype, ierror)

int		*nodeid, *event, *nodetype;
int		*ierror;

{
	struct route	rentry;

	rentry.r_nodeid = *nodeid;
	if (getrent(&rentry)) {
		*ierror = errno;
	}
	else {
		*event = rentry.r_event;
		*nodetype = rentry.r_nodetype;
		*ierror = 0;
	}
}


void
GRENTC(nodeid, event, nodetype, ierror)

int		*nodeid, *event, *nodetype;
int		*ierror;

{
	struct route	rentry;

	rentry.r_nodeid = *nodeid;
	if (getrentc(&rentry)) {
		*ierror = errno;
	}
	else {
		*event = rentry.r_event;
		*nodetype = rentry.r_nodetype;
		*ierror = 0;
	}
}
