/*
 *	OSU Research Computing, architects and contractors	Trillium
 *
 *	Copyright 1990 The Ohio State University & Cornell University
 *
 *	VSD
 *
 *	$Log:	NSENDRECV.c,v $
 * Revision 2.2  92/04/30  11:40:18  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  13:13:34  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.3  90/07/13  19:33:29  gdburns
 * Homo sapien
 * 
 * Revision 2.0.1.2  90/06/15  19:40:33  dixit-v
 * Changed function names and fixed bug in bcopy.
 * 
 * Revision 2.0.1.1  90/04/06  17:27:39  dixit-v
 * Changed int ndsize to int *ndsize, changed order of parameters.
 * 
 * Revision 2.0  90/02/20  11:58:20  trillium
 * Homo erectus
 * 
 *
 *	Function:	- f77 interface to nsend, ntry_send, nrecv, ntry_recv
 */


#include <net.h>
#include <kreq.h>
#include <typical.h>

extern int		do_nsend();
extern int		do_nrecv();
extern	int		errno;

#undef NSEND
#undef NRECV

void
NSEND(nnode, nevent, ntype, nlength, nflags, ndata, ndsize, nmsg, ierror)

int			*nnode,
			*nevent,
			*ntype,
			*nlength,
			*nflags,
			*ndata,
			*ndsize,
			*ierror;
			
char			*nmsg;

{
	struct nmsg	nhead;


	nhead.nh_node	= *nnode;
	nhead.nh_event	= *nevent;
	nhead.nh_type	= *ntype;
	nhead.nh_length	= *nlength;
	nhead.nh_flags	= *nflags;

        bcopy((char *) ndata, (char *) nhead.nh_data,
                (*ndsize > sizeof (nhead.nh_data))
                ? sizeof (nhead.nh_data) : *ndsize);
	nhead.nh_msg	= nmsg;

	if (do_nsend(&nhead, KSEND) != SUCCESS) {
		*ierror = errno;
	}

	else {
		*ierror = 0;
	}
}


void
NTSEND(nnode, nevent, ntype, nlength, nflags, ndata, ndsize, nmsg, ierror)

int			*nnode,
			*nevent,
			*ntype,
			*nlength,
			*nflags,
			*ndata,
			*ndsize,
			*ierror;
			
char			*nmsg;


{
	struct nmsg	nhead;

	nhead.nh_node	= *nnode;
	nhead.nh_event	= *nevent;
	nhead.nh_type	= *ntype;
	nhead.nh_length	= *nlength;
	nhead.nh_flags	= *nflags;

        bcopy((char *) ndata, (char *) nhead.nh_data,
                (*ndsize > sizeof (nhead.nh_data))
                ? sizeof (nhead.nh_data) : *ndsize);

	nhead.nh_msg	= nmsg;

	if (do_nsend(&nhead, KTRY_SEND) != SUCCESS) {
		*ierror = errno;
	}

	else {
		*ierror = 0;
	}
}


void
NRECV(nevent, ntype, nlength, nflags, ndata, ndsize, nmsg, ierror)

int 			*nevent,
			*ntype,
			*nlength,
			*nflags,
			*ndata,
			*ndsize,
			*ierror;
			
char			*nmsg;

{
	struct nmsg	nhead;

	nhead.nh_event	= *nevent;
	nhead.nh_type	= *ntype;
	nhead.nh_length	= *nlength;
	nhead.nh_flags	= *nflags;
	nhead.nh_msg	= nmsg;

	if (do_nrecv(&nhead, KRECV) != SUCCESS) {
		*ierror = errno;
	}

	else {
		*ierror = 0;
                bcopy((char *) nhead.nh_data, (char *) ndata,
                        (*ndsize > sizeof (nhead.nh_data))
                        ? sizeof (nhead.nh_data) : *ndsize);

                *ntype = nhead.nh_type;
                *nlength = nhead.nh_length;
	}
}


void
NTRECV(nevent, ntype, nlength, nflags, ndata, ndsize, nmsg, ierror)

int			*nevent,
			*ntype,
			*nlength,
			*nflags,
			*ndata,
			*ndsize,
			*ierror;
			
char			*nmsg;


{
	struct nmsg	nhead;

	nhead.nh_event	= *nevent;
	nhead.nh_type	= *ntype;
	nhead.nh_length	= *nlength;
	nhead.nh_flags	= *nflags;
	nhead.nh_msg	= nmsg;

	if (do_nrecv(&nhead, KTRY_RECV) != SUCCESS) {
		*ierror = errno;
	}

	else {
		*ierror = 0;
                bcopy((char *) nhead.nh_data, (char *) ndata,
                        (*ndsize > sizeof (nhead.nh_data))
                        ? sizeof (nhead.nh_data) : *ndsize);

                *ntype = nhead.nh_type;
                *nlength = nhead.nh_length;
	}
}


