/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	VSD
 *
 *	$Log:	PSENDRECV.c,v $
 * Revision 2.2  92/04/30  11:40:20  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.1  92/02/23  20:08:18  gdburns
 * Upgrade to suit LSTT 91.1.
 * 
 * Revision 2.1  91/03/20  13:13:36  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.2  90/07/13  19:33:47  gdburns
 * Homo sapien
 * 
 * Revision 2.0.1.1  90/04/06  18:35:15  dixit-v
 * Changed int ndsize to int *ndsize, changed order of parameters.
 * 
 * Revision 2.0  90/04/06  17:55:12  dixit-v
 * Homo erectus
 *
 *	Function:	- F77 calls for psend(), precv()
 *			- based on Trollius 2.0 Copyright 1990
 *			  The Ohio State University and Cornell
 *			  Research Foundation
 */

#ifdef itb
#include <c.h>
#endif
#include <net.h>
#include <kio.h>
#include <portable.h>
#include <terror.h>
#include <typical.h>

/*
 * external variables
 */
extern struct kio_t	_kio;			/* kernel I/O block */
extern int		errno;


void
PSEND(ndl_event, nlength, ndata, ndsize, nmsg, ierror)

int 			*ndl_event;
int			*nlength;
char			*nmsg;
int                     *ndata;
int                     *ndsize;
int			*ierror;

{
	out(*ndl_event, (char *) ndata, *ndsize);

	if (*nlength) {
		out(*ndl_event, nmsg, *nlength);
	}

	*ierror = 0;
}

void
PRECV(nevent, nlength, ndata, ndsize, nmsg, ierror)

int 			*nevent;
int			*nlength;
char			*nmsg;
int                     *ndata;
int                     *ndsize;
int			*ierror;

{
	struct khold_t	*phold;		/* virtual circuit descriptor */
	int		ev;
/*
 * Calculate the pointer to the correct virtual circuit descriptor.
 */
	ev = *nevent;
	phold = _kio.ki_khold + ((ev & HOLDBITS) +
		((ev & INT4_SIGN) ? (HOLDBITS + 1) : 0));

	if (phold->kh_event != ev) {
		errno = EINVAL; 
		*ierror = errno;
	}

	ev = phold->kh_peer_aux;
	in(ev, (char *) ndata, *ndsize);

	if (*nlength) {
		in(ev, nmsg, *nlength);
	}

	*ierror = 0;
}
