/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	VSD
 *
 *	$Log:	REVERSE.c,v $
 * Revision 2.2  92/04/30  11:40:21  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.1  92/02/23  20:08:21  gdburns
 * Upgrade to suit LSTT 91.1.
 * 
 * Revision 2.1  91/03/20  13:13:40  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.3  90/11/15  15:58:04  raghu
 * Changed function name IRD to FRD.
 * 
 * Revision 2.0.1.2  90/07/13  19:33:31  gdburns
 * Homo sapien
 * 
 * Revision 2.0.1.1  90/06/15  19:56:19  dixit-v
 * Changed function names.
 * 
 * Revision 2.0  90/02/20  11:58:20  trillium
 * Homo erectus
 *
 *	Function:	- F77 interface to rd(), rf(), rs(), rw()
 *			- based on Trollius 2.0 Copyright 1990
 *			  The Ohio State University and Cornell
 *			  Research Foundation
 */

/*
 * external functions
 */
extern double 		rd();
extern float 		rf(float f);
extern short 		rs();
extern int		rw();

void
FRD(ret, dword)

double			*ret;
double			*dword;

{
	*ret = rd(*dword);
}

void
FRF(ret, fword)

int			*ret;
float			*fword;

{
	float		f;

	f = rf(*fword);
/*
 * In the current implementation of the C compiler it is impossible to
 * return a float, since the language requires it to be promoted to a
 * double whenever it is used in an expression and the value in a
 * return statement is an expression. Hence the following casting to
 * an integer is required.
 */

	*ret = *((int *) &f);
}

void
IRS(ret, sword)

short			*ret;
short			*sword;

{
	*ret = rs(*sword);
}

void
IRW(ret, iword)

int			*ret;
int			*iword;

{
	*ret = rw(*iword);
}
