/*
 *	OSU Research Computing					Trillium
 *	Copyright 1991 The Ohio State University
 *	VSD
 *
 *	$Log:	TSENDRECV.c,v $
 * Revision 2.2  92/04/30  11:40:22  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.1  91/10/22  14:22:00  raja
 * Modify TRECV to mirror the NRECV interface.  Face-lift the file.
 * 
 * Revision 2.1  91/03/20  13:13:42  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.3  90/07/13  19:33:32  gdburns
 * Homo sapien
 * 
 * Revision 2.0.1.2  90/06/15  19:57:43  dixit-v
 * Fixed bug in bcopy.
 * 
 * Revision 2.0.1.1  90/04/06  18:39:21  dixit-v
 * Changed int ndsize to int *ndsize, changed order of parameters.
 * 
 * Revision 2.0  90/02/20  11:58:21  trillium
 * Homo erectus
 *
 *	Function:	- f77 interface to tsend, trecv
 *			- ULS version
 */

#include <portable.h>
#include <typical.h>
#include <net.h>

/*
 * external functions
 */
extern int		tsend();
extern int		trecv();

/*
 * external variables
 */
extern int		errno;

#undef TSEND
#undef TRECV


void
TSEND(nnode, nevent, ntype, nlength, nflags, ndata, ndsize, nmsg, ierror)

int4			*nnode,
			*nevent,
			*ntype,
			*nlength,
			*nflags,
			*ndata,
			*ndsize,
			*ierror;

char			*nmsg;

{
	struct nmsg	nhead;		/* network message descriptor */

	nhead.nh_node	= *nnode;
	nhead.nh_event	= *nevent;
	nhead.nh_type	= *ntype;
	nhead.nh_length = *nlength;
	nhead.nh_flags	= *nflags;

        bcopy((char *) ndata, (char *) nhead.nh_data,
                (*ndsize > sizeof(nhead.nh_data))
                ? sizeof(nhead.nh_data) : *ndsize);

	nhead.nh_msg	= nmsg;

	if (tsend(&nhead)) {
		*ierror = errno;
	}
	else {
		*ierror = 0;
	}
}


void
TRECV(nevent, ntype, nlength, nflags, ndata, ndsize, nmsg, ierror)

int4			*nevent,
			*ntype,
			*nlength,
			*nflags,
			*ndata,
			*ndsize,
			*ierror;

char			*nmsg;

{
	struct nmsg	nhead;		/* network message descriptor */

	nhead.nh_event	= *nevent;
	nhead.nh_type	= *ntype;
	nhead.nh_length = *nlength;
	nhead.nh_flags	= *nflags;
	nhead.nh_msg	= nmsg;

	if (trecv(&nhead)) {
		*ierror = errno;
	}
	else {
		*ierror = 0;
                bcopy((char *) nhead.nh_data, (char *) ndata,
                        (*ndsize > sizeof(nhead.nh_data))
                        ? sizeof(nhead.nh_data) : *ndsize);

                *ntype = nhead.nh_type;
                *nlength = nhead.nh_length;
	}
}
