/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	VSD
 *
 *	$Log:	TTOL.c,v $
 * Revision 2.2  92/04/30  11:40:23  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.1  92/02/23  20:08:23  gdburns
 * Upgrade to suit LSTT 91.1.
 * 
 * Revision 2.1  91/03/20  13:13:44  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.2  90/07/13  19:33:44  gdburns
 * Homo sapien
 * 
 * Revision 2.0.1.1  90/06/15  19:59:00  dixit-v
 * Changed function names.
 * 
 * Revision 2.0  90/02/20  11:58:24  trillium
 * Homo erectus
 *
 *	Function:	- F77 interface to ttol(), ttold(), ttolf(), ttols()
 *			- based on Trollius 2.0 Copyright 1990
 *			  The Ohio State University and Cornell
 *			  Research Foundation
 */

#include <t_types.h>

void
ITTOL(ret, iword)

int			*ret;
int			*iword;

{
	*ret = ttol(*iword);
}

void
FTTOLD(ret, dword)

double			*ret;
double			*dword;

{
	*ret = ttold(*dword);
}

void
FTTOLF(ret, fword)

int			*ret;
float			*fword;

{
	float		f;

	f = ttolf(*fword);
/*
 * In the current implementation of the C compiler it is impossible to
 * return a float, since the language requires it to be promoted to a
 * double whenever it is used in an expression and the value in a
 * return statement is an expression. Hence the following casting to
 * an integer is required.
 */
	*ret = *((int *)&f); 
}

void
ITTOLS(ret, sword)

short			*ret;
short			*sword;

{
	*ret = *sword;
}
