/*
 *	OSU Research Computing, architects and contractors	Trillium
 *
 *	Copyright 1990 The Ohio State University & Cornell University
 *
 *	VSD
 *
 *	$Log:	RCAST.c,v $
 * Revision 2.2  92/04/30  11:40:52  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  13:14:23  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.2  90/07/13  19:33:57  gdburns
 * Homo sapien
 * 
 * Revision 2.0.1.1  90/06/28  17:45:01  dixit-v
 * Added wrapper for rmelt().
 * 
 * Revision 2.0  90/02/20  11:58:30  trillium
 * Homo erectus
 * 
 *
 *	Function:	- f77 interface to rcast
 *			- register a multicast with bcastd
 *
 *      Accepts:        - target node
 *                      - multicast identifier
 *                      - combine function selector
 *                      - array of multicast members
 *                      - number of multicast members
 */
			  

#include <typical.h>

extern int	rcast();
extern int	rmelt();
extern int	errno;

void
RCAST(node, castid, combine, pcast, ncast, ierror)

int		*node;
int		*castid;
int		*combine;
int		*pcast;
int		*ncast;
int		*ierror;	/* return code */

{
	if (rcast(*node, *castid, *combine, pcast, *ncast) != SUCCESS) {
		*ierror = errno;
	}

	else {
		*ierror = 0;
	}
}


void
RMELT(node, castid, ierror)

int             *node; 
int             *castid; 
int             *ierror; 
 
{ 
        if(rmelt(*node, *castid) != SUCCESS) { 
                *ierror = errno; 
        } 
 
        else { 
                *ierror = 0; 
        } 
} 
 

