/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	GDB
 *
 *	$Log:	crt0.c,v $
 * Revision 2.2  92/04/30  11:43:35  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.2  92/02/24  10:34:24  gdburns
 * Add #ifdef to c.h.
 * 
 * Revision 2.1.1.1  91/12/16  14:56:20  gdburns
 * Retain RTF_TRACE flag.
 * 
 * Revision 2.1  91/03/20  13:09:42  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.2  90/11/29  19:55:11  gdburns
 * Converted to new filed.
 * 
 * Revision 2.0.1.1  90/07/13  19:32:22  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:57:34  trillium
 * Homo erectus
 * 
 *	Function:	- runtime startoff
 *			- based on Trollius 2.0 Copyright 1990
 *			  The Ohio State University and Cornell
 *			  Research Foundation
 *
 *			- _start() expects a stack frame as follows:
 *
 *		+----------------+
 *		| pcb            | wp[2]
 *		+----------------+
 *		| static link    | wp[1]
 *		+----------------+
 *		| return address | wp[0]
 *		+----------------+
 *
 *	    wp[0] contains the return address (as usual).   It should
 *	    probably be set to point to a "stopp" instruction.
 *
 *	    wp[1] points to the base address of the external variables.
 *
 *	    wp[2] points to the Process Control Block, and is saved in
 *	    the _pcb data segment variable
 */

#ifdef itb
#include <c.h>
#endif
#include <freq.h>
#include <kio.h>
#include <pcb.h>
#include <shared.h>

/*
 * globally defined variables
 */
int		errno = 0;			/* error number */
struct pcb_t	*_pcb = 0;			/* Process Control Block */

/*
 * external variables, defined & inited here for shared lib control
 */
struct kio_t	_kio = {0};			/* Kernel I/O */
struct fclient	_ufd[FUMAX] = {0};		/* user file desc. */

void
_start(newborn)

struct pcb_t	*newborn;

{
	clrhalterr();
	testerr();

	_pcb = newborn;

	_kio.ki_nodeid = _pcb->pc_nodeid;
	_kio.ki_rtf = _pcb->pc_rtf & (RTF_KENYA | RTF_SYSGEN | RTF_TRACE);
	_kio.ki_stdin = _pcb->pc_stdin;
	_kio.ki_stdout = _pcb->pc_stdout;
	_kio.ki_stderr = _pcb->pc_stderr;

	if (kinit(0) < 0) {
		panic(errno);
	}

	main(_pcb->pc_argc, _pcb->pc_argv);

	kexit(0);
}
