/*
 *	OSU Research Computing, architects and contractors	Trillium
 *
 *	Copyright 1990 The Ohio State University & Cornell University
 *
 *	GDB
 *
 *	$Log:	panic.c,v $
 * Revision 2.2  92/04/30  11:44:04  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  13:09:57  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.2  90/07/13  19:32:24  gdburns
 * Homo sapien
 * 
 * Revision 2.0.1.1  90/06/04  16:36:03  gdburns
 * Store some key information in onchip RAM before exiting.
 * 
 * Revision 2.0  90/02/20  11:57:35  trillium
 * Homo erectus
 * 
 *
 *	Function:	- itb panic
 *			- store the error code and stack ptr in on-chip RAM
 *			- blink LEDs if available
 *
 *	Accepts:	- error code
 */

#define PANIC_CODE	(0x800001f0)
#define PANIC_STACK	(0x800001f4)

/*
 * external functions
 */
extern int		_exit();


void
panic(code)

int			code;

{
	*((int *) PANIC_CODE) = code;
	*((int *) PANIC_STACK) = (int) &code;
    	(void) _exit(code);
}
