/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	RBD
 *
 *	$Log:	ttime.c,v $
 * Revision 2.2  92/04/30  11:44:07  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.1  92/02/23  20:11:52  gdburns
 * Remove c.h.
 * 
 * Revision 2.1  91/03/20  13:10:00  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:32:25  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:57:36  trillium
 * Homo erectus
 *  
 *	Function:	- returns the contents of a system timer
 *			  expressed in seconds
 *			- used primarily for recording elapsed 
 *			  time in the user code, in a portable manner
 *			- The resolution is not guaranteed, as it
 *			  depends on the underlying hardware,
 *			  but the units (seconds) are guaranteed.
 *			- This code is for ITB (transputer) and 
 *			  uses the  transputer hardware timers.
 */

/*
 * Local #defines.  Too little to warrant a separate .h file.
 */
#define HIPRI_TPS	1000000	/* high  priority ticks-per-second */
#define LOPRI_TPS	15625	/* low  priority ticks-per-second */

/*
 * ttime() returns the contents of the system timer (a measure
 * of time since an arbitrary but fixed point in time) expressed
 * in seconds. 
 */

double
ttime()

{
/*
 * Get the timer value and the process priority level. 
 * Depending on the priority, divide by the appropriate
 * ticks-per-second value.  High priority is ldpri() == 0.
 */
	return(((double)ldtimer())/(ldpri() ? LOPRI_TPS : HIPRI_TPS));
}

