/*
 *	Cornell Theory Center					Trillium
 *
 *	Copyright 1988 Cornell University
 *
 *	MB
 *
 *	$Log:	tprintf.c,v $
 * Revision 2.2  92/04/30  11:44:27  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  13:10:08  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:32:27  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:57:38  trillium
 * Homo erectus
 * 
 * Revision 1.1.1.1  89/02/05  14:26:34  fielding
 * changed putchar to tputc to avoid linking stdio library
 * 
 * Revision 1.1  88/12/21  11:54:38  braner
 * Initial revision
 * 
 *
 *	tprintf.c
 *
 *	Stdio-free "stripped" printf.  Write to stdout via tputc/tputs.
 *	Flush upon each newline and at the end of each tprintf call.
 *	Returns 0 (success) or -1 (error).
 *
 *	Formatting code courtesy of Logical Systems, used with permission.
 *
 *	WARNING: this code is a nonportable hack as far as handling the
 *		arguments on the stack.  Tested on the Inmos Transputer.
 */

#define	TRUE	1
#define	FALSE	0

extern tputc(), tputs(), tflush();

/* Short version of printf to save space */
int
tprintf(char *arg, ...)
{
	char	**argp, *fmt, c;
	int	base;
	char s[80], *_itob();

	argp = &arg;

	fmt = *argp;
	while (c = *fmt++) {
		if (c != '%') {
			tputc(c);
			continue;
		}
		while(*fmt >= '0' && *fmt <= '9')
			fmt++;
		switch (c = *fmt++) {
		case 'l':
			switch(c = *fmt++) {
			case 'd':
				base = -10;
				goto prt;
			case 'o':
				base = 8;
				goto prt;
			case 'u':
				base = 10;
				goto prt;
			case 'x':
				base = 16;
				goto prt;
			default:
				tputc(c);
				continue;
			}
		case 'c':
			tputc((int) (*++argp));
			continue;
		case 'd':
			base = -10;
			goto prt;
		case 'o':
			base = 8;
			goto prt;
		case 'u':
			base = 10;
			goto prt;
		case 'x':
			base = 16;
		prt:
			tputs(_itob(*++argp, s, base));
			continue;
		case 's':
			tputs(*++argp);
			continue;
		default:
			tputc(c);
			continue;
		}
	}

	return (tflush());
}


/* convert an integer to a string in any base (2-36) */
char	*
_itob(n, s, base)
	char *s;
{
	unsigned int u;
	char *p, *q, c;
	int negative;

	if (n < 0 && base == -10) {
		negative = TRUE;
		u = -n;
	} else {
		negative = FALSE;
		u = n;
	}
	if (base == -10)	/* signals signed conversion */
		base = 10;
	p = q = s;
	do {			/* generate digits in reverse order */
		if ((*p = u % base + '0') > '9')
			*p += ('A' - ('9' + 1));
		++p;
	} while ((u /= base) > 0);
	if (negative)
		*p++ = '-';
	*p = '\0';		/* terminate the string */
	while (q < --p) {	/* reverse the digits */
		c = *q;
		*q++ = *p;
		*p = c;
	}
	return (s);
}
