/*
 *	Cornell Theory Center					Trillium
 *
 *	Copyright 1988 Cornell University
 *
 *	MB
 *
 *	$Log:	tputc.c,v $
 * Revision 2.2  92/04/30  11:44:29  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  13:10:10  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:32:29  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:57:39  trillium
 * Homo erectus
 * 
 * Revision 1.1  88/12/21  11:54:01  braner
 * Initial revision
 * 
 *
 *	tputc, tputs, tflush - stdio-free putc() and puts() for Trollius.
 *
 *	Function : - write characters to stdout with local buffering.
 *
 *		int tputc (int c) takes one char, returns c or -1.
 *		int tputs (char *s) takes a string, returns 0 or -1.
 *		int tflush() flushes any buffered chars, returnd 0 or -1.
 *
 *	The buffer is also flushed upon each newline and when it's full.
 */

#define BUFSIZE	128
#define FLUSH	(-1)
#define ERROR	(-1)
#define OK	0

int
tputc (c)
	int c;
{
	static char	buf[BUFSIZE];
	static int	ptr = 0;
	static int	err = 0;
	int		n;

	if (err)
		return (ERROR);
	if (c != FLUSH)
		buf[ptr++] = c;
	if (ptr == BUFSIZE || c == '\n' || (c == FLUSH && ptr > 0)) {
		n = ptr;
		ptr = 0;
		if (twrite (1, buf, n) != n) {
			err = 1;
			return (ERROR);
		}
	}
	return (c);
}

int
tputs (s)
	char *s;
{
	while (*s) {
		if (tputc(*s++) == ERROR)
			return (ERROR);
	}
	return (OK);
}

int
tflush()
{
	if (tputc (FLUSH) == ERROR)
		return (ERROR);
	return (OK);
}
