/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	GDB
 *
 *	$Log:	kpar_Na.c,v $
 * Revision 2.2  92/04/30  11:46:28  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.1  92/02/23  20:28:31  gdburns
 * Remove c.h.
 * 
 * Revision 2.1  91/03/20  13:10:46  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:32:35  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:57:47  trillium
 * Homo erectus
 *
 *	Function:	- create a Sodium weight process from a function
 *			- a new stack is allocated
 *			- based on Trollius 2.0 Copyright 1990
 *			  The Ohio State University and Cornell
 *			  Research Foundation
 *
 *	Accepts:	- ptr to function to use as text in new process
 *			- stack size required for new process
 *			- number of parameters to pass to par_func
 */

#include <net.h>

/*
 * external variables
 */
extern int			errno;

/*
 * external functions
 */
extern char			*rmalloc();
extern int			_exit();


char *kpar_Na(par_func, wpsize, nparms)

int			(*par_func)(),	/* ptr to parallel function */
			wpsize,		/* stack size required */
			nparms;		/* # of runtime parameters */

{
	char		*wp,		/* workspace */
			*wpblock;	/* block of space for wp */
	int		(*bug)(),	/* gentp bug */
			*parmptr,	/* points at stack parameters */
			i;		/* favourite index variable */


	if ((wpblock = rmalloc(LOCAL, wpsize, 0, 0)) == (char *) 0) {
		return((char *) 0);
	}

	wp = wpblock + wpsize;
/*
 * Drop the user supplied parameters onto the stack starting at wp - 1.
 */
	parmptr = (&nparms) + 1;

	for (i = nparms; i > 0; --i) {
		*(((int *) wp) - i) = *(parmptr++);
	}

	wp = (char *) (((int *) wp) - nparms);

	*(((int *) wp) - 1) = (int) __slink();
	*(((int *) wp) - 2) = (int) _exit;
	bug = par_func;
	*(((int *) wp) - 3) = (int) bug;
/*
 * Make that baby low priority.
 */
	wp++;
/*
 * Cast to int to make lint happy.
 */
	runp((int) (((int *) wp) - 2));

	return(wpblock);
}
