/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	GDB
 *
 *	$Log:	precv.c,v $
 * Revision 2.2  92/04/30  11:48:34  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.2  92/02/23  21:16:38  gdburns
 * Add #ifdef to c.h.
 * 
 * Revision 2.1.1.1  91/10/09  14:10:45  gdburns
 * Use upgraded portable.h.
 * 
 * Revision 2.1  91/03/20  13:11:06  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.2  90/09/27  18:13:28  gdburns
 * Converted to the modern portable.h.
 * 
 * Revision 2.0.1.1  90/07/13  19:32:39  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:57:48  trillium
 * Homo erectus
 * 
 *	Function:	- physical layer receive
 *			- based on Trollius 2.0 Copyright 1990
 *			  The Ohio State University and Cornell
 *			  Research Foundation
 */

#ifdef itb
#include <c.h>
#endif
#include <kio.h>
#include <net.h>
#include <portable.h>
#include <terror.h>
#include <typical.h>

/*
 * external variables
 */
extern struct kio_t	_kio;			/* kernel I/O block */
extern int		errno;

int
precv(nhead)

struct nmsg		*nhead;		/* network message descriptor */

{
	struct khold_t	*phold;		/* virtual circuit descriptor */
	int		l;
	int		ev;

/*
 * Calculate the pointer to the correct virtual circuit descriptor.
 */
	ev = nhead->nh_event;
	phold = _kio.ki_khold + ((ev & HOLDBITS) +
		((ev & INT4_SIGN) ? (HOLDBITS + 1) : 0));

	if (phold->kh_event != ev) {
		errno = EINVAL; 
		return(ERROR);
	}

	ev = phold->kh_peer_aux;
	in(ev, (char *) nhead->nh_data, NHDSIZE * sizeof(int));

	if (l = nhead->nh_length) {
		in(ev, nhead->nh_msg, l);
	}

	return(0);
}
