/*
 *	OSU Research Computing, architects and contractors	Trillium
 *
 *	Copyright 1990 The Ohio State University & Cornell University
 *
 *	GDB
 *
 *	$Log:	rpattach.c,v $
 * Revision 2.2  92/04/30  11:50:52  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  13:15:56  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:33:10  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:58:07  trillium
 * Homo erectus
 * 
 *
 *	Function:	- attach caller to the local kenya server
 *
 *	Accepts:	- destination node
 *
 *	Returns:	- 0 or ERROR
 */


#include <net.h>
#include <events.h>
#include <ksignal.h>
#include <typical.h>
#include <preq.h>
#include <kio.h>
#include <pcb.h>
#include <t_types.h>
#include <terror.h>

/*
 * external variables
 */
extern int			errno;		/* global error variable */
extern struct kio_t		_kio;		/* Kernel Input/Output */
extern struct pcb_t		*_pcb;		/* Process Control Block */


int
rpattach(node)

int				node;

{
	struct nmsg		header;		/* network header */
	struct preq  	 	request;	/* kenya request  */
	struct preply		reply;		/* kenya reply    */
	int			mask;


	request.pq_src_node = ltot((node == LOCAL) ? LOCAL : getnodeid());
	request.pq_src_event = ltot(-getpid());
	request.pq_req = ltot(PATTACH);
	request.pq_pid = ltot(getpid());
	request.pq_loadpt = ltot((int) _pcb->pc_header);
	request.pq_datapt = ltot(__slink());
	request.pq_stack = ltot((int) _pcb->pc_stack);
	request.pq_stksize = ltot(_pcb->pc_stksize);
	request.pq_flags = ltot(_kio.ki_rtf |= RTF_NOWAIT);
	request.pq_argc = ltot(_pcb->pc_argc);
	request.pq_argv = ltot((int) _pcb->pc_argv);

	header.nh_node = node;
	header.nh_event = EVKENYAD;
	header.nh_type = 0;
	header.nh_flags = NOBUF;
	header.nh_length = sizeof(request);
	header.nh_msg = (char *) &request;

	if (nsend(&header)) {
		return(ERROR);
	}

	mask = ksigblock(SIGUDIE | SIGARREST);
	header.nh_event = -getpid();
	header.nh_length = sizeof(reply);
	header.nh_msg = (char *) &reply;

	if (nrecv(&header)) {
		return(ERROR);
	}

	(void) ksigsetmask(mask);
	_kio.ki_rtf |= RTF_KENYA;

	if (reply.pr_reply) {
		errno = ttol(reply.pr_reply);
		return(ERROR);
	}

	else {
		return(0);
	}
}
