/*
 *      Office of Research Computing				Trillium
 *
 *      Copyright 1989 The Ohio State University
 *
 *      VSD
 *
 *	$Log:	TOPEN.c,v $
 * Revision 2.2  92/04/30  11:52:15  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  13:34:09  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.4  91/03/19  23:03:48  gdburns
 * cosmetic changes
 * 
 * Revision 2.0.1.3  90/07/13  19:34:21  gdburns
 * Homo sapien
 * 
 * Revision 2.0.1.2  90/06/15  17:05:38  dixit-v
 * Changed from function to subroutine.
 * 
 * Revision 2.0.1.1  90/06/01  16:42:21  gdburns
 * Removed stray debugging message.
 * 
 * Revision 2.0  90/02/20  11:58:39  trillium
 * Homo erectus
 * 
 *
 *	Function : - tf77 interface to topen
 *		     Returns: file descriptor or ERROR
 *
 */

#include <errno.h>
#include <typical.h>

#define MAXLEN 176		/* Maximum length of file specification */

/*
 * external functions
 */
extern int	topen();

/*
 * external variables
 */
extern int      errno;		/* global error variable */

/*
 * local variables
 */
static char	buf[MAXLEN];


void
topen_(udesc, file_name, flags, modes, ierror, name_len)

int	*udesc;
char	*file_name;		/* complete node:file specification */
int	name_len;		/* length of file_name	*/
int	*flags; 		/* open flags */
int	*modes;			/* modes      */
int	*ierror;		/* returns error code */

{
	if (name_len > MAXLEN-1) {
		*ierror = errno = ENAMETOOLONG;
		*udesc = ERROR;
		return;
	}

	strncpy(buf, file_name, name_len);
	buf[name_len] = '\0';

	if ((*udesc = topen (buf, *flags, *modes)) == ERROR) {
		*ierror = errno;
	}
	else {
		*ierror = 0;
	}
}
