/*
 *	OSU Research Computing					Trillium
 *	Copyright 1991 The Ohio State University
 *	RBD
 *
 *	$Log:	BSENDRECV.c,v $
 * Revision 2.2  92/04/30  11:53:18  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/11/27  19:32:07  raja
 * initial revision
 * 
 *	Function:	- f77 interface to bsend (sendb), brecv (recvb)
 *			- OTB version
 */

#include <portable.h>
#include <typical.h>
#include <net.h>

/*
 * external functions
 */
extern int4		sendb();
extern int4		recvb();

/*
 * external variables
 */
extern int		errno;


void
bsend_(bdestnode, bmsg, blength, bdatatype, ierror)

int4			*bdestnode,
			*blength,
			*bdatatype,
			*ierror;

char			*bmsg;

{
	int4		new_length;

	new_length = sendb(*bdestnode, (void *) bmsg, *blength, *bdatatype);
	if (new_length == (int4) ERROR) {
		*ierror = errno;
	}
	else {
		*ierror = 0;
	}
}


void
brecv_(bsrcnode, bmsg, blength, bdatatype, ierror)

int4			*bsrcnode,
			*blength,
			*bdatatype,
			*ierror;

char			*bmsg;

{
	int4		new_length;

	new_length = recvb(*bsrcnode, (void *) bmsg, *blength, *bdatatype);
	if (new_length == (int4) ERROR) {
		*ierror = errno;
	}
	else {
		*ierror = 0;
		*blength = new_length;
	}
}
