/*
 *      Office of Research Computing
 *
 *      Copyright 1989 The Ohio State University
 *
 *	VSD
 *
 *	$Log:	DSENDRECV.c,v $
 * Revision 2.2  92/04/30  11:53:21  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  13:34:45  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.3  90/07/13  19:34:40  gdburns
 * Homo sapien
 * 
 * Revision 2.0.1.2  90/06/15  11:56:28  dixit-v
 * Changed function name and fixed bug in bcopy.
 * 
 * Revision 2.0.1.1  90/04/06  15:28:11  dixit-v
 * Changed int ndsize to int *ndsize.
 * 
 * Revision 2.0  90/02/20  11:58:59  trillium
 * Homo erectus
 * 
 *
 *	Function:	- f77 interface to dsend, dtrysend, drecv, dtryrecv
 */

#include <typical.h>	/* for SUCCESS		*/
#include <kreq.h>	/* for KSEND		*/
#include <net.h>	/* for struct nmsg 	*/

extern int	do_dsend();
extern int      do_drecv();
extern int	errno;			/* global error variable */

void
dsend_(ndl_event, nevent, ntype, nlength, nflags, ndata, ndsize, nmsg, ierror)

int 			*ndl_event,
			*nevent,
			*ntype,
			*nlength,
			*nflags,
			*ndata,
			*ndsize,
			*ierror;

char			*nmsg;


{
	struct	nmsg	nhead;	/* network messge descriptor */

	nhead.nh_dl_event	= *ndl_event;
	nhead.nh_node		= LOCAL;
	nhead.nh_event		= *nevent;
	nhead.nh_type		= *ntype;
	nhead.nh_length		= *nlength;
	nhead.nh_flags		= *nflags;

        bcopy((char *)ndata, (char *)nhead.nh_data, 
		(*ndsize > sizeof (nhead.nh_data)) 
		? sizeof (nhead.nh_data) : *ndsize);
	nhead.nh_msg		= nmsg;

	if (do_dsend(&nhead, KSEND) != SUCCESS) {
		*ierror = errno;
	}

	else {
		*ierror = 0;
	}

}


void
dtsend_(ndl_event, nevent, ntype, nlength, nflags, ndata,
		ndsize, nmsg, ierror)

int			*ndl_event,
			*nevent,
			*ntype,
			*nlength,
			*nflags,
			*ndata,
			*ndsize,
			*ierror;

char			*nmsg;


{
	struct	nmsg	nhead;	  /* network messge descriptor */


	nhead.nh_dl_event	= *ndl_event;
	nhead.nh_node		= LOCAL;
	nhead.nh_event		= *nevent;
	nhead.nh_type		= *ntype;
	nhead.nh_length		= *nlength;
	nhead.nh_flags		= *nflags;

        bcopy((char *) ndata, (char *) nhead.nh_data,  
                (*ndsize > sizeof (nhead.nh_data)) 
                ? sizeof (nhead.nh_data) : *ndsize);

	nhead.nh_msg		= nmsg;

	if (do_dsend(&nhead, KTRY_SEND) != SUCCESS) {
		*ierror = errno;
	}

	else {
		*ierror = 0;
	}
}


void
drecv_(nevent, ntype, nlength, nflags, ndata, ndsize, nmsg, ierror)

int		 	*nevent,
			*ntype,
			*nlength,
			*nflags,
			*ndata,
			*ndsize,
			*ierror;

char			*nmsg;


{
	struct	nmsg	nhead;	/* network messge descriptor */

	nhead.nh_event	= *nevent;
	nhead.nh_type	= *ntype;
	nhead.nh_length	= *nlength;
	nhead.nh_flags	= *nflags;
	nhead.nh_msg	= nmsg;

	if (do_drecv(&nhead, KRECV) != SUCCESS) {
		*ierror = errno;
	}

	else {
		*ierror = 0;
		bcopy((char *) nhead.nh_data, (char *) ndata,  
                	(*ndsize > sizeof (nhead.nh_data)) 
                	? sizeof (nhead.nh_data) : *ndsize);

		*ntype = nhead.nh_type;
		*nlength = nhead.nh_length;
	}

}


void
dtrecv_(nevent, ntype, nlength, nflags, ndata, ndsize, nmsg, ierror)

int			*nevent,
			*ntype,
			*nlength,
			*nflags,
			*ndata,
			*ndsize,
			*ierror;

char			*nmsg;


{
	struct	nmsg	nhead;	/* network messge descriptor */

	nhead.nh_event	= *nevent;
	nhead.nh_type	= *ntype;
	nhead.nh_length	= *nlength;
	nhead.nh_flags	= *nflags;
	nhead.nh_msg	= nmsg;

	if (do_drecv(&nhead, KTRY_RECV) != SUCCESS) {
		*ierror = errno;
	}
	else {
		*ierror = 0;
                bcopy((char *) nhead.nh_data, (char *) ndata,  
                        (*ndsize > sizeof (nhead.nh_data))  
                        ? sizeof (nhead.nh_data) : *ndsize); 

                *ntype = nhead.nh_type;
                *nlength = nhead.nh_length;
	}
}


