/*
 *      Office of Research Computing				Trillium
 *
 *      Copyright 1990 The Ohio State University
 *
 *	RBD
 *
 *	$Log:	GETNET.c,v $
 * Revision 2.2  92/04/30  11:53:23  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  13:34:46  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.2  90/07/13  19:34:39  gdburns
 * Homo sapien
 * 
 * Revision 2.0.1.1  90/06/15  12:41:31  dixit-v
 * Changed function names.
 * 
 * Revision 2.0  90/02/20  11:58:59  trillium
 * Homo erectus
 * 
 *
 *	f77 interface to getnet, getnodeid, getnodetype, getorigin
 */

#include <net.h>
#include <typical.h>

extern int	getnet();
extern int 	getnodeid();
extern int 	getnodetype();
extern int	getorigin();
extern int	errno;

void
gnet_(nodeid, nodetype, origin, ierror)

int	*nodeid, *nodetype, *origin;
int	*ierror;

{
	struct net_info nodes;

	if (getnet(&nodes) != SUCCESS) {
		*ierror = errno;
	}
	else {
		*nodeid = nodes.ni_nodeid;
		*nodetype = nodes.ni_nodetype;
		*origin = nodes.ni_origin;
		*ierror = SUCCESS;
	}
}


int
igndid_()

{
	return(getnodeid());

}


int
igndtp_()

{
	return(getnodetype());

}



int
igorgn_()

{
	return(getorigin());

}


