/*
 *	OSU Research Computing, architects and contractors	Trillium
 *
 *	Copyright 1990 The Ohio State University & Cornell University
 *
 *	RBD
 *
 *	$Log:	GETRENT.c,v $
 * Revision 2.2  92/04/30  11:53:26  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  13:34:49  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.2  91/03/19  23:18:46  raja
 * Added GRENT and GRENTC calls.
 * 
 * Revision 2.0.1.1  90/07/13  19:34:43  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/06/15  19:04:12  dixit-v
 * Homo erectus
 * 
 *
 *	Function:	- otb f77 interface to getrent, getrentc, getroute,
 *			  getrtype
 *
 */

#include <net.h>
#include <events.h>
#include <rreq.h>
#include <typical.h>

extern int		getrent();
extern int		getrentc();
extern int		getroute();
extern int		getrtype();

extern int		errno;		/* global error variable */


void
groute_(nodeid, event, ierror)

int		*nodeid, *event; 
int		*ierror;

{
	if ((*event = getroute(*nodeid, *event)) == NOTEVENT) {
		*ierror = errno;
	}
	else {
		*ierror = 0;
	}
}


int
igrtp_(nodeid)

int		*nodeid;

{
	return(getrtype(*nodeid));
}


void
grent_(nodeid, event, nodetype, ierror)

int		*nodeid, *event, *nodetype;
int		*ierror;

{
	struct route	rentry;

	rentry.r_nodeid = *nodeid;
	if (getrent(&rentry)) {
		*ierror = errno;
	}
	else {
		*event = rentry.r_event;
		*nodetype = rentry.r_nodetype;
		*ierror = 0;
	}
}


void
grentc_(nodeid, event, nodetype, ierror)

int		*nodeid, *event, *nodetype;
int		*ierror;

{
	struct route	rentry;

	rentry.r_nodeid = *nodeid;
	if (getrentc(&rentry)) {
		*ierror = errno;
	}
	else {
		*event = rentry.r_event;
		*nodetype = rentry.r_nodetype;
		*ierror = 0;
	}
}
