/*
 *      Office of Research Computing				Trillium
 *      Copyright 1989 The Ohio State University
 *	RBD,VSD
 *
 *	$Log:	REVERSE.c,v $
 * Revision 2.2  92/04/30  11:53:35  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.1  91/07/13  04:35:13  raja
 * Enhanced FRF portability and a face-lift for the file.
 * 
 * Revision 2.1  91/03/20  13:34:53  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.3  90/07/13  19:34:34  gdburns
 * Homo sapien
 * 
 * Revision 2.0.1.2  90/06/15  16:02:07  dixit-v
 * Changed function names.
 * 
 * Revision 2.0  90/02/20  11:58:51  trillium
 * Homo erectus
 *
 *	Function:	- f77 otb interface to rw, rs, rd, rf
 */

#include <math.h>

/*
 * external functions
 */
extern double 		rd();
extern float		rf();
extern int		rw();
extern short		rs();

/*
 *	irw_
 *
 *	Function:	- f77 callable wrapper (IRW) for rw
 *			- FORTRAN integer function
 *			- reverse word byte ordering
 *
 *	FORTRAN:	- new_word = IRW(word)
 *
 *	Accepts:	- word (pass by reference)
 *
 *	Returns:	- word in reverse byte ordering
 */
int
irw_(iword)

int			*iword;

{
	return(rw(*iword));
}

/*
 *	irs_
 *
 *	Function:	- f77 callable wrapper (IRS) for rs
 *			- FORTRAN integer*2 function
 *			- reverse integer*2 byte ordering
 *
 *	FORTRAN:	- new_short = IRS(short)
 *
 *	Accepts:	- short (pass by reference)
 *
 *	Returns:	- short in reverse byte ordering
 */
short
irs_(sword)

short			*sword;

{
	return(rs(*sword));
}

/*
 *	frd_
 *
 *	Function:	- f77 callable wrapper (FRD) for rd
 *			- FORTRAN real*8 function
 *			- reverse double precision real byte ordering
 *
 *	FORTRAN:	- new_double = FRD(double)
 *
 *	Accepts:	- real*8 (pass by reference)
 *
 *	Returns:	- real*8 in reverse byte ordering
 */
double
frd_(dword)

double			*dword;

{
	return(rd(*dword));
}

/*
 *	frf_
 *
 *	Function:	- f77 callable wrapper (FRF) for rf
 *			- FORTRAN real function
 *			- reverse real byte ordering
 *
 *	FORTRAN:	- new_real = FRF(real)
 *
 *	Accepts:	- real (pass by reference)
 *
 *	Returns:	- real in reverse byte ordering
 */
FLOATFUNCTIONTYPE
frf_(fword)

float			*fword;

{
	float		new_fword;
/*
 * Uses architecture dependent macros to allow returning a C float to a
 * FORTRAN real (see <math.h>).  This is needed because otherwise
 * C would upgrade the float to a double before passing it back.
 */
	new_fword = rf(*fword);
	RETURNFLOAT(new_fword);
}
