/*
 *	OSU Research Computing					Trillium
 *	Copyright 1991 The Ohio State University
 *	VSD
 *
 *	$Log:	TSENDRECV.c,v $
 * Revision 2.2  92/04/30  11:53:36  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.1  91/10/22  14:16:15  raja
 * Modify TRECV to mirror the NRECV interface.  Face-lift the file.
 * 
 * Revision 2.1  91/03/20  13:34:55  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.3  90/07/13  19:34:36  gdburns
 * Homo sapien
 * 
 * Revision 2.0.1.2  90/06/15  16:05:13  dixit-v
 * Changed function names and fixed bug in bcopy.
 * 
 * Revision 2.0.1.1  90/04/06  15:34:29  dixit-v
 * Changed int ndsize to int *ndsize.
 * 
 * Revision 2.0  90/02/20  11:58:52  trillium
 * Homo erectus
 *
 *	Function:	- f77 interface to tsend, trecv
 *			- OTB version
 */

#include <portable.h>
#include <typical.h>
#include <net.h>

/*
 * external functions
 */
extern int		tsend();
extern int		trecv();

/*
 * external variables
 */
extern int		errno;


void
tsend_(nnode, nevent, ntype, nlength, nflags, ndata, ndsize, nmsg, ierror)

int4			*nnode,
			*nevent,
			*ntype,
			*nlength,
			*nflags,
			*ndata,
			*ndsize,
			*ierror;

char			*nmsg;

{
	struct nmsg	nhead;		/* network message descriptor */

	nhead.nh_node	= *nnode;
	nhead.nh_event	= *nevent;
	nhead.nh_type	= *ntype;
	nhead.nh_length = *nlength;
	nhead.nh_flags	= *nflags;
 
        bcopy((char *) ndata, (char *) nhead.nh_data,
                (*ndsize > sizeof(nhead.nh_data))
                ? sizeof(nhead.nh_data) : *ndsize);

	nhead.nh_msg	= nmsg;

	if (tsend(&nhead)) {
		*ierror = errno;
	}
	else {
		*ierror = 0;
	}
}


void
trecv_(nevent, ntype, nlength, nflags, ndata, ndsize, nmsg, ierror)

int4			*nevent,
			*ntype,
			*nlength,
			*nflags,
			*ndata,
			*ndsize,
			*ierror;

char			*nmsg;

{
	struct nmsg	nhead;		/* network message descriptor */

	nhead.nh_event	= *nevent;
	nhead.nh_type	= *ntype;
	nhead.nh_length = *nlength;
	nhead.nh_flags	= *nflags;
	nhead.nh_msg	= nmsg;

	if (trecv(&nhead)) {
		*ierror = errno;
	}
	else {
		*ierror = 0;
                bcopy((char *) nhead.nh_data, (char *) ndata,
                        (*ndsize > sizeof(nhead.nh_data))
                        ? sizeof(nhead.nh_data) : *ndsize);

                *ntype = nhead.nh_type;
                *nlength = nhead.nh_length;
	}
}
