/*
 *	OSU Research Computing, architects and contractors	Trillium
 *
 *	Copyright 1990 The Ohio State University & Cornell University
 *
 *	VSD
 *
 *	$Log:	RCAST.c,v $
 * Revision 2.2  92/04/30  11:53:53  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  13:35:27  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.2  90/07/13  19:34:55  gdburns
 * Homo sapien
 * 
 * Revision 2.0.1.1  90/06/28  17:42:22  dixit-v
 * Added wrapper for rmelt().
 * 
 * Revision 2.0  90/02/20  11:59:02  trillium
 * Homo erectus
 * 
 *
 *	Function:	- f77 interface to rcast and rmelt
 *
 *      Accepts:        - target node
 *                      - multicast identifier
 *                      - combine function selector
 *                      - array of multicast members
 *                      - number of multicast members
 */
			  

#include <typical.h>

extern int	rcast();
extern int	rmelt();
extern int	errno;

void
rcast_(node, castid, combine, pcast, ncast, ierror)

int		*node;
int		*castid;
int		*combine;
int		*pcast;
int		*ncast;
int		*ierror;	/* return code */

{
	if (rcast(*node, *castid, *combine, pcast, *ncast) != SUCCESS) {
		*ierror = errno;
	}

	else {
		*ierror = 0;
	}
}

void
rmelt_(node, castid, ierror) 

int             *node; 
int             *castid; 
int             *ierror; 
 
{ 
        if(rmelt(*node, *castid) != SUCCESS) { 
                *ierror = errno; 
        } 
 
        else { 
                *ierror = 0; 
        } 
} 
 

