/*
 *	Cornell Theory Center					Trillium
 *
 *	Copyright 1987 Cornell University
 *
 *	GDB/AKP
 *
 *	$Log:	kcreate.c,v $
 * Revision 2.2  92/04/30  11:55:46  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  15:11:31  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:34:00  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:58:31  trillium
 * Homo erectus
 * 
 * Revision 1.1  88/06/05  02:33:46  trillium
 * long overdue after 127 fixes and upgrades
 * 
 * Revision 1.0  87/12/19  16:35:57  trillium
 * Initial revision
 * 
 *
 *	- create a new process
 *	- does not make a request of the kernel
 *	- essentially a packaged fork and exec
 */

#include <typical.h>
#include <terror.h>


int
kcreate(pathname, argv)

char			*pathname;
char			 *argv[];

{
	int		return_code;		/* status of kcreate */
	int		pid;			/* UNIX process ID */


	switch((pid = fork())) {

		case ERROR:			/* bad fork */
			return_code = ERROR;
			break;

		case 0:				/* child */
			return_code = execvp(pathname, argv);
			break;

		default:			/* parent */
			return_code = pid;
			break;

	}

	return(return_code);
}
