/*
 *	OSU Research Computing					Trillium
 *	Copyright 1991 The Ohio State University
 *	GDB
 *
 *	$Log:	maconfig.c,v $
 * Revision 2.2  92/04/30  12:02:58  trillium
 * Ohio Release
 * 
 *	Function:	- machine dependent region attributes
 *			- Archipel Volvox version
 */

#include <machine/maconfig.h>
#include <typical.h>

#define MAXM		16
#define INCM		0x40000
#define PATTERN		0x55AAFF00

/*
 *	region_size
 *
 *	Function:	- determine the size of a given region
 *	Accepts:	- region number
 *	Returns:	- region size
 */

int
region_size(region_no)

int			region_no;

{
	int		*limit;		/* upper memory limit */
	int		b_eom;		/* end of memory? */
	int		n;		/* favourite counter */

	if (region_no == ONCHIP) {
		return(ONCHIP_SIZE);
	}
/*
 * Search for end of main memory in 1Mb chunks.
 */
	else if (region_no == MAIN) {
		limit = (int *) MAIN_START;

		for (n = 1; n <= MAXM; ++n) {
			*limit = 0;
			limit += INCM;
		}

		limit = (int *) MAIN_START;
		b_eom = FALSE;

		for (n = 1; (n <= MAXM) && !b_eom; ++n) {

			if (*limit != 0) {
				b_eom = TRUE;
			} else {
				*limit = PATTERN;

				if (*limit != PATTERN) {
					b_eom = 1;
				} else {
					limit += 0x40000;
				}
			}
		}

		limit = (int *) (((int) limit) & 0xFFF00000);

		return((int) limit - MAIN_START);
	}

	else {
		return(ERROR);
	}
}

/*
 *	region_start
 *
 *	Function:	- determine the first address of a given region
 *	Accepts:	- region number
 *	Returns:	- region first address
 */

int
region_start(region_no)

int			region_no;

{
	if (region_no == ONCHIP) {
		return(ONCHIP_START);
	} else if (region_no == MAIN) {
		return(MAIN_START);
	} else {
		return(ERROR);
	}
}
