.TH SOLDER l  "April 15, 1992" "Release 2.2" "TROLLIUS TOPOLOGY TOOLS"
.SH NAME
solder \- Reconfigure communication links on a network of processors.
(Trollius) (Archipel Voltop)
.SH SYNTAX
.B solder
[-dhvNV][-c <bnail>]
.br
.SH OPTIONS
.TP 14
.B \-c <bnail>
Use <bnail> as the boot schema file.
.TP
.B \-d
Turn on debugging.
.TP
.B \-h
Print useful information on this tool.
.TP
.B \-v
Turn on verbose mode.
.TP
.B \-N
Pretend to take action but skip all steps.
.TP
.B \-V
Format and print the boot schema file.
.SH DESCRIPTION
.PP
.I Solder
is the topology tool that reconfigures the communication links connecting the
nodes of a multicomputer system, assuming that the hardware makes this possible.
The new configuration matches the connectivity of the
multicomputer network described in a boot schema file (see nail(l)).
With Archipel hardware, solder also translates node information
in the boot schema into node allocation requests for the Archipel
Voltop software.
For both allocation and link connection,
.I solder
invokes the Voltop netlogin(*) command.
.PP
A boot schema (or bnail file) is a description of a bootable multicomputer
system, specifying all physical nodes and the links that connect them.
A special tuple in the boot schema, TSOLDER, binds Trollius nodes
with vendor-specific character string designations of actual installed hardware.
This binding is necessary in determining exactly which installed
hardware links must be configured.
For Archipel, the syntax of vendor node names is identical to
that used with the Volvox software tools.
.SH EXAMPLES
.TP 4
solder -v
Reconfigure the communication links of the multicomputer system
described in the default boot schema file.
Report about important steps as they are done.
.TP
solder -c bnail.2x4
Reconfigure the communication links of the multicomputer system using the
custom boot schema bnail.2x4.
.SH FILES
.TP 4
/usr/local/trillium/boot/bnail.def
default boot schema file
.SH SEE ALSO
nail(l), spread(l), trollius(l)
.br
"VOLAPS User's Guide" for netlogin(*)
