.TH TROLLIUS l  "April 15, 1992" "Release 2.2" "TROLLIUS OPERATING SYSTEM"
.SH NAME
Trollius \- introduction to Trollius on the Archipel Multicomputer
.SH SYNTAX
.B netwhat
.br
.B netview -all
.br
.B solder
-v [-c <bnail>]
.br
.B spread
-v [-c <bnail>]
.br
.B netkill [-c <bnail>]
.br
.SH OPTIONS
.TP 14
.B \-c <bnail>
Use <bnail> as the boot schema file.
.SH DESCRIPTION
.PP
.I Trollius
is a multicomputer operating system that operates on a UNIX host machine,
a Volvox UNIX device driver, several Volvox UNIX devices, several
Volvox interface nodes and several Volvox computing nodes.
Trollius assumes the existance of the Voltop software from Achipel.
Trollius does not use higher level Archipel software but can coexist
with it on the same machine because of the common usage of Voltop
for allocation and deallocation of resources.
.PP
Second generation Trollius (as found here) does not include any
resource management services (they are found in the resource layer
of third generation Trollius).
The central concept to remember about booting Trollius 2 is that
the user provides an exact hardware description of the desired machine.
The user identifies the specific nodes and the specific links to be used.
This description is found in the
.I boot schema.
The user must have a valid boot schema before booting Trollius.
All software on all multicomputers eventually come to this point.
This point just happens to be the interface between Trollius 2 and
Trollius 3.
Without a clean break at this level, Trollius would not be portable
to many different commercial multicomputers, each with their own
resource management system.
Trollius 2 does consider that node linkage may have to be reconfigured
prior to booting the operating system.
Most of the Archipel specific portions of Trollius are concerned
with interfacing to Voltop resource management, both for allocation
and for requesting node linkage.
.PP
Boot schemata are easy but tedious to create.
A user can create any number of personal boot schemata for any
number of problem topologies and sizes.
However, the typical modus operandi is that the system administrator
will create all the common and obvious boot schemata and install
them at a central location.
We have yet to find a machine where a handful of boot schemata did
not satisfy the needs of the entire user community.
.PP
A user approaching an Archipel Volvox machine with the intent of
using Trollius must first determine what portion of the machine
is available.
The Voltop netview(*) command with the -all option reports on the
availability of all the ITB (In The Box) nodes.
By default, this command uses the first UNIX device (/dev/vxv0)
connected to the box in order to retrieve usage information.
If this device (Archipel calls it an entry) is in use, the netview(*)
command will not work without further options.
Thus, Trollius provides a simple command, netwhat(l),
that reports which devices are free and which are in use.
Begin by executing the netwhat(l) command.
.sp
.RS
% netwhat
.RE
.sp
If no devices are available, nothing can be allocated because
every boot schema requires a link to the host node.
If the first device, /dev/vxv0, is available continue by
executing the command,
.sp
.RS
% netview -all
.RE
.sp
If the first device is in use, but another device is available,
execute the command,
.sp
.RS
% netview -all -d /dev/vxv#
.RE
.sp
where /dev/vxv# is any one of the devices reported available.
.PP
With a report from netwhat(l) and netview(*)
the user can see which portion of the machine is available.
Choose a boot schema that uses only available parts of the machine.
In theory this seems difficult but in practise, with the machine
usually partitioned into grids, it is trivial.
Execute the Trollius command,
.sp
.RS
% solder -v -c bnail
.RE
.sp
where bnail is the chosen boot schema filename.
Solder(l) ensures that the reconfigurable links in the box
are switched to match the description in the boot schema.
For Volvox Trollius, solder(l) also allocates the nodes
ennumerated in the boot schema.
Both of these functions are accomplished by translating the
boot schema information into requests to the Voltop command, netlogin(*).
.PP
An allocated machine now exists that exactly matches the
description in the boot schema.
By definition, the machine is ready to boot and this is accomplished
with the command,
.sp
.RS
% spread -v -c bnail
.RE
.sp
where bnail is the \fBsame\fR boot schema filename given to solder(l).
.PP
Trollius is not an operating system that has to be rebooted before
every application run.
However, the system can be rebooted without deallocation by
executing the tkill(l) and spread(l) commands.
.sp
.nf
.RS
% tkill -v
% spread -vez -c bnail
.RE
.fi
.sp
When Trollius termination and deallocation is desired, execute the command,
.sp
.RS
% netkill -v -c bnail
.RE
.sp
where bnail is the \fBsame\fR boot schema filename given to solder(l)
and spread(l).
Netkill(l) is a combination of the tkill(l) and netlogout(*) commands
using the information in the boot schema to derive the correct
device needed by netlogout(*).
.SH BUGS
.PP
This allocation and deallocation scheme is not perfect.
With neither central control over the devices and node allocation
nor complicated back-off protocols, a deadlock is possible with
lucky timing.
Also, creating or choosing an incorrect boot schema will cause
solder(l) to fail.
These and other problems will cause solder(l) to print error
messages in which case the user should execute a corresponding
netkill(l) command immediately.
If deadlock is suspected, the user can restart the allocation
procedure.
.SH FILES
.TP 4
$TROLLIUSHOME/boot/bnail.def
default boot schema file
.SH SEE ALSO
nail(l), netkill(l), netwhat(l), solder(l), spread(l), tkill(l),
introc(l), INTROF(l), introu(l)
.sp
"Trollius Command Reference"
.br
"Trollius Tutorial Introduction in C"
.br
"Trollius Library Reference in C"
.br
"VOLAPS User's Guide", for netlogin(*), netlogout(*), netview(*)
