/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	GDB
 *
 *	$Log:	dl_mom.c,v $
 * Revision 2.2  92/04/30  12:17:43  trillium
 * Ohio Release
 * 
 *	Function:	- creates datalink moron process
 *			- command line arguments determine datalink
 *			  configuration
 *			- dl_moron creates datalink i/o processes and
 *			  does one centralized open for each datalink device
 *			- usage: dl_dev devfile event devfile event ...
 *			- based on Trollius 2.0 Copyright 1990
 *			  The Ohio State University
 *			  and Cornell Research Foundation
 */

#include <stdio.h>
#include <dlreq.h>
#include <kernel.h>

/*
 * external variables
 */
extern int		errno;			/* global error variable */
extern int4		ppid[MAXNLINK];		/* child dlo processes */

/*
 * external functions
 */
extern void		dl_moron();		/* I/O funnel */
extern void		dld();			/* datalink daemon */


main(argc, argv)

int			argc;
char			*argv[];

{
	int		pid;			/* child's or my pid */
	int		i;			/* favourite index variable */

	for (i = 0; i < MAXNLINK; ++i) {
		ppid[i] = NOTPROCESS;
	}

	argv++;
	argc--;
/*
 * We must have an even number of options.
 */
	if ((argc % 2) != 0) {
		fprintf(stderr, "usage: dl_dev device event ...\n");
		return(1);
	}
/*
 * Loop through command line pairs.
 */
	while (argc) {
/*
 * Fork the datalink moron process.
 */
		if ((pid = fork()) < 0) {
			perror("dl_dev (fork dl_moron)");
			return(errno);
		}

		else if (pid == 0) {
			dl_moron(argv[0], stoi(argv[1]));
			return(0);
		}

		argv += 2;
		argc -= 2;
	}

	dld();
	return(0);
}
