/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	GDB
 *
 *	$Log:	link.c,v $
 * Revision 2.2  92/04/30  12:19:31  trillium
 * Ohio Release
 * 
 *	Function:	- link device interface
 *			- generic Unix version
 */

#include <fcntl.h>

/*
 * external functions
 */
extern int		close();
extern int		open();
extern int		read();
extern int		write();

/*
 * global functions
 */
int			CloseLink();	/* close device */
int			OpenLink();	/* open device */
int			ReadLink();	/* read from device */
int			WriteLink();	/* write to device */

/*
 *	OpenLink
 *
 *	Function:	- opens link device
 *	Accepts:	- link name
 *	Returns:	- handle for open link device
 */

int
OpenLink(name)

char			*name;

{
	return(open(name, O_RDWR, 0));
}

/*
 *	ReadLink
 *
 *	Function:	- reads data from link device
 *	Accepts:	- link handle
 *			- buffer address
 *			- buffer length
 *			- timeout value (not used)
 *	Returns:	- #bytes written or -1 if error
 */

int
ReadLink(fd, buf, n, timeout)

int			fd;
char			*buf;
int			n;
int			timeout;

{
	return(read(fd, buf, n));
}

/*
 *	WriteLink
 *
 *	Function:	- writes data to link device
 *	Accepts:	- link handle
 *			- buffer address
 *			- buffer length
 *			- timeout value (not used)
 *	Returns:	- #bytes written or -1 if error
 */

int
WriteLink(fd, buf, n, timeout)

int			fd;
char			*buf;
int			n;
int			timeout;

{
	return(write(fd, buf, n));
}

/*
 *	CloseLink
 *
 *	Function:	- closes link device
 *	Accepts:	- link handle
 *	Returns:	- 0 for success
 *			- -1 for error
 */

int
CloseLink(fd)

int			fd;

{
	return(close(fd));
}
