/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	GDB
 *
 *	$Log:	maconfig.h,v $
 * Revision 2.2  92/04/30  12:21:03  trillium
 * Ohio Release
 * 
 *	Function:	- define machine dependent memory constants
 *			- Archipel Volvox version
 */

#ifndef _MACONFIG
#define _MACONFIG

/*
 * This is a good place to talk about the layout of on-chip RAM on
 * transputers.
 *
 *	80000000 - 01c: links
 *		   020: event
 *	     024 - 06c: reserved to transputer
 *	     070 - 1d0: moses
 *	     1d4 - 1ec: empty
 *	     1f0 - 1f8: panic info
 *		   1fc: kernel channel
 *	     200 - 204: siesta list pointers
 *	     208 - 21c: empty
 *	     220 - 288: shared library
 *	     28c - 28c: empty
 *	     290 - 29c: gearbox
 *	     2a0 - 49c: onchip stack space
 *	     4a0 -    : mallocd
 */

/*
 * region mnemonics
 */
#define NREGIONS	2		/* number of memory regions */
#define NMAIN		1		/* ANYBANK limit */
#define ANYBANK		0		/* regions 1 - NMAIN */
#define MAIN		1		/* main memory */
#define ONCHIP		2		/* on chip memory */

/*
 * region starting addresses - must be word aligned
 */
#define BOOTNSPAWN	0x80001000
#define BOOTSPAWN	0x80001004
#define DEFMEMSTART	0x80001400
#define MAIN_START	0x80031000
#define ONCHIP_START	0x800004a0
#define MAXONCHIP	ONCHIP_START
#define MAXWATER	0x80028000
#define DEFONCHIPSTART	0x800002a0
#define SH_BASE		0x80000220
#define KERNEL_CHAN	0x800001fc
#define FRONT_SIESTA	0x80000200
#define BACK_SIESTA	0x80000204

/*
 * regions sizes - must be word divisible
 */
#define ONCHIP_SIZE	0xB60

#endif
