/*
 *	OSU Research Computing					Trillium
 *	Copyright 1991 The Ohio State University
 *	GDB
 *
 *	$Log:	netwhat.c,v $
 * Revision 2.2  92/04/30  12:22:28  trillium
 * Ohio Release
 * 
 *	Function:	- netwhat
 *			- extension to Voltop that simply reports which
 *			  entry points are open
 *			- looks at one entry only if entry is given
 *			  as argument
 *			- in no way is this an idiot proof program
 */

#include <errno.h>
#include <fcntl.h>
#include <typical.h>

/*
 * external variables
 */
extern int		errno;		/* global error variable */

main(argc, argv)

int			argc;
char			*argv[];

{
	int		fd;		/* device file descriptor */
	int		n;		/* count through entry points */
	int		more;		/* stop flag */
	char		dentry[32];	/* more than enough space to hold
					   a 32 num and prefix string */
/*
 * Check for a command line argument.
 */
	if (argc > 1) {

		if ((fd = open(argv[1], O_RDWR)) < 0) {
			exit(errno);
		} else {
			(void) close(fd);
			exit(0);
		}
	}
/*
 * Scan through special entry names.
 */
	more = TRUE;
	n = 0;

	while (more) {
		sprintf(dentry, "/dev/vxv%d", n);

		if ((fd = open(dentry, O_RDWR)) < 0) {

			if (errno == EBUSY) {
				printf("netwhat: %s is in use.\n", dentry);
			}

			else {
				more = FALSE;
			}
		}

		else {
			printf("netwhat: %s is free.\n", dentry);
			(void) close(fd);
		}

		++n;
	}

	exit(0);
}
