.TH SOLDER l  "April 22, 1992" "Release 2.2" "TROLLIUS TOPOLOGY TOOLS"
.SH NAME
solder \- Reconfigure communication links on a network of processors.
(Trollius) (INMOS B014)
.SH SYNTAX
.B solder
[-dhvNV][-c <bnail>]
.br
.SH OPTIONS
.TP 14
.B \-c <bnail>
Use <bnail> as the boot schema file.
.TP
.B \-d
Turn on debugging.
.TP
.B \-h
Print useful information on this tool.
.TP
.B \-v
Turn on verbose mode.
.TP
.B \-N
Pretend to take action but skip all steps.
.TP
.B \-V
Format and print the boot schema.
.SH DESCRIPTION
.PP
.I Solder
is the topology tool that reconfigures the communication links connecting the
nodes of a multicomputer system, assuming that the hardware makes this possible.
The new configuration matches the connectivity of the
multicomputer network described in a boot schema (see nail(l)).
.I Solder
should be run before booting the operating system, if the hardware
configuration does not already match the boot schema.
.PP
A boot schema (or bnail file) is a description of a bootable multicomputer
system, specifying all physical nodes and the links that connect them.
A special tuple in the boot schema, TSOLDER, binds Trollius nodes
with vendor specific character string designations of actual installed hardware.
A node on a Inmos B014 board is designated through the string
"board.slot", where board identifies the board (customer site specific), 
and slot identifes a node location.
The sub-string slot must be an integer between 0 and NUMBEROFSLOTS-1.
The constant NUMBEROFSLOTS is currently fixed at 8.
Trollius to physical node bindings are necessary in 
determining exactly which installed hardware links must be configured.
.PP
For the Inmos B014 hardware platform, a program called
.I check
supplied by Inmos is invoked by
.I solder
to perform the actual reconfiguration.
.I Check 
issues commands to link switches in order to obtain the desired 
interconnectivity among nodes.
.SH EXAMPLES
.TP 4
solder -v
Reconfigure the communication links of the multicomputer system
described in the default boot schema.
Report about important steps as they are done.
.TP
solder -c bnail.mycube
Reconfigure the communication links of the multicomputer system using the
custom boot schema, bnail.mycube.
.SH FILES
.TP 4
$TROLLIUSHOME/boot/bnail.def
default boot schema file
.SH SEE ALSO
nail(l), spread(l)
