/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	GDB
 *
 *	$Log:	dl_mom.c,v $
 * Revision 2.2  92/04/30  13:40:27  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.1  92/04/27  10:22:03  gdburns
 * buffer flow control enhancements
 * 
 * Revision 2.1  91/03/20  11:45:41  gdburns
 * Ohio Release
 * 
 * Revision 2.0  90/10/04  16:40:07  gdburns
 * Meiko VCS
 *
 *	Function:	- creates datalink process pairs on transputer links
 *			- command line determines which links are used
 *			- usage: dl_meiko <outlink> <outlink> ...
 *			- Meiko VCS version
 *			- based on Trollius 2.0 Copyright 1990
 *			  The Ohio State University and
 *			  Cornell Research Foundation
 */

#include <net.h>
#include <shared.h>

#define DLOSTACK	0x400 + MAXNMSGLEN
#define DLISTACK	DLOSTACK

/*
 * external variables
 */
extern int		errno;			/* error number */

/*
 * external functions
 */
extern void		dli_meiko();		/* datalink input program */
extern void		dlo_meiko();		/* datalink output program */


main(argc, argv)

int			argc;
char			*argv[];

{
	int		inlink;			/* input link address */
	int		outlink;		/* output link address */
	int		pid;			/* child process ID */
	char		*memstart;		/* child memory block */

	if (kinit(0) < 0) {
		panic(errno);
	}

	--argc;
	++argv;
/*
 * Loop through command line pairs.
 */
	while (argc) {
/*
 * Open the device.
 */
		outlink = stoi(argv[0]);
		inlink = outlink + 0x10;
/*
 * Create the datalink output process.
 */
		memstart = (char *) kpar_Fe(dlo_meiko, DLOSTACK,
			&pid, 1, outlink);

		if (memstart == (char *) 0) {
			panic(errno);
		}
/*
 * Create the datalink input process.
 */
		memstart = (char *) kpar_Fe(dli_meiko, DLISTACK,
			&pid, 1, inlink);

		if (memstart == (char *) 0) {
			panic(errno);
		}

		--argc;
		++argv;
	}
/*
 * Since we do not want our memory cleaned up, we will _kexit().
 */
	_kexit(0);
}
