/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	GDB
 *
 *	$Log:	dli_meiko.c,v $
 * Revision 2.2  92/04/30  13:40:29  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.1  92/04/27  10:22:17  gdburns
 * buffer flow control enhancements
 * 
 * Revision 2.1  91/03/20  11:45:45  gdburns
 * Ohio Release
 * 
 * Revision 2.0  90/10/04  16:40:13  gdburns
 * Meiko VCS
 *
 *	Function:	- datalink input program for transputer link
 *			- Meiko VCS version
 */

#ifdef itb
#include <c.h>
#endif
#include <net.h>
#include <typical.h>
#include <pcb.h>
#include <shared.h>

/*
 * external variables
 */
extern int		errno;
extern struct pcb_t	*_pcb;

/*
 * local variables
 */
static char		*myname = "dli_meiko";

void
dli_meiko(inlink)

int			inlink;		/* input channel address */

{
	int		nw;		/* # of words input (VCS protocol) */
	int		mynodeid;	/* cache getnodeid() */
	struct nmsg	nhead;		/* network msg descriptor */
	char		nmsg[MAXNMSGLEN];

/*
 * Connect to the kernel.
 */
	if (kinit(0) < 0) {
		panic(errno);
	}
/*
 * Become a high priority process.
 */
	setpri(0);
/*
 * Fuss with our argv pointer.
 */
	_pcb->pc_argv = &myname;
	_pcb->pc_argc = 1;
/*
 * Connect to kenyad.
 */
	if (rpattach(LOCAL) < 0) {
		panic(errno);
	}
/*
 * Input frame header.
 */
	in(inlink, (char *) &nw, sizeof(nw));
	in(inlink, (char *) &nhead, sizeof(struct nmsg));
/*
 * Inform the router of activity on the link.
 * NOTNODEID will cause no damage if route table is already in place.
 * Otherwise it will set the dumb route and all outbound messages will be
 * sent to my dlo partner.
 */
	(void) rsetroute(LOCAL, NOTNODEID, inlink - 0x10);

	for (;;) {
/*
 * Store and forward.
 */
		if (nhead.nh_length) {
			in(inlink, (char *) &nw, sizeof(nw));
			nw = (nhead.nh_length + (sizeof(int) - 1))
				/ sizeof(int);
			in(inlink, nmsg, nw * sizeof(int));
		}

		nhead.nh_flags &= ~BYBUF;
		nhead.nh_flags |= DDLI;
		nhead.nh_msg = nmsg;
		mynodeid = getnodeid();

		if ((mynodeid == NOTNODEID) ||
	    		(mynodeid == nhead.nh_node)) {

			nhead.nh_node = LOCAL;
		}

		(void) nsend(&nhead);
/*
 * Input frame header.
 */
		in(inlink, (char *) &nw, sizeof(nw));
		in(inlink, (char *) &nhead, sizeof(struct nmsg));
	}
}
