/*
 *	OSU Research Computing					Trillium
 *
 *	Copyright 1990 The Ohio State University
 *
 *	GDB
 *
 *	$Log:	maconfig.c,v $
 * Revision 2.2  92/04/30  13:40:40  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  11:46:03  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/11/11  20:01:49  gdburns
 * Changed constant expression to avoid ULS bug.
 * 
 * Revision 2.0  90/10/04  16:41:20  gdburns
 * Meiko VCS
 * 
 * 
 *	Function:	- machine dependent region attributes
 *			- Meiko version
 */

#include <machine/maconfig.h>
#include <typical.h>

/*
 *	region_size
 *
 *	Function:	- determine the size of a given region
 *
 *	Accepts:	- region number
 *
 *	Returns:	- region size
 */

int
region_size(region_no)

int			region_no;

{
	int		*limit;		/* upper memory limit */

	if (region_no == ONCHIP) {
		return(ONCHIP_SIZE);
	}
/*
 * Search for end of main memory in 1Mb chunks.
 */
	else if (region_no == MAIN) {
		limit = (int *) ((MAIN_START + 0x100000) & 0xFFF00000);
		*limit = 0xAAFF0055;

		while (*limit == 0xAAFF0055) {
			limit += 0x40000;
			*limit = 0xAAFF0055;
		}

		return((int) limit - MAIN_START);
	}

	else {
		return(ERROR);
	}
}

/*
 *	region_start
 *
 *	Function:	- determine the first address of a given region
 *
 *	Accepts:	- region number
 *
 *	Returns:	- region first address
 */

int
region_start(region_no)

int			region_no;

{
	if (region_no == ONCHIP) {
		return(ONCHIP_START);
	}

	else if (region_no == MAIN) {
		return(MAIN_START);
	}

	else {
		return(ERROR);
	}
}
