.TH SOLDER l  "April 12, 1992" "Release 2.2" "TROLLIUS TOPOLOGY TOOLS"
.SH NAME
solder \- Allocate and configure a network of processors. (Trollius) (Meiko
VCS version)
.SH SYNTAX
.B solder
[-dhvNV][-c <bnail>]
.SH OPTIONS
.TP 14
.B \-c <bnail>
Use <bnail> as the boot schema file.
.TP
.B \-d
Turn on debugging.
.TP
.B \-h
Print useful information on this tool.
.TP
.B \-v
Be verbose.
.TP
.B \-N
Pretend to take action but skip all steps.
.TP
.B \-V
Format and print the boot schema.
.SH DESCRIPTION
.PP
.I Solder
is the topology tool that requests a Trollius network of processors from 
the VCS domain of ITB nodes and configures it to match the connectivity
of the multicomputer network described in a boot schema (see nail(l)).
.I Solder
should be run every time a new configuration is needed or when the previous
multicomputer network has been relinquished.
.PP
.I Solder 
follows a system dependent procedure to accomplish its task, relying on
the hardware characteristics of the multicomputer nodes and of the
reconfiguration switches.
Basically, 
.I solder
grabs the required number of processors (if available) from the SVCS daemon
(see svcsd(l)) and configures the communication channels
among them to fit the topology of the required multicomputer system.
After the network is allocated to the user,
.I solder
invokes a special shell, known as ssh(l) or small shell, from which
the Trollius system can be booted using spread(l).
Once booted, Trollius can be used, at the command layer, either from ssh or
from any other shell as long as ssh is still alive.
Using the Trollius toolkit layer must be done from within ssh.
.PP
The Trollius system can be killed using tkill(l).
This does not release the processors allocated to the user, thus allowing
the user to re-boot Trollius again.
To release the processors, ssh has to be exited.
Thus as long as ssh is alive, the processors grabbed by solder are owned by
the user.
This mechanism is mandated by the communication constraints of the SVCS
resource daemon.
.PP
A boot schema (or bnail file) is a description of a bootable
multicomputer system, specifying all physical nodes 
and the links that connect them.
A special tuple in the boot schema, TSOLDER, binds Trollius nodes
with vendor specific character string designations of actual installed hardware.
This binding is necessary in determining exactly which installed
hardware links must be configured.
.SH EXAMPLES
.TP 4
.I "solder -v"
Allocate and configure a multicomputer system as described in the default
boot schema file.
Report about important steps as they are done.
.TP
.I "solder -c bnail.mycube"
Allocate and configure a multicomputer system using the
custom boot schema, `bnail.mycube'.
.SH BUGS
.PP
For reasons unknown to Meiko and OSU, the tfish(l) command does not
operate successfully.
The reset of ITB nodes that occurs when the ITB nodes are allocated
is the only reset possible.
Thus, a reboot of the ITB system cannot be accomplished within ssh(l) and
the nodes must be relinquished and reallocated by exiting and restarting ssh(l).
.SH FILES
.TP 4
$TROLLIUSHOME/boot/bnail.def
default boot schema file
.SH SEE ALSO
nail(l), spread(l), ssh(l), tkill(l)
