.TH SSH l  "April 12, 1992" "Release 2.2" "TROLLIUS TOOLS"
.SH NAME
ssh \- Trollius Meiko VCS small shell
.SH SYNTAX
.B ssh
[-h]
.SH OPTIONS
.TP 11
.B \-h
Print useful information on this tool.
.SH DESCRIPTION
.I Ssh
is a very trivial UNIX shell that passes two open file descriptors
for a Meiko VCS domain of ITB nodes to every program that it invokes.
Spread(l) and all the Trollius toolkit programs require these descriptors
in order to communicate with the root ITB node.
The user of Trollius with Meiko VCS cannot avoid ssh for this reason.
.PP
Solder(l) allocates the VCS domain of ITB nodes and configures
the communication links between nodes based on the NaIL boot schema
(see nail(l)).
Solder receives the aforementioned file descriptors from the SVCS
daemon (see svcsd(l)) and then invokes \fIssh\fR.
The user will then typically invoke spread(l) to boot Trollius, using
the same boot schema that was passed to solder.
Afterwards, any Trollius command layer program can be invoked from
any shell, but
.I ssh
must continue running throughout the use of Trollius and the multicomputer.
When the user exits \fIssh\fR,
an implicit tkill(l) is invoked and the VCS domain is deallocated.
.PP
Instead of invoking spread(l), the user can experiment with the Trollius
toolkit layer, eg: sboot(l), hboot(l), tfish(l), export(l), moses(l) et al.
All toolkit programs must be invoked from \fIssh\fR.
.PP
As a UNIX shell,
.I ssh
is not packed with useful features.
Its sole purpose in life is to invoke programs that wish to communicate
with the root processor of a VCS domain, in a manner that keeps the
VCS daemon happy.
However,
.I ssh
will execute any UNIX program, and it will search the directories in
the environment variable PATH for programs.
It has no other features attributable to shells, such as job control
and I/O redirection.
.SH "BUILTIN COMMANDS"
.PP
.I Ssh
has a few builtin commands for the simple operations.
.LP
.nf
.ta 1.0i 1.75i
exit	Invoke tkill(l) and terminate \fIssh\fR.
help	List the commands that should be invoked from \fIssh\fR.
quit	Invoke tkill(l) and terminate \fIssh\fR.
.fi
.SH "SEE ALSO"
svcsd(8)
