.TH TROLLIUS l  "April 12, 1992" "Release 2.2" "TROLLIUS OPERATING SYSTEM"
.SH NAME
Trollius \- introduction to Trollius on the Meiko VCS Multicomputer
.SH SYNTAX
.B solder
-v [-c <bnail>]
.br
.B spread
-v [-c <bnail>]
.br
.B tkill
.br
.SH OPTIONS
.TP 11
.B \-c <bnail>
Use <bnail> as the boot schema file.
.SH DESCRIPTION
.PP
.I Trollius
is a multicomputer operating system that operates on a UNIX host machine
and several Meiko VCS processors.
Trollius assumes the existance of the VCS software from Meiko.
Trollius does not use higher level Meiko software but can coexist
with it on the same machine because of the common usage of svcsd(8)
for allocation and deallocation of resources.
.PP
Second generation Trollius (as found here) does not include any
resource management services (they are found in the resource layer
of third generation Trollius).
The central concept to remember about booting Trollius 2 is that
the user provides an exact hardware description of the desired machine.
The user identifies the specific nodes and the specific links to be used.
This description is found in the \fIboot schema\fR.
The user must have a valid boot schema before booting Trollius.
All software on all multicomputers eventually come to this point.
This point just happens to be the interface between Trollius 2 and
Trollius 3.
Without a clean break at this level, Trollius would not be portable
to many different commercial multicomputers, each with their own
resource management system.
Trollius 2 does consider that node linkage may have to be reconfigured
prior to booting the operating system.
Most of the Meiko specific portions of Trollius are concerned
with interfacing to VCS resource management, both for allocation
and for requesting node linkage.
.PP
The final identification of which silicon will be allocated as
an ITB node is hidden within svcsd(8).
Thus, the Meiko Trollius boot schema actually does not refer
to specific silicon.
The user has no choice but to choose the vender specific names
0 through N - 1, where N is the number of ITB nodes, in the
the TSOLDER tuples of the boot schema.
.PP
Boot schemata are easy but tedious to create.
A user can create any number of personal boot schemata for any
number of problem topologies and sizes.
However, the typical modus operandi is that the system administrator
will create all the common and obvious boot schemata and install
them at a central location.
We have yet to find a machine where a handful of boot schemata did
not satisfy the needs of the entire user community.
.PP
A user approaching a Meiko VCS machine with the intent of
using Trollius must first determine what portion of the machine
is available.
The VCS tps(1) command with the -l option reports on the
availability of all the ITB (In The Box) nodes.
.sp
.RS
% tps -l
.RE
.sp
With a report from tps(1)
the user can see which portion of the machine is available.
Choose a boot schema that uses only available parts of the machine.
In theory this seems difficult but in practise, with the machine
usually partitioned into grids, it is trivial.
Execute the Trollius command,
.sp
.RS
% solder -v -c bnail
.RE
.sp
where bnail is the chosen boot schema filename.
Solder(l) ensures that the reconfigurable links in the box
are switched to match the description in the boot schema.
For Meiko VCS Trollius, solder(l) also allocates the nodes
ennumerated in the boot schema.
Both of these functions are accomplished by translating the
boot schema information into requests to svcsd(8).
.PP
An allocated machine now exists that exactly matches the
description in the boot schema.
The user is left at the prompt of a new program, ssh(l),
whose presence is required by Meiko VCS Trollius.
VCS does not allow typical UNIX access to the ITB communication
link device and a special program is required.
Upon entering ssh(l), the machine is ready to boot with the command,
.sp
.RS
T> spread -vez -c bnail
.RE
.sp
where bnail is the \fBsame\fR boot schema filename given to solder(l).
.PP
Trollius is not an operating system that has to be rebooted before
every application run.
However, the system can be rebooted by executing the tkill(l), exiting
ssh(l) and restarting with solder(l).
This procedure also deallocates the ITB nodes, making them available
to other users.
.sp
.nf
.RS
T> tkill
T> exit
.RE
.fi
.sp
.SH BUGS
.PP
It should be possible to reboot with deallocation by only executing
tkill(l) and then restarting with spread(l).
.SH FILES
.TP 4
$TROLLIUSHOME/boot/bnail.def
default boot schema file
.SH SEE ALSO
nail(l), solder(l), spread(l), tkill(l), introc(l), INTROF(l), introu(l)
.sp
"Trollius Command Reference"
.br
"Trollius Tutorial Introduction in C"
.br
"Trollius Library Reference in C"
