/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	GDB
 *
 *	$Log:	dl_mom.c,v $
 * Revision 2.2  92/04/30  13:44:18  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.1  92/04/27  10:24:23  gdburns
 * buffer flow control enhancements
 * 
 * Revision 2.1  91/03/20  11:45:07  gdburns
 * Ohio Release
 * 
 * Revision 2.0  90/10/04  16:37:34  gdburns
 * Meiko VCS
 *
 *	Function:	- device connected datalink
 *			- creates one datalink process pair
 *			- Meiko VCS Version
 *			- based on Trollius 2.0 Copyright 1990
 *			  The Ohio State University and
 *			  Cornell Research Foundation
 */

#include <stdio.h>
#include <dlreq.h>
#include <kernel.h>
#include <machine/machine.h>
#include <net.h>

/*
 * external variables
 */
extern int		errno;			/* global error variable */
extern int4		ppid[MAXNLINK];		/* child dlo processes */

/*
 * external functions
 */
extern void		dld();			/* datalink daemon */
extern void		dlo_dev();		/* datalink output */
extern void		dli_dev();		/* datalink input */

/*
 * global variables
 */
char			*me;


main(argc, argv)

int			argc;
char			*argv[];

{
	int		pid;			/* child's or my pid */
	int		i;			/* favourite index */
	int		event;			/* dlo event */

	if (argc != 3) {
		fprintf(stderr, "usage: dl_dev device event ...\n");
		return(1);
	}

	me = argv[0];

	for (i = 0; i < MAXNLINK; ++i) {
		ppid[i] = NOTPROCESS;
	}
/*
 * Fork the datalink input process.
 */
	if ((pid = fork()) < 0) {
		perror(me);
		return(errno);
	} else if (pid == 0) {
		dli_dev(VCSFD);
		return(0);
	}
/*
 * Fork the datalink output process.
 */
	event = stoi(argv[2]);

	if ((pid = fork()) < 0) {
		perror(me);
		return(errno);
	} else if (pid == 0) {
		dlo_dev(VCSFD, event);
		return(0);
	}

	ppid[dl_link(event)] = pid;
	dld();
	return(0);
}
