/*
 *	OSU Research Computing					Trillium
 *
 *	(third party software provided under license)
 *
 *	$Log:	svcs.c,v $
 * Revision 2.2  92/04/30  13:45:51  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  11:46:22  gdburns
 * Ohio Release
 * 
 * Revision 2.0  90/10/04  16:51:48  gdburns
 * Meiko VCS
 * 
 *
 *	We're just putting our stamp on this for housekeeping reasons.
 */

#include <sys/types.h>
#include <sys/uio.h>

/*
 *	svcswrite
 *
 *	Function:	- write bytes to Meiko VCS device
 *			- uses negative length protocol
 *
 *	Accepts:	- VCS device descriptor
 *			- buffer ptr
 *			- buffer length
 */

int
svcswrite(fd, data, nbytes)

int			fd;
char			*data;
int			nbytes;

{
    int			hdr;
    int			rc;
    struct iovec	iov[2];

    hdr = mtohINT32(-nbytes);
    iov[0].iov_base = (caddr_t) &hdr;
    iov[0].iov_len = 4;
    iov[1].iov_base = (caddr_t) data;
    iov[1].iov_len = nbytes;
    
    rc = writev (fd, iov, 2);

    return (rc > 4 ? rc - 4: rc);
}
