/*
 *	OSU Research Computing					Trillium
 *
 *	(third party software provided under license)
 *
 *	$Log:	svcserrs.h,v $
 * Revision 2.2  92/04/30  13:46:25  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  11:46:58  gdburns
 * Ohio Release
 * 
 * Revision 2.0  90/10/04  16:53:31  gdburns
 * Meiko VCS
 * 
 *
 *	We're just putting our stamp on this for housekeeping reasons.
 */

#ifndef svcserrs_h
#define svcserrs_h 1
/*
 * @(#)svcserrs.h	1.2 12:33:22 1/10/89
 *
 * Interface to error-reporting for SVCS library functions.
 * Functions which have a return code will set svcs_errno if they
 * return < 0.
 * By default, error messages are printed on stderr as "svcs: <errmsg>\n".
 * The destination and format can be changed by calling svcs_verbose.
 * svcs_verbose(NULL, NULL) suppresses error messages completely. 
 *
 * Copyright Meiko Ltd 1988.
 */

extern int svcs_errno;

extern char *svcs_errmsg(/* int errno */);

extern void svcs_verbose(/* FILE *errstream, char *format */);

#define SVCS_ENONE  	0x1000
#define SVCS_EBADHDR	0x1001 
#define SVCS_ESEND	0x1002
#define SVCS_ERECV      0x1003
#define SVCS_EPIPESEND	0x1004
#define SVCS_EPIPERECV  0x1005
#define SVCS_EBOOT      0x1006
#define SVCS_ENOSERVICE 0x1007
#define SVCS_ESOCKET    0x1008
#define SVCS_EBIND      0x1009
#define SVCS_ENODAEMON  0x100a
#define SVCS_EACCEPT    0x100b
#define SVCS_EBADREPLY  0x100c
#define SVCS_EBADLINK   0x100d
#define SVCS_ENOTNOW    0x100e
#define SVCS_ENEVER     0x100f
#define SVCS_EBOOTEXE   0x1010
#define SVCS_EBADCPR    0x1011
#define SVCS_EFSYS      0x1012

#endif
