.TH SOLDER l  "April 23, 1992" "Release 2.2" "TROLLIUS TOPOLOGY TOOLS"
.SH NAME
solder \- Reconfigure communication links in a multicomputer.  (Trollius)
.SH SYNTAX
.B solder
[-dhvNV] [-c <bnail>]
.br
.SH OPTIONS
.TP 12
.B \-c <bnail>
Use <bnail> as the boot schema file.
.TP
.B \-d
Turn on debugging.
.TP
.B \-h
Print useful information on this tool.
.TP
.B \-v
Be verbose.
.TP
.B \-N
Pretend to take action but skip all steps.
.TP
.B \-V
Format and print the boot schema.
.SH DESCRIPTION
.PP
.I Solder
is the topology tool that reconfigures the communication links connecting the
nodes of a multicomputer, assuming that the hardware makes this possible.
The new configuration matches the connectivity of the
multicomputer network described in a boot schema (see nail(l)).
.I Solder
should be run when a new boot schema is selected and the state
of the hardware is unknown.
.PP
.I Solder 
follows a system dependent procedure to accomplish its task, relying on
the hardware characteristics of the multicomputer nodes and 
of the reconfiguration switches.
Basically, 
.I solder
reconfigures control signals (reset, error, etc.) required by the multicomputer
nodes, and reconnects the communication channels among these nodes.
.PP
A boot schema (aka bnail file) is a description of a bootable multicomputer
system, specifying all physical nodes and the links that connect them.
A special tuple in the boot schema, TSOLDER, binds Trollius nodes
with vendor-specific character string designations of actual installed hardware.
This binding is necessary in determining exactly which installed
hardware links must be configured.
.SH EXAMPLES
.TP 4
.I "solder -v"
Reconfigure the communication links of the multicomputer system
described in the default boot schema file.
Report about important steps as they are done.
.TP
.I "solder -c bnail.mycube"
Reconfigure the communication links of the multicomputer system using the
custom boot schema `bnail.mycube'.
.SH FILES
.TP 4
$TROLLIUSHOME/boot/bnail.def
default boot schema file, where $TROLLIUSHOME is the installation directory
.SH SEE ALSO
nail(l), spread(l)
