.TH TROLLIUS l  "April 23, 1992" "Release 2.2" "TROLLIUS OPERATING SYSTEM"
.SH NAME
Trollius \- introduction to Trollius on the NiCHE Multicomputer
.SH SYNTAX
.B solder
-v [-c <bnail>]
.br
.B spread
-v [-c <bnail>]
.br
.B tkill
.SH OPTIONS
.TP 14
.B \-c <bnail>
Use <bnail> as the boot schema file.
.SH DESCRIPTION
.PP
.I Trollius
is a multicomputer operating system that operates on a UNIX host machine,
a NiCHE UNIX device driver, several NiCHE UNIX devices,
and several NiCHE computing nodes.
Trollius assumes the existance of the REMOTE software.
Trollius does not use higher level NiCHE software but can coexist
with it on the same machine.
.PP
Second generation Trollius (as found here) does not include any
resource management services (they are found in the resource layer
of third generation Trollius).
The central concept to remember about booting Trollius 2 is that
the user provides an exact hardware description of the desired machine.
The user identifies the specific nodes and the specific links to be used.
This description is found in the
.I boot schema.
The user must have a valid boot schema before booting Trollius.
All software on all multicomputers eventually come to this point.
This point just happens to be the interface between Trollius 2 and
Trollius 3.
Without a clean break at this level, Trollius would not be portable
to many different commercial multicomputers, each with their own
resource management system.
Trollius 2 does consider that node linkage may have to be reconfigured
prior to booting the operating system.
.PP
Boot schemata are easy but tedious to create.
A user can create any number of personal boot schemata for any
number of problem topologies and sizes.
However, the typical modus operandi is that the system administrator
will create all the common and obvious boot schemata and install
them at a central location.
We have yet to find a machine where a handful of boot schemata did
not satisfy the needs of the entire user community.
.PP
A user approaching a NiCHE NT1000 machine with the intent of
using Trollius must first determine what portion of the machine is available.
The nt_what command reports on the
availability of all the ITB (In The Box) nodes.
.sp
.RS
% nt_what
.RE
.PP
Choose a boot schema that uses only available parts of the machine.
In theory this seems difficult but in practise, with the machine
usually partitioned into grids, it is trivial.
Execute the Trollius command,
.sp
.RS
% solder -v -c bnail
.RE
.sp
where bnail is the chosen boot schema filename.
Solder(l) ensures that the reconfigurable links in the box
are switched to match the description in the boot schema.
This function is accomplished by translating the
boot schema information into requests to the NiCHE command, ntctl.
.PP
An allocated machine now exists that exactly matches the
description in the boot schema.
By definition, the machine is ready to boot and this is accomplished
with the command,
.sp
.RS
% spread -v -c bnail
.RE
.sp
where bnail is the \fBsame\fR boot schema filename given to solder(l).
.PP
Trollius is not an operating system that has to be rebooted before
every application run.
When Trollius termination is desired, execute the command,
.sp
.RS
% tkill
.RE
.SH BUGS
.PP
This allocation and deallocation scheme is not perfect.
With neither central control over the devices and node allocation
nor complicated back-off protocols, a collision is possible with
lucky timing and the booting procedure could hang.
Also, creating or choosing an incorrect boot schema will cause
solder(l) to fail.
IF spread(l) fails, execute tkill immediately and reattempt
the boot if a collision with another user is suspected.
.SH FILES
.TP 4
$TROLLIUSHOME/boot/bnail.def
default boot schema file
.SH SEE ALSO
nail(l), solder(l), spread(l), tkill(l), introc(l), INTROF(l), introu(l)
.sp
"Trollius Command Reference"
.br
"Trollius Tutorial Introduction in C"
.br
"Trollius Library Reference in C"
