/*
 *	OSU Research Computing					Trillium
 *	Copyright 1991 The Ohio State University
 *	GDB
 *
 *	$Log:	maconfig.h,v $
 * Revision 2.2  92/04/30  13:56:05  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.2  92/02/23  22:55:14  gdburns
 * Support new boot subsystem.
 * 
 * Revision 2.1.1.1  91/11/10  23:25:57  gdburns
 * Minor overhaul fixes several problems.
 * 
 * Revision 2.1  91/03/20  11:56:48  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.2  91/03/20  00:26:24  gdburns
 * Reorganize and fix ONCHIP size to agree with ONCHIP start.
 * 
 * Revision 2.0.1.1  90/11/16  15:30:46  raja
 * Change in the configuration of on-chip RAM.
 * 
 * Revision 2.0  90/10/05  20:51:39  gdburns
 * NT1000
 * 
 *	Function:	- define machine dependent memory constants
 *			- NT1000 version
 */

#ifndef _MACONFIG
#define _MACONFIG

/*
 * This is a good place to talk about the layout of on-chip RAM on
 * transputers.
 *
 *	80000000 - 01c: links
 *		   020: event
 *	     024 - 06c: reserved to transputer
 *	     070 - 1d0: moses
 *	     1d4 - 1ec: empty
 *	     1f0 - 1f8: panic info
 *		   1fc: kernel channel
 *	     200 - 204: siesta list pointers
 *	     208 - 21c: empty
 *	     220 - 288: shared library
 *	     28c - 28c: empty
 *	     290 - 29c: gearbox
 *	     2a0 - 49c: onchip stack space
 *	     4a0 -    : mallocd
 */

/*
 * region mnemonics
 * ANYBANK searches the first NMAIN regions for an acceptable block.
 */
#define NREGIONS	2		/* number of regions */
#define NMAIN		1		/* number of main regions */
#define ANYBANK		0		/* choose any region */
#define MAIN		1		/* main memory */
#define ONCHIP		2		/* on chip memory */

/*
 * region starting addresses - must be word aligned
 */
#define BOOTNSPAWN	0x80001000
#define BOOTSPAWN	0x80001004
#define DEFMEMSTART	0x80001400
#define MAIN_START	0x80031000
#define ONCHIP_START	0x800004a0
#define MAXONCHIP	ONCHIP_START
#define MAXWATER	0x80028000
#define DEFONCHIPSTART	0x800002a0
#define SH_BASE		0x80000220
#define KERNEL_CHAN	0x800001fc
#define FRONT_SIESTA	0x80000200
#define BACK_SIESTA	0x80000204

/*
 * regions sizes - must be word divisible
 */
#define ONCHIP_SIZE	0xB60

#endif
