.TH SOLDER l  "April 23, 1991" "Release 2.1" "TROLLIUS TOPOLOGY TOOLS"
.SH NAME
solder \- Reconfigure communication links on a network of processors.
(Trollius) (Parsytec VMTM)
.SH SYNTAX
.B solder
[-dhvNV][-c <bnail>]
.br
.SH OPTIONS
.TP 11
.B \-c <bnail>
Use <bnail> as the boot schema file.
.TP
.B \-d
Turn on debugging.
.TP
.B \-h
Print useful information on this tool.
.TP
.B \-v
Turn on verbose mode.
.TP
.B \-N
Pretend to take action but skip all steps.
.TP
.B \-V
Format and print the boot schema file.
.SH DESCRIPTION
.PP
.I Solder
is the topology tool that reconfigures the communication links connecting the
nodes of a multicomputer system, assuming that the hardware makes this possible.
The new configuration matches the connectivity of the
multicomputer network described in a boot schema file (see nail(l)).
.I Solder
should be run once after the installation of a new boot schema file
containing TSOLDER tuples.
.PP
A boot schema (or bnail file) is a description of a bootable multicomputer
system, specifying all physical nodes and the links that connect them.
A special tuple in the boot schema, TSOLDER, binds Trollius nodes
with vendor-specific character string designations of actual installed hardware.
A node on a Parsytec VMTM board is designated through the string
"VMTM/board/processor", where board identifies the board number (B0, B1, etc)
and processor is in the range A to Z.
TSOLDER tuples are required in the boot schema, but are not used by
this version of the
.I solder
program.
Thus, any string will satisfy the boot schema requirement.
.PP
Parsytec supplies low level link configuration programs for the
VMTM and the MTM-SUN, typically named vmtmconf and mtmconf respectively.
A high level utility called
.I ulti
invokes these programs.
The link configuration information is supplied to the lower level
programs at compile time and not runtime, making it difficult for
.I solder
to pass along a translated boot schema to ulti.
Therefore, unlike most other versions, the VMTM
.I solder
does not parse the boot schema.
It only uses the name of the boot schema to generate a name for
the VMTM (and MTM-SUN) link configuration tool.
The filename extension on the boot schema is appended to the
name, vmtmconf (eg: bnail.1x4 corresponds to vmtmconf.1x4).
.I Solder
passes the customized name to ulti through an environment variable
and ulti dispatches the specific vmtmconf compiled (by the user) with the
topology matching that of the boot schema.
The multicomputer can then be booted with spread(l).
.SH EXAMPLES
.TP 4
.I "solder -v"
Reconfigure the communication links of the multicomputer system
described in the default boot schema file.
Report about important steps as they are done.
.TP
.I "solder -c bnail.mycube"
Reconfigure the communication links of the multicomputer using the
custom boot schema `bnail.mycube'.
.SH FILES
.TP 4
$TROLLIUSHOME/boot/bnail.def
default boot schema file
.SH SEE ALSO
nail(l), spread(l)
