.TH BFPROB l "January 16, 1992" "Release 2.2" "TROLLIUS NETWORK LIBRARY"
.SH NAME
BFPROB \- Report if a message is ready to be received.  (Trollius)
.SH SYNOPSIS
.nf
subroutine BFPROB (nevent, ntype, nlength, nflags, nready, ierror)
integer nevent, ntype, nlength, nflags, nready, ierror
.fi
.SH DESCRIPTION
.PP
The
.I BFPROB()
subroutine accesses the local Trollius buffer daemon and reports 
whether there is a message available that can synchronize on a given 
event and type. 
If such a message exists, information about its type, length 
and flags is returned.
.PP
The
.I BFPROB()
subroutine accepts the
.I nevent
and
.I ntype
arguments to specify the synchronizing message.  
These two arguments are the only ones that must be filled before calling
.I BFPROB().
.PP
.I Nevent
is an arbitrary positive integer used to synchronize sending and
receiving processes. 
This argument remains unchanged after calling
.I BFPROB().
.PP
The 
.I ntype 
argument is used to further filter the messages that match on the
.I nevent 
argument. 
For more information, see NSEND(l). 
After calling
.I BFPROB()
the
.I ntype 
argument is set to that of the message found by the buffer daemon.
.PP
The 
.I nlength
and the
.I nflags
arguments are set by the call to
.I BFPROB()
to the values used by the synchronizing message found by the buffer daemon.  
.PP
When a message has been broken down into several packets, which occurs 
when the message length exceeds MAXNMSGLEN,
.I BFPROB()
reports its existence only if all the packets have arrived and are
stored by the buffer daemon. 
If this is not the case,
.I BFPROB()
assumes that the message is not ready to be received.
.PP
In more specific terms,
.I BFPROB()
checks the buffer worker processes for appropriate messages. 
It does not check the buffer daemon's internal buffer pool, as there is
no guarantee that these messages are deliverable. 
For a description of the buffer daemon and
buffer worker processes, see buffer(l).
.SH "RETURN VALUE"
.PP
Upon successful completion of
.I BFPROB(),
a 0 is returned in 
.I ierror
and a 1 is returned in
.I nready
if an appropriate message is waiting to be received, and 
0 if no appropriate message is waiting. 
If an error occurred, 
.I nready
is set to \-1 and 
.I ierror
is set to one of the error codes returned by NSEND(l) or NRECV(l).
.SH "SEE ALSO"
NSEND(l), buffer(l)
