.TH CONSTANTS l "January 16, 1992" "Release 2.2" "TROLLIUS FORTRAN LIBRARY"
.SH NAME
CONSTANTS \- constants for Trollius FORTRAN programming
.SH DESCRIPTION
.PP
The following table describes the values appropriate to various constants used
in Trollius 2.2.
It also describes the meaning of the constants and 
lists the cpp(1) header files in which the constants can be found.
.PP
Use PARAMETER statements to set needed constants to their proper values.
This ensures that, should the value of a constant change in future releases of
Trollius, it will be easy to upgrade your program to contain the proper value.
.PP
An alternate method is to use cpp(1) #include 
statements to include the file in which the constant is defined.
If you do this, you will need to run your file through cpp(1).
.PP
.nf
.if n .ta 12 25 29 64
.if t .ta 1.35i 2.4i  2.65i 5.25i 
CONSTANT	VALUE	DESCRIPTION	FILE

.B "Network Constants:"

LOCAL	-2147483647	local node		NET.h
MAXNMSGLEN	4096	maximum length of one message packet		NET.h
NHDSIZE	8	maximum size in words of \fIndata\fR		NET.h
			argument	
NOTEVENT	-2147483647	error occurred in GROUTE(l)		NET.h
NOTNODEID	-2147483648	error occurred in IGNTP(l)		NET.h
NOTNODETYPE	-2147483648	error occurred in IGRTP(l)	NET.h

.B "Node Types:"

NTOTB	0	OTB (host) node	NET.h
NTITB	1	ITB node	NET.h
NTCAST	2	multicast definition	NET.h
NTWASTE	4	not fully used/wasted	NET.h
NTDISK	8	node with attached disk	NET.h
NTTUBE	16	node with attached video unit	NET.h
NTJONES	32	node is a neighbour	NET.h
NTBOOT	64	neighbour node to boot	NET.h
NTALL	127	matches any type	NET.h

.B "Message Flags:"

KHOLD	1	set virtual circuit	NET.h
NOBUF	16	turn off buffering	NET.h
DFORWARD	256	change all arguments except \fInmsg\fR	NET.h
			to those of the sending process
NREEL	1024	multireel	NET.h
DRAWDATA	65536	\fIndata\fR representation will not be	NET.h
			changed	
DINTDATA	131072	\fIndata\fR holds 8 32-bit integer	NET.h
DFLTDATA	262144	\fIndata\fR holds 8 single precision reals	NET.h
DDBLDATA	524288	\fIndata\fR holds 4 double precision reals	NET.h
DRAWMSG	1048576	\fInmsg\fR representation will not be	NET.h
			changed	
DINTMSG	2097152	\fInmsg\fR holds integers	NET.h
DFLTMSG	4194304	\fInmsg\fR holds single precision reals	NET.h
DDBLMSG	8388608	\fInmsg\fR holds double precision reals	NET.h

.B "Pre-defined Cast Identifiers:"

HOST2ALL	-2147483646	multicast from origin to all nodes	NET.h
HOST2ITB	-2147483645	multicast from origin to ITB nodes	NET.h
HOST2OTB	-2147483643	multicast from origin to OTB nodes	NET.h

.B "Multireel Combining Functions:"

CBN_ERR	-1	combine error codes in first	NET.h
			integer only
CBN_ADD	-2	combine by adding all corresponding	NET.h
			integers
CBN_MAX	-3	combine by taking the maximum	NET.h
CBN_MIN	-4	combine by taking the minimum	NET.h
CBN_XOR	-5	combine by applying a bitwise XOR	NET.h
CBN_OR	-6	combine by applying a bitwise OR	NET.h
CBN_AND	-7	combine by applying a bitwise AND	NET.h
CBN_CAT	-8	combine by concatenating messages	NET.h

.B "File Flags:"

O_RDONLY	0	open for reading only	FREQ.h
O_WRONLY	1	open for writing only	FREQ.h
O_RDWR	2	open for reading and writing	FREQ.h
O_APPEND	8	append on each write	FREQ.h
O_CREAT	512	create file if it does not exist	FREQ.h
O_TRUNC	1024	truncate length to 0	FREQ.h
O_EXCL	2048	error if create and file exists	FREQ.h
O_SYNC	8192	update file data and file status	FREQ.h
		before writing
O_LOCK	65536	lock file descriptor active	FREQ.h
O_REUSE	131072	reuse existing file descriptor	FREQ.h
O_SINGL	262144	open file in singular mode	FREQ.h
O_MULTI	524288	open file in multiple mode	FREQ.h
O_NOCBX	1048576	open file in asynchronous mode	FREQ.h
O_1WAY	4194304	do not acknowledge writes	FREQ.h

.B Signals:

SIGTRACE	1	turn on trace collection	KREQ.h
SIGBACK	2	used to implement controlled processes	KREQ.h
SIGNOOP	3	used to implement controlled processes	KREQ.h
SIGUDIE	4	terminate	KREQ.h
SIGARREST	5	suspend execution	KREQ.h
SIGRELEASE	6	continue execution	KREQ.h
SIGA	7	user defined	KREQ.h
SIGB	8	user defined	KREQ.h

.B "Process States:"

SSYNC	1	ready, having called KSEND(l)	KREQ.h
			or KRECV(l)	
SSTATE	2	ready, having called KSTATE(l)	KREQ.h
SERROR	3	ready, having encountered an error on	KREQ.h
			any kernel request
SATTACH	4	ready, having called KATTCH(l)	KREQ.h
SREADY	5	ready, having called KDETCH(l),	KREQ.h
			KDOOM(l), KSEND(l), or KRECV(l)
SSEND_BLKD	6	blocked sending a message to an event	KREQ.h
SRECV_BLKD	7	blocked receiving a message from an	KREQ.h
			event
SACTIVE	8	running - not under Trollius kernel	KREQ.h
