.TH CUBIX l "January 16, 1992" "Release 2.2" "TROLLIUS REMOTE LIBRARY"
.SH NAME
TMULTI, TSINGL, TASYNC \- Trollius Cubix parallel I/O control
.SH SYNOPSIS
.nf
subroutine TMULTI (fd, ierror)
subroutine UMULTI (unit, ierror)
subroutine TSINGL (fd, ierror)
subroutine USINGL (unit, ierror)
subroutine TASYNC (fd, ierror)
subroutine UASYNC (unit, ierror)

subroutine RFCHCX (fd, mode, ierror)
subroutine RUCHCX (unit, mode, ierror)
subroutine RFORDR (fd, sequence, ierror)
subroutine RUORDR (unit, sequence, ierror)

integer fd, unit, ierror, mode, sequence
.fi
.SH DESCRIPTION
.PP
The above subroutines are specific to Cubix parallel file access.
For more information on using parallel I/O under Trollius, see cubix(l).
.PP
.I TMULTI(), TSINGL(),
and 
.I TASYNC()
change the parallel access method of an existing file descriptor.
Each takes a file descriptor,
.I udesc,
as an argument.  
The remaining argument,
.I ierror,
is set to the error code if an error occurs.  
Otherwise it is set to 0.
.I UMULTI(), USINGL(),
and 
.I UASYNC()
change the parallel access method of an existing F77 file unit.
Each takes a file
.I unit
as an argument.
These unit based subroutines are only available to ITB programs.
.PP
.I TMULTI() and UMULTI()
change a descriptor or unit presently in asynchronous or singular
mode to multiple mode.
In multiple mode, clients TREAD(l) or TWRITE(l) varying amounts of
different data from/to a file.
On file units, standard Fortran unit I/O statements may be used.
Clients are serviced in fixed order, regardless of the time ordering
of the actual invocations of TREAD(l) and/or TWRITE(l).
The default order is from lowest to highest node identifier
and can be changed with the
.I RFORDR()
subroutine.  See below.
.PP
.I TSINGL() and USINGL()
change a file descriptor or unit presently in asynchronous or
multiple mode to singular mode.
In singular mode clients TREAD(l) or TWRITE(l) the same data from/to
a file.
On file units, standard Fortran unit I/O statements may be used.
The number of bytes read or written must be the same for all clients.
.PP
.I TASYNC() and UASYNC()
change a file descriptor or unit presently in singular or multiple
mode to asynchronous mode, the normal non-Cubix mode.
.PP
.I RFCHCX() and RUCHCX()
are the generalized forms of the above subroutines
for file descriptors and file units respectively.
They take a Cubix open flag (see cubix(l)) and change the access
method appropriately.
.PP
.I RFORDR() and RUORDR()
change the order in which Cubix clients are served in multiple mode.
They take a sequence number in the range 0 - (N - 1) where N is
the number of Cubix clients.
In Trollius 2.2, N must be the number of ITB nodes.
.SH ERRORS
.TP 16
[EBADF]
The descriptor or unit is invalid.
.SH "SEE ALSO"
G. Fox et al.,
.I "Solving Problems on Concurrent Processors, vol. I"
Prentice Hall, 1988.
.sp
cubix(l), fstate(l)
