.TH FTTIME l "January 16, 1992" "Release 2.2" "TROLLIUS FORTRAN LIBRARY"
.SH NAME
FTTIME \- Trollius timing function
.SH SYNOPSIS
.nf
real*8 function FTTIME ()
.fi
.SH DESCRIPTION
.PP
The
.I FTTIME()
function enables a program running on any Trollius node
(ITB or OTB) to read the current value of the system timer in a
portable fashion.
This is useful for measurements of execution times of program sections.
.I FTTIME()
returns the timer value in seconds.
.PP
On the host (OTB) the function returns the time value using the
gettimeofday(2) system call.
On the transputer (ITB), it returns the current value of the transputer timer.
There are actually two timers.
Processes running at low priority have an associated timer that is incremented
once every 64 microseconds.
Processes running at high priority read
a timer that is incremented once every microsecond.
.I FTTIME()
handles both cases, adjusting the timer value depending on the
priority of the calling process, returning a reading in seconds.
.SH EXAMPLE
.PP
.RS
.nf
real*8 FTTIME
real*8 time, start, end

start = FTTIME()
CALL MYSUB()
end = FTTIME()
time = end - start
.fi
.RE
.SH BUGS
.PP
Note that the transputer timers wraps around (from the most positive
to the most negative values). 
This happens infrequently (less than once an hour for the high
priority timer) but does happen. 
The resolution of the measurements is bound by that of the underlying system
(gettimeofday(2) on the host and the hardware timers on the transputer).
.SH SEE ALSO
gettimeofday(2)
