.TH GETRENT l "January 18, 1992" "Release 2.2" "TROLLIUS NETWORK LIBRARY"
.SH NAME
GRENT, GRENTC, GROUTE, IGRTP \- Get Trollius network route information.
.SH SYNOPSIS
.nf
subroutine GRENT (nodeid, event, nodetype, ierror)
integer	nodeid, event, nodetype, ierror

subroutine GRENTC (nodeid, event, nodetype, ierror)
integer	nodeid, event, nodetype, ierror

subroutine GROUTE (nodeid, event, ierror)
integer nodeid, event, ierror

integer function IGRTP (nodeid)
integer nodeid
.fi
.SH DESCRIPTION
.PP
These functions return information obtained from the local route daemon.
.PP
.I GRENT()
accepts a node identifier,
.I nodeid
which must be initialized, and returns the fields of the route table
entry for that node.
.I GRENT()
sends a request for network route information to the route daemon.
Upon return from \fIGRENT()\fR, the parameters hold, in order: the unmodified
node identifier, the event of the link process a message destined for that node
would be forwarded to, the node type of that node, and an error status.
The node type is a combination of flags describing the capabilities of the node.
For the definition of these flags, see CONSTANTS(l).
For an explanation of their usage, see GNET(l).
.I Ierror
is set to the error code, if an error occurs.
Otherwise it is set to 0.
.PP
.I GRENTC()
has the exact functionality of GRENT, except that it stores the
recently accessed route table entries in a cache.
This speeds up later access to the same entries.
When invoked,
.I GRENTC()
checks the route cache for the route table entry of the given node identifier.
If the entry is found, the requested information is returned.
Otherwise,
.I GRENT()
is called, and returns a copy of the route table entry from the route daemon.
This entry is then stored in the cache.
.PP
.I GROUTE()
accepts a node identifier and an event, and returns the event of the link
process to which a message destined for that node should be forwarded.
If the destination node is the local node,
.I GROUTE()
returns the supplied
.I event.
Otherwise
.I GRENTC()
is called and the 
.I event 
field of the route table entry for the given node identifier is returned.
.I Ierror
is set to the error code, if an error occurs.
Otherwise it is set to 0.
.PP
.I IGRTP()
accepts a node identifier and returns the type of that node. 
It invokes
.I GRENTC()
and returns the
.I nodetype 
field from the route table entry for the specified node.  
.SH "RETURN VALUE"
.PP
Upon successful completion of
.I GRENT()
or
.I GRENTC(),
.I ierror
is set to 0 otherwise it is set to the error number.
Upon successful completion of
.I GROUTE()
a forwarding event number is returned in 
.I event
and 
.I ierror
is set to 0.
Otherwise 
.I ierror
is set to the error number.
.I IGRTP()
returns a valid node type when successful.
NOTNODETYPE (see CONSTANTS(l)) is returned if an error
occurs, or if the route daemon does not yet know any network information.
These functions have no specific errors of 
their own, but can incur any of the errors associated with NSEND(l) or NRECV(l).
.SH "SEE ALSO"
GNET(l)
