.TH ILDTIM l "January 18, 1992" "Release 2.2" "TROLLIUS FORTRAN LIBRARY"
.SH NAME
ILDTIM \- Read the transputer timer. (Trollius)
.SH SYNOPSIS
.nf
integer function ILDTIM ()
.fi
.SH DESCRIPTION
The function
.I ILDTIM()
enables a FORTRAN program that is running on a transputer node under
Trollius to read the current value of the transputer's timer. 
This is useful for accurate measurement of execution times of parts of programs.
.PP
There are actually two timers. 
Processes running at low priority, as user processes do by default, have an
associated timer that is incremented once every 64 microseconds.
Processes running at high priority read a timer that is
incremented once every microsecond.
.PP
This command is now obsolete, since it is specific to one type of processor.
It is left for backward compatibility. 
The recommended function is FTTIME(l), which returns the current value
in seconds of the system timer on either an OTB or ITB node. 
.SH EXAMPLE
.PP
.RS
.nf
INTEGER*4 start, end
REAL*8 time

start = ILDTIM()
CALL MYSUB()
end = ILDTIM()
time = 0.064 * (end - start)
.fi
.RE
.SH BUGS
.PP
Note that the timer wraps around (from the most positive
to the most negative values). 
This happens infrequently (less than once an hour for the high
priority timer) but does happen.
.SH SEE ALSO
FTTIME(l)
