.TH INTROF l "January 19, 1992" " Release 2.2" "TROLLIUS FORTRAN LIBRARY"
.SH NAME
INTROF - introduction to Trollius functions for FORTRAN programming
.SH LIST OF FUNCTIONS
.nf
.if t .ta 10 20 30
.if n .ta 13 26 39
.nf
\fIName	Appears	Description\fR
\fI	on Page\fR
.sp 1
#BFPROB	BFPROB.l	report if a message is ready to be received
#DRECV	DSEND.l	receive a network message (datalink sublevel),
		blocking
#DSEND	DSEND.l	send a network message (datalink sublevel),
		blocking
#DTRECV	DSEND.l	receive a network message (datalink sublevel),
		non-blocking
#DTSEND	DSEND.l	send a network message (datalink sublevel),
		non-blocking
*FLTOTD	ILTOT.l	convert double precision from local to Trollius
*FLTOTF	ILTOT.l	convert single precision from local to Trollius
*FRD	IRW.l	reverse byte ordering for double precision data
*FRF	IRW.l	reverse byte ordering for single precision data
*FTTIME	FTTIME.l	return system time in seconds
*FTTOLD	ILTOT.l	convert double precision from Trollius to local
*FTTOLF	ILTOT.l	convert single precision from Trollius to local
#GNET	GNET.l	return information on the local node
#GROUTE	GRENT.l	get Trollius routing information
#GSMART	GNET.l	wait for router to receive network and 
		routing information
*IDLEVT	IDLEVT.l	get a link process event
*IGNALL	GNET.l	return the total number of nodes
*IGNCST	GNET.l	return the number of cast registrations 
		passing through the local node
*IGNDID	GNET.l	return the local node identifier
*IGNDTP	GNET.l	return the local node type
*IGNITB	GNET.l	return the number of ITB nodes
*IGNOTB	GNET.l	return the number of OTB (host) nodes
*IGNTP	GNET.l	return detailed information on the number 
		and types of nodes
*IGORGN	GNET.l	return the origin OTB identifier
*IGRTP	GRENT.l	return type of a node identifier
*ILDTIM	ILDTIM.l	read the transputer timer
*ILTOT	ILTOT.l	convert integer from local to Trollius
*ILTOTS	ILTOT.l	convert short integer from local to Trollius
*IRS	IRW.l	reverse byte ordering for short integer
*IRW	IRW.l	reverse byte ordering for integer
*ITTOL	ILTOT.l	convert integer from Trollius to local
*ITTOLS	ILTOT.l	convert short integer from Trollius to local
#KATTCH	KINIT.l	attach a process to Trollius
#KDETCH	KEXIT.l	detach a process from Trollius
#KDOOM	KDOOM.l	deliver a signal to a Trollius process
#KEXIT	KEXIT.l	detach from Trollius and exit
#KINIT	KINIT.l	attach a process to Trollius and 
		initialize data structures
#KRECV	KSEND.l	receive a local node message, blocking
#KSEND	KSEND.l	send a local node message, blocking
#KSTATE	KSTATE.l	get Trollius kernel state of a process
#KTRECV	KSEND.l	receive a local node message, non-blocking
#KTSEND	KSEND.l	send a local node message, non-blocking
#NRECV	NSEND.l	receive a network message (network sublevel),
		blocking
#NSEND	NSEND.l	send a network message (network sublevel),
		blocking
#NTRECV	NSEND.l	receive a network message (network sublevel),
		non-blocking
#NTSEND	NSEND.l	send a network message (network sublevel),
		non-blocking
#RCASK	RCAST.l	report expected number of multireel messages
#RCAST	RCAST.l	register a multicast destination
#RFCHCX	CUBIX.l	change file desc. to new Cubix mode
#RFORDR	CUBIX.l	change file desc. to new Cubix sequence
#RMELT	RCAST.l	remove a multicast registration 
#RUCHCX	CUBIX.l	change file unit to new Cubix mode
#RUORDR	CUBIX.l	change file unit to new Cubix sequence
#TASYNC	CUBIX.l	change file mode to asynchronous
#TCLOSE	TOPEN.l	close a file
#TERROR	TERROR.l	get most recent error message
#TMULTI	CUBIX.l	change file mode to multiple
#TOPEN	TOPEN.l	open a file
#TREAD	TREAD.l	read data from a file
#TRECV	TSEND.l	receive a network message (transport sublevel)
#TSEND	TSEND.l	send a network message (transport sublevel)
#TSINGL	CUBIX.l	change file mode to singular
#TWRITE	TWRITE.l	write data to a file
.SH FOR ITB ONLY
.nf
.sp 1
*IUTOD	-	get file desc. of tf77 I/O unit
*GETPID	GETPID.l	return process identification of the 
		current process
#PRECV	PSEND.l	receive a network message (physical sublevel),
		blocking
#PSEND	PSEND.l	send a network message (physical sublevel),
		blocking
#UASYNC	CUBIX.l	change unit mode to asynchronous
#UMULTI	CUBIX.l	change unit mode to multiple
#USINGL	CUBIX.l	change unit mode to singular
.SH NOTES
.PP
All names marked by a "#" are \fIsubroutine\fR calls 
and have as their last parameter \fIierror\fR which
returns the error code in case of an unsuccessful call. 
It is therefore recommended to check for the value
of \fIierror\fR immediately after subroutine calls. 
All names marked by a "*" are \fIfunction\fR calls
and return some useful value other than \fIierror\fR.
.PP 
Simple rules for creating FORTRAN subroutine/function names
from C functions are listed below.
.PP
Mappings from substrings in C functions
onto single letter or shorter substring in FORTRAN wrapper:
.PP
.ta 10 20 30
.nf
C	-->	FORTRAN
TRY		T
GET		G
NODE		ND
TYPE		TP
.fi
.PP
All functions that return an integer or short integer
are prefixed with the letter "I".
The only exception is GETPID() function to make the name identical to the OTB
(UNIX) function getpid(3).
All functions that return a single precision or double precision
value are prefixed with the letter "F".
This is to minimize the necessity of declaring functions.
However functions that return short integer and double
have still to be declared.
.PP
If after applying the above two rules, the FORTRAN name still exceeds the six
character length, it is compressed to six by dropping the least
essential vowels.
