.TH IRW l "January 18, 1992" "Release 2.2" "TROLLIUS FORTRAN LIBRARY"
.SH NAME
FRD, FRF, IRS, IRW \- Reverse order of bytes.  (Trollius)
.SH SYNOPSIS
.nf
double precision function FRD (dword)
double precision dword

real function FRF (fword)
real fword

integer*2 function IRS (sword)
integer*2 sword

integer function IRW (iword)
integer iword
.fi
.SH DESCRIPTION
.PP
The order of bytes in a word is not uniform across all the machines that a 
Trollius network may span. 
All data must be converted to the correct form when sent in a message to a
different type of node (for example, from an OTB to an ITB node).
Similarly, data written into a file by an OTB process will need conversion
after being read by an ITB node process, and vice-versa.
.PP
These functions reverse the order of bytes in the given argument. 
These functions should be used by either the sending process or 
the receiving process, not both.
The ITTOL(l) and ILTOT(l) series of functions is the preferred method of
converting data representation.
.PP
Byte order conversion is needed only for the 
.I nmsg 
argument to NSEND(l), NRECV(l), DSEND(l) and DRECV(l).
Conversion of the other relevant arguments, such as
.I nevent 
and 
.I ntype, 
is done automatically.
.SH "SEE ALSO"
ILTOT(l)
