.TH KDOOM l "January 18, 1992" "Release 2.2" "TROLLIUS LOCAL LIBRARY"
.SH NAME
KDOOM \- Deliver a signal to a Trollius process.
.SH SYNOPSIS
.nf
subroutine KDOOM (pid, signum, ierror)
integer pid, signum, ierror
.fi
.SH DESCRIPTION
.PP
The subroutine
.I KDOOM()
enables one Trollius process to deliver an asynchronous signal to
another Trollius process, including itself.
Asynchronous delivery in this context means either the next time the target
process attempts any kernel request, or immediately if the target
process is blocked on an event.
.PP
.I Pid 
is the identifier of the process to which the signal will be delivered.
Process identifiers refer to other currently attached Trollius processes,
except for the special identifier 0, which refers to the caller.
.PP
.I Signum
identifies the signal to be delivered.
Trollius signals are (see CONSTANTS(l) for their current values):
.TP 15
SIGTRACE
unloads trace data
.TP 
SIGBACK
used to implement controlled processes
.TP
SIGNOOP
used to implement controlled processes
.TP
SIGUDIE
termination
.TP
SIGARREST
suspension of execution
.TP
SIGRELEASE
continuation of execution
.TP
SIGA
user defined
.TP
SIGB
user defined
.PP 
.I Ierror
is set to the error code if an error occurs, otherwise it is set to 0.
.PP
.I KDOOM()
returns immediately; it never blocks.
.SH ERRORS
.TP 20
[ENOTPROCESS]
The process whose process identifier was passed to
.I KDOOM()
is not attached to the kernel.
.TP
[EINVAL]
The signal number is invalid.
