.TH KEXIT l "January 18, 1992" "Release 2.2" "TROLLIUS LOCAL LIBRARY"
.SH NAME
KEXIT, KDETCH \- Detach from Trollius and exit.
.SH SYNOPSIS
.nf
subroutine KEXIT (status)
integer status

subroutine KDETCH (pid, ierror)
integer pid, ierror
.fi
.SH DESCRIPTION
A process that attaches to the Trollius kernel should detach itself
before terminating.
On an ITB node detachment is done automatically when a program ends.
On an OTB nodes a Trollius program must call
.I KEXIT()
explicitly before terminating since the Trollius kernel has no other way of
knowing that a process has terminated.
The argument to
.I KEXIT()
is passed to the system when the process exits,
and is conventionally 0 for a normal exit, or some nonzero error code.
.PP
A process can detach from the local Trollius kernel but keep running by calling
\fIKDETCH()\fR.
This only undoes what KATTCH(l) did.
Normally,
.I KDETCH()
is called implicitly from
\fIKEXIT()\fR.
The 
.I pid
argument to
.I KDETCH()
is the identifier of the process to be detached.
A process ID of 0 is interpreted as a request to detach the calling process,
and is the normal usage of \fIKDETCH()\fR.
Detaching peer Trollius processes is intended as an emergency clean up
measure and is not intended for normal usage.
The
.I ierror
argument to
.I KDETCH()
is set to the error code if an error occurs.
Otherwise, it is set to 0.
.PP
To enhance portability of applications between ITB and OTB nodes,
all Trollius programs should use KINIT(l) and \fIKEXIT()\fR.
.SH ERRORS
.TP 16
[ENOTPROCESS]
The process whose process identifier was passed to
.I KDETCH()
is not attached to the kernel.
.SH SEE ALSO
KINIT(l)
