.TH KINIT l "January 18, 1992" "Release 2.2" "TROLLIUS LOCAL LIBRARY"
.SH NAME
KINIT, KATTCH \- Attach process to Trollius kernel.
.SH SYNOPSIS
.nf
subroutine KINIT (priority, ierror)
subroutine KATTCH (priority, ierror)
integer priority, ierror
.fi
.SH DESCRIPTION
.PP
.I KATTCH()
begins communication between the calling process and the Trollius kernel.
.I KINIT()
initializes data structures for kernel interface, and calls \fIKATTCH()\fR.
.PP
Every OTB program that runs under Trollius must explicitly call
.I KINIT()
before calling any Trollius functions.  
ITB processes call
.I KINIT()
before calling the main program and must call
.I KINIT()
afterwards only if they wish to run at a non-zero priority.
.PP
The arguments to
.I KINIT()
and
.I KATTCH()
are \fIpriority\fR,
an arbitrary positive integer representing the process's scheduling
priority; and 
.I ierror,
which is set to the error code if an error occurs.  
Otherwise, it is set to 0.
.PP
The maximum priority than can be assigned to a user process is 100000.
This ensures that user processes will be at a lower priority than
some important system processes.
Processes with priority zero (0) are called uncontrolled; they are
released by the kernel to be scheduled by the underlying hardware or
software whenever they are not blocked on a Trollius event.
All other non-zero priorities cause a process to be more carefully
controlled by the kernel.
Specifically, only the highest priority controlled process not blocked
on an event is released for scheduling by the underlying hardware or software.
All other unblocked controlled processes are impeded by the kernel until
the highest priority controlled process blocks.
At that point, the next highest (now the highest) priority unblocked
controlled process is released by the kernel.
The Trollius kernel does not timeslice/round-robin controlled processes.
Processes with identical controlled priorities are ordered as they
registered using
.I KATTCH()
or
.I KINIT()
with respect to time.
.PP
Controlled processes incur more overhead than uncontrolled processes.
If predictable process scheduling is not required, priority 0 should be used.
.PP
After a call to \fIKINIT()\fR,
.I KATTCH()
may be called repeatedly without an intervening KDETCH(l) to alter the
priority of the calling process.
.SH ERRORS
.PP
.I KINIT()
may fail on OTB nodes due to errors arising from the native operating system.
\fIKATTCH()\fR, which is called from \fIKINIT()\fR,
fails if:
.TP 22
[ENOKDESCRIPTORS]
The Trollius kernel is out of process descriptors and is unable to attach
additional processes.
.TP
[ENOKERNEL]
The Trollius kernel is not running.
.SH SEE ALSO
KDETCH(l)
