.TH KSTATE l "January 18, 1992" "Release 2.2" "TROLLIUS LOCAL LIBRARY"
.SH NAME
KSTATE \- Get (Trollius kernel) state of a local process.
.SH SYNOPSIS
.nf
subroutine KSTATE (pid, state, kpriority, kevent, ktype, ksignal, ierror)
integer pid, state, kpriority, kevent, ktype, ksignal, ierror
.fi
.SH DESCRIPTION
.I KSTATE()
enables a Trollius process to inquire about the kernel state of
any process on the local node, including itself.
.PP
The argument
.I pid
is the identifier of the process to be queried.  
The special identifier 0 indicates the calling process.  
The argument
.I state
returns the execution status of the process.
The process states, (see CONSTANTS(l)), are as follows:
.TP 15
SSYNC
ready, having called KSEND(l) or KRECV(l), often seen as SREADY
.TP
SSTATE
ready, having called \fIKSTATE()\fR
.TP
SERROR
ready, having encountered an error on any kernel request
.TP
SATTCH
ready, having called KATTCH(l)
.TP
SREADY
ready, having called KDETCH(l), KDOOM(l), KSEND(l) or KRECV(l) 
.TP
SSEND_BLKD
blocked sending a message to an event
.TP
SRECV_BLKD
blocked receiving a message from an event
.TP
SACTIVE
running - not under Trollius kernel control
.PP
.I Kpriority
returns the priority of the process as specified in the call to KINIT(l) or
KATTCH(l).
.I Kevent
and
.I ktype
return the event and type on which the process is blocked (if any).
.I Ksignal
returns the hexadecimal
representation of all pending signals delivered by KDOOM(l).
.I Ierror
is set to the error code if an error occurs.  
Otherwise, it is set to 0.
.SH ERRORS
.TP 16
[ENOTPROCESS]
The process whose process identifier was passed to
.I KSTATE()
is not attached to the kernel.
