.TH PSEND l "January 18, 1992" "Release 2.2" "TROLLIUS NETWORK LIBRARY"
.SH NAME
PSEND, PRECV  \- Trollius physical sublevel message passing
.SH SYNOPSIS
.nf
subroutine PSEND (ndlevent, nlength, ndata, ndsize, nmsg, ierror)
subroutine PRECV (nevent, nlength, ndata, ndsize, nmsg, ierror)

integer ndlevent, nevent, nlength, ndata(*), ndsize, nmsg(*), ierror
.fi
.SH DESCRIPTION
.PP
These subroutines access the physical sublevel message passing services of
the Trollius network level.
.I PSEND()
and
.I PRECV()
are the lowest level calls in the network message passing library. 
They do not interact with the kernel or any other Trollius process.
Instead, they access a communication device directly.
.I PSEND()
and
.I PRECV()
are thus hardware dependent, and may only be used by ITB node processes.
.SH ARGUMENTS
.PP
The physical sublevel subroutines may only be used between ITB node
neighbours and absolutely requires an existing virtual circuit between
the neighbours, usually with DSEND(l) and DRECV(l).
Synchronization effectively becomes the identification of each end
of the virtual circuit.
The sender uses the
.I ndlevent
argument of
.I PSEND()
to identify the virtual circuit by using the same value that was
given to DSEND(l).
The receiver uses the
.I nevent
argument of
.I PRECV()
to identify the virtual circuit by using the same value that was
given to DRECV(l).
The remaining arguments to
.I PSEND()
and
.I PRECV()
have the same semantics as the corresponding arguments of DSEND(l) and DRECV(l).
The important difference is that the message length, \fInlength\fR,
must agree between sender and receiver.
Mismatched message lengths will cause a fatal, unreported error.
Also, there is no limit on the message length.
.PP
The typical usage of physical sublevel communication is to send one
message between neighbour nodes with the datalink sublevel, then
any number of messages with the physical sublevel, then one last message
with the datalink sublevel to end the virtual circuit and release
the communication link for general usage.
.SH "RETURN VALUE"
.PP
In the current implementation,
.I PSEND()
and
.I PRECV()
always return 0 in the
.I ierror
argument.
.SH "SEE ALSO"
DSEND(l), NSEND(l), TSEND(l)
