.TH TOPEN l "January 19, 1992" "Release 2.2" "TROLLIUS REMOTE LIBRARY"
.SH NAME
TOPEN, TCLOSE \- Open or close a remote file. (Trollius)
.SH SYNOPSIS
.nf
subroutine TOPEN (udesc, filename, flags, mode, ierror)
character filename*(*)
integer udesc, flags, mode, ierror

subroutine TCLOSE (udesc, ierror)
integer udesc, ierror
.fi
.SH DESCRIPTION
.PP
.I TOPEN()
opens a specified file, and returns a file descriptor
.I udesc, 
which is a non-negative integer.  
.I Udesc, 
is the file descriptor to be returned;
.I filename
is the path name of the file to be opened;
.I flags
is specifies how the file will be opened;
.I mode
sets read/write/execute permissions when creating a file;
.I ierror
is set to the error code if an error occurs or 0 if no error occurs.
.PP
.I TCLOSE()
closes an open file.  
.I Udesc
is the file descriptor returned by \fITOPEN()\fR.
.SH "OPEN FLAGS"
.PP
.I Flags
are specified by summing the values of one or more of the following flags
(see CONSTANTS(l) for the precise values):
.TP 18
O_RDONLY
open for reading only
.TP
O_WRONLY
open for writing only
.TP
O_RDWR
open for reading and writing
.TP
O_APPEND
append on each write
.TP
O_CREAT
create file if it does not exist
.TP
O_TRUNC
truncate length to 0
.TP
O_EXCL
error if create and file exists
.TP
O_REUSE
reuse existing file descriptor opened with same file name, if possible
.TP
O_ASYNC
open file in asynchronous mode (default)
.TP
O_SINGL
open file in singular mode (see cubix(l))
.TP
O_MULTI
open file in multiple mode (see cubix(l))
.PP
O_APPEND starts the file pointer to the end of the file.
O_TRUNC truncates an existing file to zero length.
If O_EXCL is used with O_CREAT;
.I TOPEN()
will return an error if the file to be created already exists.  
This can be used to implement a simple exclusive access locking mechanism.
O_SINGL and O_MULTI are used to open files in singular or multiple Cubix
mode (see cubix(l)).  
If one of these is not specified, the file is opened in asynchronous
(no Cubix) mode.
.PP
.I TOPEN()
will eventually invoke open(2) on a remote node.
Most of its functionality, semantics and limitations derive from open(2).
The remote node defaults to the origin OTB node, but can be specified
as part of the file name by prepending the path name with the ascii
representation of the node identifier followed by a colon.
In the example below, the file "foo" is opened for read only on node 7.
.PP
.RS
.nf
call TOPEN("7:foo", 0, 0)
.fi
.RE
.SH ERRORS
.PP
.I TOPEN()
and
.I TCLOSE()
may incur any of the error conditions associated with open(2) and close(2)
respectively.
They may also fail due to errors associated with NSEND(l) or NRECV(l).
.SH "SEE ALSO"
TREAD(l), TWRITE(l), open(2)
