.TH TSEND l "January 19, 1992" "Release 2.2" "TROLLIUS NETWORK LIBRARY"
.SH NAME
TSEND, TRECV \- Trollius transport sublevel message passing
.SH SYNOPSIS
.nf
subroutine TSEND (nnode, nevent, ntype, nlength, nflags, ndata, ndsize, 
	nmsg, ierror)
subroutine TRECV (nevent, ntype, nlength, nflags, ndata, ndsize, 
	nmsg, ierror)

integer nnode, nevent, ntype, nlength, nflags, ndata(*), ndsize, 
	nmsg(*), ierror
.fi
.SH DESCRIPTION
.PP
These functions access the transport sublevel message passing services of
the Trollius network level.
.I TSEND()
and
.I TRECV()
add flow control to the network sublevel services (see NSEND(l)).
The sender will block until the receiver is ready.
The transport sublevel functions are typically used in debugging.  
Naturally, they have a high overhead.
.PP
The purpose of the transport sublevel is to overcome the basic danger
of Trollius network message passing, which is the lack of strong
synchronization at the network and datalink sublevels.
A sender can transmit a message that may never be received due to
programming error.
This message will never be dropped or timed out.
Some Trollius process will always be stuck with it, waiting
for a synchronizing DRECV(l) or NRECV(l) that will never happen.
If that unfortunate process is a buffer, it can
be located by the user and swept clean (see sweep(l)).
However, if the process is a link proprietor,
the link is henceforth plugged and useless.
An intelligent buffering system does try to prevent this from
happening (see buffer(l)), but it remains theoretically possible.
.PP
The transport sublevel functions solve this problem by causing the sender
to block until the receiver is ready to receiver.
This is implemented with implicit protocol messages between the two parties.
If due to a programming error there is no synchronizing receiver,
the protocol messages are guaranteed not to plug a link proprietor.
The sender is also prevented from flooding the system with messages
that no receiver will consume.
After the pre-synchronizing exchange, the network sublevel functions
are invoked and the message is transmitted.
.PP
The arguments passed to
.I TSEND()
and
.I TRECV()
are the same as described under NSEND(l).
.SH ERRORS
.I TSEND()
and
.I TRECV()
may incur any of the errors associated with NSEND(l) and NRECV(l),
respectively.
.SH "SEE ALSO"
KSEND(l), PSEND(l), DSEND(l), NSEND(l)
