.TH BFPROBE l "April 10, 1992" "Release 2.2" "TROLLIUS REMOTE LIBRARY"
.SH NAME
bfprobe \- Report if a Trollius message is ready to be received.
.SH SYNOPSIS
.nf
.ft B
#include <net.h>

int	bfprobe (struct nmsg *header);
.SH DESCRIPTION
The
.I bfprobe()
function accesses the local Trollius buffer daemon and reports whether
there is a message freely available that can synchronize on a given event
and type.
If such a message exists, information about its type, length, and flags
is returned.
.PP
The
.I bfprobe()
function accepts a pointer to a network message structure, defined in
<net.h>, and described on the nsend(l) manual page.
Only the
.I nh_event
and
.I nh_type
fields of the network message structure must be filled before calling
.I bfprobe().
.PP
.I Nh_event
is an arbitrary positive integer used to synchronize sending and
receiving processes.
This field remains unchanged after calling
.I bfprobe().
.PP
The
.I nh_type
field is used to further filter the messages that match on the
.I nh_event
field.
For more information, see nsend(l).
After calling
.I bfprobe(),
the
.I nh_type
field is set to that of the message found by the buffer daemon.
.PP
The
.I nh_length
and the
.I nh_flags
fields are set by the call to
.I bfprobe()
to the values used by the synchronizing message found by the
buffer daemon.
.PP
When a message is broken down into several packets, which occurs
when the message length exceeds MAXNMSGLEN,
.I bfprobe()
reports its existence only if all the packets have arrived and are
stored by the buffer daemon.
If this is not the case,
.I bfprobe()
assumes that the message is not ready to be received.
.PP
In more specific terms,
.I bfprobe()
checks the buffer worker processes for appropriate messages.
It does not check the buffer daemon's internal buffer pool, as there is
no guarantee that these messages are deliverable.
For a description of the buffer daemon and buffer worker processes,
see buffer(l).
.SH "RETURN VALUE"
Upon successful completion of
.I bfprobe(),
1 is returned if an appropriate message is waiting to be received, and
0 is returned if no appropriate message is waiting.
If an error occurred,
\-1 is returned and the global variable
.I errno
is set to one of the error codes returned by nsend(l) or nrecv(l).
.SH "SEE ALSO"
nsend(l)
