.TH BFSTATE l  "April 2, 1992" "Release 2.2" "TROLLIUS COMMANDS"
.SH NAME
bfstate \- report status of Trollius buffers
.SH SYNTAX
.B bfstate
[-bh] [-B <#msgs>] <node(s)>
.SH OPTIONS
.TP 12
.B \-b
Print information on blocked messages only.
.TP
.B \-h
Print useful information on this command.
.TP
.B \-l
Additionally, print buffer levels and maximums.
.TP
.B \-B <#msgs>
Limit the number of messages reported.
.SH DESCRIPTION
.PP
.I Bfstate
displays information on Trollius network message buffers on any node
in the multicomputer.
When used without the
.I \-b
option,
.I bfstate
prints one line for every buffered message.
When used with the
.I \-b
option,
.I bfstate
prints one line for every blocked message.
For each message
.I bfstate
outputs the specified node, the destination node of the message, the message
event and type (see nsend(l)), the message length in bytes, and the status
of the message.
When used with the
.I \-l
option, it also prints the maximum number of worker processes, the number
of worker processes currently being used, the number of workers holding
messages, the maximum size of the internal buffer pool, the pool size
limitation on user messages (positive events) and
the amount of space currently used in the pool.
.PP
Nodes are identified as
.I n<list>,
where <list> can be a single node identifier or a list of node identifiers.
Node identifiers are established in the boot schema (see nail(l)).
The list can be written in decimal and/or hexadecimal notation,
for example, 0-7,8,10,0xc,0x10-31.
.PP
The Trollius buffer daemon handles messages that cannot immediately be
received by forwarding or destination processes, thus preventing the
sending process from long-term blocking.
The buffer daemon transfers each message to a buffer worker process, which
will forward the message to its appropriate receiving process when that process
becomes ready.
The status of a message that is held by a worker process is "blocked".
There are a limited number of worker processes.
If all workers are blocked, the buffer daemon collects the overflow messages
in its internal buffer.
Messages in the internal buffer pool have the status "waiting".
.SH EXAMPLES
.PP
.TP 4
.I bfstate n12-14
Display the status of all network message buffers on nodes 12 through 14.
.SH DIAGNOSTICS
.PP
If no buffers are found, only the title line is displayed.
.SH BUGS
The
.I \-B
option may print information on one message more or less than specified.
.SH BUGS
.PP
If the buffer daemon's workers are all occupied, the order of network
messages handled by the target node could be jumbled by the
service request initiated by \fIbfstate\fR.
.SH SEE ALSO
buffer(l), rbfstate(l)
