.TH BTSTATE l  "January 7, 1992" "Release 2.2" "TROLLIUS COMMANDS"
.SH NAME
btstate \- Report status of Trollius ITB boot objects.
.SH SYNTAX
.B btstate
[-hp] [-B <#progs>] <node(s)>
.SH OPTIONS
.TP 15
.B \-h
Print useful information on this command.
.TP
.B \-p
Select the spawn object.
Without this option, the stage object is selected.
.TP
.B \-B <#progs>
Display a maximum of <#progs> program descriptors.
.SH DESCRIPTION
.PP
.I Btstate
displays information on Trollius ITB boot objects.
When used without the
.I \-p
option, the stage object (the loaded process schema) is fetched
from the specified nodes and displayed.
The
.I -p
option calls for the spawn table to be displayed.
A spawn table describes the programs booted and running on
the local node.
.PP
.I Btstate
prints one line for each program in the selected object on the selected nodes.
The output is displayed under the following headings:
.TP 10
NODE
The boot program resides on this node identifier.
.TP
LOAD
The load module begins at this address.
.TP
DATA
The data segment begins at this address.
.TP
STKSIZE
The stack is or will be this number of bytes.
.TP
PRI
The process will be created with this priority.
.TP
NAME
The original file containing the load module had this name.
.PP
The message, `...more...', may be displayed at the end of the output.
This indicates that the internal tables of
.I btstate
were not large enough to hold the full object from one or more of
the specified nodes.
The internal table size, or the maximum number of program descriptions
that can be printed from any one node, can be increased with the
.I -B
option.
.PP
ITB nodes are identified as
.I n<list>,
where <list> can be a single node identifier or a list of node identifiers.
Node identifiers are established in the Boot Schema (see nail(l)), and
can be written in decimal and/or hexadecimal notation,
An example
.I node(s)
specification is thus n0-7,8,10,0xc,0x10-31.
.SH EXAMPLES
.PP
.TP 4
.I btstate n12-14
Display the loaded process schemata on nodes 12 through 14.
.TP
.I btstate n7
Display the programs that were booted and are running on node 7.
.SH DIAGNOSTICS
.PP
The header is always printed.
If the stage object has not been loaded on a given node, no output
lines for that node are printed.
.SH SEE ALSO
.PP
rbtstate(l), vboot(l)
