.TH CAST l  "April 28, 1992" "Release 2.2" "TROLLIUS COMMANDS"
.SH NAME
cast \- Control Trollius multicast daemons.
.SH SYNTAX
.B cast
[-h] [-c <castid>] <node(s)>
.SH OPTIONS
.TP 15
.B \-c <castid>
Specify the multicast identifier.
.TP
.B \-h
Print helpful information on this command.
.SH DESCRIPTION
.PP
.I Cast
controls the multicast daemons on any Trollius node.
In its current version, its only function is to provide a way to remove
the spanning tree of a defined multicast identifier.
It must be called with an option:
.I cast <node(s)>
by itself has no function.
.PP
The cast identifier
.I castid
can be any user defined number.
Three special identifiers, HOST2ITB, HOST2OTB and HOST2ALL are also accepted.
They are used by some Trollius commands to reach all ITB nodes, all OTB nodes
and all nodes in the system respectively from the host node.
.PP
The node is specified on the command line.
The host node is identified as
.I h.
ITB nodes are identified as
.I n<list>,
where <list> can be a single node identifier or a list of node identifiers.
Node identifiers are established in the boot schema (see nail(l)), and can be
written in decimal or hexadecimal notation.
.PP
In the event of an application program error or premature termination
of an application process doing multireeling, unwanted partially combined
messages collect in the various multicast daemons on the spanning tree.
The user will need to clear the space used by these messages and remove
the multicast spanning tree before running the application program again.
.I Cast -c <castid> <root_node>
will deallocate the space used by messages multireeled on the
.I castid
spanning tree from all nodes in that tree, starting from the given
.I root_node,
and will remove the definition of that tree.
.SH EXAMPLES
.TP 4
.I cast -c HOST2ITB h
Remove the multicast spanning tree having the host node at its root and
branches reaching all ITB nodes in the system.
.SH SEE ALSO
cstate(l), rmelt(l)
