.TH CSTATE l  "April 29, 1992" "Release 2.2" "TROLLIUS COMMANDS"
.SH NAME
cstate \- Report status of Trollius multicast daemon.
.SH SYNTAX
.B cstate
[-h] [-c <castid>] [-C <#maxcasts>] <node(s)>
.SH OPTIONS
.TP 15
.B \-c <castid>
Print detailed information on this cast identifier.
.TP
.B \-C <#maxcasts>
Display a maximum of <#maxcasts> cast identifiers per node.
.TP
.B \-h
Print useful information on this command.
.SH DESCRIPTION
.PP
.I Cstate
displays information on Trollius multicast daemons.
When used without the
.I \-c
option,
.I cstate
prints one line for every cast identifier defined at each given node.
The output consists of the node, the cast identifier, the root node of
the spanning tree, the parent node in the tree, the combining function
used, the number of leaf nodes, and the number of multireels currently
taking place on different message events at that node.
In the rare case where a cast identifier is in the process of being
registered when the
.I cstate
command is issued, a "*" character will appear following the number of
leaf nodes indicating that some leaf nodes have not finished the
registration request.
The
.I \-c
option prints one line of information for each event used for
multireeling on the spanning tree of
.I castid.
For each event, the message type and the number of packets
stored/combined are given.
.I Castid
can be any number used to identify a multicast spanning tree.
Three special identifiers, HOST2ITB, HOST2OTB and HOST2ALL are also accepted.
They are used by some Trollius commands to reach all ITB nodes, all OTB nodes
and all nodes in the system respectively from the host node.
.PP
The host node is identified as
.I h.
ITB nodes are identified as
.I n<list>,
where <list> can be a single node identifier or a list of node identifiers.
Node identifiers are established in the Boot Schema (see nail(l)), and
can be written in decimal and/or hexadecimal notation.
An example
.I node(s)
specification is thus n0-7,8,10,0xc,0x10-31.
.SH EXAMPLES
.PP
.TP 4
.I cstate h n12-14
Display the status of all cast identifiers defined on the host node and
on nodes 12 through 14.
.TP
.I cstate -c HOST2ITB -C 20 n0
Display the status of all message events used for multireeling on
the HOST2ITB multicast spanning tree on node 0.
Do not list more than 20 entry lines.
.SH SEE ALSO
rcstate(l)
