.TH DOOM l  "February 18, 1991" "Release 2.2" "TROLLIUS COMMANDS"
.SH NAME
doom \- Deliver a signal to a Trollius process.
.SH SYNTAX
.B doom
[-h] [-<signo>] <node(s)> [<process(es)>]
.SH OPTIONS
.TP 10
.B \-h
Print useful information on this command.
.TP
.B \-<signo>
Deliver the signal
.I signo.
.SH DESCRIPTION
.I Doom
is a Trollius command that delivers a signal to one or more processes
on one or more nodes.
The signal is specified with the
.I \-<signo>
option.
.I Signo
can be:
.TP 5
4
terminate
.TP
5
suspend execution
.TP
6
continue execution
.TP
7
user defined
.TP
8
user defined
.PP
If a signal is not specified as an option, 4 (terminate) is delivered.
.PP
The nodes to which the signal will be delivered must be specified.
The host is identified as
.I h.
Compute nodes are identified as
.I n<list>,
where <list> can be a single node identifier or a list of node identifiers.
Node identifiers are established in the Boot Schema (see nail(l)), and can
be written in decimal and/or hexadecimal notation.
In addition, the
.I doom
command can be broadcast to all compute nodes
by specifying
.I node(s)
as
.I C.
.PP
If the host node is specified, you
.B must
also specify the processes to receive the signal.
These are identified as
.I p<pid_list>,
where <pid_list> is a single process identifier or a list of process
identifiers.
Process identifiers can be obtained with state(l) or
with the UNIX command ps(1).
.PP
If a compute node or nodes is specified, and no processes are specified, all
application processes on that node will receive the signal.
Processes on compute nodes can be specified in several ways, a mixture
of which may be used on the command line.
They are:
.PP
%<index_list>	by the index printed in brackets by state(l).
.PP
#<event_list>	by the event on which they are blocked
.if n		 	(reported by state(l)).
.if t (reported by state(l)).
.PP
@<loadpt_list>	by load module address (obtained with \-l
.if n 			option from state(l)).
.if t option from state(l)).
.PP
p<pid_list>	by process identifier (reported by state(l)).
.PP
The target process receives the signal specified by
.I doom
during its next kernel request (part of almost all Trollius system calls).
A signal will not be delivered if the target process never makes a
kernel request.
A signal is delivered immediately to a process blocked on an event.
.SH EXAMPLES
.TP 4
.I "doom n0\-7 %2"
Terminate processes with index 2 on nodes 0 through 7.
.TP
.I "doom h p9287-9290"
Terminate host processes with process IDs 9287 through 9290.
.TP
.I "doom -5 n0\-7,11 #6 %2 p9287"
Suspend execution of processes blocked on event 6, processes having process
index 2, and processes having process ID 9287, on nodes 0 through 7 and 11.
.SH DIAGNOSTICS
If the described process cannot be located,
.I doom
prints "not a process".
.SH SEE ALSO
kdoom(l), rdoom(l), state(l)
