.TH EXPORT l  "January 4, 1992" "Release 2.2" "TROLLIUS TOOLS"
.SH NAME
export \- Load and execute a bootstrap program on a device connected ITB node.  (Trollius)
.SH SYNTAX
.B export
[-hv][-i <bootstrap>] [-o <device>] [<device> <bootstrap>]
.SH OPTIONS
.TP 15
.B \-h
Print useful information on this tool.
.TP
.B \-i <bootstrap>
Use <bootstrap> as the input file.
.TP
.B \-o <device>
Use <device> as the output file.
.TP
.B \-v
Be verbose.
.SH DESCRIPTION
.I Export
loads and executes a bootstrap program on a device connected ITB node,
in this case, a boot-from-link reset transputer.
The transputer should be reset with tfish(l) prior to using
.I export.
.PP
The input file must be in a Trollius executable format and is usually
a bootstrap program that will conduct further loading of the node.
The output file is a communication device to a neighbour ITB node.
There are three ways of specifying the input and output files.
.sp
.nf
	1% export <device> <bootstrap>
	2% export -i <bootstrap> -o <device>
	3% export < <bootstrap> > <device>
.fi
.LP
The first method is compatible with older versions of \fIexport\fR.
The second method is easier to remember while the third method
permits \fIexport\fR to be used in a pipeline.
.PP
Following the specification of the transputer, a maximum of 255 bytes
of code from the input executable file are loaded.
The starting stack address is the first word address after the code.
No initialized data are loaded.
.SH DIAGNOSTICS
.I Export
will fail if the input file is not a valid Trollius executable file
or if it cannot open either the input or output file.
.SH "SEE ALSO"
cboot(l), tfish(l), moses(l)
