.TH FSTATE l  "November 15, 1990" "Release 2.2" "TROLLIUS COMMANDS"
.SH NAME
fstate \- report information on Trollius remote file daemon
.SH SYNTAX
.B fstate
[-Fach] <nodes>
.SH OPTIONS
.TP 8
.B \-F #
Report up to a limit of # descriptors.
.TP
.B \-a
Report on active descriptors only.
.TP
.B \-c
Report on cubix descriptors only.
.TP
.B \-h
Print helpful information on the fstate command.
.SH DESCRIPTION
.I Fstate
reports on open file descriptors maintained by the remote file daemon, filed.
With no options, information is printed on all open descriptors under the
following headings:
.TP 10
FD
the filed descriptor handle, different than the client handle or actual
Unix handle
.TP
FLAGS
the open flags: R for read, W for write, A for active, L for locked active,
S for cubix singl access method, M for cubix multi access method
.TP
FLOW
the total number of bytes transferred in both directions
.TP
CLIENT
the node ID and event number of the last client
.TP
NAME
the name of the file
.LP
If a file is showing either the M or S cubix flags, additional information
is available on the state of synchronization between processes accessing
the file.
Using the -c option adds the following headings:
.TP 10
SYNC'D
the number of cubix members to synchronize and the total number of cubix
members
.TP
REQ
the filed request that is synchronizing the cubix members
.LP
Between cubix synchronizations, the file will show 0/n for SYNC'D
and "idle" for REQ.
Prolonged non-idle cubix state reports generally indicate a synchronization
error and a hung application.
See tfile(l).
.LP
Filed is a Unix process, and Unix processes are limited in the number
of Unix file descriptors (fd) that they can open at any one time.
This is frequently less than the number of filed descriptors (tfd) requested
by Trollius processes.
Filed descriptors are associated with each client's open user descriptors
(ufd), and are used by filed to identify the file.
Filed descriptors are temporarily assigned Unix file descriptors.
When this happens, the status of the filed descriptor is active.
Locked filed descriptors remain active continuously.
.SH EXAMPLE
.TP 10
.I fstate h
Report all filed descriptors, representing every open file in the Trollius
network.
.SH SEE ALSO
cubix(l), tfile(l)
