.TH HBOOT l  "January 22, 1992" "Release 2.2" "TROLLIUS TOOLS"
.SH NAME
hboot, saboot \- Boot Trollius on a host node.
.SH SYNTAX
.B hboot
[-bdhvNV][-c <conf>][-T <topology>]
.sp
.B saboot
-T <topology> [-bdhvNV][-c <conf>]
.SH OPTIONS
.TP 15
.B \-b
Skip the boot step.
.TP
.B \-c <conf>
Use <conf> as the process schema file.
.TP
.B \-d
Turn on debugging.
.TP
.B \-h
Print useful information on this tool.
.TP
.B \-v
Be verbose.
.TP
.B \-N
Pretend to boot, going through the motions but not actually
taking any lasting actions.
.TP
.B \-T <topology>
Use <topology> to redefine the topology variable in the process schema.
This is mandatory with \fIsaboot\fR.
.TP
.B \-V
Format and print the process schema.
.SH DESCRIPTION
.PP
.I Hboot
is the tool that starts up Trollius on the host node.
It can be understood as a generic tool that starts multiple processes
on the local OTB node, based on information in a process schema.
It is not restricted to booting Trollius.
.I Hboot
is part of the booting sequence initiated by spread(l).
.PP
.I "Saboot -T <topology>"
starts up a stand-alone version of Trollius on the host node.
.I
Topology
is set to the number of ITB (compute) nodes in the system to be simulated.
The number given will be returned to all processes calling getnitb(l).
.I Saboot
is a shell script wrapper for
.I hboot
that uses a different process schema.
The stand-alone host schema includes a special router and
a minimal number of support processes aimed towards single node
debugging of multiple node applications.
See launch(l) and sakill(l) for more information on single node debugging.
.PP
A process schema is a description of the processes which constitute
the operating system on a given node.
Naturally, the process schema used by
.I hboot
should be the one that describes Trollius on the host node.
The grammar of the process schema is described in conf(l).
.PP
If Trollius was booted, the kernel records all processes that
attach to it, including all the processes in the process schema.
It is the job of tkill(l)
to use this information to remove these processes from the host node.
.SH EXAMPLES
.TP 4
.I "hboot -v"
Boot Trollius on the host node with the default schema.
Report about every step as it is done.
.TP
.I "hboot -c myconfig"
Boot the host node with the custom process schema `myconfig'.
.SH FILES
.TP 4
$TROLLIUSHOME/boot/conf.otb
host node process schema, where $TROLLIUSHOME is the installation
directory
.TP
$TROLLIUSHOME/boot/conf.SA
host node process schema for Stand-alone Trollius
.TP
$TROLLIUSHOME/locks/USERID
default kill file
.SH DIAGNOSTICS
Using ps(1) after the boot will display, among others, the Trollius
processes that have been started.
They may be killed one by one with kill(1), or all at once by killing
the Trollius kernel process with a TERM or a HUP signal.
The preferred method is to use the Trollius command tkill(l)
that should kill them all at once, and also remove the reset file.
New users should make liberal use of ps(1)
to gain confidence that the system is working properly.
In a disaster, ps(1) and kill(1) are your only hope of recovery.
.SH SEE ALSO
conf(l), spread(l), tkill(l)
