.TH INTROC l "April 23, 1992" " Release 2.2" "TROLLIUS LIBRARY"
.SH NAME
introc - introduction to Trollius C programming functions
.SH LIST OF FUNCTIONS
.nf
.if n .ta 15 30 45
.if t .ta 10 20 30
\fIName	Appears	Description\fR
\fI	on Page\fR
.sp 1
async	cubix.l	change file mode to asynchronous (CUBIX)
atkexit	kexit.l	register cleanup function
bfprobe	bfprobe.l	report if a message is ready to be received
bsend	bsend.l	basic Trollius message passing
calloc	malloc.l	allocate memory for a number of elements
drecv	dsend.l	receive message from a node (datalink layer),
		blocking
dsend	dsend.l	send message to a node (datalink layer),
		blocking
dtry_recv	dsend.l	receive message from a node (datalink layer),
		non-blocking
dtry_send	dsend.l	send message to a node (datalink layer),
		non-blocking
free	malloc.l	high-level memory deallocation
getnall	getnet.l	return total number of nodes
getncast	getnet.l	return number of cast identifiers passing
		through local node
getnet	getnet.l	return information on the Trollius network
getnitb	getnet.l	return the number of ITB nodes
getnodeid	getnet.l	return the local node identifier
getnodes	getnodes.l	return array of Trollius node identifiers
getnodetype	getnet.l	return the type of the local node
getnotb	getnet.l	return the number of OTB (host) nodes
getntype	getnet.l	return detailed information on the number
		and types of nodes
getorigin	getnet.l	return the origin host node identifier
getrent	getrent.l	get Trollius routing information
getrentc	getrent.l	cache Trollius routing information
getroute	getrent.l	return route to reach node
getrtype	getrent.l	return the type of a node
getsmart	getnet.l	wait for router to receive network
		and routing information
isasync	cubix.l	report whether file is in
		asynchronous mode (CUBIX)
ismulti	cubix.l	report whether file is in
		multiple mode (CUBIX)
issingl	cubix.l	report whether file is in
		singular mode (CUBIX)
kattach	kinit.l	attach a process to Trollius
kcreate	kcreate.l	create a Trollius process from a load module
kdetach	kexit.l	detach a process from Trollius
kdoom	kdoom.l	deliver a signal to a Trollius process
kexit	kexit.l	call atkexit functions, detach from Trollius
		and exit
_kexit	kexit.l	detach from Trollius and exit
kinit	kinit.l	attach a process to Trollius and
		initialize data structures
kpar_Fe	kpar.l	create a process, heavyweight version
kpar_He	kpar.l	create a process, lightweight version
kpar_Na	kpar.l	create a process, medium-weight version
kpause	ksignal.l	wait until a signal is delivered
krecv	ksend.l	receive a local node message, blocking
ksend	ksend.l	send a local node message, blocking
ksigblock	ksigblock.l	block a given signal
ksignal	ksignal.l	specify a signal handler for a signal
ksigretry	ksigblock.l	retry given signal
ksigsetmask	ksigblock.l	set which signals to block
ksigsetretry	ksigblock.l	set which signals to retry
kstate	kstate.l	get Trollius kernel state of a process
ktrstart	ktrstart.l	start application tracing
ktrstop	ktrstart.l	stop application tracing
ktry_recv	ksend.l	receive a local node message, non-blocking
ktry_send	ksend.l	send a local node message, non-blocking
ltot	ttol.l	convert local to Trollius data format
malloc	malloc.l	high-level memory allocation
multi	cubix.l	change file mode to multiple (CUBIX)
ncombine	ncombine.l	combine reeled messages
nrecv	nsend.l	receive message from a node (network layer),
		blocking
nsend	nsend.l	send message to a node (network layer),
		blocking
ntry_recv	nsend.l	receive message from a node (network layer),
		non-blocking
ntry_send	nsend.l	send message to a node (network layer),
		non-blocking
precv	psend.l	receive a message from a node
		(physical layer)
psend	psend.l	send a message to a node (physical layer)
rbfstate	rbfstate.l	report status of remote Trollius buffers
rbtadd	rbtadd.l	add object to boot daemon
rbtboot	rbtboot.l	boot objects into ITB node
rbtflush	rbtflush.l	remove objects from boot daemon
rbtstage	rbtstage.l	load boot objects between ITB nodes
rbtstate	rbtstate.l	get status on boot objects
rbuffer	rbuffer.l	set buffer parameters on remote nodes
rcask	rcast.l	return number of expected multireel messages
rcast	rcast.l	register a multicast destination
rcasttype	rcast.l	register a multicast destination
rcreate	rcreate.l	create a Trollius process on remote nodes
rdoom	rdoom.l	signal processes on remote nodes
rdrain	rdrain.l	dump memory from a remote ITB node
		to a file
realloc	malloc.l	enlarge or shrink a previously
		malloc-ed block
recho	recho.l	send message to echo server on remote node
recvb	sendb.l	basic Trollius message passing
rf77back	rf77.l	backspace in F77 file
rf77read	rf77.l	read F77 file record
rfincr	rfile.l	increment open count on file descriptor
rfrmfd	rfile.l	remove Trollius file descriptor
rflat	rflat.l	tag and load memory on remote node
rforder	cubix.l	change order in which multiple mode files
		are serviced (CUBIX)
rforget	rget.l	find tagged memory on remote node, remove tag
rfree	rmalloc.l	low-level memory deallocation
rfreeall	rmalloc.l	deallocate all rmalloc-ed memory on a node
rfstate	rfstate.l	report status of remote Trollius files
rfunix	rfunix.l	Unix-like remote file requests
rget	rget.l	find tagged memory on remote node
rload	rload.l	load a file onto a remote node
rloadgo	rloadgo.l	load and execute a module on a remote node
rmalloc	rmalloc.l	low-level memory allocation
rmelt	rcast.l	remove a multicast destination
rmstate	rmstate.l	report status of memory allocation on
		a remote node
rpattach	rpattach.l	become a remote process
rpdetach	rpdetach.l	cease to be a remote process
rpwait	rloadgo.l	wait for remote process to exit
rrattach	rrattach.l	register process and node ID with
		Trollius stand-alone router
rrdetach	rrattach.l	de-register process and node ID with
		Trollius stand-alone router
rremroute	rsetroute.l	remove Trollius routing information
rrnodewait	rrnodewait.l	wait for node routing information
rroute	rroute.l	set complete Trollius routing information
rsetnet	rsetnet.l	set Trollius network information
rsetroute	rsetroute.l	set Trollius routing information
rspawn	rspawn.l	spawn processes onto a remote node
rstate	rstate.l	report state of processes on remote node
rtrstore	rtrstore.l	store trace data with daemon
sendb	sendb.l	basic Trollius message passing
singl	cubix.l	change file mode to singular (CUBIX)
trecv	tsend.l	receive message from a node (transport layer)
tsend	tsend.l	send message to a node (transport layer)
ttime	ttime.l	return value of system timer in seconds
ttol	ttol.l	convert Trollius to local data format
