.TH KDETACH l "April 6, 1992" "Release 2.2" "TROLLIUS LOCAL LIBRARY"
.SH NAME
kdetach \- Detach a process from Trollius.
.SH SYNOPSIS
.nf
.ft B
int	kdetach (int pid);
.fi
.SH DESCRIPTION
.PP
.I Kdetach()
detaches a process from the local Trollius kernel.
It effectively undoes what kattach(l) did.
It should be called at the end of every program that runs
under Trollius, since the Trollius kernel has no other way of
knowing that a process has terminated.
Normally, this is done as part of a call to kexit(l).
Kexit(l) is called implicitly at the end of an ITB process and
must be called explicitly at the end of an OTB process.
.PP
The parameter passed to
.I kdetach()
is the process ID of the process to be detached.
A process ID of 0 is interpreted as a request to detach the calling process,
and is the normal usage of
.I kdetach().
Detaching peer Trollius processes is intended as an emergency clean up
measure and is not intended for normal usage.
.SH RETURN VALUE
.I Kdetach()
returns 0 upon successful completion.
Otherwise, \-1 is returned and the global variable
.I errno
is set to indicate the error.
.SH ERRORS
.PP
.I Kdetach()
fails if:
.TP 22
[ENOTPROCESS]
The process whose process identifier was passed to
.I kdetach()
is not attached to the kernel.
.SH SEE ALSO
kinit(l), kattach(l)
