.TH KDOOM l "April 6, 1992" "Release 2.2" "TROLLIUS LOCAL LIBRARY"
.SH NAME
kdoom \- Deliver a signal to a Trollius process.
.SH SYNOPSIS
.nf
.ft B
#include <ksignal.h>

int	kdoom (int pid, int signum);
.fi
.SH DESCRIPTION
The function
.I kdoom()
enables one Trollius process to deliver an asynchronous signal to
another Trollius process on the local node, including itself.
Asynchronous delivery in this context means either the next time the target
process attempts any kernel request, or immediately if the target
process is blocked on an event.
.PP
.I Pid 
is the identifier of the process to which the signal will be delivered.
Process identifiers refer to other currently attached Trollius processes,
except for the special identifier 0, which refers to the caller.
.PP
.I Signum
identifies the signal to be delivered.
Trollius signals are defined in <ksignal.h> and are:
.LP
.nf
.ta \w'SIGRELEASE 'u +\w'15*  'u
SIGROUTE	1	invalidate route cache
SIGBACK	2	used to implement controlled processes
SIGNOOP	3	used to implement controlled processes
SIGUDIE	4	terminate
SIGARREST	5	suspend execution
SIGRELEASE	6	continue execution
SIGA	7	user defined
SIGB	8	user defined
.fi
.PP
.I Kdoom()
returns immediately; it never blocks.
.SH RETURN VALUE
Upon successful completion,
.I kdoom()
returns 0.
Otherwise, \-1 is returned and the global variable
.I errno
is set to indicate the error.
.SH ERRORS
.TP 20
[ENOTPROCESS]
The process whose process identifier was passed to
.I kdoom
is not attached to the kernel.
.TP
[EINVAL]
The signal number is invalid.
.SH "SEE ALSO"
ksignal(l), ksigblock(l)
