.TH KSIGNAL l "March 16, 1992" "Release 2.2" "TROLLIUS LOCAL LIBRARY"
.SH NAME
ksignal \- Specify a signal handler for a Trollius signal.
.SH SYNOPSIS
.nf
#include <ksignal.h>

int	(*ksignal (int signum, int (*func)())) ();
.fi
.SH DESCRIPTION
.PP
.I Ksignal()
exchanges a current signal handler for a new signal handler.
When the kernel delivers a signal to a process, the signal
handler is called immediately before the kernel request subroutine
returns to the caller.
Trollius installs a default handler for each signal when kinit(l) is called.
Kinit(l) should always be called prior to
.I \fIksignal()\fR.
.PP
Trollius signals are completely separate from the signal facilities
of the host operating system on OTB nodes.
While the syntax and functionality are similar, signal(3) cannot
affect Trollius signals and vice versa.
.PP
The following is a list of Trollius signals as they appear in
<ksignal.h>:
.LP
.nf
.ta \w'SIGRELEASE 'u +\w'15*  'u
SIGTRACE	1	unload trace data
SIGBACK	2	used to implement controlled processes
SIGNOOP	3	used to implement controlled processes
SIGUDIE	4	terminate
SIGARREST	5	suspend execution
SIGRELEASE	6	continue execution
SIGA	7	user defined
SIGB	8	user defined
.fi
.PP
Of these signals, SIGBACK and SIGNOOP cannot be used with
.I ksignal()
and cannot be blocked. 
By default, SIGA and SIGB are ignored.
.PP
The new signal handler must be the address of a function.
The special value SIG_IGN ignores the given signal.
(A function that does nothing is called when the signal occurs.)
Another special value, SIG_DFL, returns the interrupt handler
to the default function initialized by kinit(l).
.PP
When a signal handler is called, the signal number that caused the
invocation is passed as the sole parameter to the handler.
.PP
A signal handler may make kernel requests and therefore receive
additional signals, including ones of the same type that are currently
being handled.
Should such complex signal handlers be installed, they should be reentrant.
.SH "RETURN VALUE"
.PP
Upon successful completion,
.I ksignal()
returns the address of the previously installed signal handler, which
may be reinstated later.
Otherwise, \-1 is returned and the global variable
.I errno
is set to indicate the error.
.SH ERRORS
.PP
.TP 20
[EINVAL]
The signal number is invalid or privileged.
.SH "SEE ALSO"
kdoom(l), ksigblock(l)
