.TH LAUNCH l  "March 5, 1991" "Release 2.2" "TROLLIUS COMMANDS"
.SH NAME
launch \- Execute programs on host node under Stand-alone Trollius (SA-T).
.SH SYNTAX
.B launch
[-dhw] <node(s)> <program(s)> [-- <args>]
.br
.SH OPTIONS
.TP 11
.B \-d
Turn on debugging.
.TP
.B \-h
Print useful information on this command.
.TP
.B \-w
Do not wait for initiated processes to terminate before exiting
.I launch.
.TP
.B -- <args>
Pass these run-time arguments to every new process.
This must always be the last option to
.I launch.
.SH DESCRIPTION
.I Launch
is a Stand-alone Trollius command used on the host to emulate a
multicomputer environment.
For every node listed on the command line, one copy of each program
is executed on the local host node.
Each copy simulates that program running on one specific node of
a multi-node system.
All the processes receive the arguments listed on the command line.
To emulate different programs on different nodes, or to pass different
arguments to different programs, multiple
.I launch
commands must be used.
.PP
Compute nodes are identified on the command-line as
.I n<list>,
where <list> can be a single node identifier or a list of node identifiers.
Node identifiers are established in the Boot Schema (see nail(l)), and
can be written in decimal and/or hexadecimal notation.
An example
.I node(s)
specification is thus n0-7,8,10,0xc,0x10-31.
.PP
A Stand-alone Trollius session is initiated on the host node using
saboot(l) and terminated using sakill(l).
Stand-alone Trollius allows the user to develop, test, and debug
multicomputer applications within the friendly confines of the host node.
The user writes programs for the multicomputer system, then compiles both
host and node programs to run on the host (using cc(1) or f77(1)).
The programs can then be debugged on the host node using Stand-alone Trollius.
When the program runs perfectly,
the node programs can be recompiled to run ITB (using tcc(l) or tf77(l)),
and the application is ready to run on the multiple node machine.
A few changes in the program code may be necessary to go from the Stand-alone
emulation to the actual multiple node environment.
.PP
The multi-node emulation engineered by
.I launch
hinges on providing node ID's and routing messages.
.I Launch
associates each copy of the running process
with one of the command-line node ID's (see rrattach(l)).
Thus, a call to getnodeid(l) will return a different value for each
copy of the program running on the host.
The stand-alone router directs all network messages to the local node.
.PP
The destination node specified by the sending process is not used to
synchronize message-passing.
This imposes one limitation on Trollius programming: the programmer must
be certain that the correct receiver of a message can be
identified by event and type only.
Thus, Stand-alone programs should use events
which are unique within the entire emulated multicomputer.
Often the node identifier itself can be used as an event in applications
that require simple message passing and one process per node.
.PP
Another limitation of the current release of Stand-alone Trollius is the
inability to emulate multicasting or multireeling.
Applications using multicast identifiers cannot be run with Stand-alone
Trollius.
.PP
Since all SA-T programs will actually run on a single OTB node,
all programs must explicitly call kinit(l) and kexit(l).
.SH EXAMPLES
.TP 4
.I "launch n2-4 prog1 -- arg1 arg2"
Execute three copies of `prog1' with arguments `arg1' and `arg2' on the
host node.
The three programs will emulate processes running on nodes 2, 3 and 4.
Wait for all processes to terminate.
.SH SEE ALSO
saboot(l), sakill(l)
