.TH LOAD l  "March 5, 1991" "Release 2.2" "TROLLIUS COMMANDS"
.SH NAME
load \- Load files on Trollius ITB (compute) nodes.
.SH SYNTAX
.B load
[-hv] <node(s)> <filename(s)>
.SH OPTIONS
.TP 8
.B \-h
Print useful information on this command.
.TP
.B \-v
Turn on verbose mode.
.SH DESCRIPTION
.I Load
is a Trollius command that loads any file from the local host node
onto the specified ITB node.
It is the command level equivalent of the remote level rload(l) function.
Its typical usage is as a component of the loadgo(l) command, or
as a means of identifying loading problems during debugging.
.PP
A single
.I load
command may specify multiple nodes and multiple files.
Compute nodes are identified as
.I n<list>,
where <list> can be a single node identifier or a list of node identifiers.
Node identifiers are established in the Boot Schema (see nail(l)), and
can be written in decimal and/or hexadecimal notation.
An example
.I node(s)
specification is thus n0-7,8,10,0xc,0x10-31.
.I Load
requests can also be broadcast to all the ITB nodes, by specifying
.I nodes(s)
as
.I C.
.PP
If the file is in Trollius executable format, it is rearranged
in preparation for eventual execution, although no other command
will create a process from a program that has already been loaded.
Otherwise the file is loaded unaltered.
.PP
If the -v option is invoked,
.I load
reports the address at which each file resides on each destination node.
.SH EXAMPLES
.TP
.I "load n0-7 data1"
Sequentially load `data1' on nodes 0 through 7.
.SH SEE ALSO
loadgo(l), rload(l)
