.TH MOSES l  "January 4, 1992" "Release 2.2" "TROLLIUS TOOLS"
.SH NAME
moses \- command interface to the moses bootstrap loader (Trollius)
.SH SYNTAX
.B moses
[-dhN] [<device>]
.br
.SH OPTIONS
.TP 11
.B \-d
Turn on debugging.
.TP
.B \-h
Print useful information on this tool.
.TP
.B \-N
`Pretend' - skip all steps.
.SH DESCRIPTION
.PP
.I Moses
is a command line interface to the moses bootstrap loader running
on a device connected ITB node.
In Trollius, communication between the host and the network of ITB nodes
passes through nodes that are directly connected to the host and appear to
the operating system on the host as a device.
These nodes are called device connected nodes.
.PP
Trollius ITB nodes typically boot from one of their communication links.
This procedure involves receiving a small bootstrap loader program, called
moses, which takes control of the node and acts as a server (see export(l)).
The moses loader accepts commands and returns results on the same link from
which it was loaded.
Moses accepts ten commands, hence the name, and is usually used for development
and debugging in addition to its normal responsibility of booting Trollius.
.PP
.I Moses,
the command line interface, provides a convenient way to access the moses
loader on a device connected node and execute its commands.
By default,
.I moses
with no options will access the moses loader across the default
communication link device.
.SH COMMANDS
.I Moses
commands can be entered either in small case or in capitalized letters.
A string of characters starting with the '#' character,
till the end of the line, is defined as a comment and hence ignored.
In some cases, in order to differentiate between a hexadecimal and
a decimal number, the hexadecimal number is to be preceeded by "0x" or "0X".
Likewise, in some cases a string of characters must be quoted in order to
distinguish it from a number.
.TP 25
.B write <addr> <word>
Write the value <word> at address <addr>.
This command can be abbreviated by
"writ".
.TP
.B read <addr>
Read the contents of the word at address <addr>.
.TP
.B load <file> <addr>
Load the contents of <file> starting at address <addr>.
.TP
.B fetch <length> <addr>
Fetch <length> bytes starting at address <addr> and display them in hexadecimal
notation.
This command can be abbreviated by "ftch".
.TP
.B fetch <file> <length> <addr>
Fetch <length> bytes starting at address <addr> and store them in <file>.
This command can be abbreviated by "ftch".
.TP
.B call <ip> <stack>
Transfer control to a new process using <ip>, the instruction pointer, and
the given stack pointer <stack>.
.TP
.B runp <ip> <stack>
Create a parallel process using <ip>, the instruction pointer, and the given
stack pointer <stack>.
.TP
.B sttimer <time>
Set the node's timer(s) to <time>.
.TP
.B warm
Warm restart the processor.
.TP
.B out <buf> <chan> <cnt>
Do an out on channel <chan>, using the buffer address <buf> of length <cnt>
bytes.
.TP
.B in <buf> <chan> <cnt>
Do an in on channel <chan>, using the buffer address <buf> of length <cnt>
bytes.
.TP
.B help
Print a summary of the moses commands.
.TP
.B exit
Exit moses.
This command can be abbreviated by "e".
.TP
.B quit
Exit moses.
This command can be abbreviated by "q".
.SH SEE ALSO
export(l)
