.TH MSTATE l  "November 8, 1991" "Release 2.2" "TROLLIUS COMMANDS"
.SH NAME
mstate \- Report status of Trollius ITB node memory allocation.
.SH SYNTAX
.B mstate
[-fh] [-M <#blocks>] <node(s)> [<process(es)>]
.SH OPTIONS
.TP 15
.B \-f
Print information on unallocated memory.
.TP
.B \-h
Print useful information on this command.
.TP
.B \-M <#blocks>
Display a maximum of <#blocks> memory blocks.
.SH DESCRIPTION
.PP
.I Mstate
displays information on Trollius ITB node memory allocation.
When used without the
.I \-f
option,
.I mstate
prints one line for every allocated memory block.
The output consists of the node and process identifiers, the starting
address, and the size of the memory block.
If no processes are specified, the memory allocation of every process on
every specified node is reported.
The
.I \-f
option prints information on free memory blocks on each specified node.
Do not specify processes when using the
.I \-f
option.
.PP
ITB nodes are identified as
.I n<list>,
where <list> can be a single node identifier or a list of node identifiers.
Node identifiers are established in the Boot Schema (see nail(l)), and
can be written in decimal and/or hexadecimal notation,
An example
.I node(s)
specification is thus n0-7,8,10,0xc,0x10-31.
.PP
Processes are identified as
.I p<pid_list>,
where <pid_list> is a process identifier
or list of process identifiers, as reported by state(l).
.SH EXAMPLES
.PP
.TP 4
.I mstate n12-14
Display the status of all allocated memory blocks on nodes 12 through 14.
.TP
.I mstate n7 p4047
Display the status of all memory blocks allocated to process 4047 on node 7.
.SH DIAGNOSTICS
If no processes are found, only the title line is displayed.
.SH BUGS
.PP
The memory management daemon returns empty descriptors to
.I mstate
along with descriptors for allocated and unallocated memory blocks.
Thus, the maximum number of blocks given by the
.I -M
option must exceed the total number of descriptors in the daemon, not
just the total number of memory blocks, if all the memory blocks
(the important information) are to be displayed.
The default value is suitable for most applications that make
conservative use of rmalloc(l) and rfree(l).
A message is printed if there were more memory blocks that
could not be displayed due to the maximum display limit.
.SH SEE ALSO
.PP
rmstate(l), rmalloc(l)
