.TH PSEND l "April 7, 1992" "Release 2.2" "TROLLIUS NETWORK LIBRARY"
.SH NAME
psend, precv  \- Trollius physical layer message passing
.SH SYNOPSIS
.nf
.ft B
#include <net.h>

int	psend (struct nmsg *header);
int	precv (struct nmsg *header);
.fi
.SH DESCRIPTION
These functions access the physical layer message passing services of
the Trollius network level.
.I Psend()
and
.I precv()
are the lowest level calls in the network message passing library.
They do not interact with the kernel or any other Trollius process.
Instead, they access a communication device directly, using transputer
IN/OUT operations.
.I Psend()
and
.I precv()
are thus hardware dependent, and may only be used by ITB node processes.
.PP
.I Psend()
and
.I precv()
accept a pointer to a network message descriptor (see nsend(l)).
The
.I "nh_node, nh_event, nh_type,"
and
.I nh_flags
fields will be ignored.
Unlike other network layer functions,
.I psend()
and
.I precv()
do not change any of the descriptor fields except the receiver's
.I nh_data
field.
Even the
.I nh_length
field is unchanged after a call to
.I precv()
because there is no protection against mismatched lengths.
.PP
The physical sub-layer calls may only be used on an
.B existing virtual circuit
between two neighboring nodes.
Thus, the user must first establish a virtual circuit with dsend(l)/drecv(l)
or nsend(l)/nrecv(l).
After the first message has been sent and received, the user can call
.I psend()
and
.I precv()
on subsequent messages.
The virtual circuit should be closed with
dsend(l)/drecv(l) or nsend(l)/nrecv(l).
The
.I nh_dl_event
and
.I nh_event
fields must not be altered while
.I psend()
and
.I precv()
are being used.
.PP
.I Psend()
and
.I precv()
do no more than set up the arguments for, and call, the out() and in() macros
found in <c.h>.
For maximum efficiency, the user may choose to use the macros directly,
instead of
.I psend()/precv().
.SH "RETURN VALUE
Upon completion, 0 is returned.
.SH "SEE ALSO"
dsend(l), nsend(l)
