.TH RASM l  "September 19, 1991" "Release 2.2" "TROLLIUS TOPOLOGY TOOLS"
.SH NAME
rasm \- Assemble routing tables from a Trollius boot schema.
.SH SYNTAX
.B rasm
[-dhvV][-c <bnail>][-i <extra>][-p <route>]
.br
.SH OPTIONS
.TP 13
.B \-c <bnail>
Use
.I bnail
as the boot schema file.
.TP
.B \-d
Turn on debugging.
.TP
.B \-h
Print useful information on this tool.
.TP
.B \-i <extra>
Increase the size of the route table for each node by
.I extra
entries.
.TP
.B \-p <route>
Use
.I route
as the route file.
.TP
.B \-v
Turn on verbose mode.
.TP
.B \-V
Format and print the boot schema file.
.SH DESCRIPTION
.I Rasm
or the Route Assembler is the tool that assembles routing tables for a
Trollius system from the topology specified in a boot schema file
according to the NaIL grammar (see nail(1)).
The
.I rasm
tool is typically used when it is essential to explicitly state the
routing paths in the multicomputer system, when the heuristic methods
used in the map(l) tool to generate shortest paths are not required, or
when map(l) is simply not available.
.PP
The routing tables describe the paths (sequence of nodes) for routing
messages from one node to another.
A boot schema is a description of a bootable multicomputer system,
specifying all physical nodes including the host node (TNODE tuples)
and the links that connect them (TLINK tuples).
The boot schema may also explicitly specify the paths between
nodes that are not directly connected (TROUTE tuples).
The
.I rasm
tool assembles routing tables from the above three tuple types.
No steps are taken to generate routes that are not explicit in the boot schema.
This means that the generated routing tables will not represent a
fully connected topology (a path from every node to every other node)
if all routes are not specified in the boot schema file.
This service is provided by the map(l) tool.
.PP
There is a one to one correspondence between a boot schema and a route
file just as with a source program written in Fortran or C and its object file.
An appropriate route file must exist before invoking spread(l) to boot
the multicomputer.
Unless overridden by the
.I -p
option, the route filename is assumed to be "route" appended by the identical
suffix (if any) of the boot schema filename.
.PP
.SH EXAMPLES
.TP 4
.I "rasm -v"
Assemble routing tables from the default boot schema file.
The routing tables are stored in the default route file.
The verbose option reports important stages in the assembling process.
.TP
.I "rasm -c bnail.mygrid"
Assemble routing tables from the boot schema file `bnail.mygrid' and
store the result in the route file `route.mygrid'.
.SH FILES
.TP 38
$TROLLIUSHOME/boot/bnail.def
default boot schema file
.TP
$TROLLIUSHOME/boot/route.def
default route file
.SH SEE ALSO
map(l), nail(l)
