.TH RBTFLUSH l "March 16, 1992" "Release 2.2" "TROLLIUS REMOTE LIBRARY"
.SH NAME
rbtflush \- Flush Trollius boot objects from a remote ITB node.
.SH SYNOPSIS
.nf
#include <bootreq.h>
.PP
int rbtflush (int node, int object);
.fi
.SH DESCRIPTION
The function
.I rbtflush()
removes boot objects from a remote ITB node, freeing the memory they
occupy.
The first argument supplies the remote ITB node identifier.
The second argument selects the boot objects to remove.
Multiple objects may be selected from the following list:
.TP 12
BTO_STRAP
The strap object is the moses(l) bootstrap.
.TP
BTO_STAGE
The stage object is the process schema.
.TP
BTO_FROZEN
The frozen object is the frozen process schema.
.TP
BTO_ROUTE
The route object is the combination of route tables for all nodes
in the multicomputer.
.PP
The object masks are defined in <bootreq.h>.
.SH "RETURN VALUE"
.PP
Upon successful completion, 0 is returned.
Otherwise \-1 is returned and the global variable
.I errno
is set to indicate the error.
.SH ERRORS
.TP 12
[EINVAL]
The
.I object
argument is invalid.
.PP
This function may also return any of the error codes applicable
to nsend(l) or nrecv(l).
.SH "SEE ALSO"
vboot(l)
