.TH RBTSPREAD l "March 16, 1992" "Release 2.2" "TROLLIUS REMOTE LIBRARY"
.SH NAME
rbtspread \- Recursively boot multiple Trollius ITB nodes.
.SH SYNOPSIS
.nf
#include <bootreq.h>
.PP
int rbtspread (int node, int object);
.fi
.SH DESCRIPTION
Parallel recursive booting is the most efficient way of booting
Trollius on a multicomputer.
The map(l) topology tool determines a boot tree with the origin
node as its root.
In any node's route table, the boot children nodes have the node
type NT_BOOT.
With this knowledge, the ITB nodes of the boot tree can be
booted recursively, or `spread', using the boot (see rbtboot(l))
and stage (see rbtstage(l)) capabilities of the remote boot daemon.
.PP
The spread can start from any ITB node, given as the first argument to
.I rbtspread(),
and will continue until all of the starting node's children have
been booted.
Child nodes are booted sequentially but they recurse in parallel.
Throughout the spread, the strap and route boot objects will be
booted and staged.
From the children of the starting node through to the leaves,
the spawn object will be booted (see rbtboot(l)).
The caller of
.I rbtspread()
chooses one of the following three objects to boot from the starting
node only:
.TP 12
BTO_STAGE
The stage object is the process schema.
.TP
BTO_FROZEN
The frozen object is the frozen process schema.
.TP
BTO_SPAWN
The spawn object is the table of programs running on the starting node.
.PP
The object masks are defined in <bootreq.h>.
If BTO_STAGE or BTO_FROZEN are chosen, they are assumed to have
been previously loaded on the starting node.
.SH "RETURN VALUE"
Upon successful completion, 0 is returned.
Otherwise \-1 is returned and the global variable
.I errno
is set to indicate the error.
.SH ERRORS
.TP 20
[ENOBOOTSTRAP]
The strap object is not present on the starting node.
.TP
[EINVAL]
The
.I object
argument is invalid.
.PP
This function may also return any of the error codes applicable
to nsend(l) or nrecv(l).
.SH "SEE ALSO"
rbtboot(l), rbtstage(l), vboot(l)
