.TH RBTSTAGE l "March 16, 1992" "Release 2.2" "TROLLIUS REMOTE LIBRARY"
.SH NAME
rbtstage \- Load Trollius boot objects from and to remote nodes.
.SH SYNOPSIS
.nf
#include <bootreq.h>
.PP
int rbtstage (int source, int object, int destination);
.fi
.SH DESCRIPTION
The function
.I rbtstage()
copies boot objects between ITB nodes.
It is typically used to load a newly booted ITB node with objects
from the closest available source - its neighbour that just booted it.
The newly booted node can then use the objects to boot its
unbooted neighbours.
The first argument to
.I rbtstage()
is the source node and the last argument is the destination node.
.PP
Multiple objects may be staged by a single call to
.I rbtstage().
The
.I object
argument is a bit field and the following objects, defined in
<bootreq.h>, can be staged.
.TP 12
BTO_STRAP
The strap object is the moses(l) bootstrap.
.TP
BTO_STAGE
The stage object (not be confused with the stage operation) is the
process schema.
.TP
BTO_FROZEN
The frozen object is the frozen process schema (see sboot(l)).
.TP
BTO_ROUTE
The route object is the combination of route tables for every
node in the multicomputer.
.SH "RETURN VALUE"
Upon successful completion, 0 is returned.
Otherwise \-1 is returned and the global variable
.I errno
is set to indicate the error.
.SH ERRORS
.TP 20
[ENOBTDESCRIPTORS]
The stage object was selected and the destination node's stage table is full.
.TP
[ENOMEM]
There is not enough memory on the destination node to hold the selected
object(s).
.TP
[EINVAL]
The
.I object
argument is invalid.
.PP
This function may also return any of the error codes applicable
to nsend(l) or nrecv(l).
.SH "SEE ALSO"
vboot(l)
