.TH RBUFFER l "April 7, 1992" "Release 2.2" "TROLLIUS REMOTE LIBRARY"
.SH NAME
rbuffer
\- Control Trollius remote buffers.
.SH SYNOPSIS
.nf
#include <bufreq.h>

int	rbuffer (int node, int request, int param);
.fi
.SH DESCRIPTION
The remote function
.I rbuffer()
sets buffering parameters on the given
.I node.
.I Request
can be set to the following request codes, defined in <bufreq.h>:
.PP
.TP 15
BFWORKER
Set the maximum number of buffer worker processes.
.TP
BFSPACE
Set the maximum size in bytes of the buffer daemon's internal buffer pool.
.TP
BFSWEEP
Sweep clean all existing message buffers.
.TP
BFUSRSPACE
Set the space threshold value that triggers the acceptance or
non-acceptance of user messages (messages with positive events).
.PP
.I Param
is set to the desired maximum number of buffer worker processes, the
desired size of the internal buffer pool, or the user space threshold,
whichever corresponds to the request code.
If the request code is BFSWEEP,
.I param
does not need to be set.
.PP
An
.I rbuffer()
request can be sent to a group of nodes.
The nodes must first be registered as a multicast destination with rcast(l).
The cast identifier can then be used as the
.I node
argument to
.I rbuffer().
.SH "RETURN VALUE"
.PP
.I Rbuffer()
returns 0 if the request was successfully sent to the remote buffer
daemon, which does not reply.
Otherwise, \-1 is returned and the global variable
.I errno
is set to one of the error codes returned by nsend(l).
.SH "SEE ALSO"
buffer(l), rbfstate(l)
