.TH RDRAIN l "April 7, 1992" "Release 2.2" "TROLLIUS REMOTE LIBRARY"
.SH NAME
rdrain \- Dump memory from a remote compute node to a file.
.SH SYNOPSIS
.nf
.ft B
int	rdrain(int src_node, int address, int no_bytes, char *filename);
.fi
.SH DESCRIPTION
The remote layer function
.I rdrain()
copies ("dumps") the contents of a range of memory in
a specified compute node to a file.
Although
.I rdrain()
is the simplest method of writing an array into a file,
it is not the most efficient one, and is mostly used for debugging purposes.
.PP
The parameters passed to
.I rdrain()
are the source node (the node from which memory will be dumped), the memory
address on the source node from which to start dumping, the number of bytes
to dump, and the name of the file in which to save the dump.
If the file does not exist, it is created.
If the file does exists, it is first truncated.
.SH "RETURN VALUE"
Upon successful completion,
.I rdrain()
returns the number of bytes that were dumped.
If an error occurs, \-1 is returned and the global variable
.I errno
is set to indicate the error.
.SH ERRORS
.TP 20
[EBADNODE]
The specified source node does not exist.
