.TH RECHO l "April 7, 1992" "Release 2.2" "TROLLIUS REMOTE LIBRARY"
.SH NAME
recho \- Send message to echo server on remote node.
.SH SYNOPSIS
.nf
.ft B
int	recho (int node, char *src_msg, char *dest_msg, int length);
.fi
.SH DESCRIPTION
The remote function
.I recho()
sends a message to the echo server on a remote node.
The echo server will return the same message.
.I Recho()
is used as a means of testing the state of the Trollius network.
If an
.I recho()
request is successfully served, communications should be clear for message
passing.
.I Recho()
is the remote function equivalent of the user interface command tping(l).
.PP
The parameters passed to
.I recho()
are
.I node,
the destination node identifier;
.I src_msg,
the location in memory where the message to be sent is located;
.I dest_msg,
the location in memory where the returned message is to be stored; and
.I length,
the length in bytes of the message.
.I Length
must not exceed the maximum network message length MAXNMSGLEN, defined in
<net.h> and currently set to 4096 bytes.
.SH "RETURN VALUE"
Upon successful completion,
.I recho()
returns the number of bytes echoed, and the original message is returned in
the location pointed to by
.I dest_msg.
If an error occurred, \-1 is returned and the global variable
.I errno
is set to indicate the error.
.SH ERRORS
.TP 20
[EMSGLEN]
The message length exceeds the maximum message length.
.TP
[EBADNODE]
The node address argument is invalid.
.SH "SEE ALSO"
tping(l)
