.TH RF77 l "April 8, 1992" "Release 2.2" "TROLLIUS C LIBRARY"
.SH NAME
rf77
\- F77 specific file daemon services (Trollius)
.SH SYNOPSIS
.nf
.ft B
#include <freq.h>
.sp
int rf77back(int fd, char format);
int rf77read(int fd, char *buffer, int length, char format);
.fi
.SH DESCRIPTION
.PP
These remote functions support the client's Fortran I/O libraries and operate
on Fortran sequential, record oriented files.
Records in formatted files terminate with the newline character.
Records in unformatted files begin and end with the record length.
.PP
The function
.I rf77back()
moves the file ptr to the beginning of the previous record.
The function
.I rf77read()
reads the next record, up to a maximum length, into a buffer including
the record delimiters described above.
Both functions accept an indication of the type of Fortran file,
either unformated (UNF) or formatted (FMT).
These constants are defined in <freq.h>.
.SH "RETURN VALUE"
Upon successful completion of
.I rf77back()
the value 0 is returned.
Upon successful completion of
.I rf77read()
the full length of the record is returned, even if it exceeds the
maximum length which was read.
If an error occurred with either function, \-1 is returned and the
global variable
.I errno
is set to indicate the type of error.
.SH ERRORS
.PP
Neither function goes to great lengths to detect improperly formed
records in the open file.
.PP
.TP 18
[EBADREC]
The F77 sequential record is improperly formed.
.SH "SEE ALSO"
rfile(l), rfunix(l)
