.TH RFILE l "April 8, 1992" "Release 2.2" "TROLLIUS C LIBRARY"
.SH NAME
rfile
\- Trollius specific file daemon services
.SH SYNOPSIS
.nf
.ft B
#include <freq.h>
.sp
int rfincr(int fd, int amount);
int rfrmfd(int node, int fd);
.fi
.SH DESCRIPTION
.PP
The remote function
.I rfincr()
increments the open count by
.I amount
on the file descriptor,
.I fd.
This is necessary before a descriptor can be passed to one or
more other clients without an associated call to open(2).
It is used by loadgo(l) and generally not used by application programs.
.PP
The remote function
.I rfrmfd()
sweeps clean and removes one or all of a file daemon's open file
descriptors.
The target file daemon is located by
.I node
and
.I fd
indicates the file descriptor handle to be removed.
If
.I fd
is NOTFD, then all open descriptors, except the standard 0, 1 and 2
are removed.
.SH "RETURN VALUE"
Upon successful completion of
.I rfincr()
or
.I rfrmfd()
the value 0 is returned.
If an error occurred, \-1 is returned and the global variable
.I errno
is set to indicate the type of error.
.SH "SEE ALSO"
cubix(l)
