.TH RFLAT l "April 8, 1992" "Release 2.2" "TROLLIUS REMOTE LIBRARY"
.SH NAME
rflat \- Tag and load memory in remote nodes.
.SH SYNOPSIS
.ft B
int	rflat (int node, char *buffer, int ld_length, int ma_length, int tag);
.SH DESCRIPTION
The remote function
.I rflat()
enables a Trollius process to request that a block of memory
be allocated in a specified node, and that the contents of a specified
local buffer be copied into the newly allocated remote block.
.PP
The parameters passed to
.I rflat()
are
.I node,
the identifier of the destination node (the node into which
the buffer will be copied);
.I buffer,
the memory address on the source node from which to copy;
.I ld_length,
the number of bytes to copy (may be 0);
.I ma_length,
the number of bytes to allocate (may be more than the number to copy,
but better not be less...), and an integer
.I tag
with which to mark the newly created remote buffer.
The tag serves as a symbolic name, and is not related to the actual
memory address of the allocated block.
The
.I flat
server remembers the tag.
A later call to rget(l) can retrieve the actual memory address of the block.
.PP
The advantage of using
.I rflat()
instead of rmalloc(l) is that, when used on a group of nodes, the blocks may
each have a different address, but they all share the same
.I tag.
.PP
An
.I rflat()
request may be sent to a group of nodes.
The nodes must first be registered as a multicast destination with rcast(l).
The cast identifier can then be used as the
.I node
argument to
.I rflat().
.SH "RETURN VALUE"
Upon successful completion, 0 is returned.
If an error occurred, \-1 is returned and the global variable
.I errno
is set to indicate the error.
.SH ERRORS
.TP 23
[EBADNODE]
The node address argument is invalid.
.TP
[ENOMEM]
There isn't enough memory available on the remote node to satisfy the request.
.TP
[ENOFLDESCRIPTORS]
The table of memory blocks (kept by the
.I flat
process) is full.
.SH "SEE ALSO"
rget(l), rload(l), rmalloc(l)
