.TH RFSTATE l "April 8, 1992" "Release 2.2" "TROLLIUS C LIBRARY"
.SH NAME
rfstate
\- Report status of remote Trollius file descriptors.
.SH SYNOPSIS
.nf
.ft B
#include <freq.h>
.sp
int rfstate(int node, struct fstate *table, int maxsize);
.fi
.SH DESCRIPTION
The remote function
.I rfstate()
accesses a remote Trollius file daemon and reports
information on all file descriptors on the given node.
In Trollius 2, this will usually be the origin host node.
.PP
The arguments to
.I rfstate()
are:
.I node,
the target node identifier;
.I table,
a pointer to an array of structures where state information will be stored;
and
.I maxsize,
the number of elements in that array.
.PP
Returned information about a file descriptor is stored in a
structure of the type
.I fstate,
defined in <freq.h> with the following fields:
.PP
.RS
.nf
.ta 1i 1.7i 2.5i
int4	fs_tfd;	/* descriptor handle */
int4	fs_tflags;	/* Trollius and Unix status flags */
int4	fs_flow;	/* total amount of I/O */
int4	fs_src_node;	/* last client's node ID */
int4	fs_src_event;	/* last client's pid/event */
int4	fs_ncubix;	/* total # cubix members */
int4	fs_nheard;	/* current # cubix synchronized members */
int4	fs_req;	/* current cubix request */
char	fs_name[24];	/* trailing 24 bytes of file name */
.fi
.DT
.RE
.PP
The
.I fs_tflags
filed contains the original Unix and Trollius open flags as well
as extra status flags added by the file daemon.
See open(2) for information on Unix open flags.
See rfunix(l) for information on Trollius open flags.
The Trollius status flags are defined in <freq.h>
and shown below:
.PP
.RS
.TP 10
FACTIVE
The Trollius file descriptor has an associated open Unix file descriptor.
.TP
FLOCK
The descriptor is permanently FACTIVE.
.RE
.SH "RETURN VALUE"
Upon successful completion of
.I rfstate(),
the number of open file descriptors mananged by the remote file daemon
is returned, and
.I table
points to an array of filled
.I fstate
structures.
The return value will be larger than the number of
.I fstate
structures, if
.I maxsize
was insufficient to hold state information for all
file descriptors.
If an error occurred, \-1 is returned and the global variable
.I errno
is set to one of the error codes returned by nsend(l) or nrecv(l).
.SH "SEE ALSO"
fstate(l), rfunix(l)
