.TH RFUNIX l "April 8, 1992" "Release 2.2" "TROLLIUS C LIBRARY"
.SH NAME
rfunix
\- Trollius UNIX-like remote file service
.SH DESCRIPTION
The remote file daemon, filed, provides UNIX file access to
any client in the Trollius multicomputer.
Some services are Trollius specific (see rfile(l) and cubix(l)).
Most of services mirror local UNIX services and these are
listed below.
.PP
.RS
.nf
.ft B
.ta 1.5i 2.5i
open(2)	open file
close(2)	close file descriptor
read(2)	read input
write(2)	write output
lseek(2)	set or increment position in file
access(2)	check permissions and/or existance of a file
mkdir(2)	create a directory
chdir(2)	change current working directory
fstat(2)	get status on a file descriptor
stat(2)	get status on a file name
dup(2)	duplicate a file descriptor
dup2(2)	duplicate a file descriptor to a specific handle
system(3)	issue a command to sh(1)
rmdir(2)	remove a directory
unlink(2)	remove a file
getwd(3)	get name of current working directory
ftruncate(2)	set open file to specified length
truncate(2)	set named file to specified length
.ft R
.fi
.DT
.RE
.PP
Special flag bits passed to open(2) will invoke special Trollius functionality.
These flags are listed below.
.PP
.RS
.nf
.ft B
.ta 1.5i 2.5i
O_LOCK	lock a file permanently active
O_SINGL	use the CUBIX singular access method
O_MULTI	use the CUBIX multiple access method
O_REUSE	reuse existing open descriptor with same file name
O_1WAY	do not reply to write requests (do not use with CUBIX)
O_DINT	data are integers
O_DFLT	data are single precision reals
O_DDBL	data are double precision reals
.ft R
.fi
.DT
.RE
.PP
An active Trollius file descriptor has an associated open UNIX file descriptor.
Since filed can maintain a limited number of open UNIX files, it
periodically has to close them and reopen them for a different
Trollius file descriptor.
The number of Trollius file descriptors is unlimited, as are the clients
of filed.
Thus, performance problems (like thrashing) may be avoided by locking
certain files in an active state.
Locked Trollius descriptors will maintain their open UNIX descriptors
until closed by the client.
Do not overuse this facility.
.PP
Most of the UNIX-like serivces behave exactly as in UNIX (in fact,
the genuine article is eventually called).
The exception is write(2) when the data size is greater than the Trollius
network message size (as defined in <net.h>).
Such requests have to be packetized.
Filed treats each packet as an individual write request in order
to remain simple and stateless.
Therefore, long writes on asynchronous descriptors are not atomic.
Thanks to the synchronization inherent in the CUBIX access methods,
long writes on a parallel file descriptor are atomic.
.SH BUGS
.PP
When an operation is requested on a slow device, such as a read on a tty,
filed blocks until the operation completes, during which time it can service no other requests.
Slow or blocking operations should be delegated to a worker process.
.SH "SEE ALSO"
fstate(l), rfile(l), cubix(l)
