.TH RGET l "April 8, 1992" "Release 2.2" "TROLLIUS REMOTE LIBRARY"
.SH NAME
rget, rforget \- Find tagged memory in a remote node.
.SH SYNOPSIS
.nf
.ft B
char	*rget (int node, int tag);
char	*rforget (int node, int tag);
.fi
.SH DESCRIPTION
The remote function
.I rget()
enables a Trollius process to retrieve the actual memory address
in a remote node that was given a symbolic
.I tag
during an earlier call to rflat(l).
The function
.I rforget()
does the same, and also removes that tag from the tables kept by the
.I flat
server in the remote node.
The latter function should be used if the symbolic tag will not be
used again, to avoid overflow of the associated tables.
To release the memory block itself, pass the address to rfree(l).
.PP
The parameters passed to
.I rget()
and
.I rforget()
are
.I node,
the identifier of the destination node (the node on which
a buffer is tagged), and an integer
.I tag
which marks the remote buffer.
.SH "RETURN VALUE"
Upon successful completion, the actual address of the remote buffer
is returned.
If an error occurred, \-1 is returned and the global variable
.I errno
is set to indicate the error.
.SH ERRORS
.TP 16
[EBADNODE]
The node address argument is invalid.
.TP
[EBADTAG]
The tag is unknown.
.SH "SEE ALSO"
rflat(l), rload(l), rmalloc(l)
