.TH RLOAD l "April 8, 1992" "Release 2.2" "TROLLIUS REMOTE LIBRARY"
.SH NAME
rload \- Load a file onto remote ITB nodes.
.SH SYNOPSIS
.nf
.ft B
int	rload(int src_node, int dest_node, int tag, char *filename);
.fi
.SH DESCRIPTION
The remote function
.I rload()
loads any file onto an ITB (compute) node or group of ITB nodes.
The file is normally a relocatable load module, and in that
case it is processed to make it ready to run.
To create a running process from the
loaded module, it is necessary to call rflat(l), then rcreate(l).
.PP
.I Rload()
is rarely used directly.
It is a component of the remote function rloadgo(l), which loads an object
module and creates a new running process.
.PP
The parameters passed to
.I rload()
are:
.I src_node,
the node on which the file resides;
.I dest_node,
the node which the file is to be loaded onto;
.I tag,
the symbolic integer through which the allocated block of memory will
be referenced in later calls to rget(l), rforget(l), or rcreate(l); and
.I filename,
the name of the file to load.
.I Tag
can be set to any arbitrary integer.
.PP
An
.I rload()
request can be sent to a group of nodes.
The nodes must first be registered as a multicast destination with rcast(l).
The cast identifier can then be used as the
.I dest_node
argument to
.I rload().
.SH "RETURN VALUE"
Upon successful completion, 0 is returned.
Otherwise, \-1 is returned and the global variable
.I errno
is set to indicate the error.
.SH ERRORS
.TP 23
[EBADNODE]
A node address argument is invalid.
.TP
[ENOMEM]
There isn't enough memory available on the remote node to satisfy the request.
.TP
[ENOFLDESCRIPTORS]
The table of memory blocks (kept by the
.I flat
process) is full.
.SH "SEE ALSO"
rcreate(l), rflat(l), rloadgo(l)
