.TH RRATTACH l "April 8, 1992" "Release 2.2" "TROLLIUS NETWORK LIBRARY"
.SH NAME
rrattach, rrdetatch \- Register (or de-register) process and node
with Trollius stand-alone router.
.SH SYNOPSIS
.nf
.ft B
int	rrattach (int pid, int node);
int	rrdetach (int pid);
.fi
.SH DESCRIPTION
These are network layer functions, used when emulating a multicomputer
system on the host node.
They are called by the launch(l) command.
.PP
.I Rrattach()
establishes that the process
.I pid
will be simulated as running on the given
.I node.
.I Rrattach()
sends a registration message containing the pair
.I pid
and
.I node
to the local stand-alone route daemon.
The router saves this information in its internal tables.
When a process sends a getnodeid(l) request to the router, the router
returns the node ID corresponding to the pid of the client process.
.PP
.I Rrdetach()
is the reverse of
.I rrattach().
It sends a message containing
.I pid
to the local stand-alone route daemon.
The router searches its internal tables for the given process ID.
If it finds an entry for the supplied
.I pid,
it deletes that entry from its tables.
.SH "RETURN VALUE
Upon successful completion of both
.I rrattach()
and
.I rrdetach(),
0 is returned.
Otherwise, \-1 is returned.
.SH "SEE ALSO"
launch(l)
