.TH RRNODEWAIT l "April 8, 1992" "Release 2.2" "TROLLIUS REMOTE LIBRARY"
.SH NAME
rrnodewait \- wait for specific Trollius routing information.
.SH SYNOPSIS
.nf
.ft B
#include <net.h>

int	rrnodewait (int nodeid, int wait_nodeid);
.fi
.SH DESCRIPTION
This remote layer function blocks the user process calling it until the
remote route daemon on node
.I nodeid
receives routing information pertaining to node
.I wait_nodeid.
.PP
If this information had already been given to the route daemon prior to
the call to
.I rrnodewait(),
the function returns directly, thus allowing the calling process to
continue its execution.
Otherwise, the calling process is blocked until some other process (or the
user) provides the required routing information about node
.I wait_nodeid
to the route daemon on node
.I nodeid.
This information can be provided by calling rsetroute(l), rroute(l)
rcast(l) or using the trout(l) tool.
.PP
Typically,
.I rrnodewait()
is used by the sending processes in a multireel communication setup.
This enables each process to wait till the cast identifier has been registered
with the local route daemon before sending its message to the receiving node.
Note that cast identifiers behave as virtual node identifiers, representing
a group of physical nodes and can thus be used where needed in lieu of a
physical nodeid.
For a detailed explanation on multicasting and multireeling, see rcast(l).
.PP
.SH "RETURN VALUE
Upon successful completion of
.I rrnodewait(),
0 is returned.
Otherwise, \-1 is returned and the global variable
.I errno
is set to indicate the error.
.I Rrnodewait()
has no specific errors of its own, but can incur any of the errors
associated with nsend(l).
.SH "SEE ALSO"
rcast(l), rroute(l), rsetroute(l), trout(l)
