.TH RROUTE l "April 8, 1992" "Release 2.2" "TROLLIUS REMOTE LIBRARY"
.SH NAME
rroute \- Send complete Trollius routing information to router.
.SH SYNOPSIS
.nf
.ft B
#include <rreq.h>
#include <net.h>

int	rroute (int node, struct route *ptable, int ntable);
.fi
.SH DESCRIPTION
This remote layer function sends general network information and a
complete routing table to a remote route daemon on the specified
.I node.
.I Rroute()
accepts a pointer to a table of
.I ntable
valid route structures, defined in <rreq.h>:
.nf

	struct route {
		int	r_nodeid,
			r_event,
			r_event2,
			r_nodetype;
	};

.fi
A completed routing table should contain one entry for every node
in the Trollius multicomputer.
A single route entry states that for a message originating from,
or forwarded through, the node identified by the
.I node
argument of
.I rroute(),
which is bound for a destination node
.I r_nodeid
of node type
.I r_nodetype,
the forwarding process will synchronize on
.I r_event.
The
.I r_event2
entry is used by the multicasting daemon (castd) to forward its messages
along specially optimized paths.
.PP
Node type is a bit field made up of the following values defined in <net.h>.
.PP
.TP 10
NT_ITB
This is an ITB (compute) node.
If this bit is not present, it is an OTB node.
.TP
NT_CAST
This in a multicast node destination.
.TP
NT_WASTE
This node is not normally used to run programs.
.TP
NT_DISK
This node has an attached disk.
.TP
NT_TUBE
This node has an attached display tube.
.TP
NT_JONES
This is a neighbor node.
.TP
NT_BOOT
This is a neighbor node that that
.I node
is responsible for booting.
.PP
If the route daemon wishes to indicate that a particular destination node
is an error condition, the
.I r_event
and
.I r_event2
fields for that destination can be set to NOTEVENT (defined in
<events.h>) and the
.I r_nodetype
field can be set to NT_ERROR (defined in <net.h>).
.SH "RETURN VALUE
Upon successful completion of
.I rroute(),
0 is returned.
Otherwise \-1 is returned and the global variable
.I errno
is set to indicate the error.
.I Rroute()
has no specific errors of its own, but can incur any of the errors
associated with nsend(l).
.SH "SEE ALSO"
getroute(l)
