.TH RSETNET l "April 8, 1992" "Release 2.2" "TROLLIUS REMOTE LIBRARY"
.SH NAME
rsetnet \- Send Trollius network information to a router.
.SH SYNOPSIS
.nf
.ft B
#include <net.h>

int	rsetnet (int node, struct net_info *nodes);
.fi
.SH DESCRIPTION
This remote layer function sends network information to a remote
route daemon on the specified
.I node.
.I Rsetnet()
is called by trout(l), which reads and ships routing information
during the course of booting with spread(l).
.PP
.I Rsetnet()
accepts a pointer to a valid net_info structure, defined in <net.h>:
.nf

	struct net_info {
		int	ni_nodeid;
		int	ni_nodetype;
		int	ni_origin;
	};

.fi
The fields in the structure hold, in order:
the remote node identifier, the remote node type, and the identifier
of the origin node from which the Trollius multicomputer was booted.
The node type is a bit field contained one or more or the bits
defined in <net.h> and described in rroute(l).
.SH "RETURN VALUE
Upon successful completion of
.I rsetnet(),
0 is returned.
Otherwise, \-1 is returned and the global variable
.I errno
is set to indicate the error.
.I Rsetnet()
has no specific errors of its own, but can incur any of
the errors associated with nsend(l).
.SH "SEE ALSO"
getnet(l), rroute(l), trout(l)
