.TH RSETROUTE l "April 8, 1992" "Release 2.2" "TROLLIUS REMOTE LIBRARY"
.SH NAME
rsetroute, rremroute \- Set or remove Trollius routing information.
.SH SYNOPSIS
.nf
.ft B
#include <net.h>

.if t int	rsetroute (int node, int dest_node, int dest_event, int dest_event2, int dest_type);
.if t int	rremroute (int node, int dest_node);
.if n int	rsetroute (int node, int dest_node, int dest_event,
.if n			int dest_event2, int dest_type);
.if nint	rremroute (int node, int dest_node);
.fi
.SH DESCRIPTION
.I Rsetroute(),
a remote layer function, sends new information about a single route
to a remote route daemon.
The
.I node
argument identifies the remote node running the desired route daemon.
.I Dest_node, dest_event, dest_event2
and
.I dest_type
become a new (or updated) entry in that route daemon's routing table.
In the future, all messages passing through, or originating from
.I node,
bound for
.I dest_node
of type
.I dest_type
will be forwarded to a process synchronizing on
.I dest_event.
The
.I dest_event2
entry is used by the multicasting daemon (castd) to forward its messages
along specially optimized paths.
.PP
.I Dest_event
and
.I dest_event2
are usually the event numbers of link processes, identified in <events.h>.
.I Dest_event
can also be set to a multicast event.
.I Dest_type
is a bit field containing one or more of the bits defined in <net.h>
and described in rroute(l).
.PP
.I
Rremroute()
removes the route table entry associated with
.I
dest_node.
.SH "RETURN VALUE
Upon successful completion of
.I rsetroute()
or
.I rremroute(),
0 is returned.
Otherwise, \-1 is returned and the global variable
.I errno
is set to indicate the error.
.I Rsetroute()
and
.I rremroute()
have no specific errors of their own, but can incur any of the errors
associated with nsend(l).
.SH "SEE ALSO"
getroute(l), rroute(l)
