.TH SBOOT l  "January 4, 1992" "Release 2.2" "TROLLIUS TOOLS"
.SH NAME
sboot \- Boot multiple programs on a neighbour ITB node.  (Trollius)
.SH SYNTAX
.B sboot
[-bdhrvxzNRVZ] [-c <conf>] [-f <device>] [-i <frozen>]
.br
[-T <topology>]
.SH OPTIONS
.TP 15
.B \-b
Skip the boot step.
.TP
.B \-c <conf>
Use <conf> as the process schema file.
.TP
.B \-d
Turn on debugging mode.
.TP
.B \-f <device>
Use <device> for the reset, export and boot steps.
.TP
.B \-h
Print useful information on this tool.
.TP
.B \-i <frozen>
Use <frozen> as the frozen boot file.
.TP
.B \-r
Skip the reset step.
.TP
.B \-v
Be verbose.
.TP
.B \-x
Skip the export step.
.TP
.B \-z
Perform a frozen boot.
.TP
.B \-N
`Pretend' - skip all steps.
.TP
.B \-R
Maintain bootstrap control after booting.
.TP
.B \-T <topology>
Use <topology> to redefine the topology variable in the process schema
(see conf(l)).
.TP
.B \-V
Format and print the process schema.
.TP
.B \-Z
Produce a frozen boot file (does not boot node).
.SH DESCRIPTION
.PP
.I Sboot
boots up multiple programs on an ITB node which is immediately
accessible (adjacent, in a topology sense) to the host node.
.I Sboot
is part of the booting sequence initiated by spread(l), where it is called
after hboot(l).
.I Sboot
can be used to boot any system of processes.
It is not restricted to booting Trollius.
.PP
.I Sboot
has a three step procedure to run processes on an adjacent ITB node.
First, the node is reset using the system dependent tool tfish(l).
Second, the bootstrap loader, moses(l), is exported to the node using the
export(l) tool.
Moses(l) is an ITB node executable program and is considered part of
the Trollius toolkit layer.
Finally, each program named in the process schema
is booted by invoking the cboot(l) tools with the proper options.
The first invocation of cboot for the first program in the process
schema starts at a fixed address.
.I Sboot
uses the -m feature of cboot(l) to read back, through a pipe,
the next free memory location or the base address for the next program.
.PP
A process schema is a description of the processes
which constitute the operating system on any given node.
Naturally, the process schema used by
.I sboot
should be the one that describes Trollius on an ITB node.
The grammar of the process schema is described in conf(l).
.SH FROZEN BOOTING
.PP
.I Sboot
has two special options,
.I \-Z
and
.I \-z,
that can be used to provide for a faster, yet less flexible boot.
.I Sboot
used with the
.I \-Z
option does not boot a node, instead it prepares a special file that can be
used later in an actual
.I sboot
using the
.I \-z
option.
.PP
Specifically,
.I "sboot \-Z"
bypasses the reset and export steps, and
redirects the output of the cboot(l) invocations to an ordinary data file,
instead of sending it to the device file representing the communication
link to the attach ITB node.
Thus, the process schema is parsed and translated to booting commands
and data, which are saved but not executed.
The file thus created is called a frozen boot file or
a frozen process schema.
A default frozen boot file is maintained by the system administrator.
.PP
.I "Sboot -z"
executes the reset and export steps, then invokes thaw(l) to boot the node
using the frozen boot file.
The process schema is not read and
.I sboot
does not incur the overhead of parsing, and individual booting steps.
Thaw(l) simply copies the frozen file to the device file.
The
.I \-i
option can be used to specify a specific frozen boot file, otherwise the
default file will be used.
.SH EXAMPLES
.TP 4
.I sboot -vz
Boot Trollius on the default ITB node with the default frozen boot file.
Report about every step as it is done.
.TP
.I "sboot -c myconfig -f test"
Boot the ITB node accessed through the device file `test' with the custom
process schema `myconfig'.
.SH FILES
.TP 4
$TROLLIUSHOME/boot/conf.isb
default process schema for device connected ITB nodes
.TP
$TROLLIUSHOME/boot/conf.isbz
default frozen boot file for device connected ITB nodes
.SH DIAGNOSTICS
If a particular configuration file, frozen or not, contains programs which
either do not work or do not work together,
.I sboot
may fail since moses(l) may be clobbered.
The only recourse is to use tfish(l) to reset the node.
.SH SEE ALSO
cboot(l), conf(l), export(l), hboot(l), spread(l), thaw(l)
