.TH SPAWN l  "April 8, 1992" "Release 2.2" "TROLLIUS COMMANDS"
.SH NAME
spawn \- Spawn (replicate) Trollius processes on compute nodes.
.SH SYNTAX
.B spawn
[-hv] <source node> [<dest node>] [<process(es)>] [-- <args>]
.SH OPTIONS
.TP 11
.B \-h
Print useful information on this command.
.TP
.B \-v
Turn on verbose mode.
.TP
.B -- <args>
Pass these runtime arguments to every new process.
This must always be the last argument to
.I spawn.
.SH DESCRIPTION
.I Spawn
is a Trollius command that replicates an existing compute node process or
processes.
Spawned processes execute on the local node, unless the
.I <dest node>
argument is used to specify a remote compute node.
Processes cannot be spawned to or from the host.
.PP
Source and destination nodes are specified as
.I n<identifier>.
Identifiers are established in the Boot Schema (see (nail(l)),
and may be written in decimal and/or hexadecimal notation.
.PP
If no processes are specified on the command line, all processes on that
node will be spawned.
Processes can be specified in several ways, a mixture of which may be
used on the command line.
They are:
.PP
%<index_list>	by the index printed in brackets by state(l)
.PP
#<event_list>	by the event on which they are blocked
.if n		 	(reported by state(l))
.if t (reported by state(l))
.PP
@<loadpt_list>	by load module address (obtained with \-l
.if n 			option from state(l))
.if t option from state(l))
.PP
p<pid_list>	by process identifier (reported by state(l))
.PP
.I Spawn
(unlike loadgo(l))
does not wait for the replicated processes to complete before returning.
A spawned process executes from the beginning of the main program.
The exit status of a spawned process is discarded.
.PP
A local
.I spawn
shares the code, but replicates the current data/bss segment, of the
existing process.
A remote
.I spawn
copies the entire program (code + data/bss) to the remote node.
In both cases,
all static data initialized to pointers will be initialized once again.
All other static data values (including simple initialized data) are
inherited from the parent process at the time of the
.I spawn.
This can lead to differences in results between the
original and the replicate process.
A new stack is allocated with the stack size equal to that of the
original process.
If arguments are given, they are passed to the new process.
Otherwise, the existing arguments are used.
.SH EXAMPLES
.TP 4
.I "spawn n0 n7 %1"
Spawn process index 1 on node 0 to node 7.
.SH BUGS
If a spawned local process is again spawned, the original parent's
data/bss segment is used.
.SH SEE ALSO
loadgo(l)
