.TH SPREAD l  "April 8, 1992" "Release 2.2" "TROLLIUS TOOLS"
.SH NAME
spread \- Boot Trollius on a multicomputer.
.SH SYNTAX
.B spread
[-dehtvzHNV] [-c <bnail>] [-n <node>] [-p <route>] [-T <topology>]
.br
.SH OPTIONS
.TP 11
.B \-c <bnail>
Use
.I bnail
as the Boot Schema file.
.TP
.B \-d
Turn on debugging mode.
.TP
.B \-e
Boot the system recursively.
.TP
.B \-h
Print useful information on this tool.
.TP
.B \-n <node>
Boot only the given
.I node.
.TP
.B \-p <route>
Use
.I route
as the route file.
.TP
.B \-t
Do not ship routing tables.
.TP
.B \-v
Turn on verbose mode.
.TP
.B \-z
Use the frozen boot file to load.
.TP
.B \-H
Do not display the tool header.
.TP
.B \-N
`pretend' - Skip all steps.
.TP
.B \-T <topology>
Override device names for given links specified in the Boot Schema.
.TP
.B \-V
Format and print the Boot Schema file.
.SH DESCRIPTION
.I Spread
is the topology tool that boots Trollius on the nodes of a multicomputer system.
It invokes hboot(l), sboot(l), vboot(l) and trout(l) as indicated by
the topology of the Boot Schema.
.PP
.I Spread
employs a four step procedure that first generates a spanning tree for the
multicomputer system described in the Boot Schema.
The spanning tree has the host node at its root and specifies the order
in which the network of processors are to be booted.
Due to deficiencies in many device drivers,
.I spread
invokes sboot(l) for each compute node that is a direct neighbor of
(adjacent to, in a topology sense) the host node, before using hboot(l)
to boot the true root of the spanning tree.
In the last step, vboot(l) starts all remaining compute nodes.
In this last step, if the
.I \-e
option is given, the remaining compute nodes boot each other recursively
with no interference from the host.
If the
.I \-e
option is not given, the host will orchestrate the booting of all remaining
compute nodes in a sequential manner.
The recursive booting method is significantly faster especially on large
multicomputers.
As nodes are booted,
trout(l) is invoked to send each node its individual routing table and
topology information.
.PP
.I Spread
uses several files to boot the system:  a boot schema file,
a route file, and three configuration files:  one for the
host node, one for the device connected compute nodes and one for the
remaining compute nodes.
A configuration file is a description of the processes
which constitute the operating system on a particular type of node.
In general, the system administrator maintains the appropriate files to boot
different topologies.
It is also possible for the user to write boot schemata (see nail(l)) and
configuration files (see conf(l)).
Route files are generated from the boot schema using the
map(l) or rasm(l) tools.
.PP
A boot schema (or bnail file) is a description of a bootable multicomputer
system, specifying all physical nodes and the links that connect them.
Optionally, it may contain further information on how to generate
a route file and how to assign Trollius compute nodes to actual available
hardware.
The route file contains the routing tables and general information about
the topology.
There is a one to one correspondence between a boot schema and a route
file just as with a source program written in Fortran or C and its object file.
An appropriate route file must exist before invoking
.I spread.
.I Spread
will not generate the routing tables from the boot schema.
Unless overridden by the
.I \-p
option, the route filename is assumed to be "route" appended by the identical
suffix (if any) of the boot schema filename.
.PP
Often, various boot schemata differ only in the name of the device(s)
connecting the host node to the compute node(s).
Instead of requiring a separate boot schema, the varying names in
the TLINK tuples (see nail(l)) can be overridden by a series of
linkname/linknum pairs given as a single argument after the
.I \-T
option.
Note that this does not affect the TSOLDER tuples of the boot
schema which are used to reconfigure the physical links to the
correct nodes (see solder(l)).
.SH EXAMPLES
.TP 4
.I "spread -ev"
Recursively boot Trollius on the nodes of the multicomputer system described
in the default boot schema.
Ship the routing tables defined in the default route file.
Report about important steps as they are done.
.TP
.I "spread -c bnail.mytorus"
Boot Trollius on the nodes of the multicomputer system described in
the boot schema `bnail.mytorus', using the route file `route.mytorus'.
.TP
.I
spread -T "/dev/link/1 0"
Boot Trollius on the nodes of the multicomputer system described in
the default boot schema.
Trollius link 0 on the host node is assigned to "/dev/link/1".
.SH FILES
.TP 38
$TROLLIUSHOME/boot/bnail.def
default boot schema file
.TP
$TROLLIUSHOME/boot/route.def
default route file
.TP
$TROLLIUSHOME/boot/conf.otb
default configuration file for OTB (host) nodes
.TP
$TROLLIUSHOME/boot/conf.isb
default configuration file for device connected ITB (compute) nodes
.TP
$TROLLIUSHOME/boot/conf.ivb
default configuration file for remaining ITB (compute) nodes
.TP
$TROLLIUSHOME/boot/conf.isbz
default frozen boot file for device connected ITB nodes
.TP
$TROLLIUSHOME/boot/conf.ivbz
default frozen boot file for remaining ITB nodes
.SH BUGS
.PP
During its operation,
.I spread
spawns many child processes on the local host node.
If a keyboard interrupt or stop signal is given to
.I spread
before it completes, the same signal is delivered to all of its
child processes, including the Trollius system process started by hboot(l).
Unfortunately, the Trollius system processes terminate upon receipt
of the keyboard stop (usually ^Z).
Thus, stopping
.I spread
does not have the desired effect.
Interrupting
.I spread
from the keyboard (usually ^C) will terminate all processes associated
with Trollius.
Neither the stop nor the interrupt will remove the lock file created
by hboot(l) and a subsequent tkill(l) will print a harmless but annoying
message to the effect of "no such process".
.SH SEE ALSO
hboot(l), nail(l), sboot(l), trout(l), vboot(l)
