.TH STATE l  "April 8, 1992" "Release 2.2" "TROLLIUS COMMANDS"
.SH NAME
state \- report status of Trollius processes
.SH SYNTAX
.B state
[-ghlt] <node(s)> [<process(es)>]
.SH OPTIONS
.TP 8
.B \-g
Print information on system and application processes.
.TP
.B \-h
Print useful information on this command.
.TP
.B \-l
Print information on load addresses.
.TP
.B \-t
Print information on system processes only.
.SH DESCRIPTION
.I State
displays information on Trollius processes.
.PP
The node(s) on which the processes to be stated are running must be specified.
The host node is identified as
.I h.
Compute nodes are identified as
.I n<list>,
where <list> can be a single node identifier or a list of node
identifiers.
Node identifiers are established in the Boot Schema (see nail(l)), and
can be written in decimal and/or hexadecimal notation.
.PP
If compute nodes are selected, and
no processes are specified on the command line, state information will be
returned for all qualifying processes on the given compute nodes.
Processes running on compute nodes can be identified in several ways, a
mixture of which may be used.
They are:
.PP
%<index_list>	by the process index
.PP
#<event_list>	by the event on which they are blocked
.PP
@<loadpt_list>	by load module address
.PP
p<pid_list>	by process identifier
.PP
If the host node is selected, the processes to be stated
.B must
be specified.
They may only be identified as
.I p<pid_list>.
.SH "STATE INFORMATION"
If a compute node is specified on the command line,
.I state
collects information from the kenya daemon and from the kernal via
kstate(l).
If no process is specified, and the
.I \-g
or
.I \-t
options are not used,
all application processes started with
loadgo(l), rloadgo(l), rcreate(l) or attached by rpattach(l) will be stated.
The
.I \-g
option displays information on all system and application
processes known to the kenya daemon.
The
.I \-t
option displays information on all system processes known to the kenya daemon.
.PP
When a compute node is specified without the '-l' option,
.I state
displays node, process index, process identifier,
priority, execution state, current or last blocked event and type (given in
parentheses, or not printed if never blocked), and program name.
When a compute node and the '-l' option are specified,
.I state
displays node, process index, stack address, data segment address, load module
address (text begins at 32 bytes past this address), pending signals, and
program name.
.PP
The execution state will be one of the following:
.TP 10
RM
ready, having completed a call to ksend(l) or krecv(l), also seen
as "R"
.TP
RS
ready, having completed a call to kstate(l)
.TP
RE
ready, having encountered an error on a kernel request
.TP
RA
ready, having completed a call to kattach(l)
.TP
R
ready, having completed a call to kdetach(l), kdoom(l), ksend(l) or krecv(l)
.TP
BS
blocked sending a message to an event
.TP
BR
blocked receiving a message from an event
.TP
A
active - not under Trollius kernel control
.TP
F
free - not attached to Trollius kernel (this applies to non-Trollius
processes that are known to the kenya daemon)
.PP
If the host node is specified, only information from kstate(l) is reported.
This includes node, process index, process identifier, priority, and execution
state.
The only information returned by the
.I \-l
option is process index and pending signals.
The
.I \-g
and
.I \-t
options do not work for the host node.
.SH EXAMPLES
.TP 4
.I state n12
Display the status of all processes on node 12.
.TP
.I state n0-7 #47
Report any processes blocked on event 47 on nodes 0 through 7.
.SH DIAGNOSTICS
If no processes are found, only the title line is displayed.
.SH SEE ALSO
kstate(l), rstate(l)
