.TH THAW l  "January 4, 1992" "Release 2.2" "TROLLIUS TOOLS"
.SH NAME
thaw \- Load a frozen process schema into a device connected ITB node.
(Trollius)
.SH SYNTAX
.B thaw
[-hv] [-i <frozen>] [-o <device>] [<device> <frozen>]
.SH OPTIONS
.TP 15
.B \-h
Print useful information on this tool.
.TP
.B \-i <frozen>
Use <frozen> as the frozen process schema file.
.TP
.B \-o <device>
Use <device> as the output file.
.TP
.B \-v
Be verbose.
.SH DESCRIPTION
.PP
.I Thaw
loads a frozen process schema on a device connected ITB node
running the moses(l) bootstrap.
This is accomplished by simply copying the input to the output device.
The node should be reset with tfish(l) and booted with export(l).
.PP
A frozen process schema consists of executable programs listed
in a related process schema and the moses(l) commands necessary
to load and execute the programs.
Frozen schemata are created with sboot(l) by diverting the output
of cboot(l) to ordinary files rather than an ITB node link device.
.PP
There are three ways of specifying the input and output files.
.sp
.nf
	1% thaw <device> <frozen>
	2% thaw -i <frozen> -o <device>
	3% thaw < <frozen> > <device>
.fi
.LP
The first method is compatible with older versions of thaw(l).
The second method is easier to remember while the third method
permits \fIthaw\fR to be used in a pipeline.
.SH DIAGNOSTICS
.I Thaw
will fail if it cannot open either the input or output file.
.SH "SEE ALSO"
cboot(l), export(l), conf(l), moses(l), sboot(l)
