.TH TKILL l  "January 22, 1992" "Release 2.2" "TROLLIUS TOOLS"
.SH NAME
tkill, sakill \- Terminate Trollius on a host node.
.SH SYNTAX
.B tkill
[-dhvN] [-f <userid>]
.br
.B sakill
[-dhvN] [-f <userid>]
.SH OPTIONS
.TP 15
.B \-d
Turn on debugging mode.
.TP
.B \-f <userid>
Kill another user's Trollius session.
.TP
.B \-v
Be verbose.
.TP
.B \-N
Be verbose.
.SH DESCRIPTION
.I Tkill
terminates a Trollius session started by hboot(l).
.I Sakill
is a wrapper for
.I tkill
that terminates a Stand-alone version of Trollius started by saboot(l).
.I Tkill
makes use of a kill file created by the Trollius OTB kernel, which contains
the process identifiers of every Trollius process, past and present,
in ASCII format.
A SIGTERM (see signal(3)) signal is sent to every process listed
in the kill file.
.I Tkill
waits a short period of time for each process to die.
By adding the verbose option, the user can see the final disposition
of each process.
The mission is accomplished if all processes end up dead.
.SH "USER CONFLICTS"
.PP
Occasionally, a user may log out without invoking
.I tkill,
thus neglecting to release resources needed by other users.
In this situation only, the
.I -f
option can direct
.I tkill
to kill another user's Trollius session.
This functionality must be enabled by the system administrator.
(See the "Trollius Installation Guide".)
The assassinated user will be automatically notified by email.
.PP
For Trollius systems, the first process to be killed is always the kernel.
When the Trollius OTB kernel receives its termination signal, it propagates
the signal to all of its constituent processes.
Therefore,
.I tkill
will ordinarily be racing the kernel to kill all other processes.
The redundant feature of
.I tkill
allows it to be used as a general purpose tool in association with hboot(l).
.SH FILES
.TP 4
$TROLLIUSHOME/locks/$USER
the kill file, created by the kernel, where $USER is the userid and
$TROLLIUSHOME is the installation directory
.SH "SEE ALSO"
hboot(l)
