.TH TPING l  "March 4, 1991" "Release 2.2" "TROLLIUS COMMANDS"
.SH NAME
tping \- send echo messages to a Trollius node and report statistics
.SH SYNTAX
.B tping
[-hv] [-c <count>] [-d <delay>] [-l <length>] <node>
.SH OPTIONS
.TP 12
.B \-c <count>
Send
.I count
messages.
.TP
.B \-d <delay>
Set time between messages to
.I delay
seconds.
.TP
.B \-h
Print useful information on this command.
.TP
.B \-l <length>
Set message length to
.I length
bytes.
.TP
.B \-v
Turn OFF verbose mode.
.SH DESCRIPTION
.I Tping
is a Trollius command that sends messages to, and collects replies from,
a given node, via the Trollius echo server.
.I Tping
is similar to the UNIX ping(8) command,
and is a tool through which the state of the Trollius network
can be diagnosed.
.PP
Unless options are specified,
.I tping
sends a 1 byte message an infinite number of times,
displaying the roundtrip time of each message as it completes,
with a delay of 1 second between roundtrips.
After the loop is broken (with control sequence termination, eg: ^C),
.I tping
prints statistics about the group of roundtrip messages.
.PP
Either one destination node may be specified, or the echo message may be sent
(multicasted) to a class of nodes.
The host node is specified as
.I h.
Compute nodes are specified as
.I n<identifier>.
Identifiers are established in the Boot Schema (see nail(l)), and may be
written in decimal or hexadecimal notation.
The echo message may be multicasted
to all nodes, all compute nodes, or all host nodes by specifying
.I <node>
as
.I N, C,
or
.I H,
respectively.
In the case of a multicast,
.I tping
reports the amount of time taken for
all the qualifying nodes to receive and reply to the message.
.SH EXAMPLES
.TP 4
.I tping h
Echo messages to the local host node.
.TP
.I "tping -v n7 -l 1000 -c 10"
Echo 1000 byte messages to node 7.
Stay silent while working.
Stop after 10 roundtrips and report statistics.
.SH BUGS
.I Tping
has no built-in timeout and will wait forever to receive an echo.
If no echo is received, due to a dead link or node,
.I tping
hangs.
Stop the process with a control sequence (eg: ^Z) and use kill(1) or
tkill(l) to terminate it.
