.TH TROUT l  "April 8, 1992" "Release 2.2" "TROLLIUS COMMANDS"
.SH NAME
trout \- Read and ship route tables to Trollius nodes.
.SH SYNTAX
.B trout
[-dehtvNV][-p <route>] <node(s)>
.br
.SH OPTIONS
.TP 11
.B \-d
Turn on debugging.
.TP
.B \-e
Load entire route file to ITB destination and inform boot daemon.
.TP
.B \-h
Print useful information on this command.
.TP
.B \-p <route>
Use
.I route
as the route file.
.TP
.B \-t
Ship the general network information, but not the route table.
.TP
.B \-v
Turn on verbose mode.
.TP
.B \-N
`pretend' - Skip all steps.
.TP
.B \-V
Format and print one or all route tables.
.SH DESCRIPTION
.I Trout
is a Trollius command that reads the route tables for the specified
nodes from the route file, and sends them to their respective nodes.
Typically, the route file is generated either by the map(l) tool
or by the rasm(l) tool.
.I Trout
is part of the booting sequence normally initiated with spread(l).
.PP
The host node is identified on the command-line as
.I h.
Compute nodes are identified as
.I n<list>,
where <list> can be a single node identifier or a list of node identifiers.
The identifiers are established in the boot schema (see nail(l)), and may be
written in decimal or hexadecimal notation.
.PP
.I Trout
repeats, for each specified node, the three-step process of reading the
node's route table from the route file, sending the node general network
information including its node identifier using rsetnet(l),
and sending the route table to the router process on the node using rroute(l).
.PP
With the -e option,
.I trout
follows a much different procedure.
It reads the entire route file, loads the entire route file on the
specified ITB nodes and informs the boot daemon, bootd, of their presence.
This feature supports the recursive boot capability of spread(l) and vboot(l).
.SH EXAMPLES
.TP 4
.I "trout -v n3,5,6"
Send their route tables, as established in the default route file,
to nodes 3, 5 and 6.
Report each node number as it is processed.
.TP
.I "trout -e -p myroutes n4"
Send the entire route file named `myroutes' to node 4.
.SH FILES
.TP 39
$TROLLIUSHOME/boot/route.def
default route file
.SH SEE ALSO
map(l), rasm(l), rroute(l), rsetnet(l)
