/*
 *	OSU Research Computing, architects and contractors	Trillium
 *
 *	Copyright 1990 The Ohio State University & Cornell University
 *
 *	GDB
 *
 *	$Log:	bfcreate.c,v $
 * Revision 2.2  92/04/30  14:17:25  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  02:57:23  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:26:00  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:53:34  trillium
 * Homo erectus
 * 
 *
 *	Function:	- Create a buffer worker process.
 *			- otb module
 *
 *	Returns:	- pid of child or ERROR
 */

#include <kio.h>
#include <kreq.h>
#include <typical.h>


/*
 * external functions
 */
extern void		bfworker();
extern int		fork();

/*
 * external variables
 */
struct kio_t		_kio;

/*
 * local variables
 */
static KS_STATE		birth;


int
create()

{
	int		pid;		/* child process ID */


	pid = fork();

	if (pid == ERROR) {
		return(ERROR);
	}

	else if (pid == 0) {
/*
 * I am the child.
 */
		_kio.ki_rtf &= ~RTF_KERNEL;
		bfworker();
	}
/*
 * To ensure proper process structuring, we must poll until the new born
 * process attaches to the kernel.
 */
	while (kstate(pid, &birth)) {
	}

	return(pid);
}
