/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	GDB
 *
 *	$Log:	filed.h,v $
 * Revision 2.2  92/04/30  14:18:35  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.1  92/02/06  10:57:40  gdburns
 * Add backwards link and remove time stamp from internal
 * file descriptor.
 * 
 * Revision 2.1  91/02/27  02:42:07  gdburns
 * Ohio Release
 *
 *	Function:	- general templates and contants used by filed
 */

#ifndef _FILED
#define _FILED

#include <portable.h>

/*
 * Trollius file descriptor
 */
struct fdesc {
	int4		f_tfd;		/* Trollius file descriptor */
	int4		f_fd;		/* Unix file descriptor */
	int4		f_ptr;		/* current pointer within file */
	int4		f_tflags;	/* Trollius peculiar flags */
	int4		f_flags;	/* Unix flags */
	int4		f_flow;		/* total data flow */
	int4		f_count;	/* open count O_REUSE */
	int4		f_src_node;	/* last client's node */
	int4		f_src_event;	/* last client's event */
	char		*f_name;	/* file name */
	int4		f_req;		/* current request (for cubix) */
	int4		f_nheard;	/* # of sync'd cubix members */
	int4		f_ncubix;	/* # of cubix cast members */
	struct cxnode	*f_pcubix;	/* cubix cast array */
	struct fdesc	*f_next;	/* next entry in file desc. list */
	struct fdesc	*f_prev;	/* previous entry in file desc. list */
};

/*
 * nulls
 */
#define FDNULL		((struct fdesc *) 0)
#define CXNULL		((struct cxnode *) 0)
#define FCNULL		((struct fcast *) 0)

/*
 * limits
 */
#define ACTIVEMAX	10		/* filed's open descriptors */

/*
 * codes
 */
#define FMT		'f'		/* formatted F77 file */
#define UFMT		'u'		/* unformatted F77 file */

/*
 * Cubix node
 */
struct cxnode {
	int4		cx_src_node;	/* client node */
	int4		cx_src_event;	/* client event */
	int4		cx_param;	/* must save this request parameter */
#define cx_length	cx_param	/* read/write length */
#define cx_offset	cx_param	/* seek distance */
#define cx_pfd		cx_param	/* async method file descriptor */
#define cx_seq		cx_param	/* new sequence number */
	int4		cx_ret;		/* return value of write() */
	int		cx_errno;
	int		cx_heard;	/* Have we heard from it? */
	int4		cx_new_node;	/* new node ID in sequence */
	int4		cx_new_event;	/* ... and corresponding event number */
};

/*
 * Cubix multicast
 */
struct fcast {
	int4		fc_id;		/* identifier */
	int4		fc_num;		/* # of cast members */
	int4		*fc_members;	/* cast members */
	struct fcast	*fc_next;	/* next entry */
};

#endif
