/*
 *	Cornell Theory Center					Trillium
 *
 *	Copyright 1987 Cornell University
 *
 *	AKP
 *
 *	$Log:	addarg.c,v $
 * Revision 2.2  92/04/30  14:20:49  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  11:28:29  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:31:18  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:56:52  trillium
 * Homo erectus
 * 
 * Revision 1.0  87/12/19  15:04:35  trillium
 * Initial revision
 * 
 *
 *	Two semi-simple routines for extending a dynamically
 *	maintained list of string pointers.
 */

#include <stdio.h>
#include <string.h>

extern char *malloc();
extern char *realloc();



StrCpy(dst, src)
  char **dst, *src;
{
    char *old, *new;

    old = *dst;
    new = malloc((unsigned) strlen(src) + 1);
    if (! new) {
	fprintf(stderr, "StrCpy: no more memory\n");
	exit(1);
    }
    (void) strcpy(new, src);
    *dst = new;

    if (old) free(old);
}



addarg(argc, argv, arg)
  int    *argc;
  char ***argv;
  char   *arg;
{
    char **new, **old;

    old = *argv;
    if (old == (char **) 0) {
	new = (char **) malloc(2 * sizeof(char *));
	if (! new) {
	    fprintf(stderr, "addarg: can't initialize\n");
	    exit(1);
	}
	new[0] = new[1] = (char *) 0;
    }
    else {
	new = (char **) realloc((char *) old,
			(unsigned) (((*argc) + 2) * sizeof(char *)));
	if (! new) {
	    fprintf(stderr, "addarg: Ouch! re-malloc() failed\n");
	    exit(209);
	}
    }

    /* don't look too closely at the following line... */
    StrCpy(&(new[(*argc)]), arg);
    *argc = (*argc) + 1;

    /* null-terminate the pointer list */
    new[*argc] = (char *) 0;
    *argv = new;

}
