/*
 *	OSU Research Computing					Trillium
 *	Copyright 1991 The Ohio State University
 *	GDB
 *
 *	$Log:	pack_argv.c,v $
 * Revision 2.2  92/04/30  14:20:54  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.1  91/12/20  17:30:56  gdburns
 * Allow argc to be zero.
 * 
 * Revision 2.1  91/03/20  11:28:32  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:31:21  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:56:54  trillium
 * Homo erectus
 *
 *	Function:	- pack an argv list into contiguous memory
 *			  and reposition the argv pointers
 *			- new space will be malloced and must
 *			  be freed by the caller
 *			- does not use realloc for a good reason
 *
 *			- based on Trollius 2.0 Copyright 1990
 *			  The Ohio State University and Cornell
 *			  Research Foundation
 *
 *	Accepts:	- argv
 *			- argc
 *			- ptr to total size of new argv structure
 *			  (a value returned parameter)
 *
 *	Returns:	- newly allocated argv
 */

char **
pack_argv(argc, argv, argv_size)

int			argc;
int			*argv_size;		/* total size of argv space */
char			**argv;

{
	int		i;			/* index variable */
	char		*new_argv;		/* ptr to new argv space */
	char		*str_argv;		/* new argv string ptr */
	char		**ptr_argv;		/* new argv ptr ptr */
	char		*malloc();
	char		*strcpy();

	*argv_size = 0;

	for (i = 0; i < argc; ++i) {
		*argv_size += strlen(argv[i]) + 1;
	}

	*argv_size += (argc + 1) * sizeof(char *);
	new_argv = malloc((unsigned) *argv_size);
		
	ptr_argv = (char **) new_argv;
	str_argv = new_argv + ((argc + 1) * sizeof(char *));

	for (i = 0; i < argc; ++i) {
		strcpy(str_argv, *argv);
		*ptr_argv++ = str_argv;
		str_argv += strlen(*argv++) + 1;
	}

	*ptr_argv = (char *) 0;
	return((char **) new_argv);
}
