/*
 *	OSU Research Computing				Trillium
 *	Copyright 1992 Cornell University
 *	AKP/GDB
 *
 *	$Log:	boot.h,v $
 * Revision 2.2  92/04/30  14:23:01  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.2  92/04/27  12:04:25  gdburns
 * Remove DEFFSTRAP.
 * 
 * Revision 2.1.1.1  92/02/23  22:21:38  gdburns
 * toolkit layer overhaul
 * 
 * Revision 2.1  91/03/20  11:30:04  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.3  90/09/11  14:11:23  gdburns
 * Remove non-portable device names to machine/machine.h.
 * 
 * Revision 2.0.1.2  90/08/23  15:02:27  raja
 * Made the file names of the sboot and vboot default config files different.
 * 
 * Revision 2.0.1.1  90/07/13  19:30:34  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:56:26  trillium
 * Homo erectus
 * 
 *	Function:	- constants associated with booting
 *
 *			- based on Trollius 2.0 Copyright 1990
 *			  The Ohio State University and Cornell
 *			  Research Foundation
 */

#ifndef _BOOT
#define _BOOT

/*
 * default search paths
 */
#ifndef DEFPPROGH
#define DEFPPROGH	"/usr/local/trillium/bin/sys"
#endif
#ifndef DEFPPROGS
#define DEFPPROGS	"/usr/local/trillium/itb/bin"
#endif
#ifndef DEFPPROGV
#define DEFPPROGV	"/usr/local/trillium/itb/bin"
#endif
#ifndef DEFPTOOL
#define DEFPTOOL	"/usr/local/trillium/bin"
#endif
#ifndef DEFPLOCK
#define DEFPLOCK	"/usr/local/trillium"
#endif
#ifndef DEFPRESET
#define DEFPRESET	"/usr/local/trillium/locks"
#endif
#ifndef DEFPCONFIG
#define DEFPCONFIG	"/usr/local/trillium/boot"
#endif
#ifndef DEFPROUTE
#define DEFPROUTE	"/usr/local/trillium/boot"
#endif

/*
 * default configuration files
 */
#define DEFFCONFIGH	"conf.otb"
#define DEFFCONFIGS	"conf.isb"
#define DEFFCONFIGV	"conf.ivb"
#define DEFFFROZENS	"conf.isbz"
#define DEFFFROZENV	"conf.ivbz"

/*
 * default tools
 */
#define DEFTRESETH	"tkill"
#define DEFTRESETS	"tfish"
#define DEFTEXPORT	"export"
#define DEFTCBOOT	"cboot"
#define DEFTTHAW	"thaw"

/*
 * miscellaneous constants
 */
#define PRIORITY	1

#endif
