/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	AKP/GDB
 *
 *	$Log:	conf.h,v $
 * Revision 2.2  92/04/30  14:23:13  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.1  92/02/23  22:24:08  gdburns
 * toolkit layer overhaul
 * 
 * Revision 2.1  91/03/20  11:30:05  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.2  90/11/16  15:18:13  raja
 * Change in the configuration of on-chip RAM.
 * 
 * Revision 2.0.1.1  90/07/13  19:30:33  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:56:26  trillium
 * Homo erectus
 *
 *	Function:	- internal representation of a process schema
 *			- built by yyparse()
 *
 *			- based on Trollius 2.0 Copyright 1990
 *			  The Ohio State University and Cornell
 *			  Research Foundation
 */

#ifndef _CONF
#define _CONF

#include <net.h>
#include <portable.h>

/*
 * defaults
 */
#define CNFSTKSIZE	(MAXNMSGLEN + 0x400)
#define CNFPRIORITY	1
#define CNFDELAY	0
#define CNFFLAGS	0

/*
 * one configured program
 */
struct pschema {
	char		**cnf_argv;	/* argv */
	int4		cnf_argc;	/* argc */
	int4		cnf_stksize;	/* stack size */
	int4		cnf_priority;	/* process priority */
	int4		cnf_delay;	/* delay (in seconds) after startup */
	int4		cnf_flags;	/* info bits (from bootreq.h */
	int4		cnf_tag;	/* remote load module tag - vboot */
#define cnf_loadpt	cnf_tag		/* remote load module address - sboot */
	struct pschema	*cnf_next;	/* linked list of programs */
};
typedef struct pschema	CONF;
#define CNFNULL		((CONF *) 0)

#endif
