/*
 *	OSU Research Computing					Trillium
 *	Copyright 1991 The Ohio State University
 *	RBD
 *
 *	$Log:	routeio.h,v $
 * Revision 2.2  92/04/30  14:23:27  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.2  91/12/09  17:14:28  raja
 * Moved route file templates and constants to rtio.h.
 * 
 * Revision 2.1.1.1  91/11/26  14:32:53  raja
 * New design/implementation including support for a second route table.
 * 
 *	Function:	- templates and constants used by the routing tools
 *			  (map, rasm, trout)
 */

#ifndef _ROUTEIO
#define _ROUTEIO

#include <portable.h>
#include <rreq.h>
#include <all_hash.h>
#include <rtio.h>

/*
 * type definitions
 */
typedef struct rtiodesc	RTIOFD;

/*
 * function declarations (routeio.c) and macros
 */
extern RTIOFD		*rtio_init();
extern RTIOFD		*rtio_open();
extern int		rtio_dir();
extern int		rtio_header();
extern int		rtio_rtinit();
extern int		rtio_rtread();
extern int		rtio_rtwrite();
extern int4		rtio_thisnode();
extern void		rtio_cleanup();
extern void		rtio_nextnode();
extern void		rtio_topnode();
extern void		rtio_rtprint();

#define rtio_close(x)	rtio_cleanup(x)

/*
 * constants
 */
#define PARLINK		4		/* max # parallel links btn 2 nodes */

/* 
 * structure definitions
 */
struct rtiodesc {				/* route file descriptor */
	char		*rd_filename;		/* filename */
	int		rd_fd;			/* system file descriptor */
	struct rtiohead	rd_head;		/* file header */
	SHASH		rd_dir;			/* directory hash table desc. */
	struct rtiodir	*rd_dirtable;		/* directory array */
	struct rtiodir	*rd_dircur;		/* current directory entry */
	int4		rd_rtnode;		/* route table's nodeid */
	SHASH		rd_route;		/* route hash table desc. */
	struct route	*rd_rtable;		/* route table array */
	struct bschema	*rd_net;		/* network information */
};

#endif
