/*
 *	OSU Research Computing					Trillium
 *	Copyright 1991 The Ohio State University
 *	RBD
 *
 *	$Log:	rtio.h,v $
 * Revision 2.2  92/04/30  14:23:28  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/12/09  17:04:09  raja
 * initial revision
 * 
 *	Function:	- route file templates and constants 
 */

#ifndef _RTIO
#define _RTIO

#include <portable.h>

/*
 * constants
 */
#define DEFFROUTE	"route.def"	/* default route file name */
#define RTIO_MAGIC	0x544D4150	/* "TMAP" route file magic number */
#define OLDMAGIC	0x54474150	/* "TGAP" old route file magic number */
					/* a typo that we put to good use */

/* 
 * structure definitions
 */
struct rtiohead {				/* route file header */
	int4		rh_magicno;		/* magic number */
	int4		rh_nentries;		/* dir. & route tables size */
	int4		rh_rootnode;		/* root nodeid */
};

struct rtiodir {				/* route file directory */
	int4		rd_nodeid;		/* nodeid */
	long		rd_rtoffset;		/* route table lseek offset */
	struct rtiodir	*rd_bootnext;		/* ptr next bootable node */
};

#endif
