/*
 *	Cornell Theory Center					Trillium
 *
 *	Copyright 1987 Cornell University
 *
 *	GDB
 *
 *	$Log:	echod.c,v $
 * Revision 2.2  92/04/30  14:39:40  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  11:32:08  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:30:19  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:56:21  trillium
 * Homo erectus
 * 
 * Revision 1.1  88/06/05  01:07:11  trillium
 * long overdue after 127 fixes and upgrades
 * 
 * Revision 1.0  87/12/19  15:44:44  trillium
 * Initial revision
 * 
 *
 *	Function:	- echo server
 *			- receives a message and echos it back to the sender
 *			- primarily a diagnostic tool
 *			- message size limited to MAXECHOLEN
 */


#include <net.h>
#include <events.h>
#include <ereq.h>
#include <shared.h>
#include <terror.h>


/*
 * external variables
 */
extern int		errno;			/* global error variable */

/*
 * local variables
 */
char			msg[MAXNMSGLEN];	/* echo message */


main()

{
	struct nmsg		echo;		/* echo network message */
	struct ereq		*request;	/* request from client */

/*
 * Initialize and attach to kernel.
 */
	if (kinit(0)) {
		panic(errno);
	}
/*
 * Attach to kenyad (ITB only).
 */
	if (rpattach(LOCAL) && (errno != ESERVICE)) {
		panic(errno);
	}

	echo.nh_flags = NREEL;
	echo.nh_type = 0;
	echo.nh_msg = msg;

	request = (struct ereq *) echo.nh_data;

	for (;;) {
/*
 * Set up to nrecv a request.
 */
		echo.nh_length = MAXNMSGLEN;
		echo.nh_event = EVECHOD;

		if (nrecv(&echo)) {
			panic(errno);
		}
/*
 * Set up to nsend a reply.
 */
		echo.nh_node = request->eq_node;
		echo.nh_event = request->eq_event;
		echo.nh_type = 0;

		if (nsend(&echo)) {
			panic(errno);
		}
	}
}
