/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	RBD
 *
 *	$Log:	predef.c,v $
 * Revision 2.2  92/04/30  14:40:23  trillium
 * Ohio Release
 * 
 *	Function:	- register a host multicast if needed
 *			- host multicasts are defined for nodeids
 *			  HOST2ITB, HOST2OTB and HOST2ALL
 *			- nothing is done for other nodeids
 *
 *	Accepts:	- nodeid or castid
 *
 *	Returns:	- 0 or ERROR
 */

#include <portable.h>
#include <typical.h>
#include <net.h>
#include <castreq.h>

/*
 * external functions
 */
extern int		rcasttype();
extern int4		getrtype();

int
predef(nodeid)

int4			nodeid;

{
	int4		nodetype;		/* node type */
	int4		typemask;		/* node type bit mask */

	switch(nodeid) {
		case HOST2ITB:
			nodetype = NT_ITB;
			typemask = NT_ALL;
			break;
		case HOST2OTB:
			nodetype = NT_OTB;
			typemask = NT_ITB | NT_CAST;
			break;
		case HOST2ALL:
			nodetype = ~NT_CAST;
			typemask = NT_CAST;
			break;
		default:
			return(0);
	}

	if (getrtype(nodeid) == NOTNODETYPE) {
/*
 * Castid is not defined, register it.
 */
		if (rcasttype(ORIGIN, nodeid, CBN_ERR, nodetype, typemask)) {
			return(ERROR);
		}
	}

	return(0);
}
