/*
 *	Cornell Theory Center					Trillium
 *
 *	Copyright 1987 Cornell University
 *
 *	MB
 *
 *	$Log:	rf.c,v $
 * Revision 2.2  92/04/30  14:40:45  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  11:32:46  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:31:06  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:56:45  trillium
 * Homo erectus
 * 
 *
 *  Routines to reverse the byte ordering in the floating point types.
 *  This toggles between the representations of a single- and double-
 *  precision FP numbers on the T800 transputer and on the MC68881 FPU
 *  (Sun, Apollo, Mac II, etc).  Note that for some machines (VAX)
 *  further bit-munging is required.
 *
 *  The single-precision routine now converts to double and back.
 *  We can make a better single-precision version only after we adopt
 *  ANSI-style function prototypes, to defeat the automatic conversion
 *  to double of function arguments.
 *
 *  These routines are accessed via the ltotf, ltotd, ttolf, ttold macros.
 */

extern int rw();

double
rd (x)
	double x;
{
	int *p, *q;
	double y;

	p  = (int *) &x;
	q  = (int *) &y;
	q[0] = rw (p[1]);
	q[1] = rw (p[0]);
	return (y);
}

float
rf (x)
	double x;		/* assume argument promoted to double */
{
	float f, g;
	int *p, *q;

	f = x;			/* convert back to float */
	p  = (int *) &f;
	q  = (int *) &g;
	*q = rw (*p);
	return (g);
}
