/*
 *	Cornell Theory Center					Trillium
 *
 *	Copyright 1987 Cornell University
 *
 *	GDB
 *
 *	$Log:	set_order.c,v $
 * Revision 2.2  92/04/30  14:40:49  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  11:32:48  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:31:01  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:56:44  trillium
 * Homo erectus
 * 
 * Revision 1.1  88/06/05  01:12:16  trillium
 * long overdue after 127 fixes and upgrades
 * 
 * Revision 1.0  87/12/19  15:48:41  trillium
 * Initial revision
 * 
 *
 *	Function:	- determine which byte ordering function to use
 *			- byte ordering function will either reverse bytes
 *			  or do nothing
 *			- purpose is to allow Trillium load module services
 *			  to deal with load modules produced on any machine.
 *			- preferably, the load module would be produced in
 *			  a standard byte order, but some tools (Unidot)
 *			  produce them using local byte order
 *
 *	Accepts:	- load module ptr
 *	
 *	Returns:	- byte ordering function ptr
 */


#include <t.out.h>
#include <terror.h>


extern int		errno,			/* global error variable */
			rw();			/* byte reversal function */


int stub(x) int x; { return(x); }		/* stub routine for byte
						   ordering */

int
(*(set_order(tout)))()

struct exec			*tout;		/* ptr to load module */

{
	if ((tout->a_magic == rw(TO_MAGIC_T4_X)) ||
		(tout->a_magic == rw(TO_MAGIC_T8_X)) ||
		(tout->a_magic == rw(TO_MAGIC_TN_X))) {
/*
 * not transputer byte ordering
 */
		return(rw);
	}

	else if ((tout->a_magic == TO_MAGIC_T4_X) ||
		(tout->a_magic == TO_MAGIC_T8_X) ||
		(tout->a_magic == TO_MAGIC_TN_X)) {
/*
 * transputer byte ordering
 */
		return(stub);
	}

	else {
		errno = EMAGIC;
		return(0);
	}
}
