/*
 *	OSU Research Computing, architects and contractors	Trillium
 *
 *	Copyright 1990 The Ohio State University
 *
 *	GDB
 *
 *	$Log:	rfclose.c,v $
 * Revision 2.2  92/04/30  14:41:34  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/02/24  20:57:44  gdburns
 * Ohio Release
 * 
 *
 *	Function:	- close a file using remote filed
 *
 *	Accepts:	- runtime file descriptor
 *
 *	Returns:	- 0 or ERROR
 */

#include <events.h>
#include <freq.h>
#include <ksignal.h>
#include <net.h>
#include <typical.h>

/*
 * external variables
 */
extern int		errno;		/* error number */
extern struct fclient	_ufd[FUMAX];	/* client file descriptor table */

/*
 * external functions
 */
extern int		_fdvalid();	/* check validity of file desc */

/*
 * backwards compatible
 */
int tclose(fd) int fd; { return(rfclose(fd)); }

int
rfclose(fd)

int			fd;

{
	struct nmsg	nhead;		/* network message desc. */
	struct freq  	*request;	/* filed request */
	struct freply	*reply;		/* filed reply */
	int		mask;		/* signal mask */

/*
 * Do simple error checking.
 */
	if (_fdvalid(fd) == ERROR) {
		return(ERROR);
	}

	request = (struct freq *) nhead.nh_data;
	reply = (struct freply *) nhead.nh_data;

	request->fq_src_node = getnodeid();
	request->fq_src_event = -getpid();
	request->fq_req = FQCLOSE;
	request->fq_tfd = _ufd[fd].fu_tfd;

	if ((fd <= 2) && (_ufd[fd].fu_node == NOTNODEID)) {
		_ufd[fd].fu_node = getorigin();
	}

	nhead.nh_node = _ufd[fd].fu_node;
	nhead.nh_event = EVFILED;
	nhead.nh_type = 0;
	nhead.nh_flags = 0;
	nhead.nh_length = 0;
	nhead.nh_msg = (char *) 0;

	if (nsend(&nhead)) {
		return(ERROR);
	}

	if (! (_ufd[fd].fu_tflags & FCUBIX)) {
		mask = ksigblock(sigmask(SIGUDIE) | sigmask(SIGARREST));
	}

	nhead.nh_event = -getpid();

	if (nrecv(&nhead)) {
		return(ERROR);
	}

	if (! (_ufd[fd].fu_tflags & FCUBIX)) {
		(void) ksigsetmask(mask);
	}

	if (reply->fr_errno != 0) {
		errno = reply->fr_errno;
		return(ERROR);
	}

	else {
		_ufd[fd].fu_tflags = 0;
		return(0);
	}
}
