/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	GDB
 *
 *	$Log:	rfstat.unicos.c,v $
 * Revision 2.2  92/04/30  14:41:46  trillium
 * Ohio Release
 * 
 * Revision 2.1  92/02/28  10:47:02  gdburns
 * initial revision
 * 
 *	Function:	- rfstat() and rffstat()
 *			- get file status
 *			- Unicos version
 */

#include <freq.h>
#include <net.h>
#include <typical.h>

#undef NULL
#define NULL		((char *) 0)

/*
 * global functions
 */
int			rffstat();
int			rfstat();

/*
 * external variables
 */
extern int		errno;		/* error number */
extern struct fclient	_ufd[FUMAX];	/* client file descriptor table */

/*
 * external functions
 */
extern int		_fdvalid();	/* check validity of file desc */
extern int4		_makefreq();	/* make simple file request */
extern char		*_fnparse();	/* parse nodeid from file name */

/*
 * backwards compatibility
 */
int tfstat(fd, buf) int fd; char *buf;
{ return(rffstat(fd, buf)); }
int tstat(fname, buf) char *fname; char *buf;
{ return(rfstat(fname, buf)); }

/*
 *	rfstat
 *
 *	Function:	- get status on a named file
 *
 *	Accepts:	- file name
 *			- ptr to status buffer
 *
 *	Returns:	- 0 or ERROR
 */

int
rfstat(fname, buf)

char			*fname;
char			*buf;

{
	int4		node;			/* server node ID */
	int4		len;

	fname = _fnparse(fname, &node);
	len = (int4) (strlen(fname) + 1);
	if (len > MAXNMSGLEN) len = MAXNMSGLEN;
	return((int) _makefreq(node, FQSTAT, INT4_NIL, fname, len, buf,
		(int4) MAXNMSGLEN));
}

/*
 *	rffstat
 *
 *	Function:	- get status on a file descriptor
 *
 *	Accepts:	- file descriptor handle
 *			- ptr to status buffer
 *
 *	Returns:	- 0 or ERROR
 */

int
rffstat(fd, buf)

int			fd;
char			*buf;

{
	if (_fdvalid(fd) == ERROR) {
		return(ERROR);
	}

	if ((fd <= 2) && (_ufd[fd].fu_node == NOTNODEID)) {
		_ufd[fd].fu_node = getorigin();
	}

	return((int) _makefreq(_ufd[fd].fu_node, FQFSTAT, _ufd[fd].fu_tfd,
		NULL, INT4_NIL, buf, (int4) MAXNMSGLEN));
}
