/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	GDB
 *
 *	$Log:	KREQ.h,v $
 * Revision 2.2  92/04/30  14:44:39  trillium
 * Ohio Release
 * 
 * Revision 2.1  92/01/19  20:23:11  gdburns
 * initial revision
 * 
 *	Function:	- F77 kernel interface constants
 */

#ifndef _KREQF
#define _KREQF

/*
 * process states
 */
#define SSYNC		(1)		/* synchronized, ready to run */
#define SSTATE		(2)		/* needs state info, ready to run */
#define SERROR		(3)		/* unsuccessful request, ready to run */
#define SATTACH		(4)		/* reply process index, ready to run */
#define SREADY		(5)		/* ready to run */
#define SSEND_BLKD	(6)		/* send blocked on an event */
#define SRECV_BLKD	(7)		/* recv blocked on an event */
#define SACTIVE		(8)		/* running */
#define SFREE		(9)		/* unused */

/*
 * signals
 */
#define SIGTRACE	(1)		/* unload trace data */
#define SIGBACK		(2)		/* go back to the kernel */
#define SIGNOOP		(3)		/* no operation */
#define SIGUDIE		(4)		/* unavoidable death */
#define SIGARREST	(5)		/* unavoidable stop */
#define SIGRELEASE	(6)		/* continue stopped process */
#define SIGA		(7)		/* user defined */
#define SIGB		(8)		/* user defined */

#endif
