/*
 *      OSU Research Computing					Trillium
 *	Copyright 1991 The Ohio State University
 *      GDB
 *
 *      $Log:	all_list.h,v $
 * Revision 2.2  92/04/30  14:44:49  trillium
 * Ohio Release
 * 
 * Revision 2.1  92/01/10  17:36:14  gdburns
 * initial revision
 * 
 *	Function:	- constants and templates associated with all_list
 */

#ifndef _ALLLIST
#define _ALLLIST

#include <portable.h>

struct al_head {
	struct al_head	*al_next;		/* next list element */
	struct al_head	*al_prev;		/* previous list element */
};

#define ALNULL ((struct al_head *) 0)

struct al_desc {
	int4		al_elemsize;		/* element size */
	struct al_head	*al_ltop;		/* top of list ptr */
	struct al_head	*al_lbottom;		/* bottom of list ptr */
	struct al_head	*al_ftop;		/* top of free list ptr */
	int4		(*al_comp)();		/* comparison function */
};

typedef struct al_desc	LIST;

#define al_body(x) ((x) ? (((char *) (x)) + sizeof(struct al_head)) : 0)

#define al_top(x) (al_body(x->al_ltop))
#define al_bottom(x) (al_body(x->al_lbottom))

/*
 * function declarations
 */
extern LIST		*al_init();
extern int4		al_delete();
extern int4		al_free();
extern int4		al_count();
extern char		*al_append();
extern char		*al_find();
extern char		*al_insert();
extern char		*al_next();
extern char		*al_prev();

#endif
