/*
 *	OSU Research Computing					Trillium
 *	Copyright 1991 The Ohio State University
 *	RBD
 *
 *	$Log:	all_queue.h,v $
 * Revision 2.2  92/04/30  14:44:51  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.1  92/01/19  22:01:51  raja
 * Modified functions to fit new standard interface.
 * 
 * Revision 2.1  91/03/20  11:34:37  gdburns
 * Ohio Release
 * 
 * Revision 2.0  90/11/16  15:12:05  raja
 * Package for managing generic queues.
 *
 *	Function:	- generic queue templates and constants
 *			- for both the static and dynamic versions
 */

#ifndef _ALLQUEUE
#define _ALLQUEUE

#include <portable.h>

/*
 * type definitions
 */
typedef struct aq_desc	QUEUE;
typedef struct aq_desc	SQUEUE;

/*
 * function prototypes (all_queue.c, all_squeue.c)
 */
extern QUEUE		*aq_init();		/* create dynamic queue */
extern SQUEUE		*aqs_init();		/* create static queue */
extern void		aq_free();		/* free dynamic queue */
extern void		*aq_find();		/* read an element */
extern int		aq_delete();		/* remove an element */
extern int		aq_expand();		/* enlarge the queue */
extern int		aq_insert();		/* insert an element */
extern int		aq_shove();		/* insert by expanding */
 
/*
 * function macros
 */
#define aq_count(aqd)		((aqd)->aq_nelem)
#define aq_size(aqd)		((aqd)->aq_maxnelem)

#define aqs_find(aqd)		aq_find(aqd)
#define aqs_delete(aqd)		aq_delete(aqd)
#define aqs_insert(aqd, x)	aq_insert(aqd, x)
#define aqs_count(aqd)		aq_count(aqd)
#define aqs_size(aqd)		aq_size(aqd)

/* 
 * structure definitions
 */
struct aq_desc {			/* queue descriptor */
	int4		aq_maxnelem;	/* maximum nbr. elements */
	int4		aq_nelem;	/* current nbr. elements */
	int4		aq_elemsize;	/* size of element */
	int4		aq_first;	/* index to first element */
	int4		aq_last;	/* index to last element */
	void		*aq_queue;	/* ptr to the queue array */
};

#endif
