/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	GDB
 *
 *	$Log:	dlreq.h,v $
 * Revision 2.2  92/04/30  14:45:05  trillium
 * Ohio Release
 * 
 *	Function:	- constants for datalink administrators
 */

#ifndef _DLREQ
#define _DLREQ

#include <portable.h>

/*
 * bootd request codes
 */
#define DLQVALVE	0		/* positive event value on/off */
#define DLQATTACH	1		/* register with dld */
#define DLQPOLL		2		/* poll signal delivery */

/*
 * valve settings
 */
#define DLOFF		0		/* valve closed, neg events only */
#define DLON		1		/* valve open, all events */

/*
 * message type filters
 */
#define DLALL		0		/* every message */
#define DLUSR		1		/* user messages */
#define DLSYS		2		/* system messages */

/*
 * This needs to be defined in machine.h.
 */
#define MAXNLINK	4		/* max # links per node */

/*
 * dl_mom request
 */
struct dlreq {
	int4		dlq_req;
	int4		dlq_valve;
	int4		dlq_node;
	int4		dlq_event;
	int4		dlq_pid;
};

#endif
