/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	GDB
 *
 *	$Log:	i8req.h,v $
 * Revision 2.2  92/04/30  14:45:23  trillium
 * Ohio Release
 * 
 *	Function:	- constants and templates for the
 *			  i860 process manager
 */

#include <mng.h>
#include <portable.h>

#ifndef _I8REQ
#define _I8REQ

#define I8QCREATE	1		/* create the i860 process */

/*
 * i860d request
 */
struct i8req {
	int4		i8q_src_node;
	int4		i8q_src_event;
	int4		i8q_req;
	struct mng	*i8q_pload;	/* load module flat tag */
	char		**i8q_pargv;	/* argument flat tag */
	int4		i8q_argc;	/* number of argumentss */
	int4		i8q_rtf;	/* kenyad option flags */
	int4		i8q_stksize;	/* stack size */
	int4		i8q_stdin;	/* std input desc. */
	int4		i8q_stdout;	/* std input desc. */
	int4		i8q_stderr;	/* std input desc. */
};

/*
 * i860d reply
 */
struct i8reply {
	int4		i8r_reply;	/* error code */
	int4		i8r_pid;	/* kenyad process ID */
	int4		*i8r_pstatic;	/* ptr to data/bss segment */
	int4		*i8r_pstack;	/* ptr to stack segment */
	int4		*i8r_pload;	/* ptr to load module */
	char		**i8r_pargv;	/* ptr to argv structure */
};

#endif
