/*
 *	Cornell Theory Center					Trillium
 *
 *	Copyright 1987 Cornell University
 *
 *	GDB
 *
 *	$Log:	kmsg.h,v $
 * Revision 2.2  92/04/30  14:45:33  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  11:34:51  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:28:03  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:54:52  trillium
 * Homo erectus
 * 
 * Revision 1.1  88/06/05  01:09:56  trillium
 * long overdue after 127 fixes and upgrades
 * 
 * Revision 1.0  87/12/19  15:46:12  trillium
 * Initial revision
 * 
 *
 *	Function:	- define kernel IPC message header
 */


#ifndef _KMSG

#define _KMSG

#include "kreq.h"


struct kmsg {
	int		k_event,	/* message event number */
			k_type,		/* message type (filter) */
			k_length,	/* length of message */
			k_flags;	/* option flags, jives with nh_flags */
#define KHOLD		0x01		/* using virtual circuit */
#define KREVPORT	0x08		/* reverse port protocol */
#define KBREAK		0x20		/* end of virtual circuit */
#define KCLOBBER	0x40		/* length overrun in virtual circuit */
#define KDLI		0x200		/* special flag for dli_t4 */
	char		*k_msg;		/* pointer to message buffer */
};

#endif
