/*
 *	OSU Research Computing					Trillium
 *	Copyright 1991 The Ohio State University
 *	GDB
 *
 *	$Log:	ksignal.h,v $
 * Revision 2.2  92/04/30  14:45:47  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.1  91/10/03  15:08:18  gdburns
 * Change SIGROUTE to SIGTRACE.
 * 
 * Revision 2.1  91/03/20  11:34:54  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.2  90/11/20  15:19:34  gdburns
 * Added function declarations.
 * 
 * Revision 2.0.1.1  90/07/13  19:28:27  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:55:12  trillium
 * Homo erectus
 * 
 *	Function:	- define constants for the software signal package
 *			- SIGNOOP and SIGBACK are used in combination to
 *			  support controlled processes in the 2.0 kernel.
 *
 *			- based on Trollius 2.0 Copyright 1990
 *			  The Ohio State University and Cornell
 *			  Research Foundation
 */

#ifndef _KSIGNAL
#define _KSIGNAL

#ifndef NSIG
#define NSIG
#define BADSIG          (int (*)())-1
#define SIG_DFL         (int (*)())0
#define SIG_IGN         (int (*)())1
#define sigmask(s)	(1 << ((s) - 1))
#endif

/*
 * signals
 */
#define TNSIG		8			/* number of signals */
#define SIGTRACE	1			/* unload trace data */
#define SIGBACK		2			/* go back to the kernel */
#define SIGNOOP		3			/* no operation */
#define SIGUDIE		4			/* unavoidable death */
#define SIGARREST	5			/* unavoidable stop */
#define SIGRELEASE	6			/* continue stopped process */
#define SIGA		7			/* user defined */
#define SIGB		8			/* user defined */
#define SIG_PRIV	(sigmask(SIGBACK) | sigmask(SIGNOOP))
						/* signals which cannot be
						   affected by the user */
/*
 * function declarations
 */
extern int		kpause();		/* wait for a signal */
extern int		(*ksignal())();		/* redirect signals */
extern int		ksigsetmask();		/* install entire block mask */
extern int		ksigblock();		/* set selected block bits */
extern int		ksigsetretry();		/* install entire retry mask */
extern int		ksigretry();		/* set selected retry bits */
			  
#endif
