/*
 *      OSU Research Computing					Trillium
 *	Copyright 1991 The Ohio State University
 *      GDB
 *
 *      $Log:	ktrace.h,v $
 * Revision 2.2  92/04/30  14:45:49  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.1  92/01/10  17:37:32  gdburns
 * Introduce TID, the trace identifier.
 * 
 * Revision 2.1  91/10/03  15:25:56  gdburns
 * initial version
 * 
 *	Function:	- constants and templates associated with the
 *			  runtime trace system
 */

#ifndef _KTRACE
#define _KTRACE

#include <portable.h>

/*
 * external functions
 */
extern void		ktrcflow();
extern void		ktrdflow();
extern void		ktrstart();
extern void		ktrstop();
extern char		*ktrpoint();

/*
 * trace header
 */
struct trhead {
	char		*trh_buf;	/* trace buffer ptr */
	int		trh_length;	/* trace buffer length */
};

/*
 * constants
 */
#define TRHMAX		256		/* TRHMAX * MAXNMSGLEN = length limit */
#define TRHQUAN		16		/* TRHQUAN * MAXNMSGLEN = alloc chunk */

/*
 * trace type constants
 */
#define TRSTART		1
#define TREND		2
#define TRCFLOW		3
#define TRDFLOW		4
#define TRSEND		5
#define TRRECV		6

/*
 * trace structures
 */
struct trtr {
	int4		trt_type;
	int4		trt_stamp;
	int4		trt_tid;
};

struct trstart {
	struct trtr	tr1_head;
	int4		tr1_node;
	int4		tr1_pid;
};

struct trend {
	struct trtr	tr2_head;
};

struct trcflow {
	struct trtr	tr3_head;
	int4		tr3_type;
	int4		tr3_data;
};

struct trdflow {
	struct trtr	tr4_head;
	int4		tr4_type;
	int4		tr4_size;
	int4		tr4_data[1];
};

struct trsend {
	struct trtr	tr5_head;
	int4		tr5_tonode;
	int4		tr5_event;
	int4		tr5_length;
	int4		tr5_total;
	int4		tr5_blocked;
	int4		tr5_transmit;
};

struct trrecv {
	struct trtr	tr6_head;
	int4		tr6_frtid;
	int4		tr6_event;
	int4		tr6_length;
	int4		tr6_total;
	int4		tr6_blocked;
	int4		tr6_transmit;
};

#endif
