/*
 *	OSU Research Computing					Trillium
 *	Copyright 1991 The Ohio State University
 *	GDB
 *
 *	$Log:	portable.h,v $
 * Revision 2.2  92/04/30  14:46:11  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.2  92/02/27  11:25:16  gdburns
 * Add i860.
 * 
 * Revision 2.1.1.1  92/01/11  11:59:52  gdburns
 * Overhaul constants and add string version of pathname separator.
 * 
 * Revision 2.1  91/03/20  11:35:05  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.4  90/11/28  00:06:28  gdburns
 * Added 4 byte 0 constant.
 * 
 * Revision 2.0.1.3  90/11/15  16:44:17  raja
 * Added STRDIR to handle different directory name separators.
 * 
 * Revision 2.0.1.2  90/09/27  18:03:43  gdburns
 * Upgraded to the modern era of portability.
 * 
 * Revision 2.0  90/02/20  11:54:53  trillium
 * Homo erectus
 * 
 *	Function:	- Put some order into a world of chaos.
 *			- Anybody without an 8 bit byte can get lost.
 */

#ifndef _PORTABLE
#define _PORTABLE

#ifndef DOS
#define STRDIR		'/'
#define STRSDIR		"/"
#else
#define STRDIR		'\\'
#define STRSDIR		"\\"
#endif

#ifdef tputer
typedef int		int4;	/* four bytes */
typedef unsigned int	uint4;
#define stoi4		stoi
#define atoi4		atoi
#elif mc68020
typedef int		int4;
typedef unsigned int	uint4;
#define stoi4		stoi
#define atoi4		atoi
#elif sparc
typedef int		int4;
typedef unsigned int	uint4;
#define stoi4		stoi
#define atoi4		atoi
#elif sparc
typedef int		int4;
typedef unsigned int	uint4;
#define stoi4		stoi
#define atoi4		atoi
#elif ibm032
typedef int		int4;
typedef unsigned int	uint4;
#define stoi4		stoi
#define atoi4		atoi
#elif i386
typedef int		int4;
typedef unsigned int	uint4;
#define stoi4		stoi
#define atoi4		atoi
#elif DOS
typedef long		int4;
typedef unsigned long	uint4;
#define stoi4		stol
#define atoi4		atol
#elif CRAY
typedef short		int4;
typedef unsigned short	uint4;
#define stoi4		stos
#define atoi4		atos
#elif i860
typedef int		int4;
typedef unsigned int	uint4;
#define stoi4		stoi
#define atoi4		atoi
#endif

#define INT4_NIL	((int4) 0)
#define INT4_MAX	((int4) 0x7FFFFFFF)
#define INT4_MIN	((int4) 0x80000000)
#define INT4_LSB	((int4) 0xFF)		/* least significant byte */
#define INT4_LSN	((int4) 0x0F)		/* least significant nibble */
#define INT4_MSN	((int4) 0xF0)		/* most significant nibble */
#define	INT4_SIGN	((int4) 0x80000000)	/* sign bit of an int4 */

#define UINT4_MAX	((uint4) 0xFFFFFFFF)	/* maximum uint4 */

#endif
