/*
 *	OSU Research Computing					Trillium
 *	Copyright 1991 The Ohio State University
 *	GDB
 *
 *	$Log:	t_types.h,v $
 * Revision 2.2  92/04/30  14:46:24  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.4  92/04/27  17:28:59  raja
 * ttolcpy() and ltotcpy() macros call the rwcpy() function.  Much cleaner.
 * 
 * Revision 2.1.1.3  91/11/27  15:28:15  raja
 * Added integer array byte ordering.
 * 
 * Revision 2.1.1.2  91/11/11  23:57:50  gdburns
 * Don't forget Mr. Cray.
 * 
 * Revision 2.1.1.1  91/11/01  17:46:36  gdburns
 * Correct cpp bug and include i860 and 386i.
 * 
 * Revision 2.1  91/03/20  11:35:11  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:27:58  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:54:49  trillium
 * Homo erectus
 * 
 *	Function:	- defines type conversions
 *			- based in part on Trollius 2.0 Copyright 1990
 *			  The Ohio State University and Cornell Research
 *			  Foundation
 */

#ifndef _T_TYPES
#define _T_TYPES

#ifdef gould

extern int		rw();
extern short		rs();

#define ltot(x)		(rw(x))
#define ttol(x)		(rw(x))
#define ltots(x)	(rs(x))
#define ttols(x)	(rs(x))

#define ltotcpy(d, s, n)	rwcpy(d, s, n)
#define ttolcpy(d, s, n)	rwcpy(d, s, n)

#elif vax

#define ltot(x)		(x)
#define ttol(x)		(x)
#define ltots(x)	(x)
#define ttols(x)	(x)

#define ltotcpy(d, s, n)
#define ttolcpy(d, s, n)

#elif sparc || mc68020

extern int		rw();
extern short		rs();
extern float		rf();
extern double		rd();

#define ltot(x)		(rw(x))
#define ttol(x)		(rw(x))
#define ltots(x)	(rs(x))
#define ttols(x)	(rs(x))
#define ttolf(x)	(rf(x))
#define ltotf(x)	(rf(x))
#define ttold(x)	(rd(x))
#define ltotd(x)	(rd(x))

#define ltotcpy(d, s, n)	rwcpy(d, s, n)
#define ttolcpy(d, s, n)	rwcpy(d, s, n)

#elif ibm032

extern int		rw();
extern short		rs();
extern float		rf();
extern double		rd();

#define ltot(x)		(rw(x))
#define ttol(x)		(rw(x))
#define ltots(x)	(rs(x))
#define ttols(x)	(rs(x))
#define ttolf(x)	(rf(x))
#define ltotf(x)	(rf(x))
#define ttold(x)	(rd(x))
#define ltotd(x)	(rd(x))

#define ltotcpy(d, s, n)	rwcpy(d, s, n)
#define ttolcpy(d, s, n)	rwcpy(d, s, n)

#elif tputer

#define ltot(x)		(x)
#define ttol(x)		(x)
#define ltots(x)	(x)
#define ttols(x)	(x)
#define ttolf(x)	(x)
#define ltotf(x)	(x)
#define ttold(x)	(x)
#define ltotd(x)	(x)

#define ltotcpy(d, s, n)
#define ttolcpy(d, s, n)

#elif i386 || i860

#define ltot(x)		(x)
#define ttol(x)		(x)
#define ltots(x)	(x)
#define ttols(x)	(x)
#define ttolf(x)	(x)
#define ltotf(x)	(x)
#define ttold(x)	(x)
#define ltotd(x)	(x)

#define ltotcpy(d, s, n)
#define ttolcpy(d, s, n)

#elif CRAY

#define ltot(x)		(x)
#define ttol(x)		(x)
#define ltots(x)	(x)
#define ttols(x)	(x)
#define ttolf(x)	(x)
#define ltotf(x)	(x)
#define ttold(x)	(x)
#define ltotd(x)	(x)

#define ltotcpy(d, s, n)
#define ttolcpy(d, s, n)

#endif

#endif _T_TYPES
