/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	GDB
 *
 *	$Log:	terror.h,v $
 * Revision 2.2  92/04/30  14:46:25  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.2  92/02/27  12:01:29  gdburns
 * Add EI860PROC.
 * 
 * Revision 2.1.1.1  92/01/27  17:51:35  gdburns
 * Remove ENOPORT.
 * 
 * Revision 2.1  91/03/20  11:35:12  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.5  91/01/08  12:40:18  gdburns
 * Added EBADREC.
 * 
 * Revision 2.0.1.4  90/11/27  17:46:21  gdburns
 * replaced file daemon codes
 * 
 * Revision 2.0.1.3  90/10/15  16:14:56  gdburns
 * Added EBLOWN.
 * 
 * Revision 2.0.1.2  90/07/13  19:27:55  gdburns
 * Homo sapien
 * 
 * Revision 2.0.1.1  90/07/04  14:11:26  gdburns
 * Added ECOLLIDE.
 * 
 * Revision 2.0  90/02/20  11:54:48  trillium
 * Homo erectus
 *
 *	Function:	- Trillium error codes
 *			- based on Trollius 2.0 Copyright 1990
 *			  The Ohio State University and Cornell
 *			  Research Foundation
 */

#ifndef _TERROR
#define _TERROR

#define ELOW			201
#define ENOEVDESCRIPTORS	201
#define ECIRCUITINUSE		202
#define ENOEXDESCRIPTORS	203
#define EFULL			204
#define ENOTPROCESS		205
#define EBADREQUEST		206
#define ENOTMALLOCED		207
#define ESERVICE		209
#define EMAGIC			210
#define EBLOWN			211
#define EIMPOSSIBLE		212
#define EI860PROC		213
#define EGARBAGE		214
#define ENOKERNEL		215
#define ENOTATTACHED		216
#define EPANIC			217
#define EMSGLEN			218
#define EEOF			219
#define ECOLLIDE		220

#define ESHARE			223
#define EBADLINK		224
#define EACK			225

#define	EUSAGE			226
#define EOPTION			227
#define	ENODERANGE		228
#define	EBADNODE		229
#define	EBADNODESPEC		230

#define ENORDESCRIPTORS		232
#define ENOBFDESCRIPTORS	233
#define ENOBTDESCRIPTORS	234
#define ENOFLDESCRIPTORS	235
#define ENOPDESCRIPTORS		236
#define ENOKDESCRIPTORS		237
#define EBADMOSESREQ		238
#define EMAXBULLETS		239
#define EBADTAG			240
#define EDELETE			241
#define ENOBOOTSTRAP		242
#define EBADREC			243
#define EBADASCIINUMB		244
#define EHIGHWATER		245

/*
 * cubix specific error codes
 */
#define	ECXREQ			260
#define	ECXMEMBER		261
#define	ECXSINGL		262

#define EHIGH			262

#ifndef EINTR
#define EINTR			4
#endif	EINTR

#ifndef ENOMEM
#define ENOMEM			12
#endif	ENOMEM

#ifndef EINVAL
#define EINVAL			22
#endif	EINVAL

#ifndef EWOULDBLOCK
#define EWOULDBLOCK		35
#endif	EWOULDBLOCK

#endif !_TERROR
