/*
 *      OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *      GDB
 *
 *      $Log:	trreq.h,v $
 * Revision 2.2  92/04/30  14:46:26  trillium
 * Ohio Release
 * 
 * Revision 2.1  92/01/19  20:52:52  gdburns
 * initial revision
 * 
 *	Function:	- constants and templates associated with traced
 */

#ifndef _TRREQ
#define _TRREQ

#include <portable.h>

/*
 * logd requests
 */
#define TRQATTACH	0		/* attach to traced */
#define	TRQDETACH	1		/* detach from traced */
#define	TRQSTORE	2		/* store traces */
#define	TRQGET		3		/* get traces */
#define	TRQFORGET	4		/* get and remove traces */
#define	TRQSTATE	5		/* get traced status */
#define	TRQSWEEP	6		/* remove traces */
#define	TRQSIG		7		/* signal traced clients */

/*
 * misc constants
 */
#define TRSMAX		100		/* # state descs in trstate */

/*
 * traced request
 */
struct trreq {
	int4		trq_src_node;	/* client's nodeid */
	int4		trq_src_event;	/* client's reply event	*/
	int4		trq_req;	/* traced request code */
	int4		trq_pid;	/* client pid */
	int4		trq_length;	/* trace length */
};

/*
 * traced reply
 */
struct trreply {
	int4		trr_errno;	/* error code */
	int4		trr_nstate;	/* # returned state descs */
	int4		trr_length;	/* length of detatched trace data */
};

/*
 * traced status
 */
struct trstate {
	int4		trs_pid;	/* client pid */
	int4		trs_length;	/* length of traces stored */
	int4		trs_sig;	/* outstanding signal? */
};

#endif
