/*
 *	Cornell Theory Center					Trillium
 *
 *	Copyright 1987 Cornell University
 *
 *	GDB
 *
 *	$Log:	typical.h,v $
 * Revision 2.2  92/04/30  14:46:30  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  11:35:13  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.2  90/11/15  16:33:41  raja
 * Added min() and max() macros.
 * 
 * Revision 2.0.1.1  90/07/13  19:27:56  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:54:49  trillium
 * Homo erectus
 * 
 * Revision 1.1  88/06/05  01:11:14  trillium
 * long overdue after 127 fixes and upgrades
 * 
 * Revision 1.0  87/12/19  15:46:28  trillium
 * Initial revision
 * 
 *
 *	Function:	- typically used constants and macros
 */


#ifndef _TYPICAL

#define _TYPICAL

/*
 * constants
 */
#ifndef FALSE
#define FALSE		0		/* boolean false */
#define TRUE		1		/* boolean true */
#endif

#define READ		0		/* read access for UNIX interface */
#define WRITE		1		/* write access for UNIX interface */

#ifndef ERROR
#define ERROR		-1		/* general function return code */
#endif

#define SUCCESS		0		/* general function return code */
#define STDIN		0		/* standard input file descriptor */
#define STDOUT		1		/* standard output file descriptor */
#define STDERR		2		/* standard error file descriptor */
#define MININT		0x80000000	/* smallest integer */
#define MAXINT		0x7FFFFFFF	/* largest integer */

/*
 * macros
 */
#define max(a,b)	(((a) > (b)) ? (a) : (b))
#define min(a,b)	(((a) < (b)) ? (a) : (b))

#endif
