/*
 *	OSU Research Computing, architects and contractors	Trillium
 *
 *	Copyright 1990 The Ohio State University & Cornell University
 *
 *	GDB
 *
 *	$Log:	kattach.c,v $
 * Revision 2.2  92/04/30  14:47:28  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  11:36:56  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:27:34  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:54:35  trillium
 * Homo erectus
 * 
 * Revision 1.1  88/06/05  01:11:37  trillium
 * long overdue after 127 fixes and upgrades
 * 
 * Revision 1.0  87/12/19  15:46:46  trillium
 * Initial revision
 * 
 *
 *	Function:	- attach process (yourself) to the kernel
 *
 *	Accepts:	- your process priority value
 */
			  

#include <kio.h>
#include <typical.h>
#include <terror.h>


/*
 * external variables
 */
extern struct kio_t	_kio;			/* Kernel I/O block */
extern int		errno;

/*
 * external functions
 */
extern int		getpid();		/* get my process ID */
extern int		_make_kreq();		/* make request of the kernel */
extern int		atkexit();		/* add exit routine */
extern void		_follow_signal();	/* check signals */


int
kattach(priority)

int			priority;		/* requested priority */

{
	int		ret_code;		/* return code */
	struct kreq	req;			/* kernel request */
	struct kreply	reply;			/* kernel reply */

/*
 * Set up the KATTACH request.
 */
	req.kq_request = KATTACH;
	req.kq_index = _kio.ki_index;
	req.kqa_pid = getpid();
	req.kqa_port = _kio.ki_port;
	req.kqa_client = _kio.ki_client;
	req.kqa_priority = priority;
/*
 * Send the request to the kernel and receive a reply.
 */
	if (!(ret_code = _make_kreq(&req, &reply))) {
/*
 * Remember the kernel process descriptor index and note that we are now
 * attached.
 */
		_kio.ki_index = reply.kra_index;
		_kio.ki_rtf |= RTF_KERNEL;	
		_kio.ki_priority = priority;
	}
/*
 * Check signals.
 */
	if (_kio.ki_signal) {
		_follow_signal();
	}

	return(ret_code);
}
