/*
 *	OSU Research Computing, architects and contractors	Trillium
 *
 *	Copyright 1990 The Ohio State University & Cornell University
 *
 *	GDB
 *
 *	$Log:	kdetach.c,v $
 * Revision 2.2  92/04/30  14:47:30  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  11:36:57  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:27:35  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:54:36  trillium
 * Homo erectus
 * 
 * Revision 1.1  88/06/05  01:11:40  trillium
 * long overdue after 127 fixes and upgrades
 * 
 * Revision 1.0  87/12/19  15:46:47  trillium
 * Initial revision
 * 
 *
 *	Function:	- detach process (yourself) from the kernel
 */
			  

#include <kio.h>
#include <typical.h>


/*
 * external data
 */
extern struct kio_t	_kio;			/* Kernel I/O block */

/*
 * external functions
 */
extern int		_make_kreq();		/* make request of kernel */
extern void		_follow_signal();	/* check signals */


int
kdetach(pid)

int			pid;			/* process id to detach */

{
	int		ret_code;		/* return code */
	struct kreq	req;			/* kernel request */
	struct kreply	reply;			/* kernel reply */

/*
 * Make sure that we are attached.
 */
	if (!(_kio.ki_rtf & RTF_KERNEL)) {
		return(0);
	}

	req.kq_request = KDETACH;
	req.kq_index = _kio.ki_index;
	req.kqu_pid = pid;

	if (!(ret_code = _make_kreq(&req, &reply))) {
		_kio.ki_rtf &= ~RTF_KERNEL;
		_kio.ki_index = -1;
	}
/*
 * Check signals.
 */
	if (_kio.ki_signal) {
		_follow_signal();
	}

	return(ret_code);
}
