/*
 *	OSU Research Computing, architects and contractors	Trillium
 *
 *	Copyright 1990 The Ohio State University & Cornell University
 *
 *	GDB
 *
 *	$Log:	kdoom.c,v $
 * Revision 2.2  92/04/30  14:47:32  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  11:36:58  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:27:37  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:54:37  trillium
 * Homo erectus
 * 
 * Revision 1.1  88/06/05  01:11:43  trillium
 * long overdue after 127 fixes and upgrades
 * 
 * Revision 1.0  87/12/19  15:46:48  trillium
 * Initial revision
 * 
 *
 *	Function:	- deliver a signal to a process
 *
 *	Accepts:	- a Trillium process identifier (0 means yourself)
 *
 *	Returns:	- an error indicator
 */
			  

#include <kreq.h>
#include <kio.h>
#include <terror.h>
#include <typical.h>


/*
 * external variables
 */
extern struct kio_t	_kio;			/* kernel I/O block */
extern int		errno;

/*
 * external functions
 */
extern int		_make_kreq();		/* make request of kernel */
extern void		_follow_signal();	/* check signals */


int
kdoom(pid, signal)

int			pid;			/* Trillium process ID */
int			signal;			/* signal number */

{
	int		ret;			/* return code */
	struct kreq	req;			/* kernel request */
	struct kreply	reply;			/* kernel reply */

/*
 * Check the signal number bounds.
 */
	if ((signal < 1) || (signal > TNSIG)) {
		errno = EINVAL;
		return(ERROR);
	}
/*
 * Formulate the KDOOM kernel request.
 */
	req.kq_request = KDOOM;
	req.kq_index = _kio.ki_index;
	req.kqd_pid = pid;
	req.kqd_signal = sigmask(signal);

	ret = _make_kreq(&req, &reply);
/*
 * Check signals.
 */
	if (_kio.ki_signal) {
		_follow_signal();
	}

	return(ret);
}
