/*
 *	OSU Research Computing					Trillium
 *	Copyright 1991 The Ohio State University
 *	RBD
 *
 *	$Log:	brecv.c,v $
 * Revision 2.2  92/04/30  14:48:24  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/10/24  23:05:41  raja
 * initial revision
 * 
 *	Function:	- basic receive using a pointer to structure
 *			- keeps the "look-and-feel" of nsend
 */

#include <portable.h>
#include <typical.h>
#include <net.h>
#include <terror.h>

/*
 * external variables
 */
extern int		errno;

/*
 * external functions
 */
extern int4		getnodeid();


int
brecv(nhead)

struct nmsg		*nhead;

{
	int4		datasize;	/* size of data element */
	int		ret;
/*
 * The event is the sender's nodeid, forced to be positive.
 * If the nodeid is LOCAL, get the real nodeid.
 */
	nhead->nh_event = INT4_MAX &
		((nhead->nh_node == LOCAL) ? getnodeid() : nhead->nh_node);
	nhead->nh_type = INT4_NIL;
/*
 * Get the message length in bytes.
 */
	if (nhead->nh_flags == DINTMSG) {
		datasize = sizeof(int4);
	}
	else if (nhead->nh_flags == DFLTMSG) {
		datasize = sizeof(float);
	}
	else if (nhead->nh_flags == DDBLMSG) {
		datasize = sizeof(double);
	}
	else if (nhead->nh_flags == DRAWMSG) {
		datasize = (int4) 1;
	}
	else {
		errno = EINVAL;
		return(ERROR);
	}
	nhead->nh_length *= datasize;

	ret = nrecv(nhead);

	nhead->nh_length /= datasize;
	return(ret);
}
