/*
 *	OSU Research Computing					Trillium
 *	Copyright 1991 The Ohio State University
 *	RBD
 *
 *	$Log:	bsend.c,v $
 * Revision 2.2  92/04/30  14:48:27  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/10/24  23:04:03  raja
 * initial revision
 * 
 *	Function:	- basic send using a pointer to structure
 *			- keeps the "look-and-feel" of nsend
 */

#include <portable.h>
#include <typical.h>
#include <net.h>
#include <terror.h>

/*
 * external variables
 */
extern int		errno;

/*
 * external functions
 */
extern int4		getnodeid();


int
bsend(nhead)

struct nmsg		*nhead;

{
	int4		datasize;	/* size of data element */
	int4		array_length;
	int		ret;
/*
 * The event used is the sender's nodeid, forced to be positive.
 */
	nhead->nh_event = getnodeid() & INT4_MAX;
	nhead->nh_type = INT4_NIL;
/*
 * Get the message length in bytes.
 */
	if (nhead->nh_flags == DINTMSG) {
		datasize = sizeof(int4);
	}
	else if (nhead->nh_flags == DFLTMSG) {
		datasize = sizeof(float);
	}
	else if (nhead->nh_flags == DDBLMSG) {
		datasize = sizeof(double);
	}
	else if (nhead->nh_flags == DRAWMSG) {
		datasize = (int4) 1;
	}
	else {
		errno = EINVAL;
		return(ERROR);
	}
	array_length = nhead->nh_length;
	nhead->nh_length *= datasize;

	ret = nsend(nhead);

	nhead->nh_length = array_length;
	return(ret);
}
