/*
 *	OSU Research Computing					Trillium
 *	Copyright 1991 The Ohio State University
 *	RBD
 *
 *	$Log:	recvb.c,v $
 * Revision 2.2  92/04/30  14:48:51  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/10/24  23:07:15  raja
 * initial revision
 * 
 *	Function:	- basic receive using a parameter list
 */

#include <portable.h>
#include <typical.h>
#include <net.h>
#include <terror.h>

/*
 * external variables
 */
extern int		errno;

/*
 * external functions
 */
extern int4		getnodeid();


int4
recvb(srcnode, msg, length, datatype)

int4			srcnode;
void			*msg;
int4			length;
int4			datatype;

{
	struct nmsg	nhead;		/* message descriptor */
	int4		datasize;	/* size of data element */

	nhead.nh_event = INT4_MAX &
		((srcnode == LOCAL) ? getnodeid() : srcnode);
	nhead.nh_type = INT4_NIL;
	nhead.nh_flags = datatype;
	nhead.nh_msg = (char *) msg;
/*
 * Get the message length in bytes.
 */
	if (datatype == DINTMSG) {
		datasize = sizeof(int4);
	}
	else if (datatype == DFLTMSG) {
		datasize = sizeof(float);
	}
	else if (datatype == DDBLMSG) {
		datasize = sizeof(double);
	}
	else if (datatype == DRAWMSG) {
		datasize = (int4) 1;
	}
	else {
		errno = EINVAL;
		return((int4) ERROR);
	}
	nhead.nh_length = length * datasize;

	if (nrecv(&nhead)) {
		return((int4) ERROR);
	}
	else {
		return(nhead.nh_length / datasize);
	}
}
