/*
 *	OSU Research Computing					Trillium
 *	Copyright 1991 The Ohio State University
 *	RBD,GDB
 *
 *	$Log:	trecv.c,v $
 * Revision 2.2  92/04/30  14:48:58  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.2  92/04/27  17:10:01  raja
 * Return a new event to the sender to eliminate same-event packet mixups.
 * 
 * Revision 2.1.1.1  91/10/20  22:06:16  raja
 * Make trecv() compatible with nrecv().
 * 
 * Revision 2.1  91/03/20  11:37:26  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:27:24  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:54:31  trillium
 * Homo erectus
 * 
 *	Function:	- transport layer receive
 */

#include <portable.h>
#include <typical.h>
#include <net.h>

int
trecv(nhead)

struct nmsg		*nhead;		/* network message descriptor */

{
	struct nmsg	sync;		/* synchronization message */
	int		save_event;	/* saved message event */
	int		ret;		/* returned value */
/*
 * Receive "ready to send" message.
 */
	sync.nh_event = nhead->nh_event;
	sync.nh_type = nhead->nh_type;
	sync.nh_flags = DINTDATA;
	sync.nh_length = INT4_NIL;
	sync.nh_msg = (char *) 0;

	if (nrecv(&sync)) {
		return(ERROR);
	}
/*
 * Send "ready to receive" to sending party.  Include the event to be used.
 */
	sync.nh_node = sync.nh_data[0];
	sync.nh_event = sync.nh_data[1];
	sync.nh_type = INT4_NIL;
	sync.nh_flags = DINTDATA;
	sync.nh_data[0] = -getpid();

	if (nsend(&sync)) {
		return(ERROR);
	}
/*
 * Receive the data message using the new event.
 */
	save_event = nhead->nh_event;
	nhead->nh_event = -getpid();

	ret = nrecv(nhead);

	nhead->nh_event = save_event;
	return(ret);
}
