/*
 *	OSU Research Computing					Trillium
 *	Copyright 1991 The Ohio State University
 *	RBD,GDB
 *
 *	$Log:	tsend.c,v $
 * Revision 2.2  92/04/30  14:48:59  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.3  92/04/27  17:07:49  raja
 * Send message body using the event returned by the receiver.
 * 
 * Revision 2.1.1.2  91/10/20  22:04:41  raja
 * Make tsend() compatible with nsend().
 * 
 * Revision 2.1.1.1  91/06/27  12:12:28  radiya-v
 * Deleted line which incorrectly set nhead->nh_flags to 0.
 * 
 * Revision 2.1  91/03/20  11:37:27  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:27:25  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:54:32  trillium
 * Homo erectus
 * 
 *	Function:	- transport layer send
 */

#include <portable.h>
#include <typical.h>
#include <net.h>


int
tsend(nhead)

struct nmsg		*nhead;		/* network message descriptor */

{
	struct nmsg	sync;		/* synchronization message */
	int		save_event;	/* saved message event */
	int		ret;		/* returned value */
/*
 * Send the "ready to send" message.
 */
	sync.nh_node = nhead->nh_node;
	sync.nh_event = nhead->nh_event;
	sync.nh_type = nhead->nh_type;
	sync.nh_flags = DINTDATA;
	sync.nh_length = INT4_NIL;
	sync.nh_msg = (char *) 0;

	sync.nh_data[0] = getnodeid();
	sync.nh_data[1] = -getpid();

	if (nsend(&sync)) {
		return(ERROR);
	}
/*
 * Receive the "ready to receive" message.
 */
	sync.nh_event = -getpid();
	sync.nh_type = INT4_NIL;

	if (nrecv(&sync)) {
		return(ERROR);
	}
/*
 * Send the data message using the event given by the receiver.
 */
	save_event = nhead->nh_event;
	nhead->nh_event = sync.nh_data[0];

	ret = nsend(nhead);

	nhead->nh_event = save_event;
	return(ret);
}
