/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	VSD/RBD
 *
 *	$Log:	rrhold.c,v $
 * Revision 2.2.1.1  92/05/14  12:18:19  raja
 * Fixed non-orthodox dsend() call.
 * 
 * Revision 2.2  92/04/30  14:49:47  trillium
 * Ohio Release
 *
 * Revision 2.1  91/03/20  11:37:58  gdburns
 * Ohio Release
 *
 * Revision 2.0.1.1  90/07/13  19:30:56  gdburns
 * Homo sapien
 *
 * Revision 2.0  90/02/20  11:56:41  trillium
 * Homo erectus
 *
 *	Function:	- make the RHOLD request to the local router
 *	Returns:	- 0 or ERROR
 */

#include <net.h>
#include <events.h>
#include <typical.h>
#include <rreq.h>

int
rrhold()

{
	struct rreq	*request;	/* router request */
	struct nmsg	nhead;		/* network header */
/*
 * Set up the router request.
 */
	request = (struct rreq *) nhead.nh_data;
	request->rq_request = RHOLD;
	request->rq_src_event = -getpid();

	nhead.nh_node = LOCAL;
	nhead.nh_event = nhead.nh_dl_event = EVROUTER;
	nhead.nh_type = 0;
	nhead.nh_flags = NOBUF;
	nhead.nh_length = 0;
	nhead.nh_msg = (char *) 0;

	return(dsend(&nhead));
}
