/*
 *	OSU Research Computing					Trillium
 *	Copyright 1991 The Ohio State University
 *	RBD
 *
 *	$Log:	rrnodewait.c,v $
 * Revision 2.2  92/04/30  14:49:50  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/11/27  14:46:07  raja
 * initial revision
 * 
 *	Function:	- make the RNODEWAIT request to a remote router
 *
 *	Accepts: 	- node ID of affected router process
 *			- node ID to wait for at that router
 *
 *	Returns:	- 0 or ERROR
 */

#include <portable.h>
#include <events.h>
#include <net.h>
#include <rreq.h>
#include <typical.h>

/*
 * external variables
 */
extern int		errno;

int
rrnodewait(nodeid, wait_nodeid)

int4			nodeid;
int4			wait_nodeid;

{
	struct rreq	*request;	/* router request */
	struct rreply	*reply;		/* router reply */
	struct nmsg	nhead;		/* network header */
/*
 * Set up the router request.
 */
	request = (struct rreq *) nhead.nh_data;

	request->rq_src_node = (nodeid == LOCAL) ? nodeid : getnodeid();
	request->rq_src_event = -getpid();
	request->rq_request = RNODEWAIT;
	request->rq_nodeid = wait_nodeid;

	nhead.nh_node = nodeid;
	nhead.nh_event = EVROUTER;
	nhead.nh_type = INT4_NIL;
	nhead.nh_flags = (nodeid == LOCAL) ? NOBUF : INT4_NIL;
	nhead.nh_length = INT4_NIL;
	nhead.nh_msg = (char *) 0;

	if (nsend(&nhead)) {
		return(ERROR);
	}

	nhead.nh_event = -getpid();
	nhead.nh_type = INT4_NIL;

	if (nrecv(&nhead)) {
		return(ERROR);
	}

	reply = (struct rreply *) nhead.nh_data;

	if (reply->rr_reply) {
		errno = reply->rr_reply;
		return(ERROR);
	}
	else {
		return(0);
	}
}
