/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	GDB
 *
 *	$Log:	rsetnet.c,v $
 * Revision 2.2  92/04/30  14:49:54  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.1  92/01/20  19:24:27  gdburns
 * Use the shared library.
 * 
 * Revision 2.1  91/03/20  11:38:00  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.2  91/03/20  00:21:12  gdburns
 * Allow the use of buffering.
 * 
 * Revision 2.0.1.1  90/07/13  19:30:50  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:56:34  trillium
 * Homo erectus
 *
 *	Function:	- make the RSETNET request to the local router
 *			- set network information in the router
 *			- based on Trollius 2.0 Copyright 1990
 *			  The Ohio State University and Cornell
 *			  Research Foundation
 *
 *	Accepts: 	- destination node ID
 *			- ptr to node information structure
 *
 *	Returns:	- 0 or ERROR
 */

#include <net.h>
#include <events.h>
#include <rreq.h>
#include <shared.h>

int
rsetnet(dest_node, nodes)

int				dest_node;
struct net_info			*nodes;

{
	struct rreq		*request;	/* router request */
	struct nmsg		nhead;		/* network header */
/*
 * Set up the router request.
 */
	request = (struct rreq *) nhead.nh_data;

	request->rq_request = RSETNET;
	request->rq_nodeid = nodes->ni_nodeid;
	request->rq_origin = nodes->ni_origin;
	request->rq_nodetype = nodes->ni_nodetype;

	nhead.nh_node = dest_node;
	nhead.nh_event = EVROUTER;
	nhead.nh_type = 0;
	nhead.nh_flags = (dest_node == LOCAL) ? NOBUF : 0;
	nhead.nh_length = 0;
	nhead.nh_msg = (char *) 0;

	return(nsend(&nhead));
}
