/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	GDB
 *
 *	$Log:	rbtstage.c,v $
 * Revision 2.2  92/04/30  14:52:36  trillium
 * Ohio Release
 * 
 * Revision 2.1  92/01/20  19:29:57  gdburns
 * initial revision
 * 
 *	Function:	- stages objects to neighbour of remote node
 *
 *	Accepts:	- remote nodeid
 *			- object mask
 *			- neighbour nodeid
 *
 *	Returns:	- 0 or ERROR
 */

#include <bootreq.h>
#include <events.h>
#include <ksignal.h>
#include <net.h>
#include <portable.h>
#include <typical.h>

/*
 * external variables
 */
extern int4			errno;		/* global error */

int
rbtstage(nodeid, object, neighbour)

int4				nodeid;		/* target node ID */
int4				object;		/* bit field of boot objects */
int4				neighbour;	/* could be any node w/bootd */

{
	struct nmsg		nhead;		/* network message */
	struct bootreq		*request;	/* bootd request template */
	struct bootreply	*reply;		/* bootd reply template */
	int4			mask;		/* signal mask */

	request = (struct bootreq *) nhead.nh_data;
	reply = (struct bootreply *) nhead.nh_data;

	request->btq_src_node = (nodeid == LOCAL) ? nodeid : getnodeid();
	request->btq_src_event = -getpid();
	request->btq_request = BTQSTAGE;
	request->btq_object = object;
	request->btq_node = neighbour;

	nhead.nh_node = nodeid;
	nhead.nh_event = EVBOOTD;
	nhead.nh_type = 0;
	nhead.nh_flags = 0;
	nhead.nh_length = 0;
	nhead.nh_msg = (char *) 0;

	if (nsend(&nhead)) {
		return(ERROR);
	}

	mask = ksigblock(sigmask(SIGUDIE) | sigmask(SIGARREST));
	nhead.nh_event = -getpid();

	if (nrecv(&nhead)) {
		return(ERROR);
	}

	(void) ksigsetmask(mask);

	if (reply->btr_reply) {
		errno = reply->btr_reply;
		return(ERROR);
	} else {
		return(0);
	}
}
