/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	GDB
 *
 *	$Log:	rbuffer.c,v $
 * Revision 2.2  92/04/30  14:52:40  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.1  92/04/27  15:49:33  gdburns
 * new information - user space threshold
 * 
 * Revision 2.1  91/03/20  11:38:27  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.2  90/07/13  19:30:18  gdburns
 * Homo sapien
 * 
 * Revision 2.0.1.1  90/05/06  16:43:26  raja
 * Modified variable name bfq_parm1 to bfq_parm3 due to change in bufreq.h.
 * 
 * Revision 2.0  90/02/20  11:56:17  trillium
 * Homo erectus
 *
 *	Function:	- runtime access to the buffer server
 *			- based on Trollius 2.0 Copyright 1990
 *			  The Ohio State University and Cornell
 *			  Research Foundation
 */

#include <net.h>
#include <events.h>
#include <bufreq.h>

/*
 * external variables
 */
extern int		errno;		/* global error variable */

int
rbuffer(nodeid, req, parm)

int			req;		/* buffer request code */
int			parm;		/* #workers, #space, or #usr */
int			nodeid;		/* target node address */

{
	struct nmsg	nhead;		/* network header */
	struct bufreq  	*request;	/* bufferd request  */


	request = (struct bufreq *) nhead.nh_data;
	request->bfq_req = req;
	request->bfq_parm3 = parm;
/*
 *	request->bfq_src_node = (nodeid == LOCAL) ? nodeid : getnodeid;
 *	request->bfq_src_event = -getpid();
 */
	nhead.nh_node = nodeid;
	nhead.nh_event = EVBUFFERD;
	nhead.nh_type = BFREQ;
	nhead.nh_flags = NOBUF;
	nhead.nh_length = 0;
	nhead.nh_msg = (char *) 0;

	return(nsend(&nhead));
/*
 * no replies for now
 */
}
