/*
 *      OSU Research Computing                            	Trillium
 *      Copyright 1992 The Ohio State University
 *      GDB
 *
 *      $Log:	rdlvalve.c,v $
 * Revision 2.2  92/04/30  14:52:58  trillium
 * Ohio Release
 * 
 *      Function:	- turns positive event valve on or off
 *	Accepts:	- destination node ID
 *			- valve operation
 *	Returns:	- 0 or ERROR
 */

#include <net.h>
#include <events.h>
#include <dlreq.h>
#include <typical.h>

int4
rdlvalve(node, src_node, op)

int4			node;
int4			src_node;
int4			op;

{
	struct nmsg	nhead;
	struct dlreq	*req;

	req = (struct dlreq *) nhead.nh_data;
	req->dlq_req = DLQVALVE;
	req->dlq_valve = op;
	req->dlq_node = src_node;

	nhead.nh_node = node;
	nhead.nh_event = EVDLMOM;
	nhead.nh_type = 0;
	nhead.nh_flags = NOBUF;
	nhead.nh_length = 0;
	nhead.nh_msg = (char *) 0;

	if (nsend(&nhead) < 0) {
		return(ERROR);
	}

	return(0);
}
