/*
 *	Cornell Theory Center					Trillium
 *
 *	Copyright 1987 Cornell University
 *
 *	DLF
 *
 *	$Log:	rdrain.c,v $
 * Revision 2.2  92/04/30  14:53:07  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.1  91/10/20  21:44:12  gdburns
 * Use fcntl.h.
 * 
 * Revision 2.1  91/03/20  11:38:34  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:29:55  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:56:05  trillium
 * Homo erectus
 * 
 *
 *	Function : - run-time call for draining memory from any node
 *		     into a file on the local node
 *
 *	Accepts  : - node number
 *		   - address to begin drain 
 *		   - number of bytes to drain
 *		   - filename 
 */


#include <typical.h>		/* commonly used constants */
#include <memreq.h>		/* memory request structures */
#include <fcntl.h>		/* unix file system constants */


/*
 * external variables
 */
extern int 	errno;		/* Global error variable */

/*
 * external functions
 */
extern char	*malloc();


int
rdrain(src_node, address, no_bytes, filename)

int	src_node,	/* node whose memory we are draining        */
	address,	/* address to begin draining                */
	no_bytes;	/* number of bytes to drain                 */
char	*filename;      /* file to place drained memory             */

{
	int	fdesc;	/* file descriptor of drain file 	   */
	char	*buffer;/* buffer for reading memory into	   */


	if ((fdesc = open(filename, O_WRONLY | O_CREAT | O_TRUNC, 0666))
		== ERROR) 

		return(ERROR);

	if ((buffer = malloc((unsigned) no_bytes)) == (char *) 0) 
		return(ERROR);
	
	if (rmread(src_node, (char *) address, buffer, no_bytes) == ERROR)
		return(ERROR);

	if (write(fdesc, buffer, no_bytes) == ERROR) 
		return(ERROR);

	if (close(fdesc) == ERROR)
		return(ERROR);

	return(no_bytes);
}
