/*
 *	Cornell Theory Center					Trillium
 *
 *	Copyright 1987 Cornell University
 *
 *	DLF/GDB
 *
 *	$Log:	rloadgo.c,v $
 * Revision 2.2  92/04/30  14:53:18  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  11:38:41  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:29:50  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:55:59  trillium
 * Homo erectus
 * 
 * Revision 1.1  88/06/05  01:13:46  trillium
 * long overdue after 127 fixes and upgrades
 * 
 * Revision 1.0.1.1  88/06/01  16:25:22  gdburns
 * Used different tags for argv structure and load module.
 * 
 * Revision 1.0  87/12/19  15:48:34  trillium
 * Initial revision
 * 
 *
 *	Function : - run-time call for loading a file into any node and
 *	  	     then making it a process. 
 *
 *	Accepts  : - source node of file 
 *		   - destination node 
 *		   - stacksize
 *		   - process flags
 *		   - filename to load
 *		   - ptr to process ID (value returned)
 *		   - argc
 *		   - ptr to argv structure
 *		   - size of argv structure
 */


#include <typical.h>


int
rloadgo(src_node, dest_node, wpsize, flags, filename, argc, argv, avsize, pid)

int		src_node;
int		dest_node;
int		wpsize;
int		flags;
int		argc;
int		avsize;
int	       *pid;
char	       *filename;
char	      **argv;

{
	int	tag;	/* load tag for load module AND argv structure */
	int	ret;


	tag = getpid();

	if (rload(src_node, dest_node, tag, filename)) {
		return(ERROR);
	}
		
	if (argc) {
		if (rflat(dest_node, (char *) argv, avsize, avsize, -tag)) {
			return(ERROR);
		}
	}
		
	return(rcreate(dest_node, tag, flags, wpsize, pid, argc, -tag));
}
