/*
 *	Cornell Theory Center					Trillium
 *
 *	Copyright 1987 Cornell University
 *
 *	GDB
 *
 *	$Log:	rmload.c,v $
 * Revision 2.2  92/04/30  14:53:23  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/03/20  11:38:44  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.1  90/07/13  19:29:44  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:55:56  trillium
 * Homo erectus
 * 
 * Revision 1.1  88/06/05  01:13:55  trillium
 * long overdue after 127 fixes and upgrades
 * 
 * Revision 1.0  87/12/19  15:48:37  trillium
 * Initial revision
 * 
 *
 *	Function:	- remotely load the contents of memory
 *			- uses rmalloc and rmwrite
 *
 *	Accepts:	- destination node
 *			- address of local buffer
 *			- length of local buffer
 *
 *	Returns:	- remote ptr to buffer or NULL ptr
 */


#include <typical.h>
#include <memreq.h>


/*
 * external variables
 */
extern int		errno;

/*
 * external functions
 */
extern char		*rmalloc();


char
*rmload(nodeid, buffer, length)

int			nodeid,			/* destination node ID */
			length;			/* length of buffer */
char			*buffer;		/* buffer ptr */

{
	char		*rbuffer;		/* remote buffer ptr */


	rbuffer = rmalloc(nodeid, length, 0, 0);

	if ((rbuffer != (char *) 0) || !errno) {

		if (rmwrite(nodeid, buffer, rbuffer, length) == ERROR) {
			rbuffer = (char *) 0;
		}
	}

	return(rbuffer);
}
