/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	GDB
 *
 *	$Log:	rpwait.c,v $
 * Revision 2.2  92/04/30  14:53:29  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.2  92/03/05  19:59:55  gdburns
 * Kludge source event so as not to clash with rloadgo().
 * 
 * Revision 2.1.1.1  91/06/05  13:28:57  gdburns
 * Use unmodified parent reply event (-pid).
 * 
 * Revision 2.1  91/03/20  11:38:49  gdburns
 * Ohio Release
 * 
 * Revision 2.0.1.2  91/03/20  00:01:58  gdburns
 * Use a modified reply event.
 * 
 * Revision 2.0.1.1  90/07/13  19:30:10  gdburns
 * Homo sapien
 * 
 * Revision 2.0  90/02/20  11:56:16  trillium
 * Homo erectus
 * 
 *	Function:	- waits for kenya process to die
 *			- based on Trollius 2.0 Copyright 1990
 *			  The Ohio State University and Cornell
 *			  Research Foundation
 *
 *	Accepts:	- ptr to node ID
 *			- ptr to process ID
 *			- ptr to child process status
 *
 *	Returns:	- 0 or ERROR with errno set accordingly
 */

#include <net.h>
#include <preq.h>
#include <t_types.h>
#include <typical.h>

int
rpwait(nodeid, pid, status)

int			*nodeid;
int			*pid;
int			*status;

{
	struct nmsg	nhead;			/* network message descriptor */
	struct preply	reply;			/* kenyad reply */

	nhead.nh_event = (-getpid()) & 0x40000000;
	nhead.nh_type = 0;
	nhead.nh_flags = 0;
	nhead.nh_length = sizeof(struct preply);
	nhead.nh_msg = (char *) &reply;

	if (nrecv(&nhead)) {
		return(ERROR);
	}

	*nodeid = ttol(reply.pr_nodeid);
	*pid = ttol(reply.pr_pid);
	*status = ttol(reply.pr_reply);

	return(0);
}
