/*
 *	OSU Research Computing					Trillium
 *	Copyright 1990 The Ohio State University
 *	GDB
 *
 *	$Log:	rtrattach.c,v $
 * Revision 2.2  92/04/30  14:53:34  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/10/09  12:17:37  gdburns
 * initial revision
 * 
 *	Function:	- attach and detach from traced
 *			- become and cease to be a traced client
 *			- no reply from traced
 *
 *	Accepts:	- target node ID (should be local)
 *
 *	Returns:	- return value of nsend()
 */

#include <trreq.h>
#include <events.h>
#include <net.h>

int4
rtrattach(nodeid)

int4			nodeid;		/* target node ID */

{
	struct nmsg	nhead;		/* network message desc. */
	struct trreq  	*request;	/* traced request */

	request = (struct trreq *) nhead.nh_data;
	request->trq_req = TRQATTACH;
	request->trq_pid = getpid();

	nhead.nh_node = nodeid;
	nhead.nh_event = EVTRACED;
	nhead.nh_type = 0;
	nhead.nh_flags = 0;
	nhead.nh_length = 0;
	nhead.nh_msg = (char *) 0;

	return(nsend(&nhead));
}

int4
rtrdetach(nodeid)

int4			nodeid;		/* target node ID */

{
	struct nmsg	nhead;		/* network message desc. */
	struct trreq  	*request;	/* traced request */

	request = (struct trreq *) nhead.nh_data;
	request->trq_req = TRQDETACH;
	request->trq_pid = getpid();

	nhead.nh_node = nodeid;
	nhead.nh_event = EVTRACED;
	nhead.nh_type = 0;
	nhead.nh_flags = 0;
	nhead.nh_length = 0;
	nhead.nh_msg = (char *) 0;

	return(nsend(&nhead));
}
