/*
 *	OSU Research Computing					Trillium
 *	Copyright 1990 The Ohio State University
 *	GDB
 *
 *	$Log:	rtrstore.c,v $
 * Revision 2.2  92/04/30  14:53:36  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/10/09  12:18:28  gdburns
 * initial revision
 * 
 *	Function:	- stores trace data with traced
 *			- generates 1 to N store requests, each less
 *			  than MAXNMSGLEN
 *
 *	Accepts:	- target node ID (should be LOCAL)
 *			- ptr to trace data buffer
 *			- buffer length
 *			- no reply from traced
 *
 *	Returns:	- return value of nsend()
 */

#include <events.h>
#include <net.h>
#include <trreq.h>
#include <typical.h>

int4
rtrstore(nodeid, buffer, length)

int4			nodeid;		/* target node ID */
char			*buffer;	/* trace data */
int4			length;		/* buffer length */

{
	struct nmsg	nhead;		/* network message desc. */
	struct trreq  	*request;	/* traced request */

	request = (struct trreq *) nhead.nh_data;

	request->trq_req = TRQSTORE;
	request->trq_pid = getpid();

	nhead.nh_node = nodeid;
	nhead.nh_event = EVTRACED;
	nhead.nh_type = 0;
	nhead.nh_flags = 0;
	nhead.nh_msg = buffer;

	while (length > 0) {
		nhead.nh_length = (length > MAXNMSGLEN) ? MAXNMSGLEN : length;
		request->trq_length = nhead.nh_length;

		if (nsend(&nhead)) {
			return(ERROR);
		}

		length -= nhead.nh_length;
		buffer += nhead.nh_length;
	}

	return(0);
}
