
/*
 *	Cornell Theory Center					Trillium
 *
 *	Copyright 1987 Cornell University
 *
 *	AKP
 *
 *	$Log:	T414.h,v $
 * Revision 1.1  88/06/05  01:59:54  trillium
 * long overdue after 127 fixes and upgrades
 * 
 * Revision 1.0  87/12/19  16:20:45  trillium
 * Initial revision
 * 
 *
 *	t414
 */

#ifndef T414

#define T414

#define BPW	 4
#define BYTEMASK 0x3
#define WORDMASK 0xFFFFFFFC

#define iReg	0
#define aReg	1
#define bReg	2
#define cReg	3

/* locations below workspace for inactive processes */
#define INACTIVE_IP	(-1)
#define INACTIVE_LIST	(-2)
#define INACTIVE_MSGPTR	(-3)
#define INACTIVE_STATE	(-3)
#define INACTIVE_TLINK	(-4)
#define INACTIVE_TIMER	(-5)

#define OnChipRAM 0x80000000
#define OnChipMAX 0x800007FF
#define OnChipMax 0x800007FC
#define MemStart  0x80000048
#define OnChipMem 0x800

/* hard channel addresses */
#define Link0Out	0x80000000
#define Link1Out	0x80000004
#define Link2Out	0x80000008
#define Link3Out	0x8000000C
#define Link0In		0x80000010
#define Link1In		0x80000014
#define Link2In		0x80000018
#define Link3In		0x8000001C
#define Event		0x80000020

/* timer registers */
#define ClockReg0	0x80000024
#define ClockReg1	0x80000028

/* register save area */
#define wRegSave	0x8000002C
#define iRegSave	0x80000030
#define aRegSave	0x80000034
#define bRegSave	0x80000038
#define cRegSave	0x8000003C
#define sRegSave	0x80000040
#define eRegSave	0x80000044

#endif T414
