/*
 *	Cornell Theory Center				tti
 *
 *	Copyright 1988 Cornell University
 *
 *	AKP
 *
 *	Function:	- execution support for branching
 *
 *	$Log:	branch.ts,v $
Revision 1.1  88/08/19  15:35:43  gdburns
Initial revision

 */


#include "tti.h"


	IMPORT	Next
	EXPORT  If
	EXPORT	Goto

/*
**
**  If executes a conditional branch.  The current IP points at
**  a relative offset.  If the top of the stack is zero, the
**  contents of what IP points to are added to the IP (ie, the
**  branch is taken), otherwise the IP is incremented over the
**  branching offset.
**
**  It acts the same as "cj" -- jump if false.
*/

_if:
	pop(DS, DINC)	; get the value
	cj if_br	; do the branch if false
	incw(IP)	; True: bump IP over the offset
	j Next		; on to the next word...
if_br:
	ldl  IP		; False: take the branch
	ldnl  0		; the offset
	ldl  IP		; current value
	add		;
	stl  IP		; new IP
	j Next		;

/*
**
**  Goto does an unconditional branch using the contents of what the
**  current IP points at as a relative branch offset.  Subtle trickery
**  here as we set the code pointer to be the branch portion of "If".
**
*/
	ISEG
Goto:
	dw if_br
If:
	dw _if
