; Increment a local word variable by Bytes/Word
define(`incw',
        ldl     $1
        adc     BPW
        stl     $1
)
; Increment a local word variable by 1
define(`inc',
        ldl     $1
        adc     1
        stl     $1
)
;
;
;  TTI header macros (and support)
;
;    The important ones are "header" and "codep".
;
;	header(string, label, link, code pointer[,IMMEDIATE])
;	  Builds a header using "dw" and "db"
;
;	codep(label)
;	  Replaces "label" with "label + 12".  12 is the offset of
;	  the code pointer field from "label".
;
define(m4HDR,7)
define(`m4min',`ifelse(eval($1<$2),1,$1,1,1,$2)')
define(`m4len',`eval(len($1)-2)')
define(`m4str',`substr($1, 1, m4min(m4HDR,m4len($1)))')
;
;	m4zero and m4pad combine to add ", 0" to the end of a string
;	so that the total length becomes m4HDR.  Getting m4 to recurse
;	at the appropriate time is the crowning achievement of my career.
;	--GDB
;
define(`m4zero', ``, 0'm4pad(incr($1))')
define(`m4pad',`ifelse(eval($1<m4HDR),1,`m4zero($1)')')
define(`m4imm',`ifelse(eval(len($1)>0),1,128,0)')
define(`codep',`$1 + 12')
define(`at',`$1 - Boot')
define(header,
;
;	NAME:	$1
;	LABEL:	$2
;	LINK:	$3
;	CODE:	$4
;	FLAG:	$5
;
	ISEG
	EXPORT $2
	ALIGN 4
$2:	db	`"m4str($1)"m4pad(m4len($1)), m4len($1) + m4imm($5)'
	dw	$3
	dw	$4
	CSEG)

;
;
;	M4 macros for TTI stack manipulation
;
;
;	`push'(sp, increment)
;	`pop'(sp, increment)
;
;    where
;	sp		local var containing abs address of TOS
;	increment	constant: sp = sp [+|-] increment (bytes/word)
;
;

;
; Push the contents of the A register onto a local stack
;
define(push,
; ``push''($1, $2)
	ldl	$1
	stnl	0
	ldl	$1
	adc	$2
	stl	$1)

;
; Pop a local stack into the A register
;
define(pop,
; ``pop''($1, $2)
	ldl	$1
	adc	-($2)
	stl	$1
	ldl	$1
	ldnl	0)
